import { User } from "../models/user";
import { EventEmitter } from "@angular/core";
export declare abstract class BaseUserService {
    User: User | null;
    IsLoggedIn: boolean | null;
    IsAuthenticationReady: boolean;
    AuthenticationChanged: EventEmitter<User>;
    abstract Init(): void;
    abstract Login(redirectUrl?: string, silent?: boolean, thirdPartyOnly?: boolean, thirdPartyProvider?: string): Promise<boolean>;
    abstract Logout(): void;
    abstract SetOrganization(organizationId?: number): Promise<void>;
    abstract UpdateAvailability(available: boolean): Promise<void>;
    abstract GetAccessToken(): string | null;
    abstract GetCookie(cname: string): string | null;
    abstract SetCookie(cname: string, cvalue: string, exdays: number): void;
}
//# sourceMappingURL=baseuser.service.d.ts.map