import * as i0 from '@angular/core';
import { Component, Input, Injectable, NgModule, EventEmitter, ContentChild, Output, ViewChild, InjectionToken, Inject } from '@angular/core';
import * as i1 from '@progress/kendo-angular-dialog';
import { DialogCloseResult } from '@progress/kendo-angular-dialog';
import { __awaiter } from 'tslib';
import * as i2 from '@angular/forms';
import { Validators, FormsModule, ReactiveFormsModule, ControlContainer, FormGroupDirective, FormControl, FormGroup } from '@angular/forms';
import * as i1$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { switchMap, tap, delay, map } from 'rxjs/operators';
import { from, timer } from 'rxjs';
import * as i2$1 from '@progress/kendo-angular-dropdowns';
import { DropDownsModule } from '@progress/kendo-angular-dropdowns';
import { PaymentMethods, Roles } from 'cadlearning.dto';
import * as i1$2 from '@angular/common/http';
import { HttpHeaders, HttpRequest, HttpEventType, HttpParams, HttpErrorResponse } from '@angular/common/http';
import { ActivatedRoute } from '@angular/router';
import { TranslateService } from '@ngx-translate/core';
import { process } from '@progress/kendo-data-query';

class PromptComponent {
    constructor(modal, fb) {
        this.modal = modal;
        this.fb = fb;
        this.Required = false;
        this.MaxLength = 50;
    }
    ngOnInit() {
        return __awaiter(this, void 0, void 0, function* () {
            this.Form = this.fb.group({
                Prompt: [this.OriginalValue, this.Required ? Validators.required : null]
            });
            this.Title = this.modal.dialog.instance.title;
        });
    }
    onSubmit() {
        return __awaiter(this, void 0, void 0, function* () {
            let ctrl = this.Form.get('Prompt');
            if (ctrl) {
                let val = ctrl.value;
                if (this.Required && !val)
                    return;
                this.modal.close(val);
            }
        });
    }
    close() {
        this.modal.close(null);
    }
}
PromptComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PromptComponent, deps: [{ token: i1.DialogRef }, { token: i2.FormBuilder }], target: i0.ɵɵFactoryTarget.Component });
PromptComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.4", type: PromptComponent, selector: "ng-component", inputs: { Field: "Field", Required: "Required", OriginalValue: "OriginalValue", MaxLength: "MaxLength" }, ngImport: i0, template: "<form action=\"POST\" novalidate [formGroup]=\"Form\" (ngSubmit)=\"onSubmit()\">\r\n\t<div class=\"modal-body\" *ngIf=\"Form\">\r\n\t\t<div class=\"row\">\r\n\t\t\t<div class=\"col-md-12 form-group\"\r\n\t\t\t\t[class.has-danger]=\"!Form.get('Prompt')!.valid && Form.get('Prompt')!.touched\"\r\n\t\t\t\t[class.has-success]=\"Form.get('Prompt')!.valid && Form.get('Prompt')!.touched\">\r\n\t\t\t\t<label for=\"txtPrompt\">{{Field}}</label>\r\n\t\t\t\t<input type=\"text\" class=\"form-control mb-3\" id=\"txtPrompt\" formControlName=\"Prompt\"\r\n\t\t\t\t\t[maxlength]=\"MaxLength\"\r\n\t\t\t\t\t[class.form-control-danger]=\"!Form.get('Prompt')!.valid && Form.get('Prompt')!.touched\"\r\n\t\t\t\t\t[class.form-control-success]=\"Form.get('Prompt')!.valid\" />\r\n\t\t\t</div>\r\n\t\t</div>\r\n\t</div>\r\n\t<div class=\"modal-footer\">\r\n\t\t<button type=\"submit\" [disabled]=\"!Form!.valid\" class='btn btn-orange' id=\"btnSave\">Save</button>\r\n\t\t<button type='button' type=\"button\" class='btn btn-warning' id=\"btnCancel\" (click)='close()'>Cancel</button>\r\n\t</div>\r\n</form>\r\n", dependencies: [{ kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { kind: "directive", type: i2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PromptComponent, decorators: [{
            type: Component,
            args: [{ template: "<form action=\"POST\" novalidate [formGroup]=\"Form\" (ngSubmit)=\"onSubmit()\">\r\n\t<div class=\"modal-body\" *ngIf=\"Form\">\r\n\t\t<div class=\"row\">\r\n\t\t\t<div class=\"col-md-12 form-group\"\r\n\t\t\t\t[class.has-danger]=\"!Form.get('Prompt')!.valid && Form.get('Prompt')!.touched\"\r\n\t\t\t\t[class.has-success]=\"Form.get('Prompt')!.valid && Form.get('Prompt')!.touched\">\r\n\t\t\t\t<label for=\"txtPrompt\">{{Field}}</label>\r\n\t\t\t\t<input type=\"text\" class=\"form-control mb-3\" id=\"txtPrompt\" formControlName=\"Prompt\"\r\n\t\t\t\t\t[maxlength]=\"MaxLength\"\r\n\t\t\t\t\t[class.form-control-danger]=\"!Form.get('Prompt')!.valid && Form.get('Prompt')!.touched\"\r\n\t\t\t\t\t[class.form-control-success]=\"Form.get('Prompt')!.valid\" />\r\n\t\t\t</div>\r\n\t\t</div>\r\n\t</div>\r\n\t<div class=\"modal-footer\">\r\n\t\t<button type=\"submit\" [disabled]=\"!Form!.valid\" class='btn btn-orange' id=\"btnSave\">Save</button>\r\n\t\t<button type='button' type=\"button\" class='btn btn-warning' id=\"btnCancel\" (click)='close()'>Cancel</button>\r\n\t</div>\r\n</form>\r\n" }]
        }], ctorParameters: function () { return [{ type: i1.DialogRef }, { type: i2.FormBuilder }]; }, propDecorators: { Field: [{
                type: Input
            }], Required: [{
                type: Input
            }], OriginalValue: [{
                type: Input
            }], MaxLength: [{
                type: Input
            }] } });

class ConfirmService {
    constructor(modalService) {
        this.modalService = modalService;
    }
    confirm(body, title, yesText = 'Yes', noText = 'No') {
        let promise = new Promise((resolve, reject) => {
            const dialog = this.modalService.open({
                title: title,
                content: body,
                actions: [{ text: yesText, primary: true }, { text: noText }]
            });
            dialog.result.subscribe(result => {
                if (result instanceof DialogCloseResult) {
                    resolve(false);
                }
                else {
                    if (result.text === yesText) {
                        resolve(true);
                    }
                    else {
                        resolve(false);
                    }
                }
            });
        });
        return promise;
    }
    alert(body, title) {
        const promise = new Promise((resolve, reject) => {
            const dialog = this.modalService.open({
                title: title,
                content: body,
                actions: [{ text: 'OK', primary: true }]
            });
            dialog.result.subscribe(result => {
                resolve();
            });
        });
        return promise;
    }
    prompt(title = undefined, fieldName, originalValue, required, maxlength) {
        const dialog = this.modalService.open({
            content: PromptComponent,
            actions: [],
            title: title
        });
        dialog.content.instance['Required'] = required;
        dialog.content.instance['MaxLength'] = maxlength || 50;
        dialog.content.instance['OriginalValue'] = originalValue;
        dialog.content.instance['Field'] = fieldName;
        const promise = new Promise((resolve, reject) => {
            dialog.result.subscribe((result) => {
                if (result instanceof DialogCloseResult) {
                    resolve(null);
                }
                else {
                    resolve(result);
                }
            });
        });
        return promise;
    }
    showDialog(title, component, yesProperty, yesText = 'Yes', noText = 'No', dialogSave = 'onSubmit', additionalContent) {
        let promise = new Promise((resolve, reject) => {
            const dialog = this.modalService.open({
                title: title,
                content: component,
                actions: [{ text: yesText, primary: true }, { text: noText }]
            });
            if (additionalContent) {
                let content = dialog.content.instance;
                let keys = Object.keys(additionalContent);
                for (let i = 0; i < keys.length; ++i) {
                    content[keys[i]] = additionalContent[keys[i]];
                }
            }
            dialog.result.subscribe(result => {
                if (result instanceof DialogCloseResult) {
                    resolve(null);
                }
                else {
                    if (result.text === yesText) {
                        let instance = dialog.content.instance;
                        if (dialogSave && typeof instance[dialogSave] === 'function') {
                            let result = instance[dialogSave]();
                            if (typeof result.then === 'function') {
                                //hacky...
                                result.then(() => {
                                    resolve(instance[yesProperty]);
                                });
                            }
                            else {
                                resolve(instance[yesProperty]);
                            }
                        }
                        else {
                            resolve(instance[yesProperty]);
                        }
                    }
                    else {
                        resolve(null);
                    }
                }
            });
        });
        return promise;
    }
}
ConfirmService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ConfirmService, deps: [{ token: i1.DialogService }], target: i0.ɵɵFactoryTarget.Injectable });
ConfirmService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ConfirmService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ConfirmService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i1.DialogService }]; } });

class ConfirmModule {
    static forRoot() {
        return {
            ngModule: ConfirmModule,
            providers: [ConfirmService, PromptComponent]
        };
    }
}
ConfirmModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ConfirmModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ConfirmModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.4", ngImport: i0, type: ConfirmModule, declarations: [PromptComponent], imports: [CommonModule, FormsModule, ReactiveFormsModule], exports: [PromptComponent] });
ConfirmModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ConfirmModule, imports: [CommonModule, FormsModule, ReactiveFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ConfirmModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, FormsModule, ReactiveFormsModule],
                    declarations: [PromptComponent],
                    exports: [PromptComponent]
                }]
        }] });

class LoadingComponent {
    constructor() {
        this.LoadingText = null;
        this.FontSize = "3em";
    }
}
LoadingComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: LoadingComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
LoadingComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.4", type: LoadingComponent, selector: "cad-loading", inputs: { LoadingText: "LoadingText", FontSize: "FontSize" }, ngImport: i0, template: `
		<div id="loading-group">
			<div id="loading-symbol">
				<i class="fa fa-spin fa-spinner" [ngStyle]="{ 'font-size': FontSize }" aria-hidden="true"></i>
			</div>
			<div id="loading-text" *ngIf="LoadingText">
				<span>{{ LoadingText }}</span>
			</div>
		</div>
	`, isInline: true, styles: ["#loading-group{display:flex;flex-direction:row;flex-wrap:wrap;flex:0 0 100%;justify-content:center;align-items:center}#loading-group #loading-text{align-self:center;margin-left:15px}\n"], dependencies: [{ kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1$1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: LoadingComponent, decorators: [{
            type: Component,
            args: [{ selector: "cad-loading", template: `
		<div id="loading-group">
			<div id="loading-symbol">
				<i class="fa fa-spin fa-spinner" [ngStyle]="{ 'font-size': FontSize }" aria-hidden="true"></i>
			</div>
			<div id="loading-text" *ngIf="LoadingText">
				<span>{{ LoadingText }}</span>
			</div>
		</div>
	`, styles: ["#loading-group{display:flex;flex-direction:row;flex-wrap:wrap;flex:0 0 100%;justify-content:center;align-items:center}#loading-group #loading-text{align-self:center;margin-left:15px}\n"] }]
        }], propDecorators: { LoadingText: [{
                type: Input
            }], FontSize: [{
                type: Input
            }] } });

class OdataKendoComboBoxComponent {
    constructor() {
        this.Data = [];
        this.comboboxDataRef = null;
        this.getData = (v) => { return Promise.resolve([]); };
        this.placeholder = "Please enter a value to search";
        this.textField = "Name";
        this.valueField = "Id";
        this.valuePrimative = false;
        this.formControlName = null;
        this.class = "form-control";
        this.style = null;
        this.selected = new EventEmitter();
        this.list = null;
        this.filterSubscribed = false;
    }
    selectionChange($event) {
        this.selected.emit($event);
    }
    ngAfterViewChecked() {
        if (!this.filterSubscribed) {
            //contrary to kendo's documentation, for whatever reason the view child isn't defined on AfterViewInit
            //So I used this hacky work around. I suspect it's partially due to OnInit being async
            if (this.list) {
                const contains = (value) => (s) => s.text.toLowerCase().indexOf(value.toLowerCase()) !== -1;
                this.filterSubscribed = true;
                this.list.filterChange
                    .asObservable()
                    .pipe(switchMap((value) => from([this.Data]).pipe(tap(() => (this.list.loading = true)), delay(300), map((data) => data.filter(contains(value))))))
                    .subscribe((x) => {
                    this.Data = x;
                    this.list.loading = false;
                });
            }
        }
    }
}
OdataKendoComboBoxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: OdataKendoComboBoxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
OdataKendoComboBoxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.4", type: OdataKendoComboBoxComponent, selector: "odata-kendo-combobox", inputs: { getData: "getData", placeholder: "placeholder", textField: "textField", valueField: "valueField", valuePrimative: "valuePrimative", formControlName: "formControlName", class: "class", style: "style" }, outputs: { selected: "selected" }, queries: [{ propertyName: "comboboxDataRef", first: true, predicate: ["comboboxDataRef"], descendants: true, static: true }], viewQueries: [{ propertyName: "list", first: true, predicate: ["list"], descendants: true, static: true }], ngImport: i0, template: `
		<kendo-combobox
			#list
			style="width:90%"
			[filterable]="true"
			[data]="Data"
			[textField]="textField"
			[valueField]="valueField"
			[valuePrimitive]="false"
			[formControlName]="formControlName"
			[placeholder]="placeholder"
			(selectionChange)="selectionChange($event)"
		>
			<ng-template kendoComboBoxItemTemplate let-dataItem>
				<ng-container [ngTemplateOutlet]="comboboxDataRef" [ngTemplateOutletContext]="{ $implicit: dataItem }">
				</ng-container>
			</ng-template>
		</kendo-combobox>
	`, isInline: true, dependencies: [{ kind: "directive", type: i1$1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2$1.ItemTemplateDirective, selector: "[kendoDropDownListItemTemplate],[kendoComboBoxItemTemplate],[kendoAutoCompleteItemTemplate],[kendoMultiSelectItemTemplate]" }, { kind: "component", type: i2$1.ComboBoxComponent, selector: "kendo-combobox", inputs: ["focusableId", "allowCustom", "data", "value", "textField", "valueField", "valuePrimitive", "valueNormalizer", "placeholder", "popupSettings", "listHeight", "iconClass", "loading", "suggest", "clearButton", "disabled", "itemDisabled", "readonly", "tabindex", "tabIndex", "filterable", "virtual", "size", "rounded", "fillMode"], outputs: ["valueChange", "selectionChange", "filterChange", "open", "opened", "close", "closed", "focus", "blur"], exportAs: ["kendoComboBox"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }], viewProviders: [
        {
            provide: ControlContainer,
            useExisting: FormGroupDirective,
        },
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: OdataKendoComboBoxComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "odata-kendo-combobox",
                    template: `
		<kendo-combobox
			#list
			style="width:90%"
			[filterable]="true"
			[data]="Data"
			[textField]="textField"
			[valueField]="valueField"
			[valuePrimitive]="false"
			[formControlName]="formControlName"
			[placeholder]="placeholder"
			(selectionChange)="selectionChange($event)"
		>
			<ng-template kendoComboBoxItemTemplate let-dataItem>
				<ng-container [ngTemplateOutlet]="comboboxDataRef" [ngTemplateOutletContext]="{ $implicit: dataItem }">
				</ng-container>
			</ng-template>
		</kendo-combobox>
	`,
                    viewProviders: [
                        {
                            provide: ControlContainer,
                            useExisting: FormGroupDirective,
                        },
                    ],
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { comboboxDataRef: [{
                type: ContentChild,
                args: ["comboboxDataRef", { static: true }]
            }], getData: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], textField: [{
                type: Input
            }], valueField: [{
                type: Input
            }], valuePrimative: [{
                type: Input
            }], formControlName: [{
                type: Input
            }], class: [{
                type: Input
            }], style: [{
                type: Input
            }], selected: [{
                type: Output
            }], list: [{
                type: ViewChild,
                args: ["list", { static: true }]
            }] } });

class CADLearningLightboxComponent {
    constructor() {
        /* Shamelessly copied from w3schools lightbox adapted into angular component */
        this.modalOpen = false;
        this.Source = null;
        this.Caption = null;
    }
    OpenModal($event, src) {
        this.modalOpen = true;
        if (src === 'image') {
            //Makes it so clicking on the image doesn't close the modal
            $event.stopPropagation();
        }
    }
    Close() {
        this.modalOpen = false;
    }
}
CADLearningLightboxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CADLearningLightboxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CADLearningLightboxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.1.4", type: CADLearningLightboxComponent, selector: "cad-lightbox", inputs: { Source: "Source", Caption: "Caption" }, ngImport: i0, template: `
		<img id="lb-myImg" [src]="Source" alt="{{ Caption }}" style="width:100%;max-width:100px" (click)="OpenModal($event, 'thumb')" />

		<!-- The Modal -->
		<div id="lb-myModal" class="lb-modal" *ngIf="modalOpen" (click)="Close()">
			<span class="lb-close" (click)="Close()">&times;</span>
			<img class="lb-modal-content" id="img01" [src]="Source" (click)="OpenModal($event, 'image')" />
			<div id="lb-caption">{{ Caption }}</div>
		</div>
	`, isInline: true, styles: ["#lb-myImg{border-radius:5px;cursor:pointer;transition:.3s}#lb-myImg:hover{opacity:.7}.lb-modal{display:block;position:fixed;z-index:1;padding-top:100px;left:0;top:65px;width:100%;height:100%;overflow:auto;background-color:#000;background-color:#000000e6}.lb-modal-content{margin:auto;display:block;width:80%;max-width:700px}#lb-caption{margin:auto;display:block;width:80%;max-width:700px;text-align:center;color:#ccc;padding:10px 0;height:150px}.lb-modal-content,#lb-caption{-webkit-animation-name:zoom;-webkit-animation-duration:.6s;animation-name:zoom;animation-duration:.6s}@keyframes zoom{0%{transform:scale(0)}to{transform:scale(1)}}.lb-close{position:absolute;top:15px;right:35px;color:#f1f1f1;font-size:40px;font-weight:700;transition:.3s}.lb-close:hover,.lb-close:focus{color:#bbb;text-decoration:none;cursor:pointer}@media only screen and (max-width: 700px){.lb-modal-content{width:100%}}\n"], dependencies: [{ kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CADLearningLightboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'cad-lightbox', template: `
		<img id="lb-myImg" [src]="Source" alt="{{ Caption }}" style="width:100%;max-width:100px" (click)="OpenModal($event, 'thumb')" />

		<!-- The Modal -->
		<div id="lb-myModal" class="lb-modal" *ngIf="modalOpen" (click)="Close()">
			<span class="lb-close" (click)="Close()">&times;</span>
			<img class="lb-modal-content" id="img01" [src]="Source" (click)="OpenModal($event, 'image')" />
			<div id="lb-caption">{{ Caption }}</div>
		</div>
	`, styles: ["#lb-myImg{border-radius:5px;cursor:pointer;transition:.3s}#lb-myImg:hover{opacity:.7}.lb-modal{display:block;position:fixed;z-index:1;padding-top:100px;left:0;top:65px;width:100%;height:100%;overflow:auto;background-color:#000;background-color:#000000e6}.lb-modal-content{margin:auto;display:block;width:80%;max-width:700px}#lb-caption{margin:auto;display:block;width:80%;max-width:700px;text-align:center;color:#ccc;padding:10px 0;height:150px}.lb-modal-content,#lb-caption{-webkit-animation-name:zoom;-webkit-animation-duration:.6s;animation-name:zoom;animation-duration:.6s}@keyframes zoom{0%{transform:scale(0)}to{transform:scale(1)}}.lb-close{position:absolute;top:15px;right:35px;color:#f1f1f1;font-size:40px;font-weight:700;transition:.3s}.lb-close:hover,.lb-close:focus{color:#bbb;text-decoration:none;cursor:pointer}@media only screen and (max-width: 700px){.lb-modal-content{width:100%}}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { Source: [{
                type: Input
            }], Caption: [{
                type: Input
            }] } });

class CADLearningCommonModule {
    static forRoot() {
        return {
            ngModule: CADLearningCommonModule,
            providers: [LoadingComponent, OdataKendoComboBoxComponent]
        };
    }
}
CADLearningCommonModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CADLearningCommonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CADLearningCommonModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.1.4", ngImport: i0, type: CADLearningCommonModule, declarations: [LoadingComponent, OdataKendoComboBoxComponent, CADLearningLightboxComponent], imports: [CommonModule, DropDownsModule, FormsModule, ReactiveFormsModule], exports: [LoadingComponent, OdataKendoComboBoxComponent, CADLearningLightboxComponent] });
CADLearningCommonModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CADLearningCommonModule, imports: [CommonModule, DropDownsModule, FormsModule, ReactiveFormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CADLearningCommonModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, DropDownsModule, FormsModule, ReactiveFormsModule],
                    declarations: [LoadingComponent, OdataKendoComboBoxComponent, CADLearningLightboxComponent],
                    exports: [LoadingComponent, OdataKendoComboBoxComponent, CADLearningLightboxComponent]
                }]
        }] });

const IsValidEmail = (control) => {
    let re = /^([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x22([^\x0d\x22\x5c\x80-\xff]|\x5c[\x00-\x7f])*\x22)(\x2e([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x22([^\x0d\x22\x5c\x80-\xff]|\x5c[\x00-\x7f])*\x22))*\x40([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x5b([^\x0d\x5b-\x5d\x80-\xff]|\x5c[\x00-\x7f])*\x5d)(\x2e([^\x00-\x20\x22\x28\x29\x2c\x2e\x3a-\x3c\x3e\x40\x5b-\x5d\x7f-\xff]+|\x5b([^\x0d\x5b-\x5d\x80-\xff]|\x5c[\x00-\x7f])*\x5d))*$/;
    if (!re.test(control.value))
        return { isValidEmail: 'Please enter a valid email address' };
    return null;
};
const IsValidPassword = (control) => {
    let re = /(?=.*[!@#$&*])(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{6,15}/;
    if (!re.test(control.value)) {
        return {
            isValidPassword: 'Password does not meet complexity requirements.'
        };
    }
    else {
        return null;
    }
};
const IsValidUri = (control) => {
    /* Taken from http://www.ietf.org/rfc/rfc3986.txt */
    let re = /^(https?:\/\/.+)+$/gm;
    if (!re.test(control.value)) {
        return { isValidUri: 'Uri is not valid.' };
    }
    return null;
};
function ReturnCardType(cardNumber) {
    if (cardNumber.startsWith('4')) {
        return PaymentMethods.Visa;
    }
    else if (cardNumber.startsWith('34') || cardNumber.startsWith('37')) {
        return PaymentMethods.Amex;
    }
    else if (cardNumber.startsWith('51') ||
        cardNumber.startsWith('52') ||
        cardNumber.startsWith('53') ||
        cardNumber.startsWith('54') ||
        cardNumber.startsWith('55')) {
        return PaymentMethods.MasterCard;
    }
    else if (cardNumber.startsWith('6011') || cardNumber.startsWith('644') || cardNumber.startsWith('65')) {
        return PaymentMethods.Discover;
    }
    else if (cardNumber.startsWith('300') ||
        cardNumber.startsWith('301') ||
        cardNumber.startsWith('302') ||
        cardNumber.startsWith('303') ||
        cardNumber.startsWith('304') ||
        cardNumber.startsWith('305') ||
        cardNumber.startsWith('36') ||
        cardNumber.startsWith('38')) {
        return PaymentMethods.DinersClub;
    }
    else {
        return null;
    }
}
const numbersOnly = (control) => {
    return control.value.match(/^\d+$/);
};
const OrgInfoFilled = (group) => {
    let accountType = group.get('AccountType');
    let organizationName = group.get('OrganizationName');
    let organizationDomain = group.get('OrganizationDomain');
    let numberOfUsers = group.get('NumberOfUsers');
    if (!accountType || !organizationDomain || !organizationName || !numberOfUsers)
        return { OrgInfoFilled: 'AccountType, OrganizationName, OrganizationDomain, or NumberOfUsers control is not present' };
    let valid = false;
    if (accountType.value === 'individual')
        return null;
    return organizationName.value && organizationDomain.value && numberOfUsers.value
        ? null
        : { OrgInfoFilled: 'Organization Info must be filled out!' };
};
const AreEqual = (group) => {
    let passwordControl = group.get('Password');
    let confirmControl = group.get('ConfirmPassword');
    if (!passwordControl || !confirmControl) {
        return {
            areEqual: 'Password or Confirm password control are not present'
        };
    }
    if (passwordControl.value === confirmControl.value) {
        return null;
    }
    else {
        return {
            areEqual: 'Confirm Password must match the new Password'
        };
    }
};
const Range = (min, max) => {
    return (control) => {
        let n = +control.value;
        return n >= min && n <= max ? null : { range: true };
    };
};
const AtLeastOneChecked = (controls) => {
    return (group) => {
        let checked = false;
        for (let i = 0; i < controls.length; ++i) {
            let ctrl = group.get(controls[i]);
            if (!ctrl)
                continue;
            if (ctrl.value === true) {
                checked = true;
                break;
            }
        }
        return checked ? null : { atLeastOneChecked: true };
    };
};
const IsTrue = (control) => {
    if (control.value === true)
        return null;
    else {
        return { isFalse: 'Control must be checked' };
    }
};
const ConfirmEmail = (emailField, confirmEmailField) => {
    return (control) => {
        let emailControl = control.get(emailField);
        let confirmEmailControl = control.get(confirmEmailField);
        if (!emailControl || !confirmEmailControl)
            return { ConfirmEmail: 'Email or Confirm email field cannot be found' };
        let email = emailControl.value;
        let confirmEmail = confirmEmailControl.value;
        return email === confirmEmail ? null : { ConfirmEmail: 'The email and confirm email fields must match' };
    };
};
const RoutingNumber = (control) => {
    let aba = control.value;
    let iTotal = 0;
    if (!/^\d+$/.test(aba))
        return { routingNumber: true };
    if (aba.length !== 9)
        return { routingNumber: true };
    for (let i = 0; i < aba.length; i += 3) {
        iTotal += parseInt(aba.charAt(i), 10) * 3 + parseInt(aba.charAt(i + 1), 10) * 7 + parseInt(aba.charAt(i + 2), 10);
    }
    if (iTotal !== 0 && iTotal % 10 === 0)
        return null;
    else
        return { routingNumber: true };
};
const CardNumber = (paymentMethod) => {
    return (control) => {
        let cardNo = control.value;
        if (!cardNo)
            return { cardNumber: true };
        let s = 0;
        let doubleDigit = false;
        for (let i = cardNo.length - 1; i >= 0; i--) {
            let digit = +cardNo[i];
            if (doubleDigit) {
                digit *= 2;
                if (digit > 9)
                    digit -= 9;
            }
            s += digit;
            doubleDigit = !doubleDigit;
        }
        if (!(s % 10 === 0))
            return { cardNumber: true };
        let method = paymentMethod();
        if (!method || !method.Type)
            return { cardNumber: true };
        let starting;
        switch (method.Type) {
            case PaymentMethods.Visa:
                if (cardNo.indexOf('4') !== 0 || (cardNo.length !== 13 && cardNo.length !== 16))
                    return { cardNumber: true };
                break;
            case PaymentMethods.MasterCard:
                if (cardNo.length !== 16)
                    return { cardNumber: true };
                starting = parseInt(cardNo.substr(0, 2));
                if (starting < 51 || starting > 55)
                    return { cardNumber: true };
                break;
            case PaymentMethods.Amex:
                starting = parseInt(cardNo.substr(0, 2));
                if ((starting !== 34 && starting !== 37) || cardNo.length !== 15)
                    return { cardNumber: true };
                break;
            case PaymentMethods.Discover:
                if ((cardNo.indexOf('6011') !== 0 || cardNo.length === 16) && (cardNo.indexOf('5') !== 0 || cardNo.length !== 15))
                    return { cardNumber: true };
                break;
            case PaymentMethods.DinersClub:
                let starting3 = parseInt(cardNo.substr(0, 3));
                let starting2 = parseInt(cardNo.substr(0, 2));
                if (((starting3 < 300 || starting3 > 305) && starting2 !== 36 && starting2 !== 38) || cardNo.length !== 14)
                    return { cardNumber: true };
                break;
            default:
                return null;
        }
        return null;
    };
};
const RequiredCond = (check) => {
    return (control) => {
        if (check(control.value)) {
            return Validators.required(control);
        }
        return null;
    };
};
const OtherRequiredValidator = (otherControlName) => {
    let thisControl;
    let otherControl;
    return function OtherRequiredValidate(control) {
        if (!control.parent)
            return null;
        if (!thisControl) {
            thisControl = control;
            otherControl = control.parent.get(otherControlName);
            if (!otherControl) {
                throw new Error('matchOtherValidator(): other control is not found in parent group');
            }
            otherControl.valueChanges.subscribe(() => {
                thisControl.updateValueAndValidity();
            });
        }
        if (!otherControl)
            return null;
        if (otherControl.value && !thisControl.value) {
            return {
                OtherRequiredValidator: 'Required'
            };
        }
        else {
            return null;
        }
    };
};

let CLIENT_CONFIG = new InjectionToken("CLIENT_CONFIG");
class BaseClient {
    constructor(clientService, http) {
        this.clientService = clientService;
        this.http = http;
    }
    GetFile(url, fileType, progressEvent) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        let headers = new HttpHeaders();
        if (fileType)
            headers = headers.set("Accept", fileType);
        const req = new HttpRequest("Get", this.clientService.ServiceUrl + url, {
            headers: headers,
            responseType: "blob",
            reportProgress: true,
        });
        let promise = new Promise((resolve, reject) => {
            this.http.request(req).subscribe((event) => {
                switch (event.type) {
                    case HttpEventType.DownloadProgress:
                        if (event.total) {
                            if (progressEvent)
                                progressEvent((event.loaded / event.total) * 100.0);
                        }
                        break;
                    case HttpEventType.Response:
                        if (event.status === 200) {
                            resolve(event.body);
                        }
                        else {
                            reject(JSON.parse(event.body));
                        }
                        break;
                    default:
                        break;
                }
            });
        });
        return promise;
    }
    GetPageable(url, params, willHandleError = false, withCredentials = false) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            this.http
                .get(this.clientService.ServiceUrl + url, {
                headers: undefined,
                params: params,
                responseType: "text",
                withCredentials: withCredentials,
            })
                .pipe(map((r) => {
                if (!r || r === "null")
                    return null;
                return JSON.parse(r, this.dateReviver);
            }))
                .subscribe({
                next: (response) => {
                    resolve(response);
                },
                error: (err) => {
                    const result = this.processError(err, willHandleError);
                    reject(result);
                },
            });
        });
        return promise;
    }
    GetData(url, params, data = null, willHandleError = false, withCredentials = false) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            if (data == null) {
                this.http
                    .get(this.clientService.ServiceUrl + url, {
                    headers: undefined,
                    responseType: "text",
                    params: params,
                    withCredentials: withCredentials,
                })
                    .pipe(map((r) => this.parseResponse(r)))
                    .subscribe({
                    next: (response) => {
                        resolve(response);
                    },
                    error: (err) => {
                        const result = this.processError(err, willHandleError);
                        reject(result);
                    },
                });
            }
            else {
                this.http
                    .request("GET", this.clientService.ServiceUrl + url, {
                    body: data,
                    headers: undefined,
                    responseType: "text",
                    params: params,
                    withCredentials: withCredentials,
                })
                    .pipe(map((r) => this.parseResponse(r)))
                    .subscribe({
                    next: (response) => {
                        resolve(response);
                    },
                    error: (err) => {
                        this.processError(err, willHandleError);
                        reject(err);
                    },
                });
            }
        });
        return promise;
    }
    ListData(url, params, data = null, willHandleError = false, withCredentials = false) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            if (data == null) {
                this.http
                    .get(this.clientService.ServiceUrl + url, {
                    headers: undefined,
                    responseType: "text",
                    params: params,
                    withCredentials: withCredentials,
                })
                    .pipe(map((r) => this.parseResponse(r)))
                    .subscribe({
                    next: (response) => {
                        resolve(response);
                    },
                    error: (err) => {
                        const result = this.processError(err, willHandleError);
                        reject(result);
                    },
                });
            }
            else {
                this.http
                    .request("GET", this.clientService.ServiceUrl + url, {
                    body: data,
                    headers: undefined,
                    responseType: "text",
                    params: params,
                    withCredentials: withCredentials,
                })
                    .pipe(map((r) => this.parseResponse(r)))
                    .subscribe({
                    next: (response) => {
                        resolve(response);
                    },
                    error: (err) => {
                        this.processError(err, willHandleError);
                        reject(err);
                    },
                });
            }
        });
        return promise;
    }
    ListDataRaw(url, params, willHandleError = false, withCredentials = false) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            this.http
                .get(this.clientService.ServiceUrl + url, {
                headers: undefined,
                params: params,
                withCredentials: withCredentials,
            })
                .subscribe({
                next: (response) => {
                    resolve(response);
                },
                error: (err) => {
                    const result = this.processError(err, willHandleError);
                    reject(result);
                },
            });
        });
        return promise;
    }
    PutMany(url, data, params, willHandleError = false, withCredentials = false, progress) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            this.http
                .put(this.clientService.ServiceUrl + url, data, {
                headers: undefined,
                params: params,
                responseType: "text",
                withCredentials: withCredentials,
                observe: "events",
                reportProgress: progress != null && progress != undefined,
            })
                .subscribe({
                next: (event) => {
                    if (event.type == HttpEventType.UploadProgress && event.total && progress) {
                        progress((event.loaded / event.total) * 100.0);
                    }
                    else if (event.type == HttpEventType.Response) {
                        resolve(this.parseResponse(event.body));
                    }
                },
                error: (err) => {
                    const result = this.processError(err, willHandleError);
                    reject(result);
                },
            });
        });
        return promise;
    }
    PutOne(url, data, params, willHandleError = false, withCredentials = false, progress) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            this.http
                .put(this.clientService.ServiceUrl + url, data, {
                headers: undefined,
                params: params,
                responseType: "text",
                withCredentials: withCredentials,
                observe: "events",
                reportProgress: progress != null && progress != undefined,
            })
                .subscribe({
                next: (event) => {
                    if (event.type == HttpEventType.UploadProgress && event.total && progress) {
                        progress((event.loaded / event.total) * 100.0);
                    }
                    else if (event.type == HttpEventType.Response) {
                        resolve(this.parseResponse(event.body));
                    }
                },
                error: (err) => {
                    const result = this.processError(err, willHandleError);
                    reject(result);
                },
            });
        });
        return promise;
    }
    PostMany(url, data, params, willHandleError = false, withCredentials = false, progress) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            this.http
                .post(this.clientService.ServiceUrl + url, data, {
                headers: undefined,
                params: params,
                responseType: "text",
                withCredentials: withCredentials,
                observe: "events",
                reportProgress: progress != null && progress != undefined,
            })
                .subscribe({
                next: (event) => {
                    if (event.type == HttpEventType.UploadProgress && event.total && progress) {
                        progress((event.loaded / event.total) * 100.0);
                    }
                    else if (event.type == HttpEventType.Response) {
                        resolve(this.parseResponse(event.body));
                    }
                },
                error: (err) => {
                    const result = this.processError(err, willHandleError);
                    reject(result);
                },
            });
        });
        return promise;
    }
    PostPageable(url, data, params, willHandleError = false, withCredentials = false) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            this.http
                .post(this.clientService.ServiceUrl + url, data, {
                headers: undefined,
                params: params,
                responseType: "text",
                withCredentials: withCredentials,
            })
                .pipe(map((r) => {
                if (!r || r === "null")
                    return null;
                return JSON.parse(r, this.dateReviver);
            }))
                .subscribe({
                next: (response) => {
                    resolve(response);
                },
                error: (err) => {
                    const result = this.processError(err, willHandleError);
                    reject(result);
                },
            });
        });
        return promise;
    }
    PostOne(url, data, params, willHandleError = false, withCredentials = false, progress) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            this.http
                .post(this.clientService.ServiceUrl + url, data, {
                headers: undefined,
                params: params,
                responseType: "text",
                observe: "events",
                withCredentials: withCredentials,
                reportProgress: progress != null && progress != undefined,
            })
                .subscribe({
                next: (event) => {
                    if (event.type == HttpEventType.UploadProgress && event.total && progress) {
                        progress((event.loaded / event.total) * 100.0);
                    }
                    else if (event.type == HttpEventType.Response) {
                        resolve(this.parseResponse(event.body));
                    }
                },
                error: (err) => {
                    const result = this.processError(err, willHandleError);
                    reject(result);
                },
            });
        });
        return promise;
    }
    static FormFromData(data) {
        var _a;
        const formData = new FormData();
        debugger;
        for (const prop in data) {
            if (data[prop] instanceof File) {
                const file = data[prop];
                formData.append(prop, file, file.name);
            }
            else if (data[prop] instanceof Blob) {
                formData.append(prop, data[prop]);
            }
            else {
                formData.append(prop, (_a = data[prop]) === null || _a === void 0 ? void 0 : _a.toString());
            }
        }
        return formData;
    }
    DeleteAny(url, params, willHandleError = false) {
        if (!this.clientService.ServiceUrl)
            throw "Please set the ServiceUrl before continuing.";
        const promise = new Promise((resolve, reject) => {
            this.http
                .delete(this.clientService.ServiceUrl + url, {
                params: params,
                responseType: "json",
            })
                .subscribe({
                next: (response) => {
                    resolve(response);
                },
                error: (err) => {
                    const result = this.processError(err, willHandleError);
                    reject(result);
                },
            });
        });
        return promise;
    }
    /**
     * Creates a new `HttpParams` with the correct codec
     */
    newParams() {
        return new HttpParams({
            encoder: PARAMETER_CODEC,
        });
    }
    parseResponse(r, useResult = true) {
        if (!r || r === "null")
            return null;
        const response = JSON.parse(r, this.dateReviver);
        console.log(response);
        if (useResult) {
            return response.Result;
        }
        else {
            return response;
        }
    }
    dateReviver(key, value) {
        const regexIso8601 = /^(\d{4})-(\d{2})-(\d{2})T(\d{2})\:(\d{2})\:(\d{2})(\.\d*)?[+-](\d{2})\:(\d{2})$/g;
        if (typeof value === "string" && regexIso8601.test(value))
            return new Date(value);
        return value;
    }
    processError(error, willHandleError) {
        var _a, _b, _c, _d;
        let details;
        if (error instanceof HttpErrorResponse) {
            if (error.error instanceof ErrorEvent) {
                return {
                    detail: error.error.message,
                    instance: error.url,
                    status: error.status,
                    title: error.statusText,
                    type: (_a = error.type) === null || _a === void 0 ? void 0 : _a.toString(),
                    url: error.url,
                };
            }
            else if (error.error instanceof ProgressEvent) {
                if (error.error.type == "error") {
                    return {
                        detail: error.message,
                        instance: error.url,
                        status: error.status,
                        title: error.statusText,
                        type: error.error.type,
                        url: error.url,
                    };
                }
                details = {
                    detail: error.message,
                    instance: error.url,
                    status: error.status,
                    title: error.statusText,
                    type: (_c = (_b = error.type) === null || _b === void 0 ? void 0 : _b.toString()) !== null && _c !== void 0 ? _c : "Unknown",
                    url: error.url,
                };
            }
            else {
                if (error.error != null && error.error === String(error.error)) {
                    try {
                        return JSON.parse(error.error);
                    }
                    catch (_e) { }
                }
                return {
                    detail: error.message,
                    instance: error.url,
                    status: error.status,
                    title: error.statusText,
                    type: (_d = error.type) === null || _d === void 0 ? void 0 : _d.toString(),
                    url: error.url,
                };
            }
        }
        else if (error instanceof Error) {
            details = {
                detail: error.detail,
                instance: error.instance,
                status: error.status,
                title: error.title,
                type: error.type,
                url: error.url,
            };
        }
        else if ("status" in error && "title" in error) {
            details = error;
        }
        else if (error === String(error)) {
            details = {
                detail: error,
                title: "Unknown Error",
                status: 0,
                instance: null,
                type: "UnHandledException",
            };
        }
        else {
            details = {
                title: "Unknown Error",
                detail: error === null || error === void 0 ? void 0 : error.toString(),
                status: 0,
                instance: null,
                type: "UnHandledException",
            };
        }
        if (!willHandleError && this.clientService.ErrorService) {
            this.clientService.ErrorService.handleError(details);
        }
        return details;
    }
}
BaseClient.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BaseClient, deps: [{ token: CLIENT_CONFIG }, { token: i1$2.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
BaseClient.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BaseClient });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BaseClient, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [CLIENT_CONFIG]
                    }] }, { type: i1$2.HttpClient }];
    } });
class ParameterCodec {
    encodeKey(key) {
        return encodeURIComponent(key);
    }
    encodeValue(value) {
        return encodeURIComponent(value);
    }
    decodeKey(key) {
        return decodeURIComponent(key);
    }
    decodeValue(value) {
        return decodeURIComponent(value);
    }
}
const PARAMETER_CODEC = new ParameterCodec();

class AssessmentsV1Client extends BaseClient {
    /** Adds a details to a assessment. The details must still be uploaded. */
    AddResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/AddResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes the selected details from a assessment. If the details is no longer associated with anything the details will be completely removed. */
    RemoveResource(ResourceId, AssessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/RemoveResource';
        let params = this.newParams();
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        if (AssessmentId != null)
            params = params.append('AssessmentId', AssessmentId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns the resources (downloads etc.) associated with the specified assessment */
    ListResourcesByType(AssessmentId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/ListResourcesByType';
        let params = this.newParams();
        if (AssessmentId != null)
            params = params.append('AssessmentId', AssessmentId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists the resources on a given assessment */
    ListResources(AssessmentId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/ListResources';
        let params = this.newParams();
        if (AssessmentId != null)
            params = params.append('AssessmentId', AssessmentId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the information about t/he current assessment and where it is in the workflow. If it isn't in the workflow then it puts it at stage 2 for triage by default. */
    GetWorkflowStatus(assessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/GetWorkflowStatus';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified question's workflow step and based on that will execute specific functions. */
    UpdateWorkflowStep(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateWorkflowStep';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the assessment workflow task */
    UpdateWorkflowTask(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateWorkflowTask';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns all workflow assignees to the assessment. */
    ListAssignees(assessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/ListAssignees';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the workflow assignments for a given Assessment */
    UpdateAssignees(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateAssignees';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the questions for the assessment or lessons */
    ListQuestions(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListQuestions';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of Assessments with their parents for easier identification */
    ListWithParents(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/ListWithParents';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Assessment Pre-Hire invite new user */
    InvitePreHireUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/InvitePreHireUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Assessment Pre-Hire invite new user */
    InvitePreHireNewUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/InvitePreHireNewUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Assessment Pre-Hire invite existing user */
    InvitePreHireExistingUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/InvitePreHireExistingUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the available assessments that can be added to the specified course. */
    ListAvailableAssessmentsByCourseId(courseId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListAvailableAssessmentsByCourseId';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Adds an assessment that already exists to a course */
    AddAssessmentToCourse(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/AddAssessmentToCourse';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** removes an assessment from a course */
    RemoveAssessmentFromCourse(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/RemoveAssessmentFromCourse';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get the specified translation */
    GetTranslation(assessmentId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/GetTranslation';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the questions for the assessment or lessons */
    GetAssessmentQuestionsWithParents(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/GetAssessmentQuestionsWithParents';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists all of the courses associated with the given assessment */
    ListCourses(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListCourses';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists all of the badges associated with the given assessment */
    ListBadges(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListBadges';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists all of the medallions associated with the given assessment */
    ListMedallions(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListMedallions';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates all of the courses assigned to the Assessment */
    UpdateCourses(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateCourses';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates all of the courses assigned to the Assessment */
    UpdateBadges(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateBadges';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates all of the courses assigned to the Assessment */
    UpdateMedallions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateMedallions';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List custom assessments */
    ListCustomAssessments(userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListCustomAssessments';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Remove prehire invitations */
    RemoveAssessmentInvitation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/RemoveAssessmentInvitation';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the assessments dynamic items */
    ListAssessmentDynamicItems(assessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/ListAssessmentDynamicItems';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** List available assessments */
    ListAvailableAssessments(assessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/ListAvailableAssessments';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the dynamic items attached to an assessment */
    UpdateAssessmentDynamicItems(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateAssessmentDynamicItems';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Update the assessment's questions. Ensure that you pass all questions associated with the assessment */
    UpdateQuestions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/UpdateQuestions';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Generates an assessment */
    GenerateAssessmentGamification(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/GenerateAssessmentGamification';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Generates an assessment */
    GenerateAssessment(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/GenerateAssessment';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Generate Gap Assessment */
    GenerateGapAssessment(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/GenerateGapAssessment';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the questions for the assessment or lessons */
    GetQuestions(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/GetQuestions';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns the questions for the assessment or lessons by course id */
    GetQuestionsByCourseId(courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/GetQuestionsByCourseId';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the questions for the assessment or lessons */
    GetQuestionsWithParents(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/GetQuestionsWithParents';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a user's transcript */
    ListUserTranscript(userId, includeIncompletes, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/ListUserTranscript';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (includeIncompletes != null)
            params = params.append('includeIncompletes', includeIncompletes.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists the assessments taken in the organization */
    ListTakenAssessments(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListTakenAssessments';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns the results for the given assessment */
    GetAssessmentResults(userAssessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/GetAssessmentResults';
        let params = this.newParams();
        if (userAssessmentId != null)
            params = params.append('userAssessmentId', userAssessmentId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists assessments by Topic */
    ListAssessmentInvitations(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListAssessmentInvitations';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Answers a question on a user assessment */
    RecordUserAssessmentAnswer(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/RecordUserAssessmentAnswer';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns an assessment based on the specific Identity Assessment Id (not the base assessment that is pre-created) */
    GetUserAssessmentById(userAssessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/GetUserAssessmentById';
        let params = this.newParams();
        if (userAssessmentId != null)
            params = params.append('userAssessmentId', userAssessmentId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a new user assessment on the user if the user hasn't started one or returns the current values for the assessment if they have. */
    GetUserAssessment(userId, assessmentId, parentId, parentType, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/GetUserAssessment';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        if (parentId != null)
            params = params.append('parentId', parentId.toString());
        if (parentType != null)
            params = params.append('parentType', parentType.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Deletes an existing user assessment */
    DeleteUserAssessment(userAssessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/DeleteUserAssessment';
        let params = this.newParams();
        if (userAssessmentId != null)
            params = params.append('userAssessmentId', userAssessmentId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns a new user assessment based on the playlist passed or returns an existing one that has outstanding questions to answer. */
    GetAssessmentByPlayList(userId, playListId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/GetAssessmentByPlayList';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (playListId != null)
            params = params.append('playListId', playListId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists assessments by Course */
    ListByCourseId(courseId, showPrehire, body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListByCourseId';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (showPrehire != null)
            params = params.append('showPrehire', showPrehire.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** List custom assessments */
    ListManageableCustomAssessments(body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/ListManageableCustomAssessments';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Insert or update a assessments */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed assessments */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the assessments by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Delete the specified translation */
    DeleteTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/DeleteTranslation';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets question of the day assessment */
    GetQuestionOfTheDayAssessment(userId, badgeId, medallionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/GetQuestionOfTheDayAssessment';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Records question of the day answer and returns the next question if applicable */
    RecordQuestionOfTheDayAnswer(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Assessments/RecordQuestionOfTheDayAnswer';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Assessments/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Assessments/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
AssessmentsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: AssessmentsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
AssessmentsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: AssessmentsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: AssessmentsV1Client, decorators: [{
            type: Injectable
        }] });
class BadgesV1Client extends BaseClient {
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Insert or update a badge */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Badges/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Recalculates badge earnings */
    RecalculateEarnedBadge(badgeId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Badges/RecalculateEarnedBadge';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Lists Badges by Medallion */
    ListBadgesByMedallion(medallionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Badges/ListBadgesByMedallion';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of lessons based on the question */
    ListLessons(badgeId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/ListLessons';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows bulk updating of all lessons associated with the question. */
    UpdateLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Badges/UpdateLessons';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a display image for a badge */
    AddImageResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Badges/AddImageResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes a products associated product image */
    RemoveImageResource(BadgeId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/RemoveImageResource';
        let params = this.newParams();
        if (BadgeId != null)
            params = params.append('BadgeId', BadgeId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Downloads the badge image if any */
    DownloadImage(BadgeId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/DownloadImage';
        let params = this.newParams();
        if (BadgeId != null)
            params = params.append('BadgeId', BadgeId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets an achievement assessment based on badge */
    GetAchievementAssessment(userId, badgeId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/GetAchievementAssessment';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the badge learning path
            
Not supplying a discipline or medallion id shows all related badges to users selected disciplines. */
    GetLearningPath(userId, badgeId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/GetLearningPath';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of the existing translations */
    GetTranslations(badgeId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/GetTranslations';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get the specified translation */
    GetTranslation(badgeId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/GetTranslation';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Badges/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes a translation */
    DeleteTranslation(badgeId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/DeleteTranslation';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists the syndication providers for the given badge */
    ListSyndicationProviders(badgeId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/ListSyndicationProviders';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        return this.GetPageable(requestPath, params, willHandleError);
    }
    /** Updates the badge's syndication providers */
    UpdateSyndicationProviders(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Badges/UpdateSyndicationProviders';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the header lessons for the given badge */
    ListHeaderLessons(badgeId, body = null, willHandleError = false) {
        let requestPath = '/v1/Badges/ListHeaderLessons';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the badge's header lessons */
    UpdateHeaderLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Badges/UpdateHeaderLessons';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the available lessons for a badge */
    ListAvailableLessons(badgeId, body = null, willHandleError = false) {
        let requestPath = '/v1/Badges/ListAvailableLessons';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Delete */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Delete by Ids */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** List badge groups */
    ListGroups(badgeId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/ListGroups';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update Badge Groups */
    UpdateGroups(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Badges/UpdateGroups';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Copies a Badge to a New Organization */
    CopyBadgeToOrganization(badgeId, medallionId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Badges/CopyBadgeToOrganization';
        let params = this.newParams();
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Badges/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
BadgesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BadgesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
BadgesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BadgesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BadgesV1Client, decorators: [{
            type: Injectable
        }] });
class BotV1Client extends BaseClient {
    /** Get A Conversation by Id */
    GetConversation(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Bot/GetConversation';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists the conversations based on the criteria passed. */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Bot/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Completes a given conversation by Id */
    Complete(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Bot/Complete';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Adds a message to a conversation or creates a new one if the Id is null */
    Add(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Bot/Add';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
}
BotV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BotV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
BotV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BotV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: BotV1Client, decorators: [{
            type: Injectable
        }] });
class CampaignDripsV1Client extends BaseClient {
    /** Drip Override for Partners */
    UpdateOverrideDrip(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/CampaignDrips/UpdateOverrideDrip';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists campaign Drips */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/CampaignDrips/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Get the campaign drip dto */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/CampaignDrips/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Sends a test email (Without merge field) to a specified email */
    SendTest(dripId, email, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/CampaignDrips/SendTest';
        let params = this.newParams();
        if (dripId != null)
            params = params.append('dripId', dripId.toString());
        if (email != null)
            params = params.append('email', email.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Insert or update a campaign drips */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/CampaignDrips/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed campaign drips */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/CampaignDrips/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the campaign drips by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/CampaignDrips/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
CampaignDripsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CampaignDripsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
CampaignDripsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CampaignDripsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CampaignDripsV1Client, decorators: [{
            type: Injectable
        }] });
class CampaignsV1Client extends BaseClient {
    /** Lists Subscriptions for the given campaign */
    ListSubscriptions(campaignId, body = null, willHandleError = false) {
        let requestPath = '/v1/Campaigns/ListSubscriptions';
        let params = this.newParams();
        if (campaignId != null)
            params = params.append('campaignId', campaignId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the Campaign's Subscriptions */
    UpdateSubscriptions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Campaigns/UpdateSubscriptions';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the specified Campaign */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Campaigns/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists the campaign drips */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Campaigns/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Insert or update a campaigns */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Campaigns/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed campaigns */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Campaigns/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the campaigns by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Campaigns/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
CampaignsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CampaignsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
CampaignsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CampaignsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CampaignsV1Client, decorators: [{
            type: Injectable
        }] });
class CoursesV1Client extends BaseClient {
    /** Adds a resource to a course. */
    AddResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/AddResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes the selected resource from a course. If the resource is no longer associated with anything the resource will be completely removed. */
    RemoveResource(CourseId, ResourceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/RemoveResource';
        let params = this.newParams();
        if (CourseId != null)
            params = params.append('CourseId', CourseId.toString());
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns the resources (downloads etc.) associated with the specified course */
    ListResourcesByType(CourseId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/ListResourcesByType';
        let params = this.newParams();
        if (CourseId != null)
            params = params.append('CourseId', CourseId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the resources associated with the specified course */
    ListResources(CourseId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/ListResources';
        let params = this.newParams();
        if (CourseId != null)
            params = params.append('CourseId', CourseId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the status of an item and if necessary creates a new item and returns the updated item to replace. */
    SetEditingStatus(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/SetEditingStatus';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the information about the current course and where it is in the workflow. If it isn't in the workflow then it puts it at stage 2 for triage by default. */
    GetWorkflowStatus(courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetWorkflowStatus';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified course's workflow step and based on that will execute specific functions. */
    UpdateWorkflowStep(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateWorkflowStep';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the course workflow task */
    UpdateWorkflowTask(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateWorkflowTask';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns all workflow assignees to the Course. */
    ListAssignees(courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/ListAssignees';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the workflow assignments for a given course */
    UpdateAssignees(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateAssignees';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List items by course id */
    ListItemsByCourseId(courseId, organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListItemsByCourseId';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns the course with user information */
    GetWithUserInfo(courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetWithUserInfo';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Delete the specified translation */
    DeleteTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/DeleteTranslation';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists lesson with questions */
    ListLessonQuestions(courseId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListLessonQuestions';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Edit Version Plan */
    EditVersionPlan(courseId, versionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/EditVersionPlan';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Creates a new course from the existing course */
    CreateCourse(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/CreateCourse';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Imports the specified items from the selected course structure into the specified destination. */
    ImportCourse(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/ImportCourse';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deactivates a course and all sub content if not attached to other active items */
    DeactivateCourse(courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/DeactivateCourse';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of all lessons on the course */
    ListLessonsByCourse(courseId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListLessonsByCourse';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of all lessons on the course filtered by version */
    ListLessonsByCourseAndVersion(courseId, versionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListLessonsByCourseAndVersion';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Edit Introduction */
    EditIntroduction(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/EditIntroduction';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Edit Conclusion */
    EditConclusion(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/EditConclusion';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the full course details for editing */
    GetAdmin(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetAdmin';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Adds a new lesson to the existing topic. */
    CreateTopic(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/CreateTopic';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a new lesson to the existing topic. */
    CreateLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/CreateLesson';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns all of the topics for a given course that are syndicated for your organization */
    ListTopicsWithSyndicatedContent(courseId, organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListTopicsWithSyndicatedContent';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists the syndications for the given course */
    ListSyndications(courseId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListSyndications';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the topic's syndications */
    UpdateSyndications(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateSyndications';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the syndication providers for the given course */
    ListSyndicationProviders(courseId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListSyndicationProviders';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the course's syndication providers */
    UpdateSyndicationProviders(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateSyndicationProviders';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns changes to the given course over time */
    GetCourseFeed(courseId, portalUrl, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetCourseFeed';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (portalUrl != null)
            params = params.append('portalUrl', portalUrl.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the course path information */
    UpdateCoursePath(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateCoursePath';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the path information for the specified course */
    GetCoursePaths(courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetCoursePaths';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Update Organizations on the course */
    UpdateOrganizations(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateOrganizations';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Update Public Videos on the course */
    UpsertPublicVideos(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpsertPublicVideos';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all organizations assigned to the current course. */
    ListOrganizations(courseId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListOrganizations';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the products and versions on the course */
    UpdateProductVersions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateProductVersions';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets all of the products and versions associated with the given course */
    ListProductVersions(courseId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListProductVersions';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Creates a custom course for the current organization */
    CreateCustomCourse(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/CreateCustomCourse';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all courses for the given product with list of versions */
    ListCoursesByProductId(productId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListCoursesByProductId';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists all Courses grouped by Product */
    ListCoursesByProducts(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/ListCoursesByProducts';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets the course with public details with the specified language code */
    GetWithTranslation(courseId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetWithTranslation';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** List the course structure including resources etc. attached directly to the structure with the current user's ratings and percent complete etc. */
    GetStructureWithUserInfo(courseId, languageCode, versionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetStructureWithUserInfo';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of the entire structure of the course by the id. */
    GetStructurePublic(courseId, versionId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetStructurePublic';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists all courses that are custom for the current organization of the current user AND do not have products assigned. */
    ListCustomCourses(body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListCustomCourses';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns the course structure for editing purposes. */
    GetStructureForEditing(courseId, productId, versionId, showOnlyCadlearningVersions, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetStructureForEditing';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (showOnlyCadlearningVersions != null)
            params = params.append('showOnlyCadlearningVersions', showOnlyCadlearningVersions.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the specified course's structure with any changes from the user. All items must be included. */
    UpdateCustomCourseStructure(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateCustomCourseStructure';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get SCORM Package */
    GetSCORMPackage(productId, versionId, courseId, portalUrl, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/GetSCORMPackage';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (portalUrl != null)
            params = params.append('portalUrl', portalUrl.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists all courses that are custom for the current organization of the current user AND do not have products assigned. */
    ListManageableCustomCourses(body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListManageableCustomCourses';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Insert or update a course */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed courses */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the courses by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns courses by owner id with lesson completion percentage */
    ListCoursesByOwner(ownerId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListCoursesByOwner';
        let params = this.newParams();
        if (ownerId != null)
            params = params.append('ownerId', ownerId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns courses by external partner id with lesson completion percentage */
    ListCoursesByExternalPartner(partnerId, body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/ListCoursesByExternalPartner';
        let params = this.newParams();
        if (partnerId != null)
            params = params.append('partnerId', partnerId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets course work for hire dashboard */
    CourseForHireDashboard(body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/CourseForHireDashboard';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Publish Course */
    PublishCourse(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/PublishCourse';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the tasks in Jira related to the course */
    ListProjectManagementTasks(CourseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/ListProjectManagementTasks';
        let params = this.newParams();
        if (CourseId != null)
            params = params.append('CourseId', CourseId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Edit Body */
    EditRawAssets(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/EditRawAssets';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** List course groups */
    ListGroups(courseId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/ListGroups';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update Course Groups */
    UpdateGroups(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Courses/UpdateGroups';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Courses/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Courses/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
CoursesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CoursesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
CoursesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CoursesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: CoursesV1Client, decorators: [{
            type: Injectable
        }] });
class DisciplinesV1Client extends BaseClient {
    /** Lists all available roles */
    AdminList(body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/AdminList';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Recalculates discipline earnings */
    RecalculateEarnedDiscipline(disciplineId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/RecalculateEarnedDiscipline';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the given goals */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the given goals by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets owned goals */
    GetOwned(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/GetOwned';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists Owned Goals */
    ListOwned(body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/ListOwned';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Insert or update a discipline */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists Disciplines with Display Images */
    ListWithDisplayImages(body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/ListWithDisplayImages';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists Disciplines with Products and Display Images */
    ListWithProducts(body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/ListWithProducts';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists Disciplines with Products and Display Images by Industry Id */
    ListWithProductsByIndustry(industryId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/ListWithProductsByIndustry';
        let params = this.newParams();
        if (industryId != null)
            params = params.append('industryId', industryId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List associated medallions */
    ListMedallions(disciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/ListMedallions';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows bulk updating of all medallions associated with the discipline. */
    UpdateMedallions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpdateMedallions';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List associated industries */
    ListIndustries(disciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/ListIndustries';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates Industries on a Goal */
    UpdateIndustries(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpdateIndustries';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of lessons based on the question */
    ListOrganizations(disciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/ListOrganizations';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows bulk updating of all lessons associated with the question. */
    UpdateOrganizations(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpdateOrganizations';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Downloads the Discipline image if any */
    DownloadImage(DisciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/DownloadImage';
        let params = this.newParams();
        if (DisciplineId != null)
            params = params.append('DisciplineId', DisciplineId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Adds a display image for a badge */
    AddImageResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/AddImageResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes a products associated product image */
    RemoveImageResource(DisciplineId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/RemoveImageResource';
        let params = this.newParams();
        if (DisciplineId != null)
            params = params.append('DisciplineId', DisciplineId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** List Discipline Products */
    ListProducts(disciplineId, body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/ListProducts';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the specified Discipline's Products. */
    UpdateProducts(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpdateProducts';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets an achievement assessment based on discipline */
    GetAchievementAssessment(userId, disciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/GetAchievementAssessment';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the discipline learning path in the form of a Discipline first tree */
    GetLearningPath(userId, disciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/GetLearningPath';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the discipline certificate information */
    GetCertificateInfo(userId, disciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/GetCertificateInfo';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Update Public Videos on the Discipline */
    UpsertPublicVideos(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpsertPublicVideos';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of the existing translations */
    GetTranslations(disciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/GetTranslations';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get the specified translation */
    GetTranslation(disciplineId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/GetTranslation';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes a translation */
    DeleteTranslation(disciplineId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/DeleteTranslation';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists the syndication providers for the given discipline */
    ListSyndicationProviders(disciplineId, body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/ListSyndicationProviders';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the discipline's syndication providers */
    UpdateSyndicationProviders(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpdateSyndicationProviders';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the header lessons for the given discipline */
    ListHeaderLessons(disciplineId, body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/ListHeaderLessons';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the discipline's header lessons */
    UpdateHeaderLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpdateHeaderLessons';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the available lessons for a discipline */
    ListAvailableLessons(disciplineId, body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/ListAvailableLessons';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists disciplines by product version */
    ListDisciplinesByProductVersion(productId, versionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/ListDisciplinesByProductVersion';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets the goal structure for editing */
    GetDisciplineStructureForEditing(disciplineId, sourceProductId, sourceVersionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/GetDisciplineStructureForEditing';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        if (sourceProductId != null)
            params = params.append('sourceProductId', sourceProductId.toString());
        if (sourceVersionId != null)
            params = params.append('sourceVersionId', sourceVersionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Saves a set of discipline, medallions, badges with their children */
    SaveDisciplineStructure(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/SaveDisciplineStructure';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List discipline groups */
    ListGroups(disciplineId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Disciplines/ListGroups';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update Discipline Groups */
    UpdateGroups(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Disciplines/UpdateGroups';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Disciplines/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
DisciplinesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DisciplinesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
DisciplinesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DisciplinesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DisciplinesV1Client, decorators: [{
            type: Injectable
        }] });
class DocumentsV1Client extends BaseClient {
    /** Lists documents by category */
    ListByCategory(categoryId, body = null, willHandleError = false) {
        let requestPath = '/v1/Documents/ListByCategory';
        let params = this.newParams();
        if (categoryId != null)
            params = params.append('categoryId', categoryId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists the document categories in the system */
    ListDocumentCategories(body = null, willHandleError = false) {
        let requestPath = '/v1/Documents/ListDocumentCategories';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or updates a single document category */
    InsertOrUpdateDocumentCategory(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Documents/InsertOrUpdateDocumentCategory';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the systems document categories */
    UpdateDocumentCategories(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Documents/UpdateDocumentCategories';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a document category */
    GetDocumentCategory(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Documents/GetDocumentCategory';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Deletes a document category */
    DeleteDocumentCategory(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Documents/DeleteDocumentCategory';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** List Document Links */
    ListDocumentLinks(documentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Documents/ListDocumentLinks';
        let params = this.newParams();
        if (documentId != null)
            params = params.append('documentId', documentId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update Document Links */
    UpdateDocumentLinks(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Documents/UpdateDocumentLinks';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Uploads a new document */
    UploadDocument(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Documents/UploadDocument';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Gets a document access token so that the document may be downloaded. */
    DownloadDocument(DocumentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Documents/DownloadDocument';
        let params = this.newParams();
        if (DocumentId != null)
            params = params.append('DocumentId', DocumentId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets a list of documents, grouped by category, by the organization id */
    ListDocumentsByOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Documents/ListDocumentsByOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Insert or update a documents */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Documents/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed documents */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Documents/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the documents by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Documents/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Documents/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Documents/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
DocumentsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DocumentsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
DocumentsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DocumentsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DocumentsV1Client, decorators: [{
            type: Injectable
        }] });
class DomainsV1Client extends BaseClient {
    /** Updates the auth methods for the given domain. Should include all valid auth methods */
    UpdateAuthMethods(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Domains/UpdateAuthMethods';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Delete by Ids */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Domains/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Uploads the specified stylesheet to azure */
    UploadStyleSheet(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Domains/UploadStyleSheet';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** GetDomainStyleSheet */
    GetStyleSheet(DomainId, FallbackUrl, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Domains/GetStyleSheet';
        let params = this.newParams();
        if (DomainId != null)
            params = params.append('DomainId', DomainId.toString());
        if (FallbackUrl != null)
            params = params.append('FallbackUrl', FallbackUrl.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Get Domain By Email Address */
    GetDomainByEmailAddress(emailAddress, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Domains/GetDomainByEmailAddress';
        let params = this.newParams();
        if (emailAddress != null)
            params = params.append('emailAddress', emailAddress.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the information for the domain by the site's Url */
    GetDomainWithAuthMethodsByUrl(siteUrl, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Domains/GetDomainWithAuthMethodsByUrl';
        let params = this.newParams();
        if (siteUrl != null)
            params = params.append('siteUrl', siteUrl.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** List auth methods by Domain Id */
    ListAuthMethodsByDomainId(domainId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Domains/ListAuthMethodsByDomainId';
        let params = this.newParams();
        if (domainId != null)
            params = params.append('domainId', domainId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List auth methods by Domain Id */
    ListAuthMethodsByDomainIdAdmin(domainId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Domains/ListAuthMethodsByDomainIdAdmin';
        let params = this.newParams();
        if (domainId != null)
            params = params.append('domainId', domainId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Domains/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Domains/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Domains/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Domains/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
DomainsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DomainsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
DomainsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DomainsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: DomainsV1Client, decorators: [{
            type: Injectable
        }] });
class EntitlementsV1Client extends BaseClient {
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Entitlements/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the payment history for the given entitlement */
    ListPaymentHistory(entitlementId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Entitlements/ListPaymentHistory';
        let params = this.newParams();
        if (entitlementId != null)
            params = params.append('entitlementId', entitlementId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists entitlements for organization tools */
    ListOrgToolSubscriptionsByOrganizationId(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Entitlements/ListOrgToolSubscriptionsByOrganizationId';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Renews a subscription */
    RenewSubscription(entitlementId, billingAddressId, paymentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Entitlements/RenewSubscription';
        let params = this.newParams();
        if (entitlementId != null)
            params = params.append('entitlementId', entitlementId.toString());
        if (billingAddressId != null)
            params = params.append('billingAddressId', billingAddressId.toString());
        if (paymentId != null)
            params = params.append('paymentId', paymentId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Renews a subscription */
    RenewPartnerSubscription(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Entitlements/RenewPartnerSubscription';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Purchase a new subscription for a user or organization */
    PurchaseSubscription(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Entitlements/PurchaseSubscription';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns all entitlements for the given user. */
    ListByUserId(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Entitlements/ListByUserId';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists all entitlements for the given organization. */
    ListByOrganizationId(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Entitlements/ListByOrganizationId';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Cancels the specified entitlement */
    CancelEntitlement(entitlementId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Entitlements/CancelEntitlement';
        let params = this.newParams();
        if (entitlementId != null)
            params = params.append('entitlementId', entitlementId.toString());
        return this.PutOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Updates the entitlement's payment details. */
    UpdateEntitlementPaymentDetails(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Entitlements/UpdateEntitlementPaymentDetails';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates all of the user assignments on Organization entitlements */
    UpdateOrganizationEntitlementUsers(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Entitlements/UpdateOrganizationEntitlementUsers';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates all of the user assignments on Organization entitlements */
    BulkCreateEntitlements(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Entitlements/BulkCreateEntitlements';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Entitlements/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Entitlements/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Entitlements/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Entitlements/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
EntitlementsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: EntitlementsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
EntitlementsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: EntitlementsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: EntitlementsV1Client, decorators: [{
            type: Injectable
        }] });
class IndustriesV1Client extends BaseClient {
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Industries/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Insert or update a badge */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Industries/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Delete */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Industries/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Delete by Ids */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Industries/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Industries/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
IndustriesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: IndustriesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
IndustriesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: IndustriesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: IndustriesV1Client, decorators: [{
            type: Injectable
        }] });
class InventoryV1Client extends BaseClient {
    /** Updates Inventory Items on inventory */
    UpdateItems(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Inventory/UpdateItems';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets an Inventory item by Sku. */
    GetBySku(sku, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Inventory/GetBySku';
        let params = this.newParams();
        if (sku != null)
            params = params.append('sku', sku.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists inventory items based on the inventory id */
    ListItems(inventoryId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Inventory/ListItems';
        let params = this.newParams();
        if (inventoryId != null)
            params = params.append('inventoryId', inventoryId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the inventory item with price by sku with optional partner Id to get the right pricing */
    GetWithPriceBySku(sku, partnerId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Inventory/GetWithPriceBySku';
        let params = this.newParams();
        if (sku != null)
            params = params.append('sku', sku.toString());
        if (partnerId != null)
            params = params.append('partnerId', partnerId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of Web products */
    ListWebProducts(subscriptionsOnly, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Inventory/ListWebProducts';
        let params = this.newParams();
        if (subscriptionsOnly != null)
            params = params.append('subscriptionsOnly', subscriptionsOnly.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of web SKUs by the course id */
    ListWebSkusByCourse(courseId, partnerId, body = null, willHandleError = false) {
        let requestPath = '/v1/Inventory/ListWebSkusByCourse';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        if (partnerId != null)
            params = params.append('partnerId', partnerId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Insert or update a inventory */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Inventory/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed inventory */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Inventory/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the inventory by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Inventory/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Inventory/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Inventory/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
InventoryV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: InventoryV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
InventoryV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: InventoryV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: InventoryV1Client, decorators: [{
            type: Injectable
        }] });
class InvoicesV1Client extends BaseClient {
    /** Calculate Sales Tax on the given request */
    RequestSalesTaxes(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/RequestSalesTaxes';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Calculate Sales Tax on the given invoice */
    CalculateTaxes(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/CalculateTaxes';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Accept a quote */
    CopyQuote(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/CopyQuote';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Voids a payment within the system and automatically updates balances on invoices etc.
This does not reverse entitlements etc. at this time. */
    VoidPayment(paymentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/VoidPayment';
        let params = this.newParams();
        if (paymentId != null)
            params = params.append('paymentId', paymentId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Marks the invoice as shipped */
    ShipInvoice(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/ShipInvoice';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Unlocks an invoice that has not yet received payment but was locked to allow for payment. */
    UnlockInvoice(invoiceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/UnlockInvoice';
        let params = this.newParams();
        if (invoiceId != null)
            params = params.append('invoiceId', invoiceId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lock the invoice and prepare it to accept a payment */
    LockInvoiceForPayment(invoiceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/LockInvoiceForPayment';
        let params = this.newParams();
        if (invoiceId != null)
            params = params.append('invoiceId', invoiceId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Completes the specified invoice posting it and creating entitlements etc. from it. */
    CompleteInvoice(invoiceId, sendToCustomer, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/CompleteInvoice';
        let params = this.newParams();
        if (invoiceId != null)
            params = params.append('invoiceId', invoiceId.toString());
        if (sendToCustomer != null)
            params = params.append('sendToCustomer', sendToCustomer.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Posts the payment to the specified invoices */
    PostPaymentToInvoice(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/PostPaymentToInvoice';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the stored credentials for the given contact */
    ListStoredPaymentCredentials(contactId, type, body = null, willHandleError = false) {
        let requestPath = '/v1/Invoices/ListStoredPaymentCredentials';
        let params = this.newParams();
        if (contactId != null)
            params = params.append('contactId', contactId.toString());
        if (type != null)
            params = params.append('type', type.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists quotes by requesting organization */
    ListQuotesByOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/ListQuotesByOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists the bills from organization */
    ListBillsByOrganizationId(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/ListBillsByOrganizationId';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists invoices by the Identity */
    ListByUserId(userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Invoices/ListByUserId';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists quotes by requesting organization */
    ListRfqsByDeal(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/ListRfqsByDeal';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists invoices by organization */
    ListByOrganizationId(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Invoices/ListByOrganizationId';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Accept a quote */
    AcceptQuote(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/AcceptQuote';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Accept a quote */
    RejectQuote(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/RejectQuote';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a displayable list of invoices */
    ListForDisplay(body = null, willHandleError = false) {
        let requestPath = '/v1/Invoices/ListForDisplay';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a displayable version of the specified invoice */
    GetForDisplay(invoiceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/GetForDisplay';
        let params = this.newParams();
        if (invoiceId != null)
            params = params.append('invoiceId', invoiceId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Submits a quote to sales */
    SubmitQuote(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/SubmitQuote';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the inventory for the given invoice */
    UpdateInventory(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/UpdateInventory';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists a set of quotes by the parent request for a quote */
    ListQuotesByRFQ(rfqId, body = null, willHandleError = false) {
        let requestPath = '/v1/Invoices/ListQuotesByRFQ';
        let params = this.newParams();
        if (rfqId != null)
            params = params.append('rfqId', rfqId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns the price for the given inventory number between the two parties */
    GetInventoryItemPrice(fromContactId, toContactId, toContactType, inventoryId, units, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/GetInventoryItemPrice';
        let params = this.newParams();
        if (fromContactId != null)
            params = params.append('fromContactId', fromContactId.toString());
        if (toContactId != null)
            params = params.append('toContactId', toContactId.toString());
        if (toContactType != null)
            params = params.append('toContactType', toContactType.toString());
        if (inventoryId != null)
            params = params.append('inventoryId', inventoryId.toString());
        if (units != null)
            params = params.append('units', units.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Allows the customer to dispute the invoice */
    DisputeInvoice(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/DisputeInvoice';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all of the inventory items on the invoice specified. */
    ListInventory(invoiceId, body = null, willHandleError = false) {
        let requestPath = '/v1/Invoices/ListInventory';
        let params = this.newParams();
        if (invoiceId != null)
            params = params.append('invoiceId', invoiceId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** List all payments for the given invoice */
    ListPayments(invoiceId, body = null, willHandleError = false) {
        let requestPath = '/v1/Invoices/ListPayments';
        let params = this.newParams();
        if (invoiceId != null)
            params = params.append('invoiceId', invoiceId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Insert or update a invoices */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Invoices/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed invoices */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the invoices by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Invoices/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Invoices/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
InvoicesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: InvoicesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
InvoicesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: InvoicesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: InvoicesV1Client, decorators: [{
            type: Injectable
        }] });
class JobsV1Client extends BaseClient {
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists the available products for the given job based on the products assigned to the disciplines on the role. */
    ListAvailableProductsAndVersions(jobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/ListAvailableProductsAndVersions';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Insert or update a job */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the job learning path in the form of a job first tree */
    GetLearningPath(userId, jobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/GetLearningPath';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of jobs with the ids of the included discipline */
    ListJobsWithDisciplineIds(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/ListJobsWithDisciplineIds';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List Products by JobId(s) */
    ListJobsWithProducts(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/ListJobsWithProducts';
        let params = this.newParams();
        return this.GetPageable(requestPath, params, willHandleError);
    }
    /** List Products by JobId(s) */
    ListProducts(jobIds, body = null, willHandleError = false) {
        let requestPath = '/v1/Jobs/ListProducts';
        let params = this.newParams();
        if (jobIds != null)
            jobIds.forEach(p => params = params.append('jobIds', p.toString()));
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the specified Discipline's Products. */
    UpdateProducts(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpdateProducts';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List associated industries */
    ListIndustries(jobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/ListIndustries';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the specified Discipline's Products. */
    UpdateIndustries(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpdateIndustries';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of lessons based on the question */
    ListOrganizations(jobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/ListOrganizations';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows bulk updating of all organizations associated with the job. */
    UpdateOrganizations(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpdateOrganizations';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the given roles */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the given role by id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists all available roles */
    AdminList(body = null, willHandleError = false) {
        let requestPath = '/v1/Jobs/AdminList';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** List associated Disciplines */
    ListDisciplines(jobId, body = null, willHandleError = false) {
        let requestPath = '/v1/Jobs/ListDisciplines';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Allows bulk updating of all disciplines associated with the job. */
    UpdateDisciplines(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpdateDisciplines';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Update Public Videos on the Job */
    UpsertPublicVideos(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpsertPublicVideos';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Recalculates job earnings */
    RecalculateEarnedJob(jobId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/RecalculateEarnedJob';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Adds a display image for a badge */
    AddImageResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/AddImageResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes a job's associated product image */
    RemoveImageResource(JobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/RemoveImageResource';
        let params = this.newParams();
        if (JobId != null)
            params = params.append('JobId', JobId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Downloads the job image if any */
    DownloadImage(JobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/DownloadImage';
        let params = this.newParams();
        if (JobId != null)
            params = params.append('JobId', JobId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets an achievement assessment based on job */
    GetAchievementAssessment(userId, jobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/GetAchievementAssessment';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of the existing translations */
    GetTranslations(jobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/GetTranslations';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get the specified translation */
    GetTranslation(jobId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/GetTranslation';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes a translation */
    DeleteTranslation(jobId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/DeleteTranslation';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists the syndication providers for the given job */
    ListSyndicationProviders(jobId, body = null, willHandleError = false) {
        let requestPath = '/v1/Jobs/ListSyndicationProviders';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the job's syndication providers */
    UpdateSyndicationProviders(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpdateSyndicationProviders';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the header lessons for the given job */
    ListHeaderLessons(jobId, body = null, willHandleError = false) {
        let requestPath = '/v1/Jobs/ListHeaderLessons';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the job's header lessons */
    UpdateHeaderLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpdateHeaderLessons';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the available lessons for a job */
    ListAvailableLessons(jobId, body = null, willHandleError = false) {
        let requestPath = '/v1/Jobs/ListAvailableLessons';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** List job groups */
    ListGroups(jobId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Jobs/ListGroups';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update Job Groups */
    UpdateGroups(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Jobs/UpdateGroups';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Jobs/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
JobsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: JobsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
JobsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: JobsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: JobsV1Client, decorators: [{
            type: Injectable
        }] });
class LessonsV1Client extends BaseClient {
    /** Lists the tasks in Jira related to the lesson */
    ListProjectManagementTasks(LessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListProjectManagementTasks';
        let params = this.newParams();
        if (LessonId != null)
            params = params.append('LessonId', LessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Completes the lesson dependency task in Project Management for a lesson */
    CompleteLessonProjectManagementDependencies(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/CompleteLessonProjectManagementDependencies';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Completes the lesson commands task in Jira for a lesson */
    JiraCompleteLessonCommands(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/JiraCompleteLessonCommands';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Completes the lesson questions task in Jira for a lesson */
    JiraCompleteLessonQuestions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/JiraCompleteLessonQuestions';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Completes the lesson resources task in Jira for a lesson */
    JiraCompleteLessonResources(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/JiraCompleteLessonResources';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Searches Project Management Issues */
    SearchProjectManagementIssues(SearchKeywords, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/SearchProjectManagementIssues';
        let params = this.newParams();
        if (SearchKeywords != null)
            params = params.append('SearchKeywords', SearchKeywords.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Adds a resource to a lesson. This should post a MultiPartForm that includes all of the resource properties AND the file as a stream. */
    AddResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/AddResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes the selected resource from a lesson. If the resource is no longer associated with anything the resource will be completely removed. */
    RemoveResource(LessonId, ResourceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/RemoveResource';
        let params = this.newParams();
        if (LessonId != null)
            params = params.append('LessonId', LessonId.toString());
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns the resources (downloads etc.) associated with the specified lesson */
    ListResourcesByType(LessonId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListResourcesByType';
        let params = this.newParams();
        if (LessonId != null)
            params = params.append('LessonId', LessonId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the resources (downloads etc.) associated with the specified lesson */
    ListResources(LessonId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListResources';
        let params = this.newParams();
        if (LessonId != null)
            params = params.append('LessonId', LessonId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the specified lesson's workflow step and based on that will execute specific functions. */
    UpdateWorkflowStep(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateWorkflowStep';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Approves work for hire step */
    ApproveWorkflowStep(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/ApproveWorkflowStep';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Approves work for hire step */
    RejectWorkflowStep(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/RejectWorkflowStep';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the information about the current lesson and where it is in the workflow. If it isn't in the workflow then it puts it at stage 2 for triage by default. */
    GetWorkflowStatus(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetWorkflowStatus';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the lesson workflow task */
    UpdateWorkflowTask(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateWorkflowTask';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns all workflow assignees to the Lesson. */
    ListAssignees(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListAssignees';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the workflow assignments for a given course */
    UpdateAssignees(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateAssignees';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Sets the current user's rating of the selected lesson. */
    SetCurrentUserRating(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/SetCurrentUserRating';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Get the script/narration for the lesson */
    GetLessonScript(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetLessonScript';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the next and previous lessons based on the current lesson and course */
    GetNextAndPreviousLessons(lessonId, courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetNextAndPreviousLessons';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the next and previous lessons based on the current lesson and goal */
    GetNextAndPreviousLessonsByGoal(lessonId, goalId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetNextAndPreviousLessonsByGoal';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        if (goalId != null)
            params = params.append('goalId', goalId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the next and previous lessons based on the current lesson and playlist */
    GetNextAndPreviousLessonsByPlaylist(lessonId, playListId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetNextAndPreviousLessonsByPlaylist';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        if (playListId != null)
            params = params.append('playListId', playListId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of courses that are associated with the lesson */
    GetLessonCoursesList(lessonId, body = null, willHandleError = false) {
        let requestPath = '/v1/Lessons/GetLessonCoursesList';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Forces a reload from documentProvider of the contents of the lesson */
    ForceReloadBody(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ForceReloadBody';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Edit Body */
    EditBody(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/EditBody';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Edit Body */
    EditRawAssets(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/EditRawAssets';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Edit Body */
    GetRawAssetFiles(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetRawAssetFiles';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets possible lesson versions based on its attached courses */
    GetPossibleLessonVersions(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetPossibleLessonVersions';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List Labels */
    ListLabels(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListLabels';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists all available lesson labels */
    ListAllLabels(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListAllLabels';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates lesson Labels */
    UpdateLabels(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateLabels';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List Labels */
    ListDependencies(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListDependencies';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates lesson Labels */
    UpdateDependencies(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateDependencies';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Removes a lesson from production and allows editing. Means that it will not show up anywhere until it is completed. */
    RemoveFromProduction(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/RemoveFromProduction';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get Admin version of the Lesson */
    GetAdmin(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetAdmin';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of the existing translations */
    GetTranslations(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetTranslations';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get the specified translation */
    GetTranslation(lessonId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetTranslation';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes a translation */
    DeleteTranslation(lessonId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/DeleteTranslation';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Copies a lesson that is in a course and adds it immediately after that lesson, setting the status to the first step of the workflow and flagged as orange. */
    CopyLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/CopyLesson';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all lessons with course information and can be filtered using oData. */
    ListLessonsWithCourses(body = null, willHandleError = false) {
        let requestPath = '/v1/Lessons/ListLessonsWithCourses';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists the syndications for the given lesson */
    ListSyndications(lessonId, body = null, willHandleError = false) {
        let requestPath = '/v1/Lessons/ListSyndications';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the topic's syndications */
    UpdateSyndications(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateSyndications';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the syndication providers for the given lesson */
    ListSyndicationProviders(lessonId, body = null, willHandleError = false) {
        let requestPath = '/v1/Lessons/ListSyndicationProviders';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the topic's syndication providers */
    UpdateSyndicationProviders(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateSyndicationProviders';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Update Public Videos on the lesson */
    UpsertPublicVideos(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpsertPublicVideos';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all lessons with course information by a requested assessment id */
    ListLessonsWithCoursesForAssessment(assessmentId, nameFilter, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListLessonsWithCoursesForAssessment';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        if (nameFilter != null)
            params = params.append('nameFilter', nameFilter.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets all of the products and versions associated with the given lesson */
    ListProductVersions(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListProductVersions';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Creates a custom lesson under the specified parent. */
    CreateCustomLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/CreateCustomLesson';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the products and versions on the lesson */
    UpdateProductVersions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateProductVersions';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the commands on a lesson */
    ListCommands(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListCommands';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists possible commands that can be attached to a lesson */
    ListPossibleLessonCommands(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListPossibleLessonCommands';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the commands on a lesson */
    UpdateCommands(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateCommands';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Logs the view of a lesson by the current user */
    LogLessonView(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/LogLessonView';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get the promo video for the given lesson and language */
    GetPromoVideoUri(lessonId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetPromoVideoUri';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of videos for the specified lesson. */
    GetLessonVideos(lessonId, courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetLessonVideos';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a single organization lesson note */
    GetOrganizationNote(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetOrganizationNote';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates organization lesson notes for an org */
    UpdateOrganizationNotes(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/UpdateOrganizationNotes';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the full lesson with user statistics */
    GetLessonDetailsWithUserInfo(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetLessonDetailsWithUserInfo';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the public content for the lesson details. */
    GetLessonPublicDetails(lessonId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetLessonPublicDetails';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the associated workflows with the lesson */
    GetLessonWorkflows(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetLessonWorkflows';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Saves a lesson override thumbnail with the specified resource */
    SaveLessonOverrideThumbnail(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/SaveLessonOverrideThumbnail';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Publish Lesson */
    PublishLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/PublishLesson';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a lessons publication status
<param name="command" /><param name="cancellationToken" /> */
    GetPublicationStatus(LessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/GetPublicationStatus';
        let params = this.newParams();
        if (LessonId != null)
            params = params.append('LessonId', LessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists badges of the lesson */
    ListBadges(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListBadges';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists medallions of the lesson */
    ListMedallions(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListMedallions';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists disciplines of the lesson */
    ListDisciplines(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListDisciplines';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists jobs of the lesson */
    ListJobs(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/ListJobs';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Completes the lesson resources task in Jira for a lesson */
    ViewedInProduction(lessonId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/ViewedInProduction';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Insert or update one or more lessons */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Lessons/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed lessons */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the lessons by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Lessons/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Lessons/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
LessonsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: LessonsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
LessonsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: LessonsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: LessonsV1Client, decorators: [{
            type: Injectable
        }] });
class MedallionsV1Client extends BaseClient {
    /** Deletes the given medallions */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the given medallions by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Insert or update a medallion */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Medallions/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists Badges by Medallion */
    ListBadges(medallionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Medallions/ListBadges';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Allows bulk updating of all badges associated with the medallion. */
    UpdateBadges(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Medallions/UpdateBadges';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Recalculates discipline earnings */
    RecalculateEarnedMedallion(medallionId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Medallions/RecalculateEarnedMedallion';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Adds a display image for a medallion. */
    AddImageResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Medallions/AddImageResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes a products associated product image */
    RemoveImageResource(MedallionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/RemoveImageResource';
        let params = this.newParams();
        if (MedallionId != null)
            params = params.append('MedallionId', MedallionId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Downloads the medallion image if any */
    DownloadImage(MedallionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/DownloadImage';
        let params = this.newParams();
        if (MedallionId != null)
            params = params.append('MedallionId', MedallionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets an achievement assessment based on medallion */
    GetAchievementAssessment(userId, medallionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/GetAchievementAssessment';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the medallion learning path in the form of a Medallion first tree */
    GetLearningPath(userId, medallionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/GetLearningPath';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of the existing translations */
    GetTranslations(medallionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/GetTranslations';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get the specified translation */
    GetTranslation(medallionId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/GetTranslation';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Medallions/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes a translation */
    DeleteTranslation(medallionId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/DeleteTranslation';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists the syndication providers for the given medallion */
    ListSyndicationProviders(medallionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Medallions/ListSyndicationProviders';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the medallion's syndication providers */
    UpdateSyndicationProviders(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Medallions/UpdateSyndicationProviders';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the header lessons for the given medallion */
    ListHeaderLessons(medallionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Medallions/ListHeaderLessons';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the medallion's header lessons */
    UpdateHeaderLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Medallions/UpdateHeaderLessons';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the available lessons for a medallion */
    ListAvailableLessons(medallionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Medallions/ListAvailableLessons';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** List medallion groups */
    ListGroups(medallionId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/ListGroups';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update Medallion Groups */
    UpdateGroups(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Medallions/UpdateGroups';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Copies a Medallion to a New Organization */
    CopyMedallionToOrganization(medallionId, disciplineId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Medallions/CopyMedallionToOrganization';
        let params = this.newParams();
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Medallions/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
MedallionsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: MedallionsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
MedallionsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: MedallionsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: MedallionsV1Client, decorators: [{
            type: Injectable
        }] });
class OrganizationsV1Client extends BaseClient {
    /**  */
    AddIndividualSubscriptionToPartner(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/AddIndividualSubscriptionToPartner';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a Subscription to the org */
    AddSubscriptionToPartnerOrganization(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/AddSubscriptionToPartnerOrganization';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Enterprise Request Information */
    EnterpriseRequestInformation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/EnterpriseRequestInformation';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a Subscription to the org */
    AddSubscriptionToOrganization(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/AddSubscriptionToOrganization';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Completes the invitation process */
    CompleteInvite(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/CompleteInvite';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Completes the Auth side of the complete partner subscription process */
    CompletePartnerSubscription(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/CompletePartnerSubscription';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a Subscription to the org */
    CompletePartnerSmbSubscription(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/CompletePartnerSmbSubscription';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the specified Identity for the given organization */
    GetOrganizationUser(OrganizationId, UserId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetOrganizationUser';
        let params = this.newParams();
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        if (UserId != null)
            params = params.append('UserId', UserId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Can an organization sell resale items */
    CanOrganizationSellResale(OrganizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/CanOrganizationSellResale';
        let params = this.newParams();
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists all of the jobs under the Organization's Identity. */
    ListOrganizationUserJobs(organizationId, userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Organizations/ListOrganizationUserJobs';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the user's jobs */
    UpdateOrganizationUserJobs(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateOrganizationUserJobs';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates an organization users and their roles. */
    UpdateOrganizationUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateOrganizationUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the specified Organization Identity */
    DeleteOrganizationUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/DeleteOrganizationUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the xAPI configuration information */
    GetXApiCredentials(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetXApiCredentials';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Update the xApi credentials for the specified organization */
    UpdateXApiCredentials(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateXApiCredentials';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of email domains for the given user */
    ListEmailDomains(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Organizations/ListEmailDomains';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the specified organization's email domains */
    UpdateEmailDomains(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateEmailDomains';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Inserts or updates an organization with administrative information. */
    AdminUpsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/AdminUpsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all organizations with administrative information */
    AdminList(body = null, willHandleError = false) {
        let requestPath = '/v1/Organizations/AdminList';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Assigns the specified roles to the user. All existing roles if not included will be removed. */
    AssignRolesToUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/AssignRolesToUser';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of roles for the given user */
    ListUserRoles(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListUserRoles';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Broadcasts an organizational message */
    Broadcast(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/Broadcast';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns all messages under the organization */
    GetOrganizationMessages(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetOrganizationMessages';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns all messages under the organization */
    GetMessages(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetMessages';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows inserting, updating, deleting messages under the specified organization. Should include all messages as any others will be deleted. */
    UpdateMessages(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateMessages';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the courses associated with a group and organization */
    ListUserGroupCourses(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListUserGroupCourses';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the organization group courses for an organization */
    UpdateOrganizationGroupCourses(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateOrganizationGroupCourses';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Allows invitation of a user to an organization */
    InviteUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/InviteUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the specified organization's content creation capabilities */
    GetOrganizationContentCreationCapabilities(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetOrganizationContentCreationCapabilities';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists the customers of the specified organization */
    ListCustomers(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListCustomers';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets all of the users for the given organization with roles. */
    ListOrganizationUsers(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Organizations/ListOrganizationUsers';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Partner has a resale SKU */
    PartnerHasResaleSku(sku, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/PartnerHasResaleSku';
        let params = this.newParams();
        if (sku != null)
            params = params.append('sku', sku.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets if the current Org is an SMB */
    IsSmb(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/IsSmb';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Determines whether or not an org is a educational institution */
    IsEduOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/IsEduOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Determines whether or not an org is a partner */
    IsPartnerOrganization(OrganizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/IsPartnerOrganization';
        let params = this.newParams();
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists a partners user expiring entitlements */
    ListExpiringEntitlements(organizationId, days, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListExpiringEntitlements';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (days != null)
            params = params.append('days', days.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets an email template from the system */
    GetEmailTemplate(key, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetEmailTemplate';
        let params = this.newParams();
        if (key != null)
            params = params.append('key', key.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the e-mail templates for an organization */
    UpdateEmailTemplates(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateEmailTemplates';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates a specific partner prospect */
    UpdatePartnerProspect(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdatePartnerProspect';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates a partners prospects */
    UpdatePartnerProspects(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdatePartnerProspects';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all partner prospects */
    ListPartnerProspects(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Organizations/ListPartnerProspects';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or updates a new or existing users into the current user's managing organization */
    ListProspectContacts(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListProspectContacts';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a list of organizations owned by the partner */
    ListPartnerOrganizations(partnerId, isLead, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListPartnerOrganizations';
        let params = this.newParams();
        if (partnerId != null)
            params = params.append('partnerId', partnerId.toString());
        if (isLead != null)
            params = params.append('isLead', isLead.toString());
        return this.GetPageable(requestPath, params, willHandleError);
    }
    /** Lists all groups currently existing within an organization */
    ListUserFields(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListUserFields';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of stored payment credentials */
    ListPaymentCredentials(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Organizations/ListPaymentCredentials';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets a specific organization with administrative information */
    AdminGet(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/AdminGet';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists Permission Requests */
    ListPermissionRequests(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListPermissionRequests';
        let params = this.newParams();
        return this.GetPageable(requestPath, params, willHandleError);
    }
    /** Creates a Permission Request */
    ListPermissions(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListPermissions';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Searches for available permission requests */
    PermissionRequestSearch(email, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/PermissionRequestSearch';
        let params = this.newParams();
        if (email != null)
            params = params.append('email', email.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Accepts a permission request */
    AcceptPermissionRequest(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/AcceptPermissionRequest';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Accepts a permission request */
    UpdatePermission(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdatePermission';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Denies a permission request */
    DenyPermissionRequest(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/DenyPermissionRequest';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Denies a permission request */
    RevokePermission(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/RevokePermission';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Creates a permission request */
    CreatePermissionRequest(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/CreatePermissionRequest';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Determines if an organization has a particular sku assigned to them */
    HasEntitlementSku(organizationId, sku, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/HasEntitlementSku';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (sku != null)
            params = params.append('sku', sku.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns if the given organization has unused entitlements */
    HasUnusedEntitlements(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/HasUnusedEntitlements';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the set of features an organization has access to */
    GetOrganizationFeatures(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetOrganizationFeatures';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists addresses by user id */
    ListAddresses(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Organizations/ListAddresses';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Update Identity Addresses */
    UpdateAddresses(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateAddresses';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists organization groups */
    ListGroups(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListGroups';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetPageable(requestPath, params, willHandleError);
    }
    /** Update Identity Addresses */
    UpdateGroups(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateGroups';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the specific organization requested. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists the available organizations */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Organizations/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or updates the organizations */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the given entities */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the given entities by ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Runs SMb Rollup for single org */
    RunSmbRollup(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/RunSmbRollup';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List Identity Groups by Identity */
    ListUserGroupsByUser(organizationId, userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListUserGroupsByUser';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the Organization's Identity Groups. */
    UpdateUserGroupsByUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UpdateUserGroupsByUser';
        let params = this.newParams();
        return this.PutMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a list of groups by partners organizations. */
    GetPartnerOrganizationGroups(partnerId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetPartnerOrganizationGroups';
        let params = this.newParams();
        if (partnerId != null)
            params = params.append('partnerId', partnerId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Uploads users in csv format */
    UploadPartnerUsers(organizationId, sendEmailInvites, SKU, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Organizations/UploadPartnerUsers';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (sendEmailInvites != null)
            params = params.append('sendEmailInvites', sendEmailInvites.toString());
        if (SKU != null)
            params = params.append('SKU', SKU.toString());
        return this.PostMany(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Returns all courses that have available syndicated content */
    ListCoursesWithSyndicatedContent(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/ListCoursesWithSyndicatedContent';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets Organizations Question Options */
    GetOrganizationContentOptions(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetOrganizationContentOptions';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets Public Organization Info */
    GetPublicOrganizationInfo(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetPublicOrganizationInfo';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the current inventory for the specified organization */
    GetCurrentPriceList(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Organizations/GetCurrentPriceList';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
}
OrganizationsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: OrganizationsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
OrganizationsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: OrganizationsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: OrganizationsV1Client, decorators: [{
            type: Injectable
        }] });
class PaymentMethodsV1Client extends BaseClient {
    /** List Payment Methods */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/PaymentMethods/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /**  */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PaymentMethods/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the stored credentials for the given contact */
    ListStoredPaymentCredentials(contactId, type, body = null, willHandleError = false) {
        let requestPath = '/v1/PaymentMethods/ListStoredPaymentCredentials';
        let params = this.newParams();
        if (contactId != null)
            params = params.append('contactId', contactId.toString());
        if (type != null)
            params = params.append('type', type.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets the specified stored payment credential */
    GetStoredPaymentCredential(storedPaymentCredentialId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentMethods/GetStoredPaymentCredential';
        let params = this.newParams();
        if (storedPaymentCredentialId != null)
            params = params.append('storedPaymentCredentialId', storedPaymentCredentialId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the given payment credential with new expiry etc. */
    UpdateCreditCardPaymentCredentials(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PaymentMethods/UpdateCreditCardPaymentCredentials';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Add Payment Credentials */
    InsertOrUpdatePaymentCredential(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PaymentMethods/InsertOrUpdatePaymentCredential';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the specified payment credential */
    DeletePaymentCredential(credentialId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentMethods/DeletePaymentCredential';
        let params = this.newParams();
        if (credentialId != null)
            params = params.append('credentialId', credentialId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentMethods/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentMethods/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentMethods/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
PaymentMethodsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PaymentMethodsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PaymentMethodsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PaymentMethodsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PaymentMethodsV1Client, decorators: [{
            type: Injectable
        }] });
class PaymentProvidersV1Client extends BaseClient {
    /** Returns a list of implementations for the specified provider */
    ListImplementations(providerId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentProviders/ListImplementations';
        let params = this.newParams();
        if (providerId != null)
            params = params.append('providerId', providerId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the specified provider's implementations. Should include all implementations for the given provider */
    UpdateImplementations(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PaymentProviders/UpdateImplementations';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentProviders/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/PaymentProviders/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PaymentProviders/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentProviders/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PaymentProviders/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
PaymentProvidersV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PaymentProvidersV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PaymentProvidersV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PaymentProvidersV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PaymentProvidersV1Client, decorators: [{
            type: Injectable
        }] });
class PlatformV1Client extends BaseClient {
    /** List all platform reports */
    ListReports(body = null, willHandleError = false) {
        let requestPath = '/v1/Platform/ListReports';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Get a specified report */
    GetReport(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Platform/GetReport';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Inserts or Updates a given platform report */
    UpsertReport(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Platform/UpsertReport';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Delete a specified report */
    DeleteReport(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Platform/DeleteReport';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
PlatformV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PlatformV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PlatformV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PlatformV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PlatformV1Client, decorators: [{
            type: Injectable
        }] });
class PlaylistsV1Client extends BaseClient {
    /** Get the given playlist. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Playlists/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Playlists/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Inserts or Updates the playlist content passed. */
    UpsertWithContent(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Playlists/UpsertWithContent';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the playlists that the user can view */
    ListPlaylistByUser(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Playlists/ListPlaylistByUser';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists the users associated with a playlist */
    ListPlayListUsers(playListId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Playlists/ListPlayListUsers';
        let params = this.newParams();
        if (playListId != null)
            params = params.append('playListId', playListId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Deletes a specified user from the playlist */
    DeletePlayListUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Playlists/DeletePlayListUser';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the playlists for the specified user. If the user is not specified gets the play lists for the currently logged in user. */
    ListPlayListsByOwningOrganization(owningOrganization, body = null, willHandleError = false) {
        let requestPath = '/v1/Playlists/ListPlayListsByOwningOrganization';
        let params = this.newParams();
        if (owningOrganization != null)
            params = params.append('owningOrganization', owningOrganization.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Generates Lessons based on the gap and adds them to the playlist */
    GenerateGapLessons(playlistId, productId, versionId, version2Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Playlists/GenerateGapLessons';
        let params = this.newParams();
        if (playlistId != null)
            params = params.append('playlistId', playlistId.toString());
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (version2Id != null)
            params = params.append('version2Id', version2Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Allows the owner of a play list to invite users into that play list. */
    InviteEmailAddressesToPlayList(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Playlists/InviteEmailAddressesToPlayList';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Invites users to a playlist by their group */
    InviteUsersByGroups(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Playlists/InviteUsersByGroups';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Allows an administrator of an organization to invite users to a play list */
    InviteUsersToPlayList(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Playlists/InviteUsersToPlayList';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the syndication providers for the given playList */
    ListSyndicationProviders(playListId, body = null, willHandleError = false) {
        let requestPath = '/v1/Playlists/ListSyndicationProviders';
        let params = this.newParams();
        if (playListId != null)
            params = params.append('playListId', playListId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the topic's syndication providers */
    UpdateSyndicationProviders(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Playlists/UpdateSyndicationProviders';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the header lessons for the given playList */
    ListHeaderLessons(playListId, body = null, willHandleError = false) {
        let requestPath = '/v1/Playlists/ListHeaderLessons';
        let params = this.newParams();
        if (playListId != null)
            params = params.append('playListId', playListId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the playList's header lessons */
    UpdateHeaderLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Playlists/UpdateHeaderLessons';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the available lessons for a playlist */
    ListAvailableLessons(playlistId, body = null, willHandleError = false) {
        let requestPath = '/v1/Playlists/ListAvailableLessons';
        let params = this.newParams();
        if (playlistId != null)
            params = params.append('playlistId', playlistId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Playlists/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Playlists/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Playlists/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
PlaylistsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PlaylistsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PlaylistsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PlaylistsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PlaylistsV1Client, decorators: [{
            type: Injectable
        }] });
class PreferencesV1Client extends BaseClient {
    /** Gets a grid layouts by ID and the current user */
    GetDefaultGridLayout(gridKey, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Preferences/GetDefaultGridLayout';
        let params = this.newParams();
        if (gridKey != null)
            params = params.append('gridKey', gridKey.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets a grid layouts by ID and the current user */
    ListGridLayouts(gridKey, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Preferences/ListGridLayouts';
        let params = this.newParams();
        if (gridKey != null)
            params = params.append('gridKey', gridKey.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Inserts or Updates a grid layout. */
    UpsertGridLayout(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Preferences/UpsertGridLayout';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the specified grid layout */
    DeleteGridLayout(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Preferences/DeleteGridLayout';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
PreferencesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PreferencesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PreferencesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PreferencesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PreferencesV1Client, decorators: [{
            type: Injectable
        }] });
class PriceListRevisionsV1Client extends BaseClient {
    /** Creates a new copy of a revision with today as the start date and all existing inventory still attached with existing pricing */
    CopyRevision(revisionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PriceListRevisions/CopyRevision';
        let params = this.newParams();
        if (revisionId != null)
            params = params.append('revisionId', revisionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the inventory of a given revision */
    ListInventory(revisionId, body = null, willHandleError = false) {
        let requestPath = '/v1/PriceListRevisions/ListInventory';
        let params = this.newParams();
        if (revisionId != null)
            params = params.append('revisionId', revisionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns the inventory of a given revision */
    ListPartnerResaleBillingInventory(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/PriceListRevisions/ListPartnerResaleBillingInventory';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the inventory for a given revision. All inventory associated with the revision must be passed. */
    UpdateInventory(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PriceListRevisions/UpdateInventory';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PriceListRevisions/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/PriceListRevisions/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PriceListRevisions/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PriceListRevisions/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PriceListRevisions/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
PriceListRevisionsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PriceListRevisionsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PriceListRevisionsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PriceListRevisionsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PriceListRevisionsV1Client, decorators: [{
            type: Injectable
        }] });
class PriceListsV1Client extends BaseClient {
    /** Get all revisions under a price list */
    ListRevisions(priceListId, body = null, willHandleError = false) {
        let requestPath = '/v1/PriceLists/ListRevisions';
        let params = this.newParams();
        if (priceListId != null)
            params = params.append('priceListId', priceListId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PriceLists/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/PriceLists/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PriceLists/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PriceLists/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PriceLists/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
PriceListsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PriceListsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PriceListsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PriceListsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PriceListsV1Client, decorators: [{
            type: Injectable
        }] });
class ProductCategoriesV1Client extends BaseClient {
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/ProductCategories/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/ProductCategories/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/ProductCategories/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/ProductCategories/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/ProductCategories/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
ProductCategoriesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProductCategoriesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
ProductCategoriesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProductCategoriesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProductCategoriesV1Client, decorators: [{
            type: Injectable
        }] });
class ProductsV1Client extends BaseClient {
    /** Request the changes feed in atom. */
    ChangesFeed(portalUrl, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ChangesFeed';
        let params = this.newParams();
        if (portalUrl != null)
            params = params.append('portalUrl', portalUrl.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Get version from web url */
    GetVersionFromWebUrl(url, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetVersionFromWebUrl';
        let params = this.newParams();
        if (url != null)
            params = params.append('url', url.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the Product and Version Ids based on the vendor info returned by the product. */
    GetVersionFromVendorInfo(productVendor, versionVendor, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetVersionFromVendorInfo';
        let params = this.newParams();
        if (productVendor != null)
            params = params.append('productVendor', productVendor.toString());
        if (versionVendor != null)
            params = params.append('versionVendor', versionVendor.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists the vendor ids associated with a product */
    ListVendorIds(productId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ListVendorIds';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates vendor ids for the associated product */
    UpdateVendorIds(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/UpdateVendorIds';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get the specified translation */
    GetTranslation(productId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetTranslation';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the translation categories associated with a product */
    ListTranslationCategories(productId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ListTranslationCategories';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates translation categories for the associated product */
    UpdateTranslationCategories(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/UpdateTranslationCategories';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the categories associated with the Product */
    ListCategories(productId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ListCategories';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates Product Categories */
    UpdateCategories(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/UpdateCategories';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the mapping between CADLearning product/version Ids and the product's own internal values. */
    GetProductVersionIdsFromAppInfo(productName, productVersion, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetProductVersionIdsFromAppInfo';
        let params = this.newParams();
        if (productName != null)
            params = params.append('productName', productName.toString());
        if (productVersion != null)
            params = params.append('productVersion', productVersion.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a set of commands for each version in a product */
    ListVersionCommands(productId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ListVersionCommands';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists the lessons associated with a particular version command */
    ListVersionCommandLessons(versionId, command, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ListVersionCommandLessons';
        let params = this.newParams();
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (command != null)
            params = params.append('command', command.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a product version command with its translations */
    GetProductVersionCommandWithTranslations(command, versionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetProductVersionCommandWithTranslations';
        let params = this.newParams();
        if (command != null)
            params = params.append('command', command.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Insert or Update Product Version Command */
    UpsertProductVersionCommandWithTranslations(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/UpsertProductVersionCommandWithTranslations';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Removes a product version command */
    RemoveProductVersionCommand(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/RemoveProductVersionCommand';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns all of the lessons for a given product and version */
    ListLessonsByProductVersion(versionId, languageCode, body = null, willHandleError = false) {
        let requestPath = '/v1/Products/ListLessonsByProductVersion';
        let params = this.newParams();
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns all of the lessons for a given product and version */
    ListLessonsByProductVersionForAddVersion(versionId, languageCode, body = null, willHandleError = false) {
        let requestPath = '/v1/Products/ListLessonsByProductVersionForAddVersion';
        let params = this.newParams();
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Adds a version and modifies lessons based on update status */
    AddVersion(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/AddVersion';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all courses by product version */
    ListCoursesByProductVersion(versionId, languageCode, body = null, willHandleError = false) {
        let requestPath = '/v1/Products/ListCoursesByProductVersion';
        let params = this.newParams();
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates Product Versions */
    UpdateVersions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/UpdateVersions';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all products that are custom for the current organization of the current user. */
    ListCustomProducts(body = null, willHandleError = false) {
        let requestPath = '/v1/Products/ListCustomProducts';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Adds a display image for a product */
    AddProductImageResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/AddProductImageResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes a products associated product image */
    RemoveProductImage(ProductId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/RemoveProductImage';
        let params = this.newParams();
        if (ProductId != null)
            params = params.append('ProductId', ProductId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Creates a custom product for the current organization */
    CreateCustomProduct(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/CreateCustomProduct';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of products concepts */
    ListProductWebAddresses(id, body = null, willHandleError = false) {
        let requestPath = '/v1/Products/ListProductWebAddresses';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates Product Concepts */
    UpdateProductWebAddresses(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/UpdateProductWebAddresses';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of active products with courses in them that are active */
    ListActiveProducts(onlyShowOwnedOrganizations, owningOrganizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Products/ListActiveProducts';
        let params = this.newParams();
        if (onlyShowOwnedOrganizations != null)
            params = params.append('onlyShowOwnedOrganizations', onlyShowOwnedOrganizations.toString());
        if (owningOrganizationId != null)
            params = params.append('owningOrganizationId', owningOrganizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists all courses by product version */
    ListCoursesByVersion(versionId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ListCoursesByVersion';
        let params = this.newParams();
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists all courses by product version */
    ListCoursesByVersionAdmin(versionId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ListCoursesByVersionAdmin';
        let params = this.newParams();
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List all work flows for the given product version. */
    ListWorkflowsByVersion(versionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/ListWorkflowsByVersion';
        let params = this.newParams();
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the Course for a given product based on latest version and default course or user's preference */
    GetProductCourse(productId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetProductCourse';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the Course for a given product based on latest version and default course or user's preference */
    GetProductVersionCourse(productId, versionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetProductVersionCourse';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of versions for the given product */
    GetVersionsAdmin(productId, onlyWithCourse, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetVersionsAdmin';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (onlyWithCourse != null)
            params = params.append('onlyWithCourse', onlyWithCourse.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of versions for the given product */
    GetVersions(productId, onlyWithCourse, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetVersions';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (onlyWithCourse != null)
            params = params.append('onlyWithCourse', onlyWithCourse.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of versions for the given product ids */
    GetVersionByProductIds(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/GetVersionByProductIds';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get Product Information translated to the specified language code */
    GetWithLanguage(id, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/GetWithLanguage';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Insert or update a assessments */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed assessments */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the assessments by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists sites attached to the product */
    ListSites(productId, body = null, willHandleError = false) {
        let requestPath = '/v1/Products/ListSites';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates Sites */
    UpdateSites(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Products/UpdateSites';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Products/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Products/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
ProductsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProductsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
ProductsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProductsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProductsV1Client, decorators: [{
            type: Injectable
        }] });
class ProjectsV1Client extends BaseClient {
    /** Generates a prehire assessment based on project position concepts */
    CreatePrehireAssessment(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Projects/CreatePrehireAssessment';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List Project Products */
    ListProducts(projectId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Projects/ListProducts';
        let params = this.newParams();
        if (projectId != null)
            params = params.append('projectId', projectId.toString());
        return this.PostMany(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Lists the users on the given project */
    ListJobs(projectId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Projects/ListJobs';
        let params = this.newParams();
        if (projectId != null)
            params = params.append('projectId', projectId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Deletes the specified job. */
    DeleteJob(projectJobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Projects/DeleteJob';
        let params = this.newParams();
        if (projectJobId != null)
            params = params.append('projectJobId', projectJobId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists the users on the given project */
    GetJob(projectJobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Projects/GetJob';
        let params = this.newParams();
        if (projectJobId != null)
            params = params.append('projectJobId', projectJobId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates a specific job. */
    UpsertJob(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Projects/UpsertJob';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the specified Project's Products. */
    UpdateProducts(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Projects/UpdateProducts';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Generates a prehire assessment based on project position concepts */
    MatchProjectJobToUsers(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Projects/MatchProjectJobToUsers';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Insert or update a project */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Projects/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed projects */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Projects/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the projects by the ids passed */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Projects/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Projects/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Projects/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
ProjectsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProjectsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
ProjectsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProjectsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ProjectsV1Client, decorators: [{
            type: Injectable
        }] });
class PublicVideosV1Client extends BaseClient {
    /** Gets a public video */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Upsert a Public Video */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a resource to a public video. The resource must still be uploaded. */
    AddResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/AddResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes the selected resource from a public video. If the resource is no longer associated with anything the resource will be completely removed. */
    RemoveResource(PublicVideoId, ResourceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/RemoveResource';
        let params = this.newParams();
        if (PublicVideoId != null)
            params = params.append('PublicVideoId', PublicVideoId.toString());
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** List all of the courses on the public video */
    ListCourses(publicVideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/ListCourses';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update Courses attached to a public video */
    UpsertCourses(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/UpsertCourses';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List all of the lessons on the public video */
    ListLessons(publicVideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/ListLessons';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists Public Videos By Course */
    ListByCourse(courseId, body = null, willHandleError = false) {
        let requestPath = '/v1/PublicVideos/ListByCourse';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists Public Videos By Lesson */
    ListByLesson(lessonId, body = null, willHandleError = false) {
        let requestPath = '/v1/PublicVideos/ListByLesson';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists Public Videos By Discipline */
    ListByDiscipline(disciplineId, body = null, willHandleError = false) {
        let requestPath = '/v1/PublicVideos/ListByDiscipline';
        let params = this.newParams();
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists Public Videos By Job */
    ListByJob(jobId, body = null, willHandleError = false) {
        let requestPath = '/v1/PublicVideos/ListByJob';
        let params = this.newParams();
        if (jobId != null)
            params = params.append('jobId', jobId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Update Lessons attached to a public video */
    UpsertLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/UpsertLessons';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List all of the disciplines on the public video */
    ListDisciplines(publicVideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/ListDisciplines';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update Disciplines attached to a public video */
    UpsertDisciplines(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/UpsertDisciplines';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List all of the jobs on the public video */
    ListJobs(publicVideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/ListJobs';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Update jobs attached to a public video */
    UpsertJobs(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/UpsertJobs';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get Public Video Captions */
    GetVideoCaptions(PublicVideoId, PreferedLanguage, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/GetVideoCaptions';
        let params = this.newParams();
        if (PublicVideoId != null)
            params = params.append('PublicVideoId', PublicVideoId.toString());
        if (PreferedLanguage != null)
            params = params.append('PreferedLanguage', PreferedLanguage.toString());
        return this.PostMany(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Delete Video Object attached to a Public Video */
    DeleteVideo(PublicVideoId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/DeleteVideo';
        let params = this.newParams();
        if (PublicVideoId != null)
            params = params.append('PublicVideoId', PublicVideoId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Get Public Video Captions */
    DeleteCaption(publicVideoId, captionId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/PublicVideos/DeleteCaption';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        if (captionId != null)
            params = params.append('captionId', captionId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Get the specified translation */
    GetTranslation(publicVideoId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/GetTranslation';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets related videos by a public videos linked courses */
    GetRelatedVideosByCourses(publicVideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/GetRelatedVideosByCourses';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets related videos by a public videos linked lessons */
    GetRelatedVideosByLessons(publicVideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/GetRelatedVideosByLessons';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets related videos by a public videos linked disciplines */
    GetRelatedVideosByDisciplines(publicVideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/GetRelatedVideosByDisciplines';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets related videos by a public videos linked jobs */
    GetRelatedVideosByJobs(publicVideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/GetRelatedVideosByJobs';
        let params = this.newParams();
        if (publicVideoId != null)
            params = params.append('publicVideoId', publicVideoId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/PublicVideos/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/PublicVideos/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
PublicVideosV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PublicVideosV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
PublicVideosV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PublicVideosV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: PublicVideosV1Client, decorators: [{
            type: Injectable
        }] });
class QuestionsV1Client extends BaseClient {
    /** Adds a resource to a question. The resource must still be uploaded. */
    AddResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/AddResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes the selected resource from a question. If the resource is no longer associated with anything the resource will be completely removed. */
    RemoveResource(ResourceId, QuestionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/RemoveResource';
        let params = this.newParams();
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        if (QuestionId != null)
            params = params.append('QuestionId', QuestionId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns the resources (downloads etc.) associated with the specified lesson */
    ListResourcesByType(QuestionId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListResourcesByType';
        let params = this.newParams();
        if (QuestionId != null)
            params = params.append('QuestionId', QuestionId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the resources (downloads etc.) associated with the specified lesson */
    ListResources(QuestionId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListResources';
        let params = this.newParams();
        if (QuestionId != null)
            params = params.append('QuestionId', QuestionId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns all workflow assignees to the question. */
    ListAssignees(questionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListAssignees';
        let params = this.newParams();
        if (questionId != null)
            params = params.append('questionId', questionId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the workflow assignments for a given question */
    UpdateAssignees(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateAssignees';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the information about t/he current question and where it is in the workflow. If it isn't in the workflow then it puts it at stage 2 for triage by default. */
    GetWorkflowStatus(questionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/GetWorkflowStatus';
        let params = this.newParams();
        if (questionId != null)
            params = params.append('questionId', questionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified question's workflow step and based on that will execute specific functions. */
    UpdateWorkflowStep(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateWorkflowStep';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the question workflow task */
    UpdateWorkflowTask(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateWorkflowTask';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Get the specified translation */
    GetTranslation(questionId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/GetTranslation';
        let params = this.newParams();
        if (questionId != null)
            params = params.append('questionId', questionId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Delete the specified translation */
    DeleteTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/DeleteTranslation';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the possible lessons to be added to an answer */
    ListAnswerPossibleLessons(answerId, versionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Questions/ListAnswerPossibleLessons';
        let params = this.newParams();
        if (answerId != null)
            params = params.append('answerId', answerId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of lessons based on the question */
    ListLessonsWithTime(questionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListLessonsWithTime';
        let params = this.newParams();
        if (questionId != null)
            params = params.append('questionId', questionId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows bulk updating of all lessons associated with the question. */
    UpdateLessonsWithTime(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateLessonsWithTime';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of branching questions based on the Answer */
    ListAnswerBranchingQuestions(answerId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListAnswerBranchingQuestions';
        let params = this.newParams();
        if (answerId != null)
            params = params.append('answerId', answerId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Questions from assessments or lessons that can be added to a question branch */
    ListAvailableForQuestionBranch(questionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListAvailableForQuestionBranch';
        let params = this.newParams();
        if (questionId != null)
            params = params.append('questionId', questionId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows bulk updating of all questions associated with the answer. */
    UpdateBranchingQuestions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateBranchingQuestions';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of lessons based on the question */
    ListLessons(questionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListLessons';
        let params = this.newParams();
        if (questionId != null)
            params = params.append('questionId', questionId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows bulk updating of all lessons associated with the question. */
    UpdateLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateLessons';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the answers associated with a question */
    UpdateAnswers(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateAnswers';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a list of questions by the assessment */
    ListByAssessmentId(assessmentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListByAssessmentId';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Adds a link between the specified lesson and question */
    AddLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/AddLesson';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a link between the specified lesson and help question */
    HelpQuestionAddLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/HelpQuestionAddLesson';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Removes a specified lesson from the question. */
    RemoveLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/RemoveLesson';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Removes a specified lesson from the help question. */
    HelpQuestionRemoveLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/HelpQuestionRemoveLesson';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of questions that can be added to the given lesson based on the product information */
    ListAvailableForLessonAdd(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListAvailableForLessonAdd';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of suggested lessons based on the Answer */
    ListAnswerSuggestedLessons(answerId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListAnswerSuggestedLessons';
        let params = this.newParams();
        if (answerId != null)
            params = params.append('answerId', answerId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Imports a question into a new organization */
    ImportQuestionToOrganization(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/ImportQuestionToOrganization';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Questions that can be added to the specified assessment */
    ListAvailableForAssessmentAdd(assessmentId, body = null, willHandleError = false) {
        let requestPath = '/v1/Questions/ListAvailableForAssessmentAdd';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates suggested lessons on the specified answer */
    UpdateAnswerSuggestedLessons(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpdateAnswerSuggestedLessons';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a list of questions by the lesson */
    PublicListByLessonId(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/PublicListByLessonId';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a list of questions by the lesson */
    ListByLessonId(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListByLessonId';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a list of questions by the lesson */
    ListByLessonIdWithAnswers(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListByLessonIdWithAnswers';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a list of questions by the lesson with the workflow step */
    ListByLessonIdWithWorkflow(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListByLessonIdWithWorkflow';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a list of questions by the lesson with the workflow step */
    ListHelpQuestionsByLessonId(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/ListHelpQuestionsByLessonId';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List Help Questions */
    ListHelpQuestions(body = null, willHandleError = false) {
        let requestPath = '/v1/Questions/ListHelpQuestions';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Insert or update a assessments */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Insert or update a help question */
    UpsertHelpQuestions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Questions/UpsertHelpQuestions';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists orphaned questions for an organization */
    ListOrphanedQuestions(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Questions/ListOrphanedQuestions';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Deletes the passed assessments */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the assessments by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Questions/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Questions/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
QuestionsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: QuestionsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
QuestionsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: QuestionsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: QuestionsV1Client, decorators: [{
            type: Injectable
        }] });
class ReportsV1Client extends BaseClient {
    /** Provides a detailed list of all activity given the load criteria. */
    UserActivity(body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/UserActivity';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists all reports for the given user */
    ListReports(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListReports';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Active Users By Month Summary */
    ActiveUsersByMonth(organizationId, numberOfMonths, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ActiveUsersByMonth';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (numberOfMonths != null)
            params = params.append('numberOfMonths', numberOfMonths.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Most Recent Badges acquired by a given user. */
    MostRecentBadges(userId, asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/MostRecentBadges';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns Organizational Learning Statistics */
    OrganizationStats(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationStats';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the current Gross MRR */
    GrossMRR(asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/GrossMRR';
        let params = this.newParams();
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the current Gross ARR */
    GrossARR(asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/GrossARR';
        let params = this.newParams();
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gross MRR Trends */
    GrossMRRTrends(asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/GrossMRRTrends';
        let params = this.newParams();
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gross ARR Trends */
    GrossARRTrends(asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/GrossARRTrends';
        let params = this.newParams();
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gross MRR Trends */
    MonthlyChurnTrends(asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/MonthlyChurnTrends';
        let params = this.newParams();
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gross MRR Trends */
    YearlyChurnTrends(asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/YearlyChurnTrends';
        let params = this.newParams();
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Monthly Churn Rate */
    MonthlyChurnRate(asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/MonthlyChurnRate';
        let params = this.newParams();
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Yearly Churn Rate */
    YearlyChurnRate(asOf, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/YearlyChurnRate';
        let params = this.newParams();
        if (asOf != null)
            params = params.append('asOf', asOf.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Engagement Trends over the organization for the past 12 months by month */
    OrganizationEngagementTrends(OrganizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationEngagementTrends';
        let params = this.newParams();
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Medallions assigned to Employees and their trends of completion */
    OrganizationSkillsGaps(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationSkillsGaps';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Medallions assigned to Employees and their trends of completion */
    OrganizationSkillsGapsAtDate(organizationId, date, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationSkillsGapsAtDate';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (date != null)
            params = params.append('date', date.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Most Improved Employees */
    OrganizationMostImprovedEmployees(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationMostImprovedEmployees';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Struggling Employees */
    OrganizationStrugglingEmployees(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationStrugglingEmployees';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Most engaged employees over the past 3 months */
    OrganizationMostEngaged(OrganizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationMostEngaged';
        let params = this.newParams();
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Least engaged employees over the past 3 months */
    OrganizationLeastEngaged(OrganizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationLeastEngaged';
        let params = this.newParams();
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Least engaged employees over the past 3 months */
    OrganizationRockStars(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/OrganizationRockStars';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get a List of Roles with assigned Employees and status */
    EmployeesAssignedToRoles(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/EmployeesAssignedToRoles';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Get a List of Goals with assigned Employees and status */
    EmployeesAssignedToGoals(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/EmployeesAssignedToGoals';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Get a List of Employees and their Roles with status */
    EmployeeRoleSummary(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/EmployeeRoleSummary';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get a List of Employees and their Goals with status */
    EmployeeGoalSummary(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/EmployeeGoalSummary';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get a List of Employees and their Roles with status */
    EmployeeRoleSummaryFlattened(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/EmployeeRoleSummaryFlattened';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Get a List of Employees and their Goals with status */
    EmployeeGoalSummaryFlattened(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/EmployeeGoalSummaryFlattened';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Download Goal Data */
    DownloadGoalData(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/DownloadGoalData';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Download Role Data */
    DownloadRoleData(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/DownloadRoleData';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Schedule a Report */
    ScheduleReport(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Reports/ScheduleReport';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get a schedule for a specific report */
    GetReportSchedule(organizationId, report, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/GetReportSchedule';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (report != null)
            params = params.append('report', report.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** List Report schedules by Organization */
    ListReportSchedules(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListReportSchedules';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Total Inactive users by Organization */
    TotalInActiveUsersByOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TotalInActiveUsersByOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Total Assessments over Organization's Current Entitlement Period */
    TotalAssessmentsOverEntitlementPeriod(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TotalAssessmentsOverEntitlementPeriod';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Total Active Users by Organization */
    TotalActiveUsersByOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TotalActiveUsersByOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Most Taken assessments by Organization */
    MostTakenAssessmentsByOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/MostTakenAssessmentsByOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Most Active Products by Organization */
    MostActiveProductsByOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/MostActiveProductsByOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Total Users by Organization */
    TotalUsersByOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TotalUsersByOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** List all trials on all organizations */
    ListTrials(dtStart, dtEnd, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/ListTrials';
        let params = this.newParams();
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets a partners sales rep sales info */
    GetPartnerSalesRepInfo(partnerId, dtStart, dtEnd, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/GetPartnerSalesRepInfo';
        let params = this.newParams();
        if (partnerId != null)
            params = params.append('partnerId', partnerId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists the tokens associated with a particular partner that have been redeemed */
    ListPartnerRedeemedTokens(partnerId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/ListPartnerRedeemedTokens';
        let params = this.newParams();
        if (partnerId != null)
            params = params.append('partnerId', partnerId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists Billable Inventory */
    ListBillableInventory(dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListBillableInventory';
        let params = this.newParams();
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List Identity Detail Activity */
    GetUserActivity(organizationId, userId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/GetUserActivity';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns items that have stalled in the pipeline */
    WorkflowStalledItems(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/WorkflowStalledItems';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists all Workflow items that had errors */
    WorkflowErrors(dtFrom, dtTo, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/WorkflowErrors';
        let params = this.newParams();
        if (dtFrom != null)
            params = params.append('dtFrom', dtFrom.toISOString());
        if (dtTo != null)
            params = params.append('dtTo', dtTo.toISOString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns items that have aged out. */
    WorkflowAgingItems(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/WorkflowAgingItems';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists the work flow task changes by date range. */
    WorkflowTaskChanges(dtFrom, dtTo, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/WorkflowTaskChanges';
        let params = this.newParams();
        if (dtFrom != null)
            params = params.append('dtFrom', dtFrom.toISOString());
        if (dtTo != null)
            params = params.append('dtTo', dtTo.toISOString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Total current active Monthly personal subscriptions */
    TotalActiveMonthlies(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TotalActiveMonthlies';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Total current active Year personal subscriptions */
    TotalActiveYearlies(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TotalActiveYearlies';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Current Users Online */
    UsersOnline(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/UsersOnline';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Totals of active users by platform */
    PlatformTotals(dtFrom, organizationId, userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/PlatformTotals';
        let params = this.newParams();
        if (dtFrom != null)
            params = params.append('dtFrom', dtFrom.toISOString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a course summary across editing steps in its topics */
    CourseGlanceReport(courseId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/CourseGlanceReport';
        let params = this.newParams();
        if (courseId != null)
            params = params.append('courseId', courseId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Top Partners by Leads */
    TopPartnersByLeads(dtFrom, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TopPartnersByLeads';
        let params = this.newParams();
        if (dtFrom != null)
            params = params.append('dtFrom', dtFrom.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Top partners by Dollars Sold */
    TopPartnersByDollarsSold(dtFrom, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TopPartnersByDollarsSold';
        let params = this.newParams();
        if (dtFrom != null)
            params = params.append('dtFrom', dtFrom.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Top Sales People in the company by dollar value. */
    TopSales(dtFrom, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TopSales';
        let params = this.newParams();
        if (dtFrom != null)
            params = params.append('dtFrom', dtFrom.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Top organizations by Dollars Sold */
    TopOrganizationsByDollarsSold(dtFrom, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TopOrganizationsByDollarsSold';
        let params = this.newParams();
        if (dtFrom != null)
            params = params.append('dtFrom', dtFrom.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Upcoming Renewals */
    UpcomingEnterpriseRenewals(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/UpcomingEnterpriseRenewals';
        let params = this.newParams();
        return this.GetPageable(requestPath, params, willHandleError);
    }
    /** Most Active Products */
    MostActiveProducts(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/MostActiveProducts';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists all partner activity */
    ListPartnerActivity(days, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListPartnerActivity';
        let params = this.newParams();
        if (days != null)
            params = params.append('days', days.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Provides the user history of a given assessment */
    AssessmentUserHistory(assessmentId, organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/AssessmentUserHistory';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns Assessment Scoring Statistical Data */
    AssessmentDistributionReport(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/AssessmentDistributionReport';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** A report that lists all of your employees that have taken the given assessment and their detailed scores with question information. */
    AssessmentReportCard(assessmentId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/AssessmentReportCard';
        let params = this.newParams();
        if (assessmentId != null)
            params = params.append('assessmentId', assessmentId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of Lessons with their total activity by project */
    ListProjectLessonViews(organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListProjectLessonViews';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of courses that can be used for LMS import */
    CourseList(portalUrl, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/CourseList';
        let params = this.newParams();
        if (portalUrl != null)
            params = params.append('portalUrl', portalUrl.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns all lesson activity for your given organization */
    DownloadAssessmentData(userName, password, organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/DownloadAssessmentData';
        let params = this.newParams();
        if (userName != null)
            params = params.append('userName', userName.toString());
        if (password != null)
            params = params.append('password', password.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns all lesson activity for your given organization */
    ListLessonActivityDetails(organizationId, userId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListLessonActivityDetails';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of summary data about user views */
    ListUserLessonViews(StartOn, EndOn, OrganizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/ListUserLessonViews';
        let params = this.newParams();
        if (StartOn != null)
            params = params.append('StartOn', StartOn.toISOString());
        if (EndOn != null)
            params = params.append('EndOn', EndOn.toISOString());
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns Report data based on detailed version information and lesson details */
    ListProjectUserViews(projectId, organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListProjectUserViews';
        let params = this.newParams();
        if (projectId != null)
            params = params.append('projectId', projectId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of Lessons with their total activity by project */
    ListProjectLessonActivity(projectId, organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListProjectLessonActivity';
        let params = this.newParams();
        if (projectId != null)
            params = params.append('projectId', projectId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns Report data based on detailed version information and lesson details */
    ListProductVersionViews(productId, organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListProductVersionViews';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of products and their views */
    ListProductLessonViews(organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListProductLessonViews';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List Product Command Views */
    ListProductCommandViews(productId, organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListProductCommandViews';
        let params = this.newParams();
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of Lessons with their total activity */
    ListLessonViews(OrganizationId, StartOn, EndOn, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListLessonViews';
        let params = this.newParams();
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        if (StartOn != null)
            params = params.append('StartOn', StartOn.toISOString());
        if (EndOn != null)
            params = params.append('EndOn', EndOn.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of Lessons with their total activity */
    ListActivity(organizationId, userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/ListActivity';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of Resources with their total activity */
    ListResourceViews(OrganizationId, StartOn, EndOn, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListResourceViews';
        let params = this.newParams();
        if (OrganizationId != null)
            params = params.append('OrganizationId', OrganizationId.toString());
        if (StartOn != null)
            params = params.append('StartOn', StartOn.toISOString());
        if (EndOn != null)
            params = params.append('EndOn', EndOn.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List Group Views */
    ListGroupViews(organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListGroupViews';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List Group Product Views */
    ListGroupProductViews(organizationId, groupName, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/ListGroupProductViews';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (groupName != null)
            params = params.append('groupName', groupName.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns a list of Users for an organization with their organization information */
    OrganizationUserEntitlements(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/OrganizationUserEntitlements';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of Users for an organization with their organization information */
    OrganizationUsers(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/OrganizationUsers';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists the tokens associated with a particular partner */
    ListPartnerTokens(partnerId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/ListPartnerTokens';
        let params = this.newParams();
        if (partnerId != null)
            params = params.append('partnerId', partnerId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list or courses viewed by the user and their completion percentage for that course */
    CourseCompletionByUser(userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/CourseCompletionByUser';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list or courses viewed by the user and their total number of lessons completed out of the total number of lessons on the course */
    CourseCompletionLessonsByUser(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/CourseCompletionLessonsByUser';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the most viewed lessons for the given user */
    MostPopularLessons(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/MostPopularLessons';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns total sign ups per month */
    SignupsByMonth(organizationId, dtStart, dtEnd, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/SignupsByMonth';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns all detail sign ups by month */
    SignupsByMonthDetail(organizationId, dtStart, dtEnd, body = null, willHandleError = false) {
        let requestPath = '/v1/Reports/SignupsByMonthDetail';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /**  */
    TimeSavedAcrossOrganization(organizationId, dtStart, dtEnd, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/TimeSavedAcrossOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (dtStart != null)
            params = params.append('dtStart', dtStart.toISOString());
        if (dtEnd != null)
            params = params.append('dtEnd', dtEnd.toISOString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the subscriptions per invoice metric */
    SubscriptionsPerInvoice(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/SubscriptionsPerInvoice';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the badges with the users under an organization with who earned the badge */
    GetBadgeWithUsersAchieved(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/GetBadgeWithUsersAchieved';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets the achievements a user has tested out of */
    GetTestedOutAchievements(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/GetTestedOutAchievements';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /**  */
    CompetenciesAchievedByOrganization(organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Reports/CompetenciesAchievedByOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
}
ReportsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ReportsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
ReportsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ReportsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ReportsV1Client, decorators: [{
            type: Injectable
        }] });
class ResourcesV1Client extends BaseClient {
    /** Gets the JWT Token required for playback of azure media assets */
    GetVideoPermissions(VideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/GetVideoPermissions';
        let params = this.newParams();
        if (VideoId != null)
            params = params.append('VideoId', VideoId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Takes existing raw resources and creates a new video generating all of the media resources on Azure etc. in a queued process. */
    QueueCreateVideoFromResources(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Resources/QueueCreateVideoFromResources';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Proxy endpoint for public videos */
    VideoPublic(videoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/VideoPublic';
        let params = this.newParams();
        if (videoId != null)
            params = params.append('videoId', videoId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Proxy endpoint for public videos */
    PlaybackPublicVideo(videoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/PlaybackPublicVideo';
        let params = this.newParams();
        if (videoId != null)
            params = params.append('videoId', videoId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets lesson m3u8 */
    VideoFromLesson(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/VideoFromLesson';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets lesson m3u8 */
    PlaybackVideoFromLesson(lessonId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/PlaybackVideoFromLesson';
        let params = this.newParams();
        if (lessonId != null)
            params = params.append('lessonId', lessonId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Proxy endpoint for private videos */
    Video(videoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/Video';
        let params = this.newParams();
        if (videoId != null)
            params = params.append('videoId', videoId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Proxy endpoint for private videos */
    PlaybackVideo(videoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/PlaybackVideo';
        let params = this.newParams();
        if (videoId != null)
            params = params.append('videoId', videoId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns the captions for the specified video if any including the urls for any captions for playback */
    GetVideoCaptions(VideoId, PreferredLanguage, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/GetVideoCaptions';
        let params = this.newParams();
        if (VideoId != null)
            params = params.append('VideoId', VideoId.toString());
        if (PreferredLanguage != null)
            params = params.append('PreferredLanguage', PreferredLanguage.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Allows adding one or more new captions to an existing video */
    AddCaptionsToVideo(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Resources/AddCaptionsToVideo';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Secondary Playlist generation */
    SecondaryVideoPlaybackPlayList(hlsUrl, playbackUrl, armored_token, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/SecondaryVideoPlaybackPlayList';
        let params = this.newParams();
        if (hlsUrl != null)
            params = params.append('hlsUrl', hlsUrl.toString());
        if (playbackUrl != null)
            params = params.append('playbackUrl', playbackUrl.toString());
        if (armored_token != null)
            params = params.append('armored_token', armored_token.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Video proxy for captions */
    SecondaryVideoCaptionsPlayList(captionId, length, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/SecondaryVideoCaptionsPlayList';
        let params = this.newParams();
        if (captionId != null)
            params = params.append('captionId', captionId.toString());
        if (length != null)
            params = params.append('length', length.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Deletes the video passed. */
    DeleteVideo(VideoId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/DeleteVideo';
        let params = this.newParams();
        if (VideoId != null)
            params = params.append('VideoId', VideoId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Imports the resource into the selected lesson */
    ImportResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Resources/ImportResource';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a list of resources by parent and resource type */
    GetResourcesByParentAndType(parentId, parentType, resourceType, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/GetResourcesByParentAndType';
        let params = this.newParams();
        if (parentId != null)
            params = params.append('parentId', parentId.toString());
        if (parentType != null)
            params = params.append('parentType', parentType.toString());
        if (resourceType != null)
            params = params.append('resourceType', resourceType.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Deletes a Caption set */
    DeleteCaption(captionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/DeleteCaption';
        let params = this.newParams();
        if (captionId != null)
            params = params.append('captionId', captionId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a list of resources with their parents. */
    ListWithParents(itemType, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/ListWithParents';
        let params = this.newParams();
        if (itemType != null)
            params = params.append('itemType', itemType.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Create captions from lesson Script */
    CreateCaptionsFromScript(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Resources/CreateCaptionsFromScript';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Allows adding a link to an existing course or topic */
    AddLink(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Resources/AddLink';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Download a given resource by Id */
    DownloadResource(ResourceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/DownloadResource';
        let params = this.newParams();
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets a resource Url */
    GetResourceUrl(ResourceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/GetResourceUrl';
        let params = this.newParams();
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets a resource Url for Syndication partners */
    GetSyndicatedResourceUrl(ResourceId, Secret, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/GetSyndicatedResourceUrl';
        let params = this.newParams();
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        if (Secret != null)
            params = params.append('Secret', Secret.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets video token with applied secret */
    GetSyndicatedVideoTokenUrl(LessonId, Secret, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/GetSyndicatedVideoTokenUrl';
        let params = this.newParams();
        if (LessonId != null)
            params = params.append('LessonId', LessonId.toString());
        if (Secret != null)
            params = params.append('Secret', Secret.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Logs the view of a resource by the current user */
    LogResourceView(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Resources/LogResourceView';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the specified resource */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the given resources */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Resources/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Resources/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Resources/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
ResourcesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ResourcesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
ResourcesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ResourcesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ResourcesV1Client, decorators: [{
            type: Injectable
        }] });
class SalesTaxesV1Client extends BaseClient {
    /** Lists sales taxes */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/SalesTaxes/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of sales tax providers to apply to a sales tax. */
    ListProviders(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/ListProviders';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates/Inserts the specified sales taxes
<param name="dtos"></param><param name="cancellationToken"></param> */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/SalesTaxes/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the specified sales taxes
<param name="dtos"></param><param name="cancellationToken"></param> */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the specified sales taxes by id
<param name="id"></param><param name="cancellationToken"></param> */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists sales tax exemptions by contact
<param name="contactId"></param><param name="contactType"></param> */
    ListSalesTaxExemptionsByContact(contactId, contactType, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/ListSalesTaxExemptionsByContact';
        let params = this.newParams();
        if (contactId != null)
            params = params.append('contactId', contactId.toString());
        if (contactType != null)
            params = params.append('contactType', contactType.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists sales tax exemptions */
    ListSalesTaxExemptions(body = null, willHandleError = false) {
        let requestPath = '/v1/SalesTaxes/ListSalesTaxExemptions';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets a security token to view the certificate for the request */
    RequestCertificateAccessToken(SalesTaxExemptionNumber, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/RequestCertificateAccessToken';
        let params = this.newParams();
        if (SalesTaxExemptionNumber != null)
            params = params.append('SalesTaxExemptionNumber', SalesTaxExemptionNumber.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Get sales tax exemption
<param name="requestId"></param><param name="cancellationToken"></param> */
    GetSalesTaxExemption(requestId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/GetSalesTaxExemption';
        let params = this.newParams();
        if (requestId != null)
            params = params.append('requestId', requestId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates sales tax exemptions by contact
<param name="update"></param><param name="cancellationToken"></param> */
    UpdateSalesTaxExemption(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/SalesTaxes/UpdateSalesTaxExemption';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Allows a new user or existing user to request sales tax exemption. Creates or updates the contact, and adds the exemption without verifying and sends to the appropriate team for validation
<param name="request"></param><param name="cancellationToken" /> */
    RequestSalesTaxExemption(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/SalesTaxes/RequestSalesTaxExemption';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Rejects an outstanding request and notifies the admin on the account
<param name="requestId"></param><param name="cancellationToken"></param> */
    AcceptSalesTaxExemptionRequest(requestId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/AcceptSalesTaxExemptionRequest';
        let params = this.newParams();
        if (requestId != null)
            params = params.append('requestId', requestId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Rejects an outstanding request and notifies the admin on the account
<param name="requestId"></param><param name="reason"></param> */
    RejectSalesTaxExemptionRequest(requestId, reason, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/RejectSalesTaxExemptionRequest';
        let params = this.newParams();
        if (requestId != null)
            params = params.append('requestId', requestId.toString());
        if (reason != null)
            params = params.append('reason', reason.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Removes a previous request
<param name="requestId"></param><param name="cancellationToken"></param> */
    RemoveSalesTaxExemptionRequest(requestId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/RemoveSalesTaxExemptionRequest';
        let params = this.newParams();
        if (requestId != null)
            params = params.append('requestId', requestId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SalesTaxes/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
}
SalesTaxesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SalesTaxesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
SalesTaxesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SalesTaxesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SalesTaxesV1Client, decorators: [{
            type: Injectable
        }] });
class SearchV1Client extends BaseClient {
    /** Does a quick search for the top 5 items of each type that is returned. */
    QuickSearch(searchPhrase, languageCode, count, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Search/QuickSearch';
        let params = this.newParams();
        if (searchPhrase != null)
            params = params.append('searchPhrase', searchPhrase.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        if (count != null)
            params = params.append('count', count.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Searches all lessons and returns meta data to do an incremental property search. */
    SearchLessons(searchPhrase, languageCode, count, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Search/SearchLessons';
        let params = this.newParams();
        if (searchPhrase != null)
            params = params.append('searchPhrase', searchPhrase.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        if (count != null)
            params = params.append('count', count.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Searches for lessons based on product information */
    SearchLessonsByProductCodes(searchPhrase, count, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Search/SearchLessonsByProductCodes';
        let params = this.newParams();
        if (searchPhrase != null)
            params = params.append('searchPhrase', searchPhrase.toString());
        if (count != null)
            params = params.append('count', count.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets the list results Q would see. */
    SearchQuestionsTest(question, count, productId, versionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Search/SearchQuestionsTest';
        let params = this.newParams();
        if (question != null)
            params = params.append('question', question.toString());
        if (count != null)
            params = params.append('count', count.toString());
        if (productId != null)
            params = params.append('productId', productId.toString());
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
}
SearchV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SearchV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
SearchV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SearchV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SearchV1Client, decorators: [{
            type: Injectable
        }] });
class ShippingMethodsV1Client extends BaseClient {
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/ShippingMethods/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/ShippingMethods/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/ShippingMethods/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/ShippingMethods/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/ShippingMethods/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
ShippingMethodsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ShippingMethodsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
ShippingMethodsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ShippingMethodsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: ShippingMethodsV1Client, decorators: [{
            type: Injectable
        }] });
class SitesV1Client extends BaseClient {
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Sites/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Sites/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Sites/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Sites/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Sites/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
SitesV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SitesV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
SitesV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SitesV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SitesV1Client, decorators: [{
            type: Injectable
        }] });
class SupportV1Client extends BaseClient {
    /** Lists Questions with oData Filtering */
    ListQuestions(body = null, willHandleError = false) {
        let requestPath = '/v1/Support/ListQuestions';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists Questions by Answer */
    ListQuestionsByAnswer(answerId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Support/ListQuestionsByAnswer';
        let params = this.newParams();
        if (answerId != null)
            params = params.append('answerId', answerId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates Questions to support answers */
    UpdateAnswerQuestions(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Support/UpdateAnswerQuestions';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Support/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Support/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Support/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Support/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Support/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
SupportV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SupportV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
SupportV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SupportV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SupportV1Client, decorators: [{
            type: Injectable
        }] });
class SyndicationProvidersV1Client extends BaseClient {
    /** Returns a list of implementations for the specified provider */
    ListImplementations(providerId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SyndicationProviders/ListImplementations';
        let params = this.newParams();
        if (providerId != null)
            params = params.append('providerId', providerId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the specified provider's implementations. Should include all implementations for the given provider */
    UpdateImplementations(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/SyndicationProviders/UpdateImplementations';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SyndicationProviders/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/SyndicationProviders/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/SyndicationProviders/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SyndicationProviders/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/SyndicationProviders/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
SyndicationProvidersV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SyndicationProvidersV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
SyndicationProvidersV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SyndicationProvidersV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SyndicationProvidersV1Client, decorators: [{
            type: Injectable
        }] });
class SystemV1Client extends BaseClient {
    /** Returns a list of system settings */
    ListSystemSettings(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/ListSystemSettings';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets the current list of email domains that cannot be configured in the system */
    ListEmailDomainBlackLists(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/ListEmailDomainBlackLists';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Adds a domain to the blacklist */
    AddEmailDomainBlack(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/AddEmailDomainBlack';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Removes a domain from the blacklist */
    DeleteEmailDomainBlack(domain, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/DeleteEmailDomainBlack';
        let params = this.newParams();
        if (domain != null)
            params = params.append('domain', domain.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns a list of Edu Domains */
    ListEduDomains(body = null, willHandleError = false) {
        let requestPath = '/v1/System/ListEduDomains';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the set of configured edu domains */
    UpdateEduDomains(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/UpdateEduDomains';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Creates a new audience for the given client */
    CreateAudience(clientId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/CreateAudience';
        let params = this.newParams();
        if (clientId != null)
            params = params.append('clientId', clientId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Creates a new hash for the audience */
    RegenerateAudienceKey(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/RegenerateAudienceKey';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Deletes the specified audience */
    DeleteAudience(identifier, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/DeleteAudience';
        let params = this.newParams();
        if (identifier != null)
            params = params.append('identifier', identifier.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists the audiences for the specified client */
    ListAudiences(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/ListAudiences';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Clients all current clients */
    ListClients(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/ListClients';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Removes a client */
    DeleteClient(clientId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/DeleteClient';
        let params = this.newParams();
        if (clientId != null)
            params = params.append('clientId', clientId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Inserts or updates the given clients */
    UpsertClient(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/UpsertClient';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the client secret in the database. */
    ChangeClientSecret(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/ChangeClientSecret';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Get latest client version */
    GetLatestClientVersion(clientId, version, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/GetLatestClientVersion';
        let params = this.newParams();
        if (clientId != null)
            params = params.append('clientId', clientId.toString());
        if (version != null)
            params = params.append('version', version.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets a list of merge fields for a particular email template */
    ListMergeFields(emailKey, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/ListMergeFields';
        let params = this.newParams();
        if (emailKey != null)
            params = params.append('emailKey', emailKey.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a list of configured email templates */
    ListEmailTemplates(showInternal, body = null, willHandleError = false) {
        let requestPath = '/v1/System/ListEmailTemplates';
        let params = this.newParams();
        if (showInternal != null)
            params = params.append('showInternal', showInternal.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Get default email template */
    GetDefaultEmailTemplate(key, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/GetDefaultEmailTemplate';
        let params = this.newParams();
        if (key != null)
            params = params.append('key', key.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Update email templates */
    UpdateEmailTemplates(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/UpdateEmailTemplates';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Ping/Pong */
    Ping(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/Ping';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Ping/Pong */
    PostPing(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/PostPing';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets terms of service last updated date */
    GetTermsOfServiceDate(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/GetTermsOfServiceDate';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the set of configured system settings */
    UpdateSystemSettings(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/UpdateSystemSettings';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Broadcasts a system message to everyone. */
    BroadcastSystemMessage(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/BroadcastSystemMessage';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Reports an error from a secure client */
    ReportError(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/ReportError';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets a static page translation */
    GetPageTranslation(pageName, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/GetPageTranslation';
        let params = this.newParams();
        if (pageName != null)
            params = params.append('pageName', pageName.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates a static page translation */
    UpdatePageTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/UpdatePageTranslation';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets pages with their associated languages */
    GetPageTranslationLanguages(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/System/GetPageTranslationLanguages';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Copies a set of keys to a new language for a page */
    CopyFromPage(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/CopyFromPage';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Copies a set of keys to a new language for a page */
    DeletePageLanguage(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/DeletePageLanguage';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Because code gen generates dtos from API, I needs this in order for LanguageImportDto to be generated */
    ImportExcelLanguagesDummy(willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/ImportExcelLanguagesDummy';
        let params = this.newParams();
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Severs _sharepoint links */
    SeverSharepointLinks(willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/System/SeverSharepointLinks';
        let params = this.newParams();
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
}
SystemV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SystemV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
SystemV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SystemV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: SystemV1Client, decorators: [{
            type: Injectable
        }] });
class TokensV1Client extends BaseClient {
    /** Cancels the given token */
    Cancel(tokenId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Tokens/Cancel';
        let params = this.newParams();
        if (tokenId != null)
            params = params.append('tokenId', tokenId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Redeem the given token */
    Redeem(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Tokens/Redeem';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the tokens assigned to the given organization */
    ListByOrganizationId(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Tokens/ListByOrganizationId';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a list of tokens by who redeemed them */
    ListByRedeemedById(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Tokens/ListByRedeemedById';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Insert or update a tokens */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Tokens/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed tokens */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Tokens/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the tokens by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Tokens/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Tokens/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Tokens/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
TokensV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: TokensV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
TokensV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: TokensV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: TokensV1Client, decorators: [{
            type: Injectable
        }] });
class TopicsV1Client extends BaseClient {
    /** Adds a resource to a topic. The content and the file must be uploaded using multipart forms. */
    AddResource(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/AddResource';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Removes the selected resource from a topic. If the resource is no longer associated with anything the resource will be completely removed. */
    RemoveResource(TopicId, ResourceId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/RemoveResource';
        let params = this.newParams();
        if (TopicId != null)
            params = params.append('TopicId', TopicId.toString());
        if (ResourceId != null)
            params = params.append('ResourceId', ResourceId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Returns the resources (downloads etc.) associated with the specified lesson */
    ListResourcesByTypeAdmin(TopicId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/ListResourcesByTypeAdmin';
        let params = this.newParams();
        if (TopicId != null)
            params = params.append('TopicId', TopicId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the resources associated with the specified topic */
    ListResources(TopicId, ShowAll, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/ListResources';
        let params = this.newParams();
        if (TopicId != null)
            params = params.append('TopicId', TopicId.toString());
        if (ShowAll != null)
            params = params.append('ShowAll', ShowAll.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the information about t/he current topic and where it is in the workflow. If it isn't in the workflow then it puts it at stage 2 for triage by default. */
    GetWorkflowStatus(topicId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/GetWorkflowStatus';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the status of an item and if necessary creates a new item and returns the updated item to replace. */
    SetEditingStatus(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/SetEditingStatus';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the specified topic's workflow step and based on that will execute specific functions. */
    UpdateWorkflowStep(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/UpdateWorkflowStep';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the topic workflow task */
    UpdateWorkflowTask(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/UpdateWorkflowTask';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns all workflow assignees to the Topic. */
    ListAssignees(topicId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/ListAssignees';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the workflow assignments for a given Topic */
    UpdateAssignees(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/UpdateAssignees';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List items by topic id */
    ListItemsByTopicId(topicId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/ListItemsByTopicId';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get the specified translation */
    GetTranslation(topicId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/GetTranslation';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the specified translation */
    UpdateTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/UpdateTranslation';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Delete the specified translation */
    DeleteTranslation(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/DeleteTranslation';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the items for the Topic for editing. */
    GetStructureForEditing(topicId, showOnlyCadlearningVersions, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/GetStructureForEditing';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        if (showOnlyCadlearningVersions != null)
            params = params.append('showOnlyCadlearningVersions', showOnlyCadlearningVersions.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates the specified topic's structure with any changes from the user. All items must be included. */
    UpdateTopicStructure(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/UpdateTopicStructure';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists lesson with questions */
    ListLessonQuestions(topicId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/ListLessonQuestions';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Edit Introduction */
    EditIntroduction(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/EditIntroduction';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Edit Conclusion */
    EditConclusion(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/EditConclusion';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Get Admin version of the topic */
    GetAdmin(Id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/GetAdmin';
        let params = this.newParams();
        if (Id != null)
            params = params.append('Id', Id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Adds a new lesson to the existing topic. */
    CreateLesson(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/CreateLesson';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of syndicated lessons for the given topic */
    ListSyndicatedLessons(topicId, organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Topics/ListSyndicatedLessons';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists the syndications for the given topic */
    ListSyndications(topicId, body = null, willHandleError = false) {
        let requestPath = '/v1/Topics/ListSyndications';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the topic's syndications */
    UpdateSyndications(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/UpdateSyndications';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the syndication providers for the given topic */
    ListSyndicationProviders(topicId, body = null, willHandleError = false) {
        let requestPath = '/v1/Topics/ListSyndicationProviders';
        let params = this.newParams();
        if (topicId != null)
            params = params.append('topicId', topicId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the topic's syndication providers */
    UpdateSyndicationProviders(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/UpdateSyndicationProviders';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Creates a Custom Topic */
    CreateCustomTopic(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/CreateCustomTopic';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Insert or update a topics */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the passed topics */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the topics by the passed ids. */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Publish Topic */
    PublishTopic(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Topics/PublishTopic';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the tasks in project management related to the topic */
    ListProjectManagementTasks(TopicId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/ListProjectManagementTasks';
        let params = this.newParams();
        if (TopicId != null)
            params = params.append('TopicId', TopicId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Topics/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Topics/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
TopicsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: TopicsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
TopicsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: TopicsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: TopicsV1Client, decorators: [{
            type: Injectable
        }] });
class UsersV1Client extends BaseClient {
    /** Creates a data retrieval or removal request */
    CreateDataRequest(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/CreateDataRequest';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Approves a data retrieval or removal request */
    ApproveDataRequest(RequestId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ApproveDataRequest';
        let params = this.newParams();
        if (RequestId != null)
            params = params.append('RequestId', RequestId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Rejects a data retrieval or removal request */
    RejectDataRequest(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/RejectDataRequest';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Creates a data retrieval or removal request */
    DeleteDataRequest(RequestId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/DeleteDataRequest';
        let params = this.newParams();
        if (RequestId != null)
            params = params.append('RequestId', RequestId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Gets current user data retrieval or removal requests */
    GetUserDataRequestsWithDocuments(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetUserDataRequestsWithDocuments';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a data request */
    GetUserDataRequestWithDocuments(requestId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetUserDataRequestWithDocuments';
        let params = this.newParams();
        if (requestId != null)
            params = params.append('requestId', requestId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists data requests */
    ListUserDataRequests(body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListUserDataRequests';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Attaches zip to user data request and also downloads. */
    AttachActivityToUserRequest(userRequestId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/AttachActivityToUserRequest';
        let params = this.newParams();
        if (userRequestId != null)
            params = params.append('userRequestId', userRequestId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Removes the selected resource from a user request document. */
    RemoveUserRequestDocument(RequestId, DocumentId, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/RemoveUserRequestDocument';
        let params = this.newParams();
        if (RequestId != null)
            params = params.append('RequestId', RequestId.toString());
        if (DocumentId != null)
            params = params.append('DocumentId', DocumentId.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Adds a resource to a course. The resource must still be uploaded. */
    AddResourceToUserDataRequest(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AddResourceToUserDataRequest';
        let params = this.newParams();
        return this.PostOne(requestPath, BaseClient.FormFromData(body), params, willHandleError, withCredentials, progress);
    }
    /** Download the document specified. */
    DownloadUserRequestDocument(RequestId, DocumentId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/DownloadUserRequestDocument';
        let params = this.newParams();
        if (RequestId != null)
            params = params.append('RequestId', RequestId.toString());
        if (DocumentId != null)
            params = params.append('DocumentId', DocumentId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Set's the current user's default discipline id */
    SetDisciplines(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/SetDisciplines';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a discipline to a user */
    UpsertDiscipline(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpsertDiscipline';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Removes a user discipline */
    RemoveDiscipline(userId, disciplineId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/RemoveDiscipline';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (disciplineId != null)
            params = params.append('disciplineId', disciplineId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Removes a user Job */
    RemoveJob(userId, userJobId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/RemoveJob';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (userJobId != null)
            params = params.append('userJobId', userJobId.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Lists users selected disciplines, by discipline */
    ListSelectedUserDisciplines(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListSelectedUserDisciplines';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a users earned achievements for a particular organization */
    GetEarnedGamificationAwards(userId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetEarnedGamificationAwards';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets if Achievements are ready for display by the user. */
    AchievementsReady(userId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/AchievementsReady';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the user's jobs and status including disciplines and medallions. */
    JobStatus(userId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/JobStatus';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Progress Stats */
    ProgressStats(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ProgressStats';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Progress */
    Progress(userId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/Progress';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets the discipline learning path in the form of a Discipline first tree */
    GetLearningPath(userId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetLearningPath';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets the user's learning path */
    YourPath(userId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/YourPath';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets the Average Scores between the user, their organization, and the greater industry for the users goals */
    GetDisciplineAverageScores(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetDisciplineAverageScores';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets the Average Scores between the user, their organization, and the greater industry for the users jobs */
    GetJobAverageScores(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetJobAverageScores';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Return the Identity's To-do */
    WhatsNext(userId, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/WhatsNext';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Sets the current user's active organization */
    SetOrganization(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/SetOrganization';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Creates a Permission Request */
    ListPermissions(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListPermissions';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a list of all of the organizations that a user is assigned to */
    ListOrganizations(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListOrganizations';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets the current organizational message for the current user their selected organization */
    GetOrganizationalMessage(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetOrganizationalMessage';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Inserts or updates a new or existing users into the current user's managing organization */
    InsertOrUpdateUserAndOrganizationDetails(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/InsertOrUpdateUserAndOrganizationDetails';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Inserts or updates a new or existing users into the current user's managing organization */
    UpsertUserAndOrganizationDetails(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpsertUserAndOrganizationDetails';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Has the user logging in accepted the terms of agreement */
    ClearSSOLogins(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ClearSSOLogins';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Inserts or updates a new or existing users into the current user's managing organization */
    InsertOrUpdateUserAndOrganizationDetailsWithOrganization(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/InsertOrUpdateUserAndOrganizationDetailsWithOrganization';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Inserts or updates a new or existing users into the current user's managing organization */
    UpsertUserAndOrganizationDetailsWithOrganization(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpsertUserAndOrganizationDetailsWithOrganization';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the organizational user information */
    GetUserAndOrganizationDetailsWithOrganization(userId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetUserAndOrganizationDetailsWithOrganization';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of users for the given organization */
    ListByOrganizationId(organizationId, active, body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListByOrganizationId';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (active != null)
            params = params.append('active', active.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets the organizational user information */
    GetProspectOrgUserDetails(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetProspectOrgUserDetails';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists Permission Requests */
    ListPermissionRequests(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListPermissionRequests';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Resumes a Pre-Hire assessment */
    ResumePreHireAssessment(code, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/ResumePreHireAssessment';
        let params = this.newParams();
        if (code != null)
            params = params.append('code', code.toString());
        return this.PostOne(requestPath, null, params, willHandleError, withCredentials, progress);
    }
    /** Completes the assessment pre-hire process */
    CompleteAssessmentInvite(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/CompleteAssessmentInvite';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the Users that are part of the specified organization and roles */
    GetUsersByRolesAndOrganization(organizationId, roleId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetUsersByRolesAndOrganization';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        if (roleId != null)
            roleId.forEach(p => params = params.append('roleId', p.toString()));
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Submits the conversation's question and answer for review */
    SubmitConversationQuestionAnswer(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/SubmitConversationQuestionAnswer';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a bot conversation */
    GetConversation(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetConversation';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** List the user's custom reports */
    ListReports(body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListReports';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** List the user's custom reports */
    ListCustomReports(body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListCustomReports';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Returns a Identity report for editing */
    GetReport(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetReport';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a Identity report for editing */
    GetSavedReport(reportName, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetSavedReport';
        let params = this.newParams();
        if (reportName != null)
            params = params.append('reportName', reportName.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a Identity report for editing */
    GetCustomReport(reportName, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetCustomReport';
        let params = this.newParams();
        if (reportName != null)
            params = params.append('reportName', reportName.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates or Inserts the given Identity Report */
    UpsertReport(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpsertReport';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the given Identity Report by the Id of the report */
    DeleteReportById(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/DeleteReportById';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Requests access to the portal associated with the specified email address */
    RequestAccess(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/RequestAccess';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Allows password reset if a user cannot log in. */
    RequestResetPassword(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/RequestResetPassword';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Complete the password reset process */
    ResetPassword(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/ResetPassword';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Completes the request access verification process */
    VerifyRequestAccess(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/VerifyRequestAccess';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Circumvents the url process and simply grants a code */
    RequestVerifyEduWithCode(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/RequestVerifyEduWithCode';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /**  */
    AddEduSubscriptionToUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AddEduSubscriptionToUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a trial to a given user */
    AddTrialToUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AddTrialToUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a Subscription to the user */
    AddSubscriptionToUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AddSubscriptionToUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /**  */
    AddEduSubscriptionPaymentToUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AddEduSubscriptionPaymentToUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Adds a Subscription to the user */
    AddSubscriptionTokenToUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AddSubscriptionTokenToUser';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all users with administrative information */
    AdminList(body = null, willHandleError = false) {
        let requestPath = '/v1/Users/AdminList';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Gets the specified user with administrative information */
    AdminGet(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/AdminGet';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Inserts or updates an organization with administrative information. */
    AdminUpsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AdminUpsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Request the rights information for the specified lessons. */
    RequestLessonRights(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/RequestLessonRights';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Sends an email to one or more users */
    AdminSendEmail(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AdminSendEmail';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all of the jobs under the Identity. */
    ListJobs(userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListJobs';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Updates the user's jobs */
    UpdateJobs(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpdateJobs';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the user's jobs */
    UpsertJob(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpsertJob';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns a list of roles for the given user */
    ListUserRoles(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListUserRoles';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Assigns the specified roles to the user. All existing roles if not included will be removed. */
    AssignRolesToUser(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AssignRolesToUser';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns the current tasks of the user specified. */
    GetUnclaimedQuestions(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetUnclaimedQuestions';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the current tasks of the user specified. */
    GetCurrentAssignments(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetCurrentAssignments';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the current tasks of the user specified. */
    GetSMEContractorAssignments(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetSMEContractorAssignments';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists all courses that the user is assigned to for production */
    ListCoursesInProcess(userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListCoursesInProcess';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists the recent CMS Activity by the user */
    ListCMSRecentActivity(userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListCMSRecentActivity';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Report a translation error */
    ReportTranslationError(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/ReportTranslationError';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists reported translation errors */
    ListTranslationErrors(body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListTranslationErrors';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists reported translation errors */
    RemoveTranslationError(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/RemoveTranslationError';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Allows a user to change their password */
    ChangePassword(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/ChangePassword';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists the users saved product preferences */
    ListUserProductPreferences(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListUserProductPreferences';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates all currently logged in user's product version and course preferences */
    UpdateProductVersionCoursePreferences(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpdateProductVersionCoursePreferences';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Lists all stored payment credentials for the user */
    ListPaymentCredentials(userId, showAdmin, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListPaymentCredentials';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (showAdmin != null)
            params = params.append('showAdmin', showAdmin.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Lists a users email preferences */
    ListEmailPreferences(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListEmailPreferences';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Updates a users email preferences */
    UpdateEmailPreferences(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpdateEmailPreferences';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the organizational user information */
    GetUserAndOrganizationDetails(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetUserAndOrganizationDetails';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Allows administrators (only) to force a password change for a user. */
    AdminChangePassword(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AdminChangePassword';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Resets a user's password and allows them to go to the site to reset their password. */
    AdminResetPassword(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/AdminResetPassword';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Inserts or updates a new or existing users into the current user's managing organization */
    ListProspectContacts(organizationId, body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListProspectContacts';
        let params = this.newParams();
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or updates a new or existing users into the current user's managing organization */
    InsertOrUpdateUserAndProspectUserDetails(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/InsertOrUpdateUserAndProspectUserDetails';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Inserts or updates a new or existing users into the current user's managing organization */
    UpsertUserAndProspectUserDetails(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpsertUserAndProspectUserDetails';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Returns if the user has already had a trial on their account. */
    HasUserHadTrial(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/HasUserHadTrial';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Set user's Language */
    SetLanguage(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/SetLanguage';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Set's the current user's default project id */
    SetProject(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/SetProject';
        let params = this.newParams();
        return this.PutOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Updates the specified user's availability for expert escalation */
    UpdateAvailability(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpdateAvailability';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Return if the current user owns the specified product and version */
    GetProductVersionOwnership(versionId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetProductVersionOwnership';
        let params = this.newParams();
        if (versionId != null)
            params = params.append('versionId', versionId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Updates the currently logged in user's Product/Version/Course preferences */
    UpdateProductVersionCoursePreference(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpdateProductVersionCoursePreference';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /**  */
    GetExpiredUserEntitlements(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetExpiredUserEntitlements';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns all products suggested publicly if the user isn't logged in. */
    GetPublicSuggestedProducts(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetPublicSuggestedProducts';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns the suggested content for the home page Question Library */
    GetSuggestedContent(userId, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetSuggestedContent';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns suggested products in the order they should be displayed. */
    GetSuggestedProducts(userId, showAll, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetSuggestedProducts';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (showAll != null)
            params = params.append('showAll', showAll.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Returns suggested products in the order they should be displayed. */
    GetSuggestedProductsAdmin(userId, showAll, organizationId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetSuggestedProductsAdmin';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (showAll != null)
            params = params.append('showAll', showAll.toString());
        if (organizationId != null)
            params = params.append('organizationId', organizationId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List Projects */
    ListProjects(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/ListProjects';
        let params = this.newParams();
        return this.GetPageable(requestPath, params, willHandleError);
    }
    /** Returns the most recent courses viewed by the current user */
    GetRecentActivity(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetRecentActivity';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /**  */
    CheckForNotifications(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/CheckForNotifications';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Has the user logging in accepted the terms of agreement at the current time */
    AcceptTerms(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/AcceptTerms';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Has the user logging in accepted the terms of agreement */
    HasAcceptedTerms(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/HasAcceptedTerms';
        let params = this.newParams();
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Reports a command usage in the software. */
    GetCommandContentCount(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/GetCommandContentCount';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Report a page view from a user */
    ReportPage(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/ReportPage';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Report a page view from a user */
    ReportPageCommand(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/ReportPageCommand';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Reports a command usage in the software. */
    ReportCommand(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/ReportCommand';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Gets the user by username */
    GetUserByName(username, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/GetUserByName';
        let params = this.newParams();
        if (username != null)
            params = params.append('username', username.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Lists addresses by user id */
    ListAddresses(userId, body = null, willHandleError = false) {
        let requestPath = '/v1/Users/ListAddresses';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Update Identity Addresses */
    UpdateAddresses(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/UpdateAddresses';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Removes a user by encryption */
    RemoveByEncryption(UserId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/RemoveByEncryption';
        let params = this.newParams();
        if (UserId != null)
            params = params.append('UserId', UserId.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Gets Users recommended lessons based on selected disciplines */
    GetRecommendedLessons(userId, badgeId, medallionId, body = null, willHandleError = false) {
        let requestPath = '/v1/Users/GetRecommendedLessons';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        if (badgeId != null)
            params = params.append('badgeId', badgeId.toString());
        if (medallionId != null)
            params = params.append('medallionId', medallionId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Lists new Question since Last Seen. Will return a maximum of 200 results ordered descending by updated date. */
    NewContentSinceLastSeen(userId, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/NewContentSinceLastSeen';
        let params = this.newParams();
        if (userId != null)
            params = params.append('userId', userId.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Gets a specific Atom based on it's Id. */
    Get(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/Get';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.GetData(requestPath, params, undefined, willHandleError, withCredentials);
    }
    /** Returns a list of items */
    List(body = null, willHandleError = false) {
        let requestPath = '/v1/Users/List';
        let params = this.newParams();
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Inserts or Updates the dtos passed. */
    Upsert(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Users/Upsert';
        let params = this.newParams();
        return this.PostMany(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** Deletes the dto by Id */
    DeleteByIds(id, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/DeleteByIds';
        let params = this.newParams();
        if (id != null)
            params = params.append('id', id.toString());
        return this.DeleteAny(requestPath, params, willHandleError);
    }
    /** Deletes the dtos */
    Delete(body, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Users/Delete';
        let params = this.newParams();
        return this.DeleteAny(requestPath, params, willHandleError);
    }
}
UsersV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: UsersV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
UsersV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: UsersV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: UsersV1Client, decorators: [{
            type: Injectable
        }] });
class WorkflowsV1Client extends BaseClient {
    /** Updates the workflow assignments for a given translation */
    UpdateTranslationAssignees(body, willHandleError = false, withCredentials = false, progress) {
        let requestPath = '/v1/Workflows/UpdateTranslationAssignees';
        let params = this.newParams();
        return this.PostOne(requestPath, body, params, willHandleError, withCredentials, progress);
    }
    /** List the assignees to the given translation */
    ListAssignees(parentId, parentType, languageCode, willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Workflows/ListAssignees';
        let params = this.newParams();
        if (parentId != null)
            params = params.append('parentId', parentId.toString());
        if (parentType != null)
            params = params.append('parentType', parentType.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List All history for the item controlled by workflow */
    ListHistoryByItem(workflowId, itemId, languageCode, body = null, willHandleError = false) {
        let requestPath = '/v1/Workflows/ListHistoryByItem';
        let params = this.newParams();
        if (workflowId != null)
            params = params.append('workflowId', workflowId.toString());
        if (itemId != null)
            params = params.append('itemId', itemId.toString());
        if (languageCode != null)
            params = params.append('languageCode', languageCode.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
    /** Get a task in the workflow status */
    GetTaskStatus(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Workflows/GetTaskStatus';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** Get the workload report by users */
    GetWorkloadByUser(willHandleError = false, withCredentials = false) {
        let requestPath = '/v1/Workflows/GetWorkloadByUser';
        let params = this.newParams();
        return this.ListData(requestPath, params, willHandleError, withCredentials);
    }
    /** List workflow steps */
    ListWorkflowSteps(workflowId, body = null, willHandleError = false) {
        let requestPath = '/v1/Workflows/ListWorkflowSteps';
        let params = this.newParams();
        if (workflowId != null)
            params = params.append('workflowId', workflowId.toString());
        return this.PostPageable(requestPath, body, params, willHandleError);
    }
}
WorkflowsV1Client.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: WorkflowsV1Client, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
WorkflowsV1Client.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: WorkflowsV1Client });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: WorkflowsV1Client, decorators: [{
            type: Injectable
        }] });

var AssessmentsV1Urls;
(function (AssessmentsV1Urls) {
    AssessmentsV1Urls.AddResource = '/V1/Assessments/AddResource';
    AssessmentsV1Urls.RemoveResource = '/V1/Assessments/RemoveResource';
    AssessmentsV1Urls.ListResourcesByType = '/V1/Assessments/ListResourcesByType';
    AssessmentsV1Urls.ListResources = '/V1/Assessments/ListResources';
    AssessmentsV1Urls.GetWorkflowStatus = '/V1/Assessments/GetWorkflowStatus';
    AssessmentsV1Urls.UpdateWorkflowStep = '/V1/Assessments/UpdateWorkflowStep';
    AssessmentsV1Urls.UpdateWorkflowTask = '/V1/Assessments/UpdateWorkflowTask';
    AssessmentsV1Urls.ListAssignees = '/V1/Assessments/ListAssignees';
    AssessmentsV1Urls.UpdateAssignees = '/V1/Assessments/UpdateAssignees';
    AssessmentsV1Urls.ListQuestions = '/V1/Assessments/ListQuestions';
    AssessmentsV1Urls.ListWithParents = '/V1/Assessments/ListWithParents';
    AssessmentsV1Urls.InvitePreHireUser = '/V1/Assessments/InvitePreHireUser';
    AssessmentsV1Urls.InvitePreHireNewUser = '/V1/Assessments/InvitePreHireNewUser';
    AssessmentsV1Urls.InvitePreHireExistingUser = '/V1/Assessments/InvitePreHireExistingUser';
    AssessmentsV1Urls.ListAvailableAssessmentsByCourseId = '/V1/Assessments/ListAvailableAssessmentsByCourseId';
    AssessmentsV1Urls.AddAssessmentToCourse = '/V1/Assessments/AddAssessmentToCourse';
    AssessmentsV1Urls.RemoveAssessmentFromCourse = '/V1/Assessments/RemoveAssessmentFromCourse';
    AssessmentsV1Urls.GetTranslation = '/V1/Assessments/GetTranslation';
    AssessmentsV1Urls.UpdateTranslation = '/V1/Assessments/UpdateTranslation';
    AssessmentsV1Urls.GetAssessmentQuestionsWithParents = '/V1/Assessments/GetAssessmentQuestionsWithParents';
    AssessmentsV1Urls.ListCourses = '/V1/Assessments/ListCourses';
    AssessmentsV1Urls.ListBadges = '/V1/Assessments/ListBadges';
    AssessmentsV1Urls.ListMedallions = '/V1/Assessments/ListMedallions';
    AssessmentsV1Urls.UpdateCourses = '/V1/Assessments/UpdateCourses';
    AssessmentsV1Urls.UpdateBadges = '/V1/Assessments/UpdateBadges';
    AssessmentsV1Urls.UpdateMedallions = '/V1/Assessments/UpdateMedallions';
    AssessmentsV1Urls.ListCustomAssessments = '/V1/Assessments/ListCustomAssessments';
    AssessmentsV1Urls.RemoveAssessmentInvitation = '/V1/Assessments/RemoveAssessmentInvitation';
    AssessmentsV1Urls.ListAssessmentDynamicItems = '/V1/Assessments/ListAssessmentDynamicItems';
    AssessmentsV1Urls.ListAvailableAssessments = '/V1/Assessments/ListAvailableAssessments';
    AssessmentsV1Urls.UpdateAssessmentDynamicItems = '/V1/Assessments/UpdateAssessmentDynamicItems';
    AssessmentsV1Urls.UpdateQuestions = '/V1/Assessments/UpdateQuestions';
    AssessmentsV1Urls.GenerateAssessmentGamification = '/V1/Assessments/GenerateAssessmentGamification';
    AssessmentsV1Urls.GenerateAssessment = '/V1/Assessments/GenerateAssessment';
    AssessmentsV1Urls.GenerateGapAssessment = '/V1/Assessments/GenerateGapAssessment';
    AssessmentsV1Urls.GetQuestions = '/V1/Assessments/GetQuestions';
    AssessmentsV1Urls.GetQuestionsByCourseId = '/V1/Assessments/GetQuestionsByCourseId';
    AssessmentsV1Urls.GetQuestionsWithParents = '/V1/Assessments/GetQuestionsWithParents';
    AssessmentsV1Urls.ListUserTranscript = '/V1/Assessments/ListUserTranscript';
    AssessmentsV1Urls.ListTakenAssessments = '/V1/Assessments/ListTakenAssessments';
    AssessmentsV1Urls.GetAssessmentResults = '/V1/Assessments/GetAssessmentResults';
    AssessmentsV1Urls.ListAssessmentInvitations = '/V1/Assessments/ListAssessmentInvitations';
    AssessmentsV1Urls.RecordUserAssessmentAnswer = '/V1/Assessments/RecordUserAssessmentAnswer';
    AssessmentsV1Urls.GetUserAssessmentById = '/V1/Assessments/GetUserAssessmentById';
    AssessmentsV1Urls.GetUserAssessment = '/V1/Assessments/GetUserAssessment';
    AssessmentsV1Urls.DeleteUserAssessment = '/V1/Assessments/DeleteUserAssessment';
    AssessmentsV1Urls.GetAssessmentByPlayList = '/V1/Assessments/GetAssessmentByPlayList';
    AssessmentsV1Urls.ListByCourseId = '/V1/Assessments/ListByCourseId';
    AssessmentsV1Urls.ListManageableCustomAssessments = '/V1/Assessments/ListManageableCustomAssessments';
    AssessmentsV1Urls.Upsert = '/V1/Assessments/Upsert';
    AssessmentsV1Urls.Delete = '/V1/Assessments/Delete';
    AssessmentsV1Urls.DeleteByIds = '/V1/Assessments/DeleteByIds';
    AssessmentsV1Urls.DeleteTranslation = '/V1/Assessments/DeleteTranslation';
    AssessmentsV1Urls.GetQuestionOfTheDayAssessment = '/V1/Assessments/GetQuestionOfTheDayAssessment';
    AssessmentsV1Urls.RecordQuestionOfTheDayAnswer = '/V1/Assessments/RecordQuestionOfTheDayAnswer';
    AssessmentsV1Urls.Get = '/V1/Assessments/Get';
    AssessmentsV1Urls.List = '/V1/Assessments/List';
})(AssessmentsV1Urls || (AssessmentsV1Urls = {}));
var BadgesV1Urls;
(function (BadgesV1Urls) {
    BadgesV1Urls.Get = '/V1/Badges/Get';
    BadgesV1Urls.Upsert = '/V1/Badges/Upsert';
    BadgesV1Urls.RecalculateEarnedBadge = '/V1/Badges/RecalculateEarnedBadge';
    BadgesV1Urls.ListBadgesByMedallion = '/V1/Badges/ListBadgesByMedallion';
    BadgesV1Urls.ListLessons = '/V1/Badges/ListLessons';
    BadgesV1Urls.UpdateLessons = '/V1/Badges/UpdateLessons';
    BadgesV1Urls.AddImageResource = '/V1/Badges/AddImageResource';
    BadgesV1Urls.RemoveImageResource = '/V1/Badges/RemoveImageResource';
    BadgesV1Urls.DownloadImage = '/V1/Badges/DownloadImage';
    BadgesV1Urls.GetAchievementAssessment = '/V1/Badges/GetAchievementAssessment';
    BadgesV1Urls.GetLearningPath = '/V1/Badges/GetLearningPath';
    BadgesV1Urls.GetTranslations = '/V1/Badges/GetTranslations';
    BadgesV1Urls.GetTranslation = '/V1/Badges/GetTranslation';
    BadgesV1Urls.UpdateTranslation = '/V1/Badges/UpdateTranslation';
    BadgesV1Urls.DeleteTranslation = '/V1/Badges/DeleteTranslation';
    BadgesV1Urls.ListSyndicationProviders = '/V1/Badges/ListSyndicationProviders';
    BadgesV1Urls.UpdateSyndicationProviders = '/V1/Badges/UpdateSyndicationProviders';
    BadgesV1Urls.ListHeaderLessons = '/V1/Badges/ListHeaderLessons';
    BadgesV1Urls.UpdateHeaderLessons = '/V1/Badges/UpdateHeaderLessons';
    BadgesV1Urls.ListAvailableLessons = '/V1/Badges/ListAvailableLessons';
    BadgesV1Urls.Delete = '/V1/Badges/Delete';
    BadgesV1Urls.DeleteByIds = '/V1/Badges/DeleteByIds';
    BadgesV1Urls.ListGroups = '/V1/Badges/ListGroups';
    BadgesV1Urls.UpdateGroups = '/V1/Badges/UpdateGroups';
    BadgesV1Urls.CopyBadgeToOrganization = '/V1/Badges/CopyBadgeToOrganization';
    BadgesV1Urls.List = '/V1/Badges/List';
})(BadgesV1Urls || (BadgesV1Urls = {}));
var BotV1Urls;
(function (BotV1Urls) {
    BotV1Urls.GetConversation = '/V1/Bot/GetConversation';
    BotV1Urls.List = '/V1/Bot/List';
    BotV1Urls.Complete = '/V1/Bot/Complete';
    BotV1Urls.Add = '/V1/Bot/Add';
})(BotV1Urls || (BotV1Urls = {}));
var CampaignDripsV1Urls;
(function (CampaignDripsV1Urls) {
    CampaignDripsV1Urls.UpdateOverrideDrip = '/V1/CampaignDrips/UpdateOverrideDrip';
    CampaignDripsV1Urls.List = '/V1/CampaignDrips/List';
    CampaignDripsV1Urls.Get = '/V1/CampaignDrips/Get';
    CampaignDripsV1Urls.SendTest = '/V1/CampaignDrips/SendTest';
    CampaignDripsV1Urls.Upsert = '/V1/CampaignDrips/Upsert';
    CampaignDripsV1Urls.Delete = '/V1/CampaignDrips/Delete';
    CampaignDripsV1Urls.DeleteByIds = '/V1/CampaignDrips/DeleteByIds';
})(CampaignDripsV1Urls || (CampaignDripsV1Urls = {}));
var CampaignsV1Urls;
(function (CampaignsV1Urls) {
    CampaignsV1Urls.ListSubscriptions = '/V1/Campaigns/ListSubscriptions';
    CampaignsV1Urls.UpdateSubscriptions = '/V1/Campaigns/UpdateSubscriptions';
    CampaignsV1Urls.Get = '/V1/Campaigns/Get';
    CampaignsV1Urls.List = '/V1/Campaigns/List';
    CampaignsV1Urls.Upsert = '/V1/Campaigns/Upsert';
    CampaignsV1Urls.Delete = '/V1/Campaigns/Delete';
    CampaignsV1Urls.DeleteByIds = '/V1/Campaigns/DeleteByIds';
})(CampaignsV1Urls || (CampaignsV1Urls = {}));
var CoursesV1Urls;
(function (CoursesV1Urls) {
    CoursesV1Urls.AddResource = '/V1/Courses/AddResource';
    CoursesV1Urls.RemoveResource = '/V1/Courses/RemoveResource';
    CoursesV1Urls.ListResourcesByType = '/V1/Courses/ListResourcesByType';
    CoursesV1Urls.ListResources = '/V1/Courses/ListResources';
    CoursesV1Urls.SetEditingStatus = '/V1/Courses/SetEditingStatus';
    CoursesV1Urls.GetWorkflowStatus = '/V1/Courses/GetWorkflowStatus';
    CoursesV1Urls.UpdateWorkflowStep = '/V1/Courses/UpdateWorkflowStep';
    CoursesV1Urls.UpdateWorkflowTask = '/V1/Courses/UpdateWorkflowTask';
    CoursesV1Urls.ListAssignees = '/V1/Courses/ListAssignees';
    CoursesV1Urls.UpdateAssignees = '/V1/Courses/UpdateAssignees';
    CoursesV1Urls.ListItemsByCourseId = '/V1/Courses/ListItemsByCourseId';
    CoursesV1Urls.GetWithUserInfo = '/V1/Courses/GetWithUserInfo';
    CoursesV1Urls.UpdateTranslation = '/V1/Courses/UpdateTranslation';
    CoursesV1Urls.DeleteTranslation = '/V1/Courses/DeleteTranslation';
    CoursesV1Urls.ListLessonQuestions = '/V1/Courses/ListLessonQuestions';
    CoursesV1Urls.EditVersionPlan = '/V1/Courses/EditVersionPlan';
    CoursesV1Urls.CreateCourse = '/V1/Courses/CreateCourse';
    CoursesV1Urls.ImportCourse = '/V1/Courses/ImportCourse';
    CoursesV1Urls.DeactivateCourse = '/V1/Courses/DeactivateCourse';
    CoursesV1Urls.ListLessonsByCourse = '/V1/Courses/ListLessonsByCourse';
    CoursesV1Urls.ListLessonsByCourseAndVersion = '/V1/Courses/ListLessonsByCourseAndVersion';
    CoursesV1Urls.EditIntroduction = '/V1/Courses/EditIntroduction';
    CoursesV1Urls.EditConclusion = '/V1/Courses/EditConclusion';
    CoursesV1Urls.GetAdmin = '/V1/Courses/GetAdmin';
    CoursesV1Urls.CreateTopic = '/V1/Courses/CreateTopic';
    CoursesV1Urls.CreateLesson = '/V1/Courses/CreateLesson';
    CoursesV1Urls.ListTopicsWithSyndicatedContent = '/V1/Courses/ListTopicsWithSyndicatedContent';
    CoursesV1Urls.ListSyndications = '/V1/Courses/ListSyndications';
    CoursesV1Urls.UpdateSyndications = '/V1/Courses/UpdateSyndications';
    CoursesV1Urls.ListSyndicationProviders = '/V1/Courses/ListSyndicationProviders';
    CoursesV1Urls.UpdateSyndicationProviders = '/V1/Courses/UpdateSyndicationProviders';
    CoursesV1Urls.GetCourseFeed = '/V1/Courses/GetCourseFeed';
    CoursesV1Urls.UpdateCoursePath = '/V1/Courses/UpdateCoursePath';
    CoursesV1Urls.GetCoursePaths = '/V1/Courses/GetCoursePaths';
    CoursesV1Urls.UpdateOrganizations = '/V1/Courses/UpdateOrganizations';
    CoursesV1Urls.UpsertPublicVideos = '/V1/Courses/UpsertPublicVideos';
    CoursesV1Urls.ListOrganizations = '/V1/Courses/ListOrganizations';
    CoursesV1Urls.UpdateProductVersions = '/V1/Courses/UpdateProductVersions';
    CoursesV1Urls.ListProductVersions = '/V1/Courses/ListProductVersions';
    CoursesV1Urls.CreateCustomCourse = '/V1/Courses/CreateCustomCourse';
    CoursesV1Urls.ListCoursesByProductId = '/V1/Courses/ListCoursesByProductId';
    CoursesV1Urls.ListCoursesByProducts = '/V1/Courses/ListCoursesByProducts';
    CoursesV1Urls.GetWithTranslation = '/V1/Courses/GetWithTranslation';
    CoursesV1Urls.GetStructureWithUserInfo = '/V1/Courses/GetStructureWithUserInfo';
    CoursesV1Urls.GetStructurePublic = '/V1/Courses/GetStructurePublic';
    CoursesV1Urls.ListCustomCourses = '/V1/Courses/ListCustomCourses';
    CoursesV1Urls.GetStructureForEditing = '/V1/Courses/GetStructureForEditing';
    CoursesV1Urls.UpdateCustomCourseStructure = '/V1/Courses/UpdateCustomCourseStructure';
    CoursesV1Urls.GetSCORMPackage = '/V1/Courses/GetSCORMPackage';
    CoursesV1Urls.ListManageableCustomCourses = '/V1/Courses/ListManageableCustomCourses';
    CoursesV1Urls.Upsert = '/V1/Courses/Upsert';
    CoursesV1Urls.Delete = '/V1/Courses/Delete';
    CoursesV1Urls.DeleteByIds = '/V1/Courses/DeleteByIds';
    CoursesV1Urls.ListCoursesByOwner = '/V1/Courses/ListCoursesByOwner';
    CoursesV1Urls.ListCoursesByExternalPartner = '/V1/Courses/ListCoursesByExternalPartner';
    CoursesV1Urls.CourseForHireDashboard = '/V1/Courses/CourseForHireDashboard';
    CoursesV1Urls.PublishCourse = '/V1/Courses/PublishCourse';
    CoursesV1Urls.ListProjectManagementTasks = '/V1/Courses/ListProjectManagementTasks';
    CoursesV1Urls.EditRawAssets = '/V1/Courses/EditRawAssets';
    CoursesV1Urls.ListGroups = '/V1/Courses/ListGroups';
    CoursesV1Urls.UpdateGroups = '/V1/Courses/UpdateGroups';
    CoursesV1Urls.Get = '/V1/Courses/Get';
    CoursesV1Urls.List = '/V1/Courses/List';
})(CoursesV1Urls || (CoursesV1Urls = {}));
var DisciplinesV1Urls;
(function (DisciplinesV1Urls) {
    DisciplinesV1Urls.AdminList = '/V1/Disciplines/AdminList';
    DisciplinesV1Urls.RecalculateEarnedDiscipline = '/V1/Disciplines/RecalculateEarnedDiscipline';
    DisciplinesV1Urls.Delete = '/V1/Disciplines/Delete';
    DisciplinesV1Urls.DeleteByIds = '/V1/Disciplines/DeleteByIds';
    DisciplinesV1Urls.Get = '/V1/Disciplines/Get';
    DisciplinesV1Urls.GetOwned = '/V1/Disciplines/GetOwned';
    DisciplinesV1Urls.ListOwned = '/V1/Disciplines/ListOwned';
    DisciplinesV1Urls.Upsert = '/V1/Disciplines/Upsert';
    DisciplinesV1Urls.ListWithDisplayImages = '/V1/Disciplines/ListWithDisplayImages';
    DisciplinesV1Urls.ListWithProducts = '/V1/Disciplines/ListWithProducts';
    DisciplinesV1Urls.ListWithProductsByIndustry = '/V1/Disciplines/ListWithProductsByIndustry';
    DisciplinesV1Urls.ListMedallions = '/V1/Disciplines/ListMedallions';
    DisciplinesV1Urls.UpdateMedallions = '/V1/Disciplines/UpdateMedallions';
    DisciplinesV1Urls.ListIndustries = '/V1/Disciplines/ListIndustries';
    DisciplinesV1Urls.UpdateIndustries = '/V1/Disciplines/UpdateIndustries';
    DisciplinesV1Urls.ListOrganizations = '/V1/Disciplines/ListOrganizations';
    DisciplinesV1Urls.UpdateOrganizations = '/V1/Disciplines/UpdateOrganizations';
    DisciplinesV1Urls.DownloadImage = '/V1/Disciplines/DownloadImage';
    DisciplinesV1Urls.AddImageResource = '/V1/Disciplines/AddImageResource';
    DisciplinesV1Urls.RemoveImageResource = '/V1/Disciplines/RemoveImageResource';
    DisciplinesV1Urls.ListProducts = '/V1/Disciplines/ListProducts';
    DisciplinesV1Urls.UpdateProducts = '/V1/Disciplines/UpdateProducts';
    DisciplinesV1Urls.GetAchievementAssessment = '/V1/Disciplines/GetAchievementAssessment';
    DisciplinesV1Urls.GetLearningPath = '/V1/Disciplines/GetLearningPath';
    DisciplinesV1Urls.GetCertificateInfo = '/V1/Disciplines/GetCertificateInfo';
    DisciplinesV1Urls.UpsertPublicVideos = '/V1/Disciplines/UpsertPublicVideos';
    DisciplinesV1Urls.GetTranslations = '/V1/Disciplines/GetTranslations';
    DisciplinesV1Urls.GetTranslation = '/V1/Disciplines/GetTranslation';
    DisciplinesV1Urls.UpdateTranslation = '/V1/Disciplines/UpdateTranslation';
    DisciplinesV1Urls.DeleteTranslation = '/V1/Disciplines/DeleteTranslation';
    DisciplinesV1Urls.ListSyndicationProviders = '/V1/Disciplines/ListSyndicationProviders';
    DisciplinesV1Urls.UpdateSyndicationProviders = '/V1/Disciplines/UpdateSyndicationProviders';
    DisciplinesV1Urls.ListHeaderLessons = '/V1/Disciplines/ListHeaderLessons';
    DisciplinesV1Urls.UpdateHeaderLessons = '/V1/Disciplines/UpdateHeaderLessons';
    DisciplinesV1Urls.ListAvailableLessons = '/V1/Disciplines/ListAvailableLessons';
    DisciplinesV1Urls.ListDisciplinesByProductVersion = '/V1/Disciplines/ListDisciplinesByProductVersion';
    DisciplinesV1Urls.GetDisciplineStructureForEditing = '/V1/Disciplines/GetDisciplineStructureForEditing';
    DisciplinesV1Urls.SaveDisciplineStructure = '/V1/Disciplines/SaveDisciplineStructure';
    DisciplinesV1Urls.ListGroups = '/V1/Disciplines/ListGroups';
    DisciplinesV1Urls.UpdateGroups = '/V1/Disciplines/UpdateGroups';
    DisciplinesV1Urls.List = '/V1/Disciplines/List';
})(DisciplinesV1Urls || (DisciplinesV1Urls = {}));
var DocumentsV1Urls;
(function (DocumentsV1Urls) {
    DocumentsV1Urls.ListByCategory = '/V1/Documents/ListByCategory';
    DocumentsV1Urls.ListDocumentCategories = '/V1/Documents/ListDocumentCategories';
    DocumentsV1Urls.InsertOrUpdateDocumentCategory = '/V1/Documents/InsertOrUpdateDocumentCategory';
    DocumentsV1Urls.UpdateDocumentCategories = '/V1/Documents/UpdateDocumentCategories';
    DocumentsV1Urls.GetDocumentCategory = '/V1/Documents/GetDocumentCategory';
    DocumentsV1Urls.DeleteDocumentCategory = '/V1/Documents/DeleteDocumentCategory';
    DocumentsV1Urls.ListDocumentLinks = '/V1/Documents/ListDocumentLinks';
    DocumentsV1Urls.UpdateDocumentLinks = '/V1/Documents/UpdateDocumentLinks';
    DocumentsV1Urls.UploadDocument = '/V1/Documents/UploadDocument';
    DocumentsV1Urls.DownloadDocument = '/V1/Documents/DownloadDocument';
    DocumentsV1Urls.ListDocumentsByOrganization = '/V1/Documents/ListDocumentsByOrganization';
    DocumentsV1Urls.Upsert = '/V1/Documents/Upsert';
    DocumentsV1Urls.Delete = '/V1/Documents/Delete';
    DocumentsV1Urls.DeleteByIds = '/V1/Documents/DeleteByIds';
    DocumentsV1Urls.Get = '/V1/Documents/Get';
    DocumentsV1Urls.List = '/V1/Documents/List';
})(DocumentsV1Urls || (DocumentsV1Urls = {}));
var DomainsV1Urls;
(function (DomainsV1Urls) {
    DomainsV1Urls.UpdateAuthMethods = '/V1/Domains/UpdateAuthMethods';
    DomainsV1Urls.DeleteByIds = '/V1/Domains/DeleteByIds';
    DomainsV1Urls.UploadStyleSheet = '/V1/Domains/UploadStyleSheet';
    DomainsV1Urls.GetStyleSheet = '/V1/Domains/GetStyleSheet';
    DomainsV1Urls.GetDomainByEmailAddress = '/V1/Domains/GetDomainByEmailAddress';
    DomainsV1Urls.GetDomainWithAuthMethodsByUrl = '/V1/Domains/GetDomainWithAuthMethodsByUrl';
    DomainsV1Urls.ListAuthMethodsByDomainId = '/V1/Domains/ListAuthMethodsByDomainId';
    DomainsV1Urls.ListAuthMethodsByDomainIdAdmin = '/V1/Domains/ListAuthMethodsByDomainIdAdmin';
    DomainsV1Urls.Get = '/V1/Domains/Get';
    DomainsV1Urls.List = '/V1/Domains/List';
    DomainsV1Urls.Upsert = '/V1/Domains/Upsert';
    DomainsV1Urls.Delete = '/V1/Domains/Delete';
})(DomainsV1Urls || (DomainsV1Urls = {}));
var EntitlementsV1Urls;
(function (EntitlementsV1Urls) {
    EntitlementsV1Urls.Upsert = '/V1/Entitlements/Upsert';
    EntitlementsV1Urls.ListPaymentHistory = '/V1/Entitlements/ListPaymentHistory';
    EntitlementsV1Urls.ListOrgToolSubscriptionsByOrganizationId = '/V1/Entitlements/ListOrgToolSubscriptionsByOrganizationId';
    EntitlementsV1Urls.RenewSubscription = '/V1/Entitlements/RenewSubscription';
    EntitlementsV1Urls.RenewPartnerSubscription = '/V1/Entitlements/RenewPartnerSubscription';
    EntitlementsV1Urls.PurchaseSubscription = '/V1/Entitlements/PurchaseSubscription';
    EntitlementsV1Urls.ListByUserId = '/V1/Entitlements/ListByUserId';
    EntitlementsV1Urls.ListByOrganizationId = '/V1/Entitlements/ListByOrganizationId';
    EntitlementsV1Urls.CancelEntitlement = '/V1/Entitlements/CancelEntitlement';
    EntitlementsV1Urls.UpdateEntitlementPaymentDetails = '/V1/Entitlements/UpdateEntitlementPaymentDetails';
    EntitlementsV1Urls.UpdateOrganizationEntitlementUsers = '/V1/Entitlements/UpdateOrganizationEntitlementUsers';
    EntitlementsV1Urls.BulkCreateEntitlements = '/V1/Entitlements/BulkCreateEntitlements';
    EntitlementsV1Urls.Get = '/V1/Entitlements/Get';
    EntitlementsV1Urls.List = '/V1/Entitlements/List';
    EntitlementsV1Urls.DeleteByIds = '/V1/Entitlements/DeleteByIds';
    EntitlementsV1Urls.Delete = '/V1/Entitlements/Delete';
})(EntitlementsV1Urls || (EntitlementsV1Urls = {}));
var IndustriesV1Urls;
(function (IndustriesV1Urls) {
    IndustriesV1Urls.Get = '/V1/Industries/Get';
    IndustriesV1Urls.Upsert = '/V1/Industries/Upsert';
    IndustriesV1Urls.Delete = '/V1/Industries/Delete';
    IndustriesV1Urls.DeleteByIds = '/V1/Industries/DeleteByIds';
    IndustriesV1Urls.List = '/V1/Industries/List';
})(IndustriesV1Urls || (IndustriesV1Urls = {}));
var InventoryV1Urls;
(function (InventoryV1Urls) {
    InventoryV1Urls.UpdateItems = '/V1/Inventory/UpdateItems';
    InventoryV1Urls.GetBySku = '/V1/Inventory/GetBySku';
    InventoryV1Urls.ListItems = '/V1/Inventory/ListItems';
    InventoryV1Urls.GetWithPriceBySku = '/V1/Inventory/GetWithPriceBySku';
    InventoryV1Urls.ListWebProducts = '/V1/Inventory/ListWebProducts';
    InventoryV1Urls.ListWebSkusByCourse = '/V1/Inventory/ListWebSkusByCourse';
    InventoryV1Urls.Upsert = '/V1/Inventory/Upsert';
    InventoryV1Urls.Delete = '/V1/Inventory/Delete';
    InventoryV1Urls.DeleteByIds = '/V1/Inventory/DeleteByIds';
    InventoryV1Urls.Get = '/V1/Inventory/Get';
    InventoryV1Urls.List = '/V1/Inventory/List';
})(InventoryV1Urls || (InventoryV1Urls = {}));
var InvoicesV1Urls;
(function (InvoicesV1Urls) {
    InvoicesV1Urls.RequestSalesTaxes = '/V1/Invoices/RequestSalesTaxes';
    InvoicesV1Urls.CalculateTaxes = '/V1/Invoices/CalculateTaxes';
    InvoicesV1Urls.CopyQuote = '/V1/Invoices/CopyQuote';
    InvoicesV1Urls.VoidPayment = '/V1/Invoices/VoidPayment';
    InvoicesV1Urls.ShipInvoice = '/V1/Invoices/ShipInvoice';
    InvoicesV1Urls.UnlockInvoice = '/V1/Invoices/UnlockInvoice';
    InvoicesV1Urls.LockInvoiceForPayment = '/V1/Invoices/LockInvoiceForPayment';
    InvoicesV1Urls.CompleteInvoice = '/V1/Invoices/CompleteInvoice';
    InvoicesV1Urls.PostPaymentToInvoice = '/V1/Invoices/PostPaymentToInvoice';
    InvoicesV1Urls.ListStoredPaymentCredentials = '/V1/Invoices/ListStoredPaymentCredentials';
    InvoicesV1Urls.ListQuotesByOrganization = '/V1/Invoices/ListQuotesByOrganization';
    InvoicesV1Urls.ListBillsByOrganizationId = '/V1/Invoices/ListBillsByOrganizationId';
    InvoicesV1Urls.ListByUserId = '/V1/Invoices/ListByUserId';
    InvoicesV1Urls.ListRfqsByDeal = '/V1/Invoices/ListRfqsByDeal';
    InvoicesV1Urls.ListByOrganizationId = '/V1/Invoices/ListByOrganizationId';
    InvoicesV1Urls.AcceptQuote = '/V1/Invoices/AcceptQuote';
    InvoicesV1Urls.RejectQuote = '/V1/Invoices/RejectQuote';
    InvoicesV1Urls.ListForDisplay = '/V1/Invoices/ListForDisplay';
    InvoicesV1Urls.GetForDisplay = '/V1/Invoices/GetForDisplay';
    InvoicesV1Urls.SubmitQuote = '/V1/Invoices/SubmitQuote';
    InvoicesV1Urls.UpdateInventory = '/V1/Invoices/UpdateInventory';
    InvoicesV1Urls.ListQuotesByRFQ = '/V1/Invoices/ListQuotesByRFQ';
    InvoicesV1Urls.GetInventoryItemPrice = '/V1/Invoices/GetInventoryItemPrice';
    InvoicesV1Urls.DisputeInvoice = '/V1/Invoices/DisputeInvoice';
    InvoicesV1Urls.ListInventory = '/V1/Invoices/ListInventory';
    InvoicesV1Urls.ListPayments = '/V1/Invoices/ListPayments';
    InvoicesV1Urls.Upsert = '/V1/Invoices/Upsert';
    InvoicesV1Urls.Delete = '/V1/Invoices/Delete';
    InvoicesV1Urls.DeleteByIds = '/V1/Invoices/DeleteByIds';
    InvoicesV1Urls.Get = '/V1/Invoices/Get';
    InvoicesV1Urls.List = '/V1/Invoices/List';
})(InvoicesV1Urls || (InvoicesV1Urls = {}));
var JobsV1Urls;
(function (JobsV1Urls) {
    JobsV1Urls.Get = '/V1/Jobs/Get';
    JobsV1Urls.ListAvailableProductsAndVersions = '/V1/Jobs/ListAvailableProductsAndVersions';
    JobsV1Urls.Upsert = '/V1/Jobs/Upsert';
    JobsV1Urls.GetLearningPath = '/V1/Jobs/GetLearningPath';
    JobsV1Urls.ListJobsWithDisciplineIds = '/V1/Jobs/ListJobsWithDisciplineIds';
    JobsV1Urls.ListJobsWithProducts = '/V1/Jobs/ListJobsWithProducts';
    JobsV1Urls.ListProducts = '/V1/Jobs/ListProducts';
    JobsV1Urls.UpdateProducts = '/V1/Jobs/UpdateProducts';
    JobsV1Urls.ListIndustries = '/V1/Jobs/ListIndustries';
    JobsV1Urls.UpdateIndustries = '/V1/Jobs/UpdateIndustries';
    JobsV1Urls.ListOrganizations = '/V1/Jobs/ListOrganizations';
    JobsV1Urls.UpdateOrganizations = '/V1/Jobs/UpdateOrganizations';
    JobsV1Urls.Delete = '/V1/Jobs/Delete';
    JobsV1Urls.DeleteByIds = '/V1/Jobs/DeleteByIds';
    JobsV1Urls.AdminList = '/V1/Jobs/AdminList';
    JobsV1Urls.ListDisciplines = '/V1/Jobs/ListDisciplines';
    JobsV1Urls.UpdateDisciplines = '/V1/Jobs/UpdateDisciplines';
    JobsV1Urls.UpsertPublicVideos = '/V1/Jobs/UpsertPublicVideos';
    JobsV1Urls.RecalculateEarnedJob = '/V1/Jobs/RecalculateEarnedJob';
    JobsV1Urls.AddImageResource = '/V1/Jobs/AddImageResource';
    JobsV1Urls.RemoveImageResource = '/V1/Jobs/RemoveImageResource';
    JobsV1Urls.DownloadImage = '/V1/Jobs/DownloadImage';
    JobsV1Urls.GetAchievementAssessment = '/V1/Jobs/GetAchievementAssessment';
    JobsV1Urls.GetTranslations = '/V1/Jobs/GetTranslations';
    JobsV1Urls.GetTranslation = '/V1/Jobs/GetTranslation';
    JobsV1Urls.UpdateTranslation = '/V1/Jobs/UpdateTranslation';
    JobsV1Urls.DeleteTranslation = '/V1/Jobs/DeleteTranslation';
    JobsV1Urls.ListSyndicationProviders = '/V1/Jobs/ListSyndicationProviders';
    JobsV1Urls.UpdateSyndicationProviders = '/V1/Jobs/UpdateSyndicationProviders';
    JobsV1Urls.ListHeaderLessons = '/V1/Jobs/ListHeaderLessons';
    JobsV1Urls.UpdateHeaderLessons = '/V1/Jobs/UpdateHeaderLessons';
    JobsV1Urls.ListAvailableLessons = '/V1/Jobs/ListAvailableLessons';
    JobsV1Urls.ListGroups = '/V1/Jobs/ListGroups';
    JobsV1Urls.UpdateGroups = '/V1/Jobs/UpdateGroups';
    JobsV1Urls.List = '/V1/Jobs/List';
})(JobsV1Urls || (JobsV1Urls = {}));
var LessonsV1Urls;
(function (LessonsV1Urls) {
    LessonsV1Urls.ListProjectManagementTasks = '/V1/Lessons/ListProjectManagementTasks';
    LessonsV1Urls.CompleteLessonProjectManagementDependencies = '/V1/Lessons/CompleteLessonProjectManagementDependencies';
    LessonsV1Urls.JiraCompleteLessonCommands = '/V1/Lessons/JiraCompleteLessonCommands';
    LessonsV1Urls.JiraCompleteLessonQuestions = '/V1/Lessons/JiraCompleteLessonQuestions';
    LessonsV1Urls.JiraCompleteLessonResources = '/V1/Lessons/JiraCompleteLessonResources';
    LessonsV1Urls.SearchProjectManagementIssues = '/V1/Lessons/SearchProjectManagementIssues';
    LessonsV1Urls.AddResource = '/V1/Lessons/AddResource';
    LessonsV1Urls.RemoveResource = '/V1/Lessons/RemoveResource';
    LessonsV1Urls.ListResourcesByType = '/V1/Lessons/ListResourcesByType';
    LessonsV1Urls.ListResources = '/V1/Lessons/ListResources';
    LessonsV1Urls.UpdateWorkflowStep = '/V1/Lessons/UpdateWorkflowStep';
    LessonsV1Urls.ApproveWorkflowStep = '/V1/Lessons/ApproveWorkflowStep';
    LessonsV1Urls.RejectWorkflowStep = '/V1/Lessons/RejectWorkflowStep';
    LessonsV1Urls.GetWorkflowStatus = '/V1/Lessons/GetWorkflowStatus';
    LessonsV1Urls.UpdateWorkflowTask = '/V1/Lessons/UpdateWorkflowTask';
    LessonsV1Urls.ListAssignees = '/V1/Lessons/ListAssignees';
    LessonsV1Urls.UpdateAssignees = '/V1/Lessons/UpdateAssignees';
    LessonsV1Urls.SetCurrentUserRating = '/V1/Lessons/SetCurrentUserRating';
    LessonsV1Urls.Get = '/V1/Lessons/Get';
    LessonsV1Urls.GetLessonScript = '/V1/Lessons/GetLessonScript';
    LessonsV1Urls.GetNextAndPreviousLessons = '/V1/Lessons/GetNextAndPreviousLessons';
    LessonsV1Urls.GetNextAndPreviousLessonsByGoal = '/V1/Lessons/GetNextAndPreviousLessonsByGoal';
    LessonsV1Urls.GetNextAndPreviousLessonsByPlaylist = '/V1/Lessons/GetNextAndPreviousLessonsByPlaylist';
    LessonsV1Urls.GetLessonCoursesList = '/V1/Lessons/GetLessonCoursesList';
    LessonsV1Urls.ForceReloadBody = '/V1/Lessons/ForceReloadBody';
    LessonsV1Urls.EditBody = '/V1/Lessons/EditBody';
    LessonsV1Urls.EditRawAssets = '/V1/Lessons/EditRawAssets';
    LessonsV1Urls.GetRawAssetFiles = '/V1/Lessons/GetRawAssetFiles';
    LessonsV1Urls.GetPossibleLessonVersions = '/V1/Lessons/GetPossibleLessonVersions';
    LessonsV1Urls.ListLabels = '/V1/Lessons/ListLabels';
    LessonsV1Urls.ListAllLabels = '/V1/Lessons/ListAllLabels';
    LessonsV1Urls.UpdateLabels = '/V1/Lessons/UpdateLabels';
    LessonsV1Urls.ListDependencies = '/V1/Lessons/ListDependencies';
    LessonsV1Urls.UpdateDependencies = '/V1/Lessons/UpdateDependencies';
    LessonsV1Urls.RemoveFromProduction = '/V1/Lessons/RemoveFromProduction';
    LessonsV1Urls.GetAdmin = '/V1/Lessons/GetAdmin';
    LessonsV1Urls.GetTranslations = '/V1/Lessons/GetTranslations';
    LessonsV1Urls.GetTranslation = '/V1/Lessons/GetTranslation';
    LessonsV1Urls.UpdateTranslation = '/V1/Lessons/UpdateTranslation';
    LessonsV1Urls.DeleteTranslation = '/V1/Lessons/DeleteTranslation';
    LessonsV1Urls.CopyLesson = '/V1/Lessons/CopyLesson';
    LessonsV1Urls.ListLessonsWithCourses = '/V1/Lessons/ListLessonsWithCourses';
    LessonsV1Urls.ListSyndications = '/V1/Lessons/ListSyndications';
    LessonsV1Urls.UpdateSyndications = '/V1/Lessons/UpdateSyndications';
    LessonsV1Urls.ListSyndicationProviders = '/V1/Lessons/ListSyndicationProviders';
    LessonsV1Urls.UpdateSyndicationProviders = '/V1/Lessons/UpdateSyndicationProviders';
    LessonsV1Urls.UpsertPublicVideos = '/V1/Lessons/UpsertPublicVideos';
    LessonsV1Urls.ListLessonsWithCoursesForAssessment = '/V1/Lessons/ListLessonsWithCoursesForAssessment';
    LessonsV1Urls.ListProductVersions = '/V1/Lessons/ListProductVersions';
    LessonsV1Urls.CreateCustomLesson = '/V1/Lessons/CreateCustomLesson';
    LessonsV1Urls.UpdateProductVersions = '/V1/Lessons/UpdateProductVersions';
    LessonsV1Urls.ListCommands = '/V1/Lessons/ListCommands';
    LessonsV1Urls.ListPossibleLessonCommands = '/V1/Lessons/ListPossibleLessonCommands';
    LessonsV1Urls.UpdateCommands = '/V1/Lessons/UpdateCommands';
    LessonsV1Urls.LogLessonView = '/V1/Lessons/LogLessonView';
    LessonsV1Urls.GetPromoVideoUri = '/V1/Lessons/GetPromoVideoUri';
    LessonsV1Urls.GetLessonVideos = '/V1/Lessons/GetLessonVideos';
    LessonsV1Urls.GetOrganizationNote = '/V1/Lessons/GetOrganizationNote';
    LessonsV1Urls.UpdateOrganizationNotes = '/V1/Lessons/UpdateOrganizationNotes';
    LessonsV1Urls.GetLessonDetailsWithUserInfo = '/V1/Lessons/GetLessonDetailsWithUserInfo';
    LessonsV1Urls.GetLessonPublicDetails = '/V1/Lessons/GetLessonPublicDetails';
    LessonsV1Urls.GetLessonWorkflows = '/V1/Lessons/GetLessonWorkflows';
    LessonsV1Urls.SaveLessonOverrideThumbnail = '/V1/Lessons/SaveLessonOverrideThumbnail';
    LessonsV1Urls.PublishLesson = '/V1/Lessons/PublishLesson';
    LessonsV1Urls.GetPublicationStatus = '/V1/Lessons/GetPublicationStatus';
    LessonsV1Urls.ListBadges = '/V1/Lessons/ListBadges';
    LessonsV1Urls.ListMedallions = '/V1/Lessons/ListMedallions';
    LessonsV1Urls.ListDisciplines = '/V1/Lessons/ListDisciplines';
    LessonsV1Urls.ListJobs = '/V1/Lessons/ListJobs';
    LessonsV1Urls.ViewedInProduction = '/V1/Lessons/ViewedInProduction';
    LessonsV1Urls.Upsert = '/V1/Lessons/Upsert';
    LessonsV1Urls.Delete = '/V1/Lessons/Delete';
    LessonsV1Urls.DeleteByIds = '/V1/Lessons/DeleteByIds';
    LessonsV1Urls.List = '/V1/Lessons/List';
})(LessonsV1Urls || (LessonsV1Urls = {}));
var MedallionsV1Urls;
(function (MedallionsV1Urls) {
    MedallionsV1Urls.Delete = '/V1/Medallions/Delete';
    MedallionsV1Urls.DeleteByIds = '/V1/Medallions/DeleteByIds';
    MedallionsV1Urls.Get = '/V1/Medallions/Get';
    MedallionsV1Urls.Upsert = '/V1/Medallions/Upsert';
    MedallionsV1Urls.ListBadges = '/V1/Medallions/ListBadges';
    MedallionsV1Urls.UpdateBadges = '/V1/Medallions/UpdateBadges';
    MedallionsV1Urls.RecalculateEarnedMedallion = '/V1/Medallions/RecalculateEarnedMedallion';
    MedallionsV1Urls.AddImageResource = '/V1/Medallions/AddImageResource';
    MedallionsV1Urls.RemoveImageResource = '/V1/Medallions/RemoveImageResource';
    MedallionsV1Urls.DownloadImage = '/V1/Medallions/DownloadImage';
    MedallionsV1Urls.GetAchievementAssessment = '/V1/Medallions/GetAchievementAssessment';
    MedallionsV1Urls.GetLearningPath = '/V1/Medallions/GetLearningPath';
    MedallionsV1Urls.GetTranslations = '/V1/Medallions/GetTranslations';
    MedallionsV1Urls.GetTranslation = '/V1/Medallions/GetTranslation';
    MedallionsV1Urls.UpdateTranslation = '/V1/Medallions/UpdateTranslation';
    MedallionsV1Urls.DeleteTranslation = '/V1/Medallions/DeleteTranslation';
    MedallionsV1Urls.ListSyndicationProviders = '/V1/Medallions/ListSyndicationProviders';
    MedallionsV1Urls.UpdateSyndicationProviders = '/V1/Medallions/UpdateSyndicationProviders';
    MedallionsV1Urls.ListHeaderLessons = '/V1/Medallions/ListHeaderLessons';
    MedallionsV1Urls.UpdateHeaderLessons = '/V1/Medallions/UpdateHeaderLessons';
    MedallionsV1Urls.ListAvailableLessons = '/V1/Medallions/ListAvailableLessons';
    MedallionsV1Urls.ListGroups = '/V1/Medallions/ListGroups';
    MedallionsV1Urls.UpdateGroups = '/V1/Medallions/UpdateGroups';
    MedallionsV1Urls.CopyMedallionToOrganization = '/V1/Medallions/CopyMedallionToOrganization';
    MedallionsV1Urls.List = '/V1/Medallions/List';
})(MedallionsV1Urls || (MedallionsV1Urls = {}));
var OrganizationsV1Urls;
(function (OrganizationsV1Urls) {
    OrganizationsV1Urls.AddIndividualSubscriptionToPartner = '/V1/Organizations/AddIndividualSubscriptionToPartner';
    OrganizationsV1Urls.AddSubscriptionToPartnerOrganization = '/V1/Organizations/AddSubscriptionToPartnerOrganization';
    OrganizationsV1Urls.EnterpriseRequestInformation = '/V1/Organizations/EnterpriseRequestInformation';
    OrganizationsV1Urls.AddSubscriptionToOrganization = '/V1/Organizations/AddSubscriptionToOrganization';
    OrganizationsV1Urls.CompleteInvite = '/V1/Organizations/CompleteInvite';
    OrganizationsV1Urls.CompletePartnerSubscription = '/V1/Organizations/CompletePartnerSubscription';
    OrganizationsV1Urls.CompletePartnerSmbSubscription = '/V1/Organizations/CompletePartnerSmbSubscription';
    OrganizationsV1Urls.GetOrganizationUser = '/V1/Organizations/GetOrganizationUser';
    OrganizationsV1Urls.CanOrganizationSellResale = '/V1/Organizations/CanOrganizationSellResale';
    OrganizationsV1Urls.ListOrganizationUserJobs = '/V1/Organizations/ListOrganizationUserJobs';
    OrganizationsV1Urls.UpdateOrganizationUserJobs = '/V1/Organizations/UpdateOrganizationUserJobs';
    OrganizationsV1Urls.UpdateOrganizationUser = '/V1/Organizations/UpdateOrganizationUser';
    OrganizationsV1Urls.DeleteOrganizationUser = '/V1/Organizations/DeleteOrganizationUser';
    OrganizationsV1Urls.GetXApiCredentials = '/V1/Organizations/GetXApiCredentials';
    OrganizationsV1Urls.UpdateXApiCredentials = '/V1/Organizations/UpdateXApiCredentials';
    OrganizationsV1Urls.ListEmailDomains = '/V1/Organizations/ListEmailDomains';
    OrganizationsV1Urls.UpdateEmailDomains = '/V1/Organizations/UpdateEmailDomains';
    OrganizationsV1Urls.AdminUpsert = '/V1/Organizations/AdminUpsert';
    OrganizationsV1Urls.AdminList = '/V1/Organizations/AdminList';
    OrganizationsV1Urls.AssignRolesToUser = '/V1/Organizations/AssignRolesToUser';
    OrganizationsV1Urls.ListUserRoles = '/V1/Organizations/ListUserRoles';
    OrganizationsV1Urls.Broadcast = '/V1/Organizations/Broadcast';
    OrganizationsV1Urls.GetOrganizationMessages = '/V1/Organizations/GetOrganizationMessages';
    OrganizationsV1Urls.GetMessages = '/V1/Organizations/GetMessages';
    OrganizationsV1Urls.UpdateMessages = '/V1/Organizations/UpdateMessages';
    OrganizationsV1Urls.ListUserGroupCourses = '/V1/Organizations/ListUserGroupCourses';
    OrganizationsV1Urls.UpdateOrganizationGroupCourses = '/V1/Organizations/UpdateOrganizationGroupCourses';
    OrganizationsV1Urls.InviteUser = '/V1/Organizations/InviteUser';
    OrganizationsV1Urls.GetOrganizationContentCreationCapabilities = '/V1/Organizations/GetOrganizationContentCreationCapabilities';
    OrganizationsV1Urls.ListCustomers = '/V1/Organizations/ListCustomers';
    OrganizationsV1Urls.ListOrganizationUsers = '/V1/Organizations/ListOrganizationUsers';
    OrganizationsV1Urls.PartnerHasResaleSku = '/V1/Organizations/PartnerHasResaleSku';
    OrganizationsV1Urls.IsSmb = '/V1/Organizations/IsSmb';
    OrganizationsV1Urls.IsEduOrganization = '/V1/Organizations/IsEduOrganization';
    OrganizationsV1Urls.IsPartnerOrganization = '/V1/Organizations/IsPartnerOrganization';
    OrganizationsV1Urls.ListExpiringEntitlements = '/V1/Organizations/ListExpiringEntitlements';
    OrganizationsV1Urls.GetEmailTemplate = '/V1/Organizations/GetEmailTemplate';
    OrganizationsV1Urls.UpdateEmailTemplates = '/V1/Organizations/UpdateEmailTemplates';
    OrganizationsV1Urls.UpdatePartnerProspect = '/V1/Organizations/UpdatePartnerProspect';
    OrganizationsV1Urls.UpdatePartnerProspects = '/V1/Organizations/UpdatePartnerProspects';
    OrganizationsV1Urls.ListPartnerProspects = '/V1/Organizations/ListPartnerProspects';
    OrganizationsV1Urls.ListProspectContacts = '/V1/Organizations/ListProspectContacts';
    OrganizationsV1Urls.ListPartnerOrganizations = '/V1/Organizations/ListPartnerOrganizations';
    OrganizationsV1Urls.ListUserFields = '/V1/Organizations/ListUserFields';
    OrganizationsV1Urls.ListPaymentCredentials = '/V1/Organizations/ListPaymentCredentials';
    OrganizationsV1Urls.AdminGet = '/V1/Organizations/AdminGet';
    OrganizationsV1Urls.ListPermissionRequests = '/V1/Organizations/ListPermissionRequests';
    OrganizationsV1Urls.ListPermissions = '/V1/Organizations/ListPermissions';
    OrganizationsV1Urls.PermissionRequestSearch = '/V1/Organizations/PermissionRequestSearch';
    OrganizationsV1Urls.AcceptPermissionRequest = '/V1/Organizations/AcceptPermissionRequest';
    OrganizationsV1Urls.UpdatePermission = '/V1/Organizations/UpdatePermission';
    OrganizationsV1Urls.DenyPermissionRequest = '/V1/Organizations/DenyPermissionRequest';
    OrganizationsV1Urls.RevokePermission = '/V1/Organizations/RevokePermission';
    OrganizationsV1Urls.CreatePermissionRequest = '/V1/Organizations/CreatePermissionRequest';
    OrganizationsV1Urls.HasEntitlementSku = '/V1/Organizations/HasEntitlementSku';
    OrganizationsV1Urls.HasUnusedEntitlements = '/V1/Organizations/HasUnusedEntitlements';
    OrganizationsV1Urls.GetOrganizationFeatures = '/V1/Organizations/GetOrganizationFeatures';
    OrganizationsV1Urls.ListAddresses = '/V1/Organizations/ListAddresses';
    OrganizationsV1Urls.UpdateAddresses = '/V1/Organizations/UpdateAddresses';
    OrganizationsV1Urls.ListGroups = '/V1/Organizations/ListGroups';
    OrganizationsV1Urls.UpdateGroups = '/V1/Organizations/UpdateGroups';
    OrganizationsV1Urls.Get = '/V1/Organizations/Get';
    OrganizationsV1Urls.List = '/V1/Organizations/List';
    OrganizationsV1Urls.Upsert = '/V1/Organizations/Upsert';
    OrganizationsV1Urls.Delete = '/V1/Organizations/Delete';
    OrganizationsV1Urls.DeleteByIds = '/V1/Organizations/DeleteByIds';
    OrganizationsV1Urls.RunSmbRollup = '/V1/Organizations/RunSmbRollup';
    OrganizationsV1Urls.ListUserGroupsByUser = '/V1/Organizations/ListUserGroupsByUser';
    OrganizationsV1Urls.UpdateUserGroupsByUser = '/V1/Organizations/UpdateUserGroupsByUser';
    OrganizationsV1Urls.GetPartnerOrganizationGroups = '/V1/Organizations/GetPartnerOrganizationGroups';
    OrganizationsV1Urls.UploadPartnerUsers = '/V1/Organizations/UploadPartnerUsers';
    OrganizationsV1Urls.ListCoursesWithSyndicatedContent = '/V1/Organizations/ListCoursesWithSyndicatedContent';
    OrganizationsV1Urls.GetOrganizationContentOptions = '/V1/Organizations/GetOrganizationContentOptions';
    OrganizationsV1Urls.GetPublicOrganizationInfo = '/V1/Organizations/GetPublicOrganizationInfo';
    OrganizationsV1Urls.GetCurrentPriceList = '/V1/Organizations/GetCurrentPriceList';
})(OrganizationsV1Urls || (OrganizationsV1Urls = {}));
var PaymentMethodsV1Urls;
(function (PaymentMethodsV1Urls) {
    PaymentMethodsV1Urls.List = '/V1/PaymentMethods/List';
    PaymentMethodsV1Urls.Upsert = '/V1/PaymentMethods/Upsert';
    PaymentMethodsV1Urls.ListStoredPaymentCredentials = '/V1/PaymentMethods/ListStoredPaymentCredentials';
    PaymentMethodsV1Urls.GetStoredPaymentCredential = '/V1/PaymentMethods/GetStoredPaymentCredential';
    PaymentMethodsV1Urls.UpdateCreditCardPaymentCredentials = '/V1/PaymentMethods/UpdateCreditCardPaymentCredentials';
    PaymentMethodsV1Urls.InsertOrUpdatePaymentCredential = '/V1/PaymentMethods/InsertOrUpdatePaymentCredential';
    PaymentMethodsV1Urls.DeletePaymentCredential = '/V1/PaymentMethods/DeletePaymentCredential';
    PaymentMethodsV1Urls.Get = '/V1/PaymentMethods/Get';
    PaymentMethodsV1Urls.DeleteByIds = '/V1/PaymentMethods/DeleteByIds';
    PaymentMethodsV1Urls.Delete = '/V1/PaymentMethods/Delete';
})(PaymentMethodsV1Urls || (PaymentMethodsV1Urls = {}));
var PaymentProvidersV1Urls;
(function (PaymentProvidersV1Urls) {
    PaymentProvidersV1Urls.ListImplementations = '/V1/PaymentProviders/ListImplementations';
    PaymentProvidersV1Urls.UpdateImplementations = '/V1/PaymentProviders/UpdateImplementations';
    PaymentProvidersV1Urls.Get = '/V1/PaymentProviders/Get';
    PaymentProvidersV1Urls.List = '/V1/PaymentProviders/List';
    PaymentProvidersV1Urls.Upsert = '/V1/PaymentProviders/Upsert';
    PaymentProvidersV1Urls.DeleteByIds = '/V1/PaymentProviders/DeleteByIds';
    PaymentProvidersV1Urls.Delete = '/V1/PaymentProviders/Delete';
})(PaymentProvidersV1Urls || (PaymentProvidersV1Urls = {}));
var PlatformV1Urls;
(function (PlatformV1Urls) {
    PlatformV1Urls.ListReports = '/V1/Platform/ListReports';
    PlatformV1Urls.GetReport = '/V1/Platform/GetReport';
    PlatformV1Urls.UpsertReport = '/V1/Platform/UpsertReport';
    PlatformV1Urls.DeleteReport = '/V1/Platform/DeleteReport';
})(PlatformV1Urls || (PlatformV1Urls = {}));
var PlaylistsV1Urls;
(function (PlaylistsV1Urls) {
    PlaylistsV1Urls.Get = '/V1/Playlists/Get';
    PlaylistsV1Urls.Upsert = '/V1/Playlists/Upsert';
    PlaylistsV1Urls.UpsertWithContent = '/V1/Playlists/UpsertWithContent';
    PlaylistsV1Urls.ListPlaylistByUser = '/V1/Playlists/ListPlaylistByUser';
    PlaylistsV1Urls.ListPlayListUsers = '/V1/Playlists/ListPlayListUsers';
    PlaylistsV1Urls.DeletePlayListUser = '/V1/Playlists/DeletePlayListUser';
    PlaylistsV1Urls.ListPlayListsByOwningOrganization = '/V1/Playlists/ListPlayListsByOwningOrganization';
    PlaylistsV1Urls.GenerateGapLessons = '/V1/Playlists/GenerateGapLessons';
    PlaylistsV1Urls.InviteEmailAddressesToPlayList = '/V1/Playlists/InviteEmailAddressesToPlayList';
    PlaylistsV1Urls.InviteUsersByGroups = '/V1/Playlists/InviteUsersByGroups';
    PlaylistsV1Urls.InviteUsersToPlayList = '/V1/Playlists/InviteUsersToPlayList';
    PlaylistsV1Urls.ListSyndicationProviders = '/V1/Playlists/ListSyndicationProviders';
    PlaylistsV1Urls.UpdateSyndicationProviders = '/V1/Playlists/UpdateSyndicationProviders';
    PlaylistsV1Urls.ListHeaderLessons = '/V1/Playlists/ListHeaderLessons';
    PlaylistsV1Urls.UpdateHeaderLessons = '/V1/Playlists/UpdateHeaderLessons';
    PlaylistsV1Urls.ListAvailableLessons = '/V1/Playlists/ListAvailableLessons';
    PlaylistsV1Urls.List = '/V1/Playlists/List';
    PlaylistsV1Urls.DeleteByIds = '/V1/Playlists/DeleteByIds';
    PlaylistsV1Urls.Delete = '/V1/Playlists/Delete';
})(PlaylistsV1Urls || (PlaylistsV1Urls = {}));
var PreferencesV1Urls;
(function (PreferencesV1Urls) {
    PreferencesV1Urls.GetDefaultGridLayout = '/V1/Preferences/GetDefaultGridLayout';
    PreferencesV1Urls.ListGridLayouts = '/V1/Preferences/ListGridLayouts';
    PreferencesV1Urls.UpsertGridLayout = '/V1/Preferences/UpsertGridLayout';
    PreferencesV1Urls.DeleteGridLayout = '/V1/Preferences/DeleteGridLayout';
})(PreferencesV1Urls || (PreferencesV1Urls = {}));
var PriceListRevisionsV1Urls;
(function (PriceListRevisionsV1Urls) {
    PriceListRevisionsV1Urls.CopyRevision = '/V1/PriceListRevisions/CopyRevision';
    PriceListRevisionsV1Urls.ListInventory = '/V1/PriceListRevisions/ListInventory';
    PriceListRevisionsV1Urls.ListPartnerResaleBillingInventory = '/V1/PriceListRevisions/ListPartnerResaleBillingInventory';
    PriceListRevisionsV1Urls.UpdateInventory = '/V1/PriceListRevisions/UpdateInventory';
    PriceListRevisionsV1Urls.Get = '/V1/PriceListRevisions/Get';
    PriceListRevisionsV1Urls.List = '/V1/PriceListRevisions/List';
    PriceListRevisionsV1Urls.Upsert = '/V1/PriceListRevisions/Upsert';
    PriceListRevisionsV1Urls.DeleteByIds = '/V1/PriceListRevisions/DeleteByIds';
    PriceListRevisionsV1Urls.Delete = '/V1/PriceListRevisions/Delete';
})(PriceListRevisionsV1Urls || (PriceListRevisionsV1Urls = {}));
var PriceListsV1Urls;
(function (PriceListsV1Urls) {
    PriceListsV1Urls.ListRevisions = '/V1/PriceLists/ListRevisions';
    PriceListsV1Urls.Get = '/V1/PriceLists/Get';
    PriceListsV1Urls.List = '/V1/PriceLists/List';
    PriceListsV1Urls.Upsert = '/V1/PriceLists/Upsert';
    PriceListsV1Urls.DeleteByIds = '/V1/PriceLists/DeleteByIds';
    PriceListsV1Urls.Delete = '/V1/PriceLists/Delete';
})(PriceListsV1Urls || (PriceListsV1Urls = {}));
var ProductCategoriesV1Urls;
(function (ProductCategoriesV1Urls) {
    ProductCategoriesV1Urls.Get = '/V1/ProductCategories/Get';
    ProductCategoriesV1Urls.List = '/V1/ProductCategories/List';
    ProductCategoriesV1Urls.Upsert = '/V1/ProductCategories/Upsert';
    ProductCategoriesV1Urls.DeleteByIds = '/V1/ProductCategories/DeleteByIds';
    ProductCategoriesV1Urls.Delete = '/V1/ProductCategories/Delete';
})(ProductCategoriesV1Urls || (ProductCategoriesV1Urls = {}));
var ProductsV1Urls;
(function (ProductsV1Urls) {
    ProductsV1Urls.ChangesFeed = '/V1/Products/ChangesFeed';
    ProductsV1Urls.GetVersionFromWebUrl = '/V1/Products/GetVersionFromWebUrl';
    ProductsV1Urls.GetVersionFromVendorInfo = '/V1/Products/GetVersionFromVendorInfo';
    ProductsV1Urls.ListVendorIds = '/V1/Products/ListVendorIds';
    ProductsV1Urls.UpdateVendorIds = '/V1/Products/UpdateVendorIds';
    ProductsV1Urls.GetTranslation = '/V1/Products/GetTranslation';
    ProductsV1Urls.UpdateTranslation = '/V1/Products/UpdateTranslation';
    ProductsV1Urls.ListTranslationCategories = '/V1/Products/ListTranslationCategories';
    ProductsV1Urls.UpdateTranslationCategories = '/V1/Products/UpdateTranslationCategories';
    ProductsV1Urls.ListCategories = '/V1/Products/ListCategories';
    ProductsV1Urls.UpdateCategories = '/V1/Products/UpdateCategories';
    ProductsV1Urls.GetProductVersionIdsFromAppInfo = '/V1/Products/GetProductVersionIdsFromAppInfo';
    ProductsV1Urls.ListVersionCommands = '/V1/Products/ListVersionCommands';
    ProductsV1Urls.ListVersionCommandLessons = '/V1/Products/ListVersionCommandLessons';
    ProductsV1Urls.GetProductVersionCommandWithTranslations = '/V1/Products/GetProductVersionCommandWithTranslations';
    ProductsV1Urls.UpsertProductVersionCommandWithTranslations = '/V1/Products/UpsertProductVersionCommandWithTranslations';
    ProductsV1Urls.RemoveProductVersionCommand = '/V1/Products/RemoveProductVersionCommand';
    ProductsV1Urls.ListLessonsByProductVersion = '/V1/Products/ListLessonsByProductVersion';
    ProductsV1Urls.ListLessonsByProductVersionForAddVersion = '/V1/Products/ListLessonsByProductVersionForAddVersion';
    ProductsV1Urls.AddVersion = '/V1/Products/AddVersion';
    ProductsV1Urls.ListCoursesByProductVersion = '/V1/Products/ListCoursesByProductVersion';
    ProductsV1Urls.UpdateVersions = '/V1/Products/UpdateVersions';
    ProductsV1Urls.ListCustomProducts = '/V1/Products/ListCustomProducts';
    ProductsV1Urls.AddProductImageResource = '/V1/Products/AddProductImageResource';
    ProductsV1Urls.RemoveProductImage = '/V1/Products/RemoveProductImage';
    ProductsV1Urls.CreateCustomProduct = '/V1/Products/CreateCustomProduct';
    ProductsV1Urls.ListProductWebAddresses = '/V1/Products/ListProductWebAddresses';
    ProductsV1Urls.UpdateProductWebAddresses = '/V1/Products/UpdateProductWebAddresses';
    ProductsV1Urls.ListActiveProducts = '/V1/Products/ListActiveProducts';
    ProductsV1Urls.ListCoursesByVersion = '/V1/Products/ListCoursesByVersion';
    ProductsV1Urls.ListCoursesByVersionAdmin = '/V1/Products/ListCoursesByVersionAdmin';
    ProductsV1Urls.ListWorkflowsByVersion = '/V1/Products/ListWorkflowsByVersion';
    ProductsV1Urls.GetProductCourse = '/V1/Products/GetProductCourse';
    ProductsV1Urls.GetProductVersionCourse = '/V1/Products/GetProductVersionCourse';
    ProductsV1Urls.GetVersionsAdmin = '/V1/Products/GetVersionsAdmin';
    ProductsV1Urls.GetVersions = '/V1/Products/GetVersions';
    ProductsV1Urls.GetVersionByProductIds = '/V1/Products/GetVersionByProductIds';
    ProductsV1Urls.GetWithLanguage = '/V1/Products/GetWithLanguage';
    ProductsV1Urls.Upsert = '/V1/Products/Upsert';
    ProductsV1Urls.Delete = '/V1/Products/Delete';
    ProductsV1Urls.DeleteByIds = '/V1/Products/DeleteByIds';
    ProductsV1Urls.ListSites = '/V1/Products/ListSites';
    ProductsV1Urls.UpdateSites = '/V1/Products/UpdateSites';
    ProductsV1Urls.Get = '/V1/Products/Get';
    ProductsV1Urls.List = '/V1/Products/List';
})(ProductsV1Urls || (ProductsV1Urls = {}));
var ProjectsV1Urls;
(function (ProjectsV1Urls) {
    ProjectsV1Urls.CreatePrehireAssessment = '/V1/Projects/CreatePrehireAssessment';
    ProjectsV1Urls.ListProducts = '/V1/Projects/ListProducts';
    ProjectsV1Urls.ListJobs = '/V1/Projects/ListJobs';
    ProjectsV1Urls.DeleteJob = '/V1/Projects/DeleteJob';
    ProjectsV1Urls.GetJob = '/V1/Projects/GetJob';
    ProjectsV1Urls.UpsertJob = '/V1/Projects/UpsertJob';
    ProjectsV1Urls.UpdateProducts = '/V1/Projects/UpdateProducts';
    ProjectsV1Urls.MatchProjectJobToUsers = '/V1/Projects/MatchProjectJobToUsers';
    ProjectsV1Urls.Upsert = '/V1/Projects/Upsert';
    ProjectsV1Urls.Delete = '/V1/Projects/Delete';
    ProjectsV1Urls.DeleteByIds = '/V1/Projects/DeleteByIds';
    ProjectsV1Urls.Get = '/V1/Projects/Get';
    ProjectsV1Urls.List = '/V1/Projects/List';
})(ProjectsV1Urls || (ProjectsV1Urls = {}));
var PublicVideosV1Urls;
(function (PublicVideosV1Urls) {
    PublicVideosV1Urls.Get = '/V1/PublicVideos/Get';
    PublicVideosV1Urls.Upsert = '/V1/PublicVideos/Upsert';
    PublicVideosV1Urls.AddResource = '/V1/PublicVideos/AddResource';
    PublicVideosV1Urls.RemoveResource = '/V1/PublicVideos/RemoveResource';
    PublicVideosV1Urls.ListCourses = '/V1/PublicVideos/ListCourses';
    PublicVideosV1Urls.UpsertCourses = '/V1/PublicVideos/UpsertCourses';
    PublicVideosV1Urls.ListLessons = '/V1/PublicVideos/ListLessons';
    PublicVideosV1Urls.ListByCourse = '/V1/PublicVideos/ListByCourse';
    PublicVideosV1Urls.ListByLesson = '/V1/PublicVideos/ListByLesson';
    PublicVideosV1Urls.ListByDiscipline = '/V1/PublicVideos/ListByDiscipline';
    PublicVideosV1Urls.ListByJob = '/V1/PublicVideos/ListByJob';
    PublicVideosV1Urls.UpsertLessons = '/V1/PublicVideos/UpsertLessons';
    PublicVideosV1Urls.ListDisciplines = '/V1/PublicVideos/ListDisciplines';
    PublicVideosV1Urls.UpsertDisciplines = '/V1/PublicVideos/UpsertDisciplines';
    PublicVideosV1Urls.ListJobs = '/V1/PublicVideos/ListJobs';
    PublicVideosV1Urls.UpsertJobs = '/V1/PublicVideos/UpsertJobs';
    PublicVideosV1Urls.GetVideoCaptions = '/V1/PublicVideos/GetVideoCaptions';
    PublicVideosV1Urls.DeleteVideo = '/V1/PublicVideos/DeleteVideo';
    PublicVideosV1Urls.DeleteCaption = '/V1/PublicVideos/DeleteCaption';
    PublicVideosV1Urls.GetTranslation = '/V1/PublicVideos/GetTranslation';
    PublicVideosV1Urls.GetRelatedVideosByCourses = '/V1/PublicVideos/GetRelatedVideosByCourses';
    PublicVideosV1Urls.GetRelatedVideosByLessons = '/V1/PublicVideos/GetRelatedVideosByLessons';
    PublicVideosV1Urls.GetRelatedVideosByDisciplines = '/V1/PublicVideos/GetRelatedVideosByDisciplines';
    PublicVideosV1Urls.GetRelatedVideosByJobs = '/V1/PublicVideos/GetRelatedVideosByJobs';
    PublicVideosV1Urls.List = '/V1/PublicVideos/List';
    PublicVideosV1Urls.DeleteByIds = '/V1/PublicVideos/DeleteByIds';
    PublicVideosV1Urls.Delete = '/V1/PublicVideos/Delete';
})(PublicVideosV1Urls || (PublicVideosV1Urls = {}));
var QuestionsV1Urls;
(function (QuestionsV1Urls) {
    QuestionsV1Urls.AddResource = '/V1/Questions/AddResource';
    QuestionsV1Urls.RemoveResource = '/V1/Questions/RemoveResource';
    QuestionsV1Urls.ListResourcesByType = '/V1/Questions/ListResourcesByType';
    QuestionsV1Urls.ListResources = '/V1/Questions/ListResources';
    QuestionsV1Urls.ListAssignees = '/V1/Questions/ListAssignees';
    QuestionsV1Urls.UpdateAssignees = '/V1/Questions/UpdateAssignees';
    QuestionsV1Urls.GetWorkflowStatus = '/V1/Questions/GetWorkflowStatus';
    QuestionsV1Urls.UpdateWorkflowStep = '/V1/Questions/UpdateWorkflowStep';
    QuestionsV1Urls.UpdateWorkflowTask = '/V1/Questions/UpdateWorkflowTask';
    QuestionsV1Urls.Get = '/V1/Questions/Get';
    QuestionsV1Urls.GetTranslation = '/V1/Questions/GetTranslation';
    QuestionsV1Urls.UpdateTranslation = '/V1/Questions/UpdateTranslation';
    QuestionsV1Urls.DeleteTranslation = '/V1/Questions/DeleteTranslation';
    QuestionsV1Urls.ListAnswerPossibleLessons = '/V1/Questions/ListAnswerPossibleLessons';
    QuestionsV1Urls.ListLessonsWithTime = '/V1/Questions/ListLessonsWithTime';
    QuestionsV1Urls.UpdateLessonsWithTime = '/V1/Questions/UpdateLessonsWithTime';
    QuestionsV1Urls.ListAnswerBranchingQuestions = '/V1/Questions/ListAnswerBranchingQuestions';
    QuestionsV1Urls.ListAvailableForQuestionBranch = '/V1/Questions/ListAvailableForQuestionBranch';
    QuestionsV1Urls.UpdateBranchingQuestions = '/V1/Questions/UpdateBranchingQuestions';
    QuestionsV1Urls.ListLessons = '/V1/Questions/ListLessons';
    QuestionsV1Urls.UpdateLessons = '/V1/Questions/UpdateLessons';
    QuestionsV1Urls.UpdateAnswers = '/V1/Questions/UpdateAnswers';
    QuestionsV1Urls.ListByAssessmentId = '/V1/Questions/ListByAssessmentId';
    QuestionsV1Urls.AddLesson = '/V1/Questions/AddLesson';
    QuestionsV1Urls.HelpQuestionAddLesson = '/V1/Questions/HelpQuestionAddLesson';
    QuestionsV1Urls.RemoveLesson = '/V1/Questions/RemoveLesson';
    QuestionsV1Urls.HelpQuestionRemoveLesson = '/V1/Questions/HelpQuestionRemoveLesson';
    QuestionsV1Urls.ListAvailableForLessonAdd = '/V1/Questions/ListAvailableForLessonAdd';
    QuestionsV1Urls.ListAnswerSuggestedLessons = '/V1/Questions/ListAnswerSuggestedLessons';
    QuestionsV1Urls.ImportQuestionToOrganization = '/V1/Questions/ImportQuestionToOrganization';
    QuestionsV1Urls.ListAvailableForAssessmentAdd = '/V1/Questions/ListAvailableForAssessmentAdd';
    QuestionsV1Urls.UpdateAnswerSuggestedLessons = '/V1/Questions/UpdateAnswerSuggestedLessons';
    QuestionsV1Urls.PublicListByLessonId = '/V1/Questions/PublicListByLessonId';
    QuestionsV1Urls.ListByLessonId = '/V1/Questions/ListByLessonId';
    QuestionsV1Urls.ListByLessonIdWithAnswers = '/V1/Questions/ListByLessonIdWithAnswers';
    QuestionsV1Urls.ListByLessonIdWithWorkflow = '/V1/Questions/ListByLessonIdWithWorkflow';
    QuestionsV1Urls.ListHelpQuestionsByLessonId = '/V1/Questions/ListHelpQuestionsByLessonId';
    QuestionsV1Urls.ListHelpQuestions = '/V1/Questions/ListHelpQuestions';
    QuestionsV1Urls.Upsert = '/V1/Questions/Upsert';
    QuestionsV1Urls.UpsertHelpQuestions = '/V1/Questions/UpsertHelpQuestions';
    QuestionsV1Urls.ListOrphanedQuestions = '/V1/Questions/ListOrphanedQuestions';
    QuestionsV1Urls.Delete = '/V1/Questions/Delete';
    QuestionsV1Urls.DeleteByIds = '/V1/Questions/DeleteByIds';
    QuestionsV1Urls.List = '/V1/Questions/List';
})(QuestionsV1Urls || (QuestionsV1Urls = {}));
var ReportsV1Urls;
(function (ReportsV1Urls) {
    ReportsV1Urls.UserActivity = '/V1/Reports/UserActivity';
    ReportsV1Urls.ListReports = '/V1/Reports/ListReports';
    ReportsV1Urls.ActiveUsersByMonth = '/V1/Reports/ActiveUsersByMonth';
    ReportsV1Urls.MostRecentBadges = '/V1/Reports/MostRecentBadges';
    ReportsV1Urls.OrganizationStats = '/V1/Reports/OrganizationStats';
    ReportsV1Urls.GrossMRR = '/V1/Reports/GrossMRR';
    ReportsV1Urls.GrossARR = '/V1/Reports/GrossARR';
    ReportsV1Urls.GrossMRRTrends = '/V1/Reports/GrossMRRTrends';
    ReportsV1Urls.GrossARRTrends = '/V1/Reports/GrossARRTrends';
    ReportsV1Urls.MonthlyChurnTrends = '/V1/Reports/MonthlyChurnTrends';
    ReportsV1Urls.YearlyChurnTrends = '/V1/Reports/YearlyChurnTrends';
    ReportsV1Urls.MonthlyChurnRate = '/V1/Reports/MonthlyChurnRate';
    ReportsV1Urls.YearlyChurnRate = '/V1/Reports/YearlyChurnRate';
    ReportsV1Urls.OrganizationEngagementTrends = '/V1/Reports/OrganizationEngagementTrends';
    ReportsV1Urls.OrganizationSkillsGaps = '/V1/Reports/OrganizationSkillsGaps';
    ReportsV1Urls.OrganizationSkillsGapsAtDate = '/V1/Reports/OrganizationSkillsGapsAtDate';
    ReportsV1Urls.OrganizationMostImprovedEmployees = '/V1/Reports/OrganizationMostImprovedEmployees';
    ReportsV1Urls.OrganizationStrugglingEmployees = '/V1/Reports/OrganizationStrugglingEmployees';
    ReportsV1Urls.OrganizationMostEngaged = '/V1/Reports/OrganizationMostEngaged';
    ReportsV1Urls.OrganizationLeastEngaged = '/V1/Reports/OrganizationLeastEngaged';
    ReportsV1Urls.OrganizationRockStars = '/V1/Reports/OrganizationRockStars';
    ReportsV1Urls.EmployeesAssignedToRoles = '/V1/Reports/EmployeesAssignedToRoles';
    ReportsV1Urls.EmployeesAssignedToGoals = '/V1/Reports/EmployeesAssignedToGoals';
    ReportsV1Urls.EmployeeRoleSummary = '/V1/Reports/EmployeeRoleSummary';
    ReportsV1Urls.EmployeeGoalSummary = '/V1/Reports/EmployeeGoalSummary';
    ReportsV1Urls.EmployeeRoleSummaryFlattened = '/V1/Reports/EmployeeRoleSummaryFlattened';
    ReportsV1Urls.EmployeeGoalSummaryFlattened = '/V1/Reports/EmployeeGoalSummaryFlattened';
    ReportsV1Urls.DownloadGoalData = '/V1/Reports/DownloadGoalData';
    ReportsV1Urls.DownloadRoleData = '/V1/Reports/DownloadRoleData';
    ReportsV1Urls.ScheduleReport = '/V1/Reports/ScheduleReport';
    ReportsV1Urls.GetReportSchedule = '/V1/Reports/GetReportSchedule';
    ReportsV1Urls.ListReportSchedules = '/V1/Reports/ListReportSchedules';
    ReportsV1Urls.TotalInActiveUsersByOrganization = '/V1/Reports/TotalInActiveUsersByOrganization';
    ReportsV1Urls.TotalAssessmentsOverEntitlementPeriod = '/V1/Reports/TotalAssessmentsOverEntitlementPeriod';
    ReportsV1Urls.TotalActiveUsersByOrganization = '/V1/Reports/TotalActiveUsersByOrganization';
    ReportsV1Urls.MostTakenAssessmentsByOrganization = '/V1/Reports/MostTakenAssessmentsByOrganization';
    ReportsV1Urls.MostActiveProductsByOrganization = '/V1/Reports/MostActiveProductsByOrganization';
    ReportsV1Urls.TotalUsersByOrganization = '/V1/Reports/TotalUsersByOrganization';
    ReportsV1Urls.ListTrials = '/V1/Reports/ListTrials';
    ReportsV1Urls.GetPartnerSalesRepInfo = '/V1/Reports/GetPartnerSalesRepInfo';
    ReportsV1Urls.ListPartnerRedeemedTokens = '/V1/Reports/ListPartnerRedeemedTokens';
    ReportsV1Urls.ListBillableInventory = '/V1/Reports/ListBillableInventory';
    ReportsV1Urls.GetUserActivity = '/V1/Reports/GetUserActivity';
    ReportsV1Urls.WorkflowStalledItems = '/V1/Reports/WorkflowStalledItems';
    ReportsV1Urls.WorkflowErrors = '/V1/Reports/WorkflowErrors';
    ReportsV1Urls.WorkflowAgingItems = '/V1/Reports/WorkflowAgingItems';
    ReportsV1Urls.WorkflowTaskChanges = '/V1/Reports/WorkflowTaskChanges';
    ReportsV1Urls.TotalActiveMonthlies = '/V1/Reports/TotalActiveMonthlies';
    ReportsV1Urls.TotalActiveYearlies = '/V1/Reports/TotalActiveYearlies';
    ReportsV1Urls.UsersOnline = '/V1/Reports/UsersOnline';
    ReportsV1Urls.PlatformTotals = '/V1/Reports/PlatformTotals';
    ReportsV1Urls.CourseGlanceReport = '/V1/Reports/CourseGlanceReport';
    ReportsV1Urls.TopPartnersByLeads = '/V1/Reports/TopPartnersByLeads';
    ReportsV1Urls.TopPartnersByDollarsSold = '/V1/Reports/TopPartnersByDollarsSold';
    ReportsV1Urls.TopSales = '/V1/Reports/TopSales';
    ReportsV1Urls.TopOrganizationsByDollarsSold = '/V1/Reports/TopOrganizationsByDollarsSold';
    ReportsV1Urls.UpcomingEnterpriseRenewals = '/V1/Reports/UpcomingEnterpriseRenewals';
    ReportsV1Urls.MostActiveProducts = '/V1/Reports/MostActiveProducts';
    ReportsV1Urls.ListPartnerActivity = '/V1/Reports/ListPartnerActivity';
    ReportsV1Urls.AssessmentUserHistory = '/V1/Reports/AssessmentUserHistory';
    ReportsV1Urls.AssessmentDistributionReport = '/V1/Reports/AssessmentDistributionReport';
    ReportsV1Urls.AssessmentReportCard = '/V1/Reports/AssessmentReportCard';
    ReportsV1Urls.ListProjectLessonViews = '/V1/Reports/ListProjectLessonViews';
    ReportsV1Urls.CourseList = '/V1/Reports/CourseList';
    ReportsV1Urls.DownloadAssessmentData = '/V1/Reports/DownloadAssessmentData';
    ReportsV1Urls.ListLessonActivityDetails = '/V1/Reports/ListLessonActivityDetails';
    ReportsV1Urls.ListUserLessonViews = '/V1/Reports/ListUserLessonViews';
    ReportsV1Urls.ListProjectUserViews = '/V1/Reports/ListProjectUserViews';
    ReportsV1Urls.ListProjectLessonActivity = '/V1/Reports/ListProjectLessonActivity';
    ReportsV1Urls.ListProductVersionViews = '/V1/Reports/ListProductVersionViews';
    ReportsV1Urls.ListProductLessonViews = '/V1/Reports/ListProductLessonViews';
    ReportsV1Urls.ListProductCommandViews = '/V1/Reports/ListProductCommandViews';
    ReportsV1Urls.ListLessonViews = '/V1/Reports/ListLessonViews';
    ReportsV1Urls.ListActivity = '/V1/Reports/ListActivity';
    ReportsV1Urls.ListResourceViews = '/V1/Reports/ListResourceViews';
    ReportsV1Urls.ListGroupViews = '/V1/Reports/ListGroupViews';
    ReportsV1Urls.ListGroupProductViews = '/V1/Reports/ListGroupProductViews';
    ReportsV1Urls.OrganizationUserEntitlements = '/V1/Reports/OrganizationUserEntitlements';
    ReportsV1Urls.OrganizationUsers = '/V1/Reports/OrganizationUsers';
    ReportsV1Urls.ListPartnerTokens = '/V1/Reports/ListPartnerTokens';
    ReportsV1Urls.CourseCompletionByUser = '/V1/Reports/CourseCompletionByUser';
    ReportsV1Urls.CourseCompletionLessonsByUser = '/V1/Reports/CourseCompletionLessonsByUser';
    ReportsV1Urls.MostPopularLessons = '/V1/Reports/MostPopularLessons';
    ReportsV1Urls.SignupsByMonth = '/V1/Reports/SignupsByMonth';
    ReportsV1Urls.SignupsByMonthDetail = '/V1/Reports/SignupsByMonthDetail';
    ReportsV1Urls.TimeSavedAcrossOrganization = '/V1/Reports/TimeSavedAcrossOrganization';
    ReportsV1Urls.SubscriptionsPerInvoice = '/V1/Reports/SubscriptionsPerInvoice';
    ReportsV1Urls.GetBadgeWithUsersAchieved = '/V1/Reports/GetBadgeWithUsersAchieved';
    ReportsV1Urls.GetTestedOutAchievements = '/V1/Reports/GetTestedOutAchievements';
    ReportsV1Urls.CompetenciesAchievedByOrganization = '/V1/Reports/CompetenciesAchievedByOrganization';
})(ReportsV1Urls || (ReportsV1Urls = {}));
var ResourcesV1Urls;
(function (ResourcesV1Urls) {
    ResourcesV1Urls.GetVideoPermissions = '/V1/Resources/GetVideoPermissions';
    ResourcesV1Urls.QueueCreateVideoFromResources = '/V1/Resources/QueueCreateVideoFromResources';
    ResourcesV1Urls.VideoPublic = '/V1/Resources/VideoPublic';
    ResourcesV1Urls.PlaybackPublicVideo = '/V1/Resources/PlaybackPublicVideo';
    ResourcesV1Urls.VideoFromLesson = '/V1/Resources/VideoFromLesson';
    ResourcesV1Urls.PlaybackVideoFromLesson = '/V1/Resources/PlaybackVideoFromLesson';
    ResourcesV1Urls.Video = '/V1/Resources/Video';
    ResourcesV1Urls.PlaybackVideo = '/V1/Resources/PlaybackVideo';
    ResourcesV1Urls.GetVideoCaptions = '/V1/Resources/GetVideoCaptions';
    ResourcesV1Urls.AddCaptionsToVideo = '/V1/Resources/AddCaptionsToVideo';
    ResourcesV1Urls.SecondaryVideoPlaybackPlayList = '/V1/Resources/SecondaryVideoPlaybackPlayList';
    ResourcesV1Urls.SecondaryVideoCaptionsPlayList = '/V1/Resources/SecondaryVideoCaptionsPlayList';
    ResourcesV1Urls.DeleteVideo = '/V1/Resources/DeleteVideo';
    ResourcesV1Urls.ImportResource = '/V1/Resources/ImportResource';
    ResourcesV1Urls.GetResourcesByParentAndType = '/V1/Resources/GetResourcesByParentAndType';
    ResourcesV1Urls.DeleteCaption = '/V1/Resources/DeleteCaption';
    ResourcesV1Urls.ListWithParents = '/V1/Resources/ListWithParents';
    ResourcesV1Urls.CreateCaptionsFromScript = '/V1/Resources/CreateCaptionsFromScript';
    ResourcesV1Urls.AddLink = '/V1/Resources/AddLink';
    ResourcesV1Urls.DownloadResource = '/V1/Resources/DownloadResource';
    ResourcesV1Urls.GetResourceUrl = '/V1/Resources/GetResourceUrl';
    ResourcesV1Urls.GetSyndicatedResourceUrl = '/V1/Resources/GetSyndicatedResourceUrl';
    ResourcesV1Urls.GetSyndicatedVideoTokenUrl = '/V1/Resources/GetSyndicatedVideoTokenUrl';
    ResourcesV1Urls.LogResourceView = '/V1/Resources/LogResourceView';
    ResourcesV1Urls.Get = '/V1/Resources/Get';
    ResourcesV1Urls.Upsert = '/V1/Resources/Upsert';
    ResourcesV1Urls.List = '/V1/Resources/List';
    ResourcesV1Urls.DeleteByIds = '/V1/Resources/DeleteByIds';
    ResourcesV1Urls.Delete = '/V1/Resources/Delete';
})(ResourcesV1Urls || (ResourcesV1Urls = {}));
var SalesTaxesV1Urls;
(function (SalesTaxesV1Urls) {
    SalesTaxesV1Urls.List = '/V1/SalesTaxes/List';
    SalesTaxesV1Urls.ListProviders = '/V1/SalesTaxes/ListProviders';
    SalesTaxesV1Urls.Upsert = '/V1/SalesTaxes/Upsert';
    SalesTaxesV1Urls.Delete = '/V1/SalesTaxes/Delete';
    SalesTaxesV1Urls.DeleteByIds = '/V1/SalesTaxes/DeleteByIds';
    SalesTaxesV1Urls.ListSalesTaxExemptionsByContact = '/V1/SalesTaxes/ListSalesTaxExemptionsByContact';
    SalesTaxesV1Urls.ListSalesTaxExemptions = '/V1/SalesTaxes/ListSalesTaxExemptions';
    SalesTaxesV1Urls.RequestCertificateAccessToken = '/V1/SalesTaxes/RequestCertificateAccessToken';
    SalesTaxesV1Urls.GetSalesTaxExemption = '/V1/SalesTaxes/GetSalesTaxExemption';
    SalesTaxesV1Urls.UpdateSalesTaxExemption = '/V1/SalesTaxes/UpdateSalesTaxExemption';
    SalesTaxesV1Urls.RequestSalesTaxExemption = '/V1/SalesTaxes/RequestSalesTaxExemption';
    SalesTaxesV1Urls.AcceptSalesTaxExemptionRequest = '/V1/SalesTaxes/AcceptSalesTaxExemptionRequest';
    SalesTaxesV1Urls.RejectSalesTaxExemptionRequest = '/V1/SalesTaxes/RejectSalesTaxExemptionRequest';
    SalesTaxesV1Urls.RemoveSalesTaxExemptionRequest = '/V1/SalesTaxes/RemoveSalesTaxExemptionRequest';
    SalesTaxesV1Urls.Get = '/V1/SalesTaxes/Get';
})(SalesTaxesV1Urls || (SalesTaxesV1Urls = {}));
var SearchV1Urls;
(function (SearchV1Urls) {
    SearchV1Urls.QuickSearch = '/V1/Search/QuickSearch';
    SearchV1Urls.SearchLessons = '/V1/Search/SearchLessons';
    SearchV1Urls.SearchLessonsByProductCodes = '/V1/Search/SearchLessonsByProductCodes';
    SearchV1Urls.SearchQuestionsTest = '/V1/Search/SearchQuestionsTest';
})(SearchV1Urls || (SearchV1Urls = {}));
var ShippingMethodsV1Urls;
(function (ShippingMethodsV1Urls) {
    ShippingMethodsV1Urls.Get = '/V1/ShippingMethods/Get';
    ShippingMethodsV1Urls.List = '/V1/ShippingMethods/List';
    ShippingMethodsV1Urls.Upsert = '/V1/ShippingMethods/Upsert';
    ShippingMethodsV1Urls.DeleteByIds = '/V1/ShippingMethods/DeleteByIds';
    ShippingMethodsV1Urls.Delete = '/V1/ShippingMethods/Delete';
})(ShippingMethodsV1Urls || (ShippingMethodsV1Urls = {}));
var SitesV1Urls;
(function (SitesV1Urls) {
    SitesV1Urls.Get = '/V1/Sites/Get';
    SitesV1Urls.List = '/V1/Sites/List';
    SitesV1Urls.Upsert = '/V1/Sites/Upsert';
    SitesV1Urls.DeleteByIds = '/V1/Sites/DeleteByIds';
    SitesV1Urls.Delete = '/V1/Sites/Delete';
})(SitesV1Urls || (SitesV1Urls = {}));
var SupportV1Urls;
(function (SupportV1Urls) {
    SupportV1Urls.ListQuestions = '/V1/Support/ListQuestions';
    SupportV1Urls.ListQuestionsByAnswer = '/V1/Support/ListQuestionsByAnswer';
    SupportV1Urls.UpdateAnswerQuestions = '/V1/Support/UpdateAnswerQuestions';
    SupportV1Urls.Get = '/V1/Support/Get';
    SupportV1Urls.List = '/V1/Support/List';
    SupportV1Urls.Upsert = '/V1/Support/Upsert';
    SupportV1Urls.DeleteByIds = '/V1/Support/DeleteByIds';
    SupportV1Urls.Delete = '/V1/Support/Delete';
})(SupportV1Urls || (SupportV1Urls = {}));
var SyndicationProvidersV1Urls;
(function (SyndicationProvidersV1Urls) {
    SyndicationProvidersV1Urls.ListImplementations = '/V1/SyndicationProviders/ListImplementations';
    SyndicationProvidersV1Urls.UpdateImplementations = '/V1/SyndicationProviders/UpdateImplementations';
    SyndicationProvidersV1Urls.Get = '/V1/SyndicationProviders/Get';
    SyndicationProvidersV1Urls.List = '/V1/SyndicationProviders/List';
    SyndicationProvidersV1Urls.Upsert = '/V1/SyndicationProviders/Upsert';
    SyndicationProvidersV1Urls.DeleteByIds = '/V1/SyndicationProviders/DeleteByIds';
    SyndicationProvidersV1Urls.Delete = '/V1/SyndicationProviders/Delete';
})(SyndicationProvidersV1Urls || (SyndicationProvidersV1Urls = {}));
var SystemV1Urls;
(function (SystemV1Urls) {
    SystemV1Urls.ListSystemSettings = '/V1/System/ListSystemSettings';
    SystemV1Urls.ListEmailDomainBlackLists = '/V1/System/ListEmailDomainBlackLists';
    SystemV1Urls.AddEmailDomainBlack = '/V1/System/AddEmailDomainBlack';
    SystemV1Urls.DeleteEmailDomainBlack = '/V1/System/DeleteEmailDomainBlack';
    SystemV1Urls.ListEduDomains = '/V1/System/ListEduDomains';
    SystemV1Urls.UpdateEduDomains = '/V1/System/UpdateEduDomains';
    SystemV1Urls.CreateAudience = '/V1/System/CreateAudience';
    SystemV1Urls.RegenerateAudienceKey = '/V1/System/RegenerateAudienceKey';
    SystemV1Urls.DeleteAudience = '/V1/System/DeleteAudience';
    SystemV1Urls.ListAudiences = '/V1/System/ListAudiences';
    SystemV1Urls.ListClients = '/V1/System/ListClients';
    SystemV1Urls.DeleteClient = '/V1/System/DeleteClient';
    SystemV1Urls.UpsertClient = '/V1/System/UpsertClient';
    SystemV1Urls.ChangeClientSecret = '/V1/System/ChangeClientSecret';
    SystemV1Urls.GetLatestClientVersion = '/V1/System/GetLatestClientVersion';
    SystemV1Urls.ListMergeFields = '/V1/System/ListMergeFields';
    SystemV1Urls.ListEmailTemplates = '/V1/System/ListEmailTemplates';
    SystemV1Urls.GetDefaultEmailTemplate = '/V1/System/GetDefaultEmailTemplate';
    SystemV1Urls.UpdateEmailTemplates = '/V1/System/UpdateEmailTemplates';
    SystemV1Urls.Ping = '/V1/System/Ping';
    SystemV1Urls.PostPing = '/V1/System/PostPing';
    SystemV1Urls.GetTermsOfServiceDate = '/V1/System/GetTermsOfServiceDate';
    SystemV1Urls.UpdateSystemSettings = '/V1/System/UpdateSystemSettings';
    SystemV1Urls.BroadcastSystemMessage = '/V1/System/BroadcastSystemMessage';
    SystemV1Urls.ReportError = '/V1/System/ReportError';
    SystemV1Urls.GetPageTranslation = '/V1/System/GetPageTranslation';
    SystemV1Urls.UpdatePageTranslation = '/V1/System/UpdatePageTranslation';
    SystemV1Urls.GetPageTranslationLanguages = '/V1/System/GetPageTranslationLanguages';
    SystemV1Urls.CopyFromPage = '/V1/System/CopyFromPage';
    SystemV1Urls.DeletePageLanguage = '/V1/System/DeletePageLanguage';
    SystemV1Urls.ImportExcelLanguagesDummy = '/V1/System/ImportExcelLanguagesDummy';
    SystemV1Urls.SeverSharepointLinks = '/V1/System/SeverSharepointLinks';
})(SystemV1Urls || (SystemV1Urls = {}));
var TokensV1Urls;
(function (TokensV1Urls) {
    TokensV1Urls.Cancel = '/V1/Tokens/Cancel';
    TokensV1Urls.Redeem = '/V1/Tokens/Redeem';
    TokensV1Urls.ListByOrganizationId = '/V1/Tokens/ListByOrganizationId';
    TokensV1Urls.ListByRedeemedById = '/V1/Tokens/ListByRedeemedById';
    TokensV1Urls.Upsert = '/V1/Tokens/Upsert';
    TokensV1Urls.Delete = '/V1/Tokens/Delete';
    TokensV1Urls.DeleteByIds = '/V1/Tokens/DeleteByIds';
    TokensV1Urls.Get = '/V1/Tokens/Get';
    TokensV1Urls.List = '/V1/Tokens/List';
})(TokensV1Urls || (TokensV1Urls = {}));
var TopicsV1Urls;
(function (TopicsV1Urls) {
    TopicsV1Urls.AddResource = '/V1/Topics/AddResource';
    TopicsV1Urls.RemoveResource = '/V1/Topics/RemoveResource';
    TopicsV1Urls.ListResourcesByTypeAdmin = '/V1/Topics/ListResourcesByTypeAdmin';
    TopicsV1Urls.ListResources = '/V1/Topics/ListResources';
    TopicsV1Urls.GetWorkflowStatus = '/V1/Topics/GetWorkflowStatus';
    TopicsV1Urls.SetEditingStatus = '/V1/Topics/SetEditingStatus';
    TopicsV1Urls.UpdateWorkflowStep = '/V1/Topics/UpdateWorkflowStep';
    TopicsV1Urls.UpdateWorkflowTask = '/V1/Topics/UpdateWorkflowTask';
    TopicsV1Urls.ListAssignees = '/V1/Topics/ListAssignees';
    TopicsV1Urls.UpdateAssignees = '/V1/Topics/UpdateAssignees';
    TopicsV1Urls.ListItemsByTopicId = '/V1/Topics/ListItemsByTopicId';
    TopicsV1Urls.GetTranslation = '/V1/Topics/GetTranslation';
    TopicsV1Urls.UpdateTranslation = '/V1/Topics/UpdateTranslation';
    TopicsV1Urls.DeleteTranslation = '/V1/Topics/DeleteTranslation';
    TopicsV1Urls.GetStructureForEditing = '/V1/Topics/GetStructureForEditing';
    TopicsV1Urls.UpdateTopicStructure = '/V1/Topics/UpdateTopicStructure';
    TopicsV1Urls.ListLessonQuestions = '/V1/Topics/ListLessonQuestions';
    TopicsV1Urls.EditIntroduction = '/V1/Topics/EditIntroduction';
    TopicsV1Urls.EditConclusion = '/V1/Topics/EditConclusion';
    TopicsV1Urls.GetAdmin = '/V1/Topics/GetAdmin';
    TopicsV1Urls.CreateLesson = '/V1/Topics/CreateLesson';
    TopicsV1Urls.ListSyndicatedLessons = '/V1/Topics/ListSyndicatedLessons';
    TopicsV1Urls.ListSyndications = '/V1/Topics/ListSyndications';
    TopicsV1Urls.UpdateSyndications = '/V1/Topics/UpdateSyndications';
    TopicsV1Urls.ListSyndicationProviders = '/V1/Topics/ListSyndicationProviders';
    TopicsV1Urls.UpdateSyndicationProviders = '/V1/Topics/UpdateSyndicationProviders';
    TopicsV1Urls.CreateCustomTopic = '/V1/Topics/CreateCustomTopic';
    TopicsV1Urls.Upsert = '/V1/Topics/Upsert';
    TopicsV1Urls.Delete = '/V1/Topics/Delete';
    TopicsV1Urls.DeleteByIds = '/V1/Topics/DeleteByIds';
    TopicsV1Urls.PublishTopic = '/V1/Topics/PublishTopic';
    TopicsV1Urls.ListProjectManagementTasks = '/V1/Topics/ListProjectManagementTasks';
    TopicsV1Urls.Get = '/V1/Topics/Get';
    TopicsV1Urls.List = '/V1/Topics/List';
})(TopicsV1Urls || (TopicsV1Urls = {}));
var UsersV1Urls;
(function (UsersV1Urls) {
    UsersV1Urls.CreateDataRequest = '/V1/Users/CreateDataRequest';
    UsersV1Urls.ApproveDataRequest = '/V1/Users/ApproveDataRequest';
    UsersV1Urls.RejectDataRequest = '/V1/Users/RejectDataRequest';
    UsersV1Urls.DeleteDataRequest = '/V1/Users/DeleteDataRequest';
    UsersV1Urls.GetUserDataRequestsWithDocuments = '/V1/Users/GetUserDataRequestsWithDocuments';
    UsersV1Urls.GetUserDataRequestWithDocuments = '/V1/Users/GetUserDataRequestWithDocuments';
    UsersV1Urls.ListUserDataRequests = '/V1/Users/ListUserDataRequests';
    UsersV1Urls.AttachActivityToUserRequest = '/V1/Users/AttachActivityToUserRequest';
    UsersV1Urls.RemoveUserRequestDocument = '/V1/Users/RemoveUserRequestDocument';
    UsersV1Urls.AddResourceToUserDataRequest = '/V1/Users/AddResourceToUserDataRequest';
    UsersV1Urls.DownloadUserRequestDocument = '/V1/Users/DownloadUserRequestDocument';
    UsersV1Urls.SetDisciplines = '/V1/Users/SetDisciplines';
    UsersV1Urls.UpsertDiscipline = '/V1/Users/UpsertDiscipline';
    UsersV1Urls.RemoveDiscipline = '/V1/Users/RemoveDiscipline';
    UsersV1Urls.RemoveJob = '/V1/Users/RemoveJob';
    UsersV1Urls.ListSelectedUserDisciplines = '/V1/Users/ListSelectedUserDisciplines';
    UsersV1Urls.GetEarnedGamificationAwards = '/V1/Users/GetEarnedGamificationAwards';
    UsersV1Urls.AchievementsReady = '/V1/Users/AchievementsReady';
    UsersV1Urls.JobStatus = '/V1/Users/JobStatus';
    UsersV1Urls.ProgressStats = '/V1/Users/ProgressStats';
    UsersV1Urls.Progress = '/V1/Users/Progress';
    UsersV1Urls.GetLearningPath = '/V1/Users/GetLearningPath';
    UsersV1Urls.YourPath = '/V1/Users/YourPath';
    UsersV1Urls.GetDisciplineAverageScores = '/V1/Users/GetDisciplineAverageScores';
    UsersV1Urls.GetJobAverageScores = '/V1/Users/GetJobAverageScores';
    UsersV1Urls.WhatsNext = '/V1/Users/WhatsNext';
    UsersV1Urls.SetOrganization = '/V1/Users/SetOrganization';
    UsersV1Urls.ListPermissions = '/V1/Users/ListPermissions';
    UsersV1Urls.ListOrganizations = '/V1/Users/ListOrganizations';
    UsersV1Urls.GetOrganizationalMessage = '/V1/Users/GetOrganizationalMessage';
    UsersV1Urls.InsertOrUpdateUserAndOrganizationDetails = '/V1/Users/InsertOrUpdateUserAndOrganizationDetails';
    UsersV1Urls.UpsertUserAndOrganizationDetails = '/V1/Users/UpsertUserAndOrganizationDetails';
    UsersV1Urls.ClearSSOLogins = '/V1/Users/ClearSSOLogins';
    UsersV1Urls.InsertOrUpdateUserAndOrganizationDetailsWithOrganization = '/V1/Users/InsertOrUpdateUserAndOrganizationDetailsWithOrganization';
    UsersV1Urls.UpsertUserAndOrganizationDetailsWithOrganization = '/V1/Users/UpsertUserAndOrganizationDetailsWithOrganization';
    UsersV1Urls.GetUserAndOrganizationDetailsWithOrganization = '/V1/Users/GetUserAndOrganizationDetailsWithOrganization';
    UsersV1Urls.ListByOrganizationId = '/V1/Users/ListByOrganizationId';
    UsersV1Urls.GetProspectOrgUserDetails = '/V1/Users/GetProspectOrgUserDetails';
    UsersV1Urls.ListPermissionRequests = '/V1/Users/ListPermissionRequests';
    UsersV1Urls.ResumePreHireAssessment = '/V1/Users/ResumePreHireAssessment';
    UsersV1Urls.CompleteAssessmentInvite = '/V1/Users/CompleteAssessmentInvite';
    UsersV1Urls.GetUsersByRolesAndOrganization = '/V1/Users/GetUsersByRolesAndOrganization';
    UsersV1Urls.SubmitConversationQuestionAnswer = '/V1/Users/SubmitConversationQuestionAnswer';
    UsersV1Urls.GetConversation = '/V1/Users/GetConversation';
    UsersV1Urls.ListReports = '/V1/Users/ListReports';
    UsersV1Urls.ListCustomReports = '/V1/Users/ListCustomReports';
    UsersV1Urls.GetReport = '/V1/Users/GetReport';
    UsersV1Urls.GetSavedReport = '/V1/Users/GetSavedReport';
    UsersV1Urls.GetCustomReport = '/V1/Users/GetCustomReport';
    UsersV1Urls.UpsertReport = '/V1/Users/UpsertReport';
    UsersV1Urls.DeleteReportById = '/V1/Users/DeleteReportById';
    UsersV1Urls.RequestAccess = '/V1/Users/RequestAccess';
    UsersV1Urls.RequestResetPassword = '/V1/Users/RequestResetPassword';
    UsersV1Urls.ResetPassword = '/V1/Users/ResetPassword';
    UsersV1Urls.VerifyRequestAccess = '/V1/Users/VerifyRequestAccess';
    UsersV1Urls.RequestVerifyEduWithCode = '/V1/Users/RequestVerifyEduWithCode';
    UsersV1Urls.AddEduSubscriptionToUser = '/V1/Users/AddEduSubscriptionToUser';
    UsersV1Urls.AddTrialToUser = '/V1/Users/AddTrialToUser';
    UsersV1Urls.AddSubscriptionToUser = '/V1/Users/AddSubscriptionToUser';
    UsersV1Urls.AddEduSubscriptionPaymentToUser = '/V1/Users/AddEduSubscriptionPaymentToUser';
    UsersV1Urls.AddSubscriptionTokenToUser = '/V1/Users/AddSubscriptionTokenToUser';
    UsersV1Urls.AdminList = '/V1/Users/AdminList';
    UsersV1Urls.AdminGet = '/V1/Users/AdminGet';
    UsersV1Urls.AdminUpsert = '/V1/Users/AdminUpsert';
    UsersV1Urls.RequestLessonRights = '/V1/Users/RequestLessonRights';
    UsersV1Urls.AdminSendEmail = '/V1/Users/AdminSendEmail';
    UsersV1Urls.ListJobs = '/V1/Users/ListJobs';
    UsersV1Urls.UpdateJobs = '/V1/Users/UpdateJobs';
    UsersV1Urls.UpsertJob = '/V1/Users/UpsertJob';
    UsersV1Urls.ListUserRoles = '/V1/Users/ListUserRoles';
    UsersV1Urls.AssignRolesToUser = '/V1/Users/AssignRolesToUser';
    UsersV1Urls.GetUnclaimedQuestions = '/V1/Users/GetUnclaimedQuestions';
    UsersV1Urls.GetCurrentAssignments = '/V1/Users/GetCurrentAssignments';
    UsersV1Urls.GetSMEContractorAssignments = '/V1/Users/GetSMEContractorAssignments';
    UsersV1Urls.ListCoursesInProcess = '/V1/Users/ListCoursesInProcess';
    UsersV1Urls.ListCMSRecentActivity = '/V1/Users/ListCMSRecentActivity';
    UsersV1Urls.ReportTranslationError = '/V1/Users/ReportTranslationError';
    UsersV1Urls.ListTranslationErrors = '/V1/Users/ListTranslationErrors';
    UsersV1Urls.RemoveTranslationError = '/V1/Users/RemoveTranslationError';
    UsersV1Urls.ChangePassword = '/V1/Users/ChangePassword';
    UsersV1Urls.ListUserProductPreferences = '/V1/Users/ListUserProductPreferences';
    UsersV1Urls.UpdateProductVersionCoursePreferences = '/V1/Users/UpdateProductVersionCoursePreferences';
    UsersV1Urls.ListPaymentCredentials = '/V1/Users/ListPaymentCredentials';
    UsersV1Urls.ListEmailPreferences = '/V1/Users/ListEmailPreferences';
    UsersV1Urls.UpdateEmailPreferences = '/V1/Users/UpdateEmailPreferences';
    UsersV1Urls.GetUserAndOrganizationDetails = '/V1/Users/GetUserAndOrganizationDetails';
    UsersV1Urls.AdminChangePassword = '/V1/Users/AdminChangePassword';
    UsersV1Urls.AdminResetPassword = '/V1/Users/AdminResetPassword';
    UsersV1Urls.ListProspectContacts = '/V1/Users/ListProspectContacts';
    UsersV1Urls.InsertOrUpdateUserAndProspectUserDetails = '/V1/Users/InsertOrUpdateUserAndProspectUserDetails';
    UsersV1Urls.UpsertUserAndProspectUserDetails = '/V1/Users/UpsertUserAndProspectUserDetails';
    UsersV1Urls.HasUserHadTrial = '/V1/Users/HasUserHadTrial';
    UsersV1Urls.SetLanguage = '/V1/Users/SetLanguage';
    UsersV1Urls.SetProject = '/V1/Users/SetProject';
    UsersV1Urls.UpdateAvailability = '/V1/Users/UpdateAvailability';
    UsersV1Urls.GetProductVersionOwnership = '/V1/Users/GetProductVersionOwnership';
    UsersV1Urls.UpdateProductVersionCoursePreference = '/V1/Users/UpdateProductVersionCoursePreference';
    UsersV1Urls.GetExpiredUserEntitlements = '/V1/Users/GetExpiredUserEntitlements';
    UsersV1Urls.GetPublicSuggestedProducts = '/V1/Users/GetPublicSuggestedProducts';
    UsersV1Urls.GetSuggestedContent = '/V1/Users/GetSuggestedContent';
    UsersV1Urls.GetSuggestedProducts = '/V1/Users/GetSuggestedProducts';
    UsersV1Urls.GetSuggestedProductsAdmin = '/V1/Users/GetSuggestedProductsAdmin';
    UsersV1Urls.ListProjects = '/V1/Users/ListProjects';
    UsersV1Urls.GetRecentActivity = '/V1/Users/GetRecentActivity';
    UsersV1Urls.CheckForNotifications = '/V1/Users/CheckForNotifications';
    UsersV1Urls.AcceptTerms = '/V1/Users/AcceptTerms';
    UsersV1Urls.HasAcceptedTerms = '/V1/Users/HasAcceptedTerms';
    UsersV1Urls.GetCommandContentCount = '/V1/Users/GetCommandContentCount';
    UsersV1Urls.ReportPage = '/V1/Users/ReportPage';
    UsersV1Urls.ReportPageCommand = '/V1/Users/ReportPageCommand';
    UsersV1Urls.ReportCommand = '/V1/Users/ReportCommand';
    UsersV1Urls.GetUserByName = '/V1/Users/GetUserByName';
    UsersV1Urls.ListAddresses = '/V1/Users/ListAddresses';
    UsersV1Urls.UpdateAddresses = '/V1/Users/UpdateAddresses';
    UsersV1Urls.RemoveByEncryption = '/V1/Users/RemoveByEncryption';
    UsersV1Urls.GetRecommendedLessons = '/V1/Users/GetRecommendedLessons';
    UsersV1Urls.NewContentSinceLastSeen = '/V1/Users/NewContentSinceLastSeen';
    UsersV1Urls.Get = '/V1/Users/Get';
    UsersV1Urls.List = '/V1/Users/List';
    UsersV1Urls.Upsert = '/V1/Users/Upsert';
    UsersV1Urls.DeleteByIds = '/V1/Users/DeleteByIds';
    UsersV1Urls.Delete = '/V1/Users/Delete';
})(UsersV1Urls || (UsersV1Urls = {}));
var WorkflowsV1Urls;
(function (WorkflowsV1Urls) {
    WorkflowsV1Urls.UpdateTranslationAssignees = '/V1/Workflows/UpdateTranslationAssignees';
    WorkflowsV1Urls.ListAssignees = '/V1/Workflows/ListAssignees';
    WorkflowsV1Urls.ListHistoryByItem = '/V1/Workflows/ListHistoryByItem';
    WorkflowsV1Urls.GetTaskStatus = '/V1/Workflows/GetTaskStatus';
    WorkflowsV1Urls.GetWorkloadByUser = '/V1/Workflows/GetWorkloadByUser';
    WorkflowsV1Urls.ListWorkflowSteps = '/V1/Workflows/ListWorkflowSteps';
})(WorkflowsV1Urls || (WorkflowsV1Urls = {}));

/**
/* Generates a form from a AcceptQuoteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AcceptQuoteDto from which to create the form.
/* @returns FormGroup
 */
function GetAcceptQuoteDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Quote being accepted */
        QuoteId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuoteId) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a ActivityFilterDataDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ActivityFilterDataDto from which to create the form.
/* @returns FormGroup
 */
function GetActivityFilterDataDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Products and Versions available to filter by */
        ProductAndVersions: fb.array((_b = (_a = dto === null || dto === void 0 ? void 0 : dto.ProductAndVersions) === null || _a === void 0 ? void 0 : _a.map(x => GetProductVersionDtoForm(fb, x))) !== null && _b !== void 0 ? _b : []),
        /** Projects available to filter by */
        Projects: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Projects) === null || _c === void 0 ? void 0 : _c.map(x => GetInt32NameValueDtoForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /** Play lists available to filter by */
        PlayLists: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.PlayLists) === null || _e === void 0 ? void 0 : _e.map(x => GetInt32NameValueDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Courses available to filter by */
        Courses: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.Courses) === null || _g === void 0 ? void 0 : _g.map(x => GetInt32NameValueDtoForm(fb, x))) !== null && _h !== void 0 ? _h : []),
        /** Organizations available to filter by */
        Organizations: fb.array((_k = (_j = dto === null || dto === void 0 ? void 0 : dto.Organizations) === null || _j === void 0 ? void 0 : _j.map(x => GetInt32NameValueDtoForm(fb, x))) !== null && _k !== void 0 ? _k : [])
    });
}
/**
/* Generates a form from a AddAssessmentToCourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddAssessmentToCourseDto from which to create the form.
/* @returns FormGroup
 */
function GetAddAssessmentToCourseDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The course to add the assessment to */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The assessment to add */
        AssessmentId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a AddBotCommunicationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddBotCommunicationDto from which to create the form.
/* @returns FormGroup
 */
function GetAddBotCommunicationDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Id of the existing conversation to contribute to or null if a new conversation */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** The communication to add */
        Content: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Content) !== null && _b !== void 0 ? _b : null),
        /** Provide context to the question like "I'm working in Revit 2023" */
        Context: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Context) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a AddCaptionsToVideoDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddCaptionsToVideoDto from which to create the form.
/* @returns FormGroup
 */
function GetAddCaptionsToVideoDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Video Id */
        VideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.VideoId) !== null && _a !== void 0 ? _a : null),
        /** Caption Resource Ids */
        CaptionResourceIds: fb.array([])
    });
}
/**
/* Generates a form from a AddIndividualSubscriptionToPartnerDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddIndividualSubscriptionToPartnerDto from which to create the form.
/* @returns FormGroup
 */
function GetAddIndividualSubscriptionToPartnerDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** The partner id */
        PartnerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The sku adding to the entitlement */
        SKU: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _b !== void 0 ? _b : null),
        /** The user id to add the subscription to. If null, it will create the user based on other fields. */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null),
        /** Email Address */
        Email: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _d !== void 0 ? _d : null, [Validators.email]),
        /** First Lesson */
        FirstName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _e !== void 0 ? _e : null),
        /** Phone Number */
        PhoneNumber: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _f !== void 0 ? _f : null),
        /** Last Lesson */
        LastName: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _g !== void 0 ? _g : null),
        /** For manually setting an ends on date. (Admin only). */
        EndsOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _h !== void 0 ? _h : null)
    });
}
/**
/* Generates a form from a AddIndividualSubscriptionToPartnerResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddIndividualSubscriptionToPartnerResultDto from which to create the form.
/* @returns FormGroup
 */
function GetAddIndividualSubscriptionToPartnerResultDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Indicates success */
        Success: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Success) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Subscription Creation Result Codes */
        Result: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Result) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Error field, if operation was unsuccessful will be shown here. */
        Error: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Error) !== null && _c !== void 0 ? _c : null),
        /** The rolling invoice id */
        InvoiceId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a AddLinkDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddLinkDto from which to create the form.
/* @returns FormGroup
 */
function GetAddLinkDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Parent Id */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ParentType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Text: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Link */
        Link: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Link) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(500)])
    });
}
/**
/* Generates a form from a AddPartnerOrganizationSubscriptionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddPartnerOrganizationSubscriptionDto from which to create the form.
/* @returns FormGroup
 */
function GetAddPartnerOrganizationSubscriptionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** The organization which to add the subscription. If this is null then the other fields for the user must be filled in. */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null),
        /** The User which to add the subscription. If this is null then the other fields for the user must be filled in. */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null),
        /** Email Address */
        Email: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _c !== void 0 ? _c : null, [Validators.email]),
        /** Email Address */
        ConfirmEmail: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ConfirmEmail) !== null && _d !== void 0 ? _d : null),
        /** First Lesson */
        FirstName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _e !== void 0 ? _e : null),
        /** Phone Number */
        PhoneNumber: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _f !== void 0 ? _f : null),
        /** Last Lesson */
        LastName: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _g !== void 0 ? _g : null),
        /** The SKU to use for the trial */
        SKU: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _h !== void 0 ? _h : null, [Validators.minLength(1), Validators.required]),
        /** Reseller Id. Used for setting associated organization */
        PartnerId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Organization Lesson */
        OrganizationName: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.OrganizationName) !== null && _k !== void 0 ? _k : null, [Validators.minLength(1), Validators.required]),
        /** Organization Size */
        OrganizationSize: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.OrganizationSize) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Organization Domain */
        OrganizationDomain: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OrganizationDomain) !== null && _m !== void 0 ? _m : null, [Validators.minLength(1), Validators.required]),
        /** Entitlement Quantity */
        EntitlementQuantity: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.EntitlementQuantity) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** The added users */
        Users: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.Users) === null || _p === void 0 ? void 0 : _p.map(x => GetUserDtoForm(fb, x))) !== null && _q !== void 0 ? _q : []),
        /** Stored billing address for payments */
        BillingAddressId: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _r !== void 0 ? _r : null),
        /** Stored payment id */
        StoredPaymentId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.StoredPaymentId) !== null && _s !== void 0 ? _s : null)
    });
}
/**
/* Generates a form from a AddRemoveQuestionFromLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddRemoveQuestionFromLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetAddRemoveQuestionFromLessonDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The lesson to remove */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Question to remove */
        QuestionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a AddStoredPaymentCredentialDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddStoredPaymentCredentialDto from which to create the form.
/* @returns FormGroup
 */
function GetAddStoredPaymentCredentialDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Payment Method Id */
        PaymentMethodId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PaymentMethodId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Payment Method */
        PaymentMethod: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.PaymentMethod) !== null && _c !== void 0 ? _c : null),
        /** Organization Id (null if attached to a user) */
        OrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Organization (null if attached to a user) */
        Organization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _e !== void 0 ? _e : null),
        /** User Id (null if attached to an organization) */
        UserId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _f !== void 0 ? _f : null),
        /** User (null if attached to an organization) */
        User: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _g !== void 0 ? _g : null),
        /** The reference number with the processor used to make a payment etc. with the credentials */
        ProcessorReferenceNumber: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ProcessorReferenceNumber) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** Merchant Payment Profile Id */
        SubProcessorReferenceNumber: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.SubProcessorReferenceNumber) !== null && _j !== void 0 ? _j : null),
        /** Card or Account Holder Lesson */
        CardHolderName: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.CardHolderName) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** The masked identifier (either card # or Account # masked) */
        MaskedIdentifier: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.MaskedIdentifier) !== null && _l !== void 0 ? _l : null, [Validators.minLength(0), Validators.maxLength(24), Validators.required]),
        /** The expiry year if any */
        ExpiryYear: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.ExpiryYear) !== null && _m !== void 0 ? _m : null),
        /** The expiry month if any */
        ExpiryMonth: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ExpiryMonth) !== null && _o !== void 0 ? _o : null),
        /** Billing Address Id */
        BillingAddressId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Is stored credential deleted */
        Deleted: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Deleted) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** Contact Types */
        ContactType: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.ContactType) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** The Contact Id associated with the stored credentials */
        ContactId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.ContactId) !== null && _s !== void 0 ? _s : null, [Validators.required]),
        /** Account details for a payment made by bank draft */
        AccountDetails: GetMakePaymentAccountDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.AccountDetails),
        /** The credit card details for a payment by credit card */
        CardDetails: GetMakePaymentCardDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.CardDetails),
    });
}
/**
/* Generates a form from a AddVersionLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddVersionLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetAddVersionLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The length of video for the content item */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Version Lesson Status */
        Status: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Status) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a AddressBaseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AddressBaseDto from which to create the form.
/* @returns FormGroup
 */
function GetAddressBaseDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the address the default for the user */
        Default: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Default) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Is the address the billing address for the user */
        Billing: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Billing) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Is the address the shipping address for the user */
        Shipping: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Shipping) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Street 1 */
        Street1: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Street1) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Street 2 */
        Street2: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Street2) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** City */
        City: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.City) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** State */
        State: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.State) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(3)]),
        /** Postal/Zip Code */
        PostalCode: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PostalCode) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(15)]),
        /** Country */
        Country: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(2), Validators.required])
    });
}
/**
/* Generates a form from a AdminChangePasswordDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AdminChangePasswordDto from which to create the form.
/* @returns FormGroup
 */
function GetAdminChangePasswordDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The user to change */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The new password */
        Password: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _b !== void 0 ? _b : null, [Validators.minLength(6), Validators.maxLength(15), IsValidPassword, Validators.required]),
        /** Confirmation of the new password */
        ConfirmPassword: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _c !== void 0 ? _c : null, [Validators.minLength(6), Validators.maxLength(15), Validators.required])
    });
}
/**
/* Generates a form from a AdminOrganizationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AdminOrganizationDto from which to create the form.
/* @returns FormGroup
 */
function GetAdminOrganizationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the organization an active customer */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the organization created */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the organization updated */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags associated with the organization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** Option to show only organization assessments */
        ShowOnlyOrgAssessments: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ShowOnlyOrgAssessments) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Indicates whether or not the organization is a lead prospect for a partner */
        Lead: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Lead) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Sales Rep Id */
        SalesRepId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.SalesRepId) !== null && _k !== void 0 ? _k : null),
        /** Partner */
        PartnerOrganizationId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.PartnerOrganizationId) !== null && _l !== void 0 ? _l : null),
        /** Partner Organization */
        PartnerOrganization: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.PartnerOrganization) !== null && _m !== void 0 ? _m : null),
        /** Organization Answer Sharing Options */
        AnswerSharingOption: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.AnswerSharingOption) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Organization Bot Escalation Rules */
        BotEscalationRule: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.BotEscalationRule) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Organization Types */
        Type: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** Price List Id */
        PriceListId: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.PriceListId) !== null && _r !== void 0 ? _r : null),
        /** Price List */
        PriceList: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.PriceList) !== null && _s !== void 0 ? _s : null),
        /** Billing Price List Id */
        BillingPriceListId: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.BillingPriceListId) !== null && _t !== void 0 ? _t : null),
        /** Billing Price List */
        BillingPriceList: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.BillingPriceList) !== null && _u !== void 0 ? _u : null),
        /** Azure Subscription Id */
        AzureSubscriptionId: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.AzureSubscriptionId) !== null && _v !== void 0 ? _v : null, [Validators.minLength(0), Validators.maxLength(40)]),
        /** Azure Blob Storage Connection String */
        AzureBlobStorageConnectionString: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.AzureBlobStorageConnectionString) !== null && _w !== void 0 ? _w : null, [Validators.minLength(0), Validators.maxLength(200)]),
        /** Azure Media Services Client Id */
        AzureMediaServicesClientId: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.AzureMediaServicesClientId) !== null && _x !== void 0 ? _x : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Azure Media Services Key */
        AzureMediaServicesKey: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.AzureMediaServicesKey) !== null && _y !== void 0 ? _y : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Azure Media Services Issuer */
        AzureMediaServicesIssuer: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.AzureMediaServicesIssuer) !== null && _z !== void 0 ? _z : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Azure Media Services Audience */
        AzureMediaServicesAudience: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.AzureMediaServicesAudience) !== null && _0 !== void 0 ? _0 : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Media Services Endpoint */
        MediaServicesRestApiEndpoint: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.MediaServicesRestApiEndpoint) !== null && _1 !== void 0 ? _1 : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Azure Tenant Id */
        AzureTenantId: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.AzureTenantId) !== null && _2 !== void 0 ? _2 : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Azure Resource Group Lesson */
        AzureResourceGroupName: new FormControl((_3 = dto === null || dto === void 0 ? void 0 : dto.AzureResourceGroupName) !== null && _3 !== void 0 ? _3 : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Desired Number of Users */
        DesiredNumberOfUsers: new FormControl((_4 = dto === null || dto === void 0 ? void 0 : dto.DesiredNumberOfUsers) !== null && _4 !== void 0 ? _4 : null),
        /** Use Bill As while processing credit cards */
        UseBillAs: new FormControl((_5 = dto === null || dto === void 0 ? void 0 : dto.UseBillAs) !== null && _5 !== void 0 ? _5 : null, [Validators.required]),
        /** RedVector's Organization Id */
        RedVectorOrganizationId: new FormControl((_6 = dto === null || dto === void 0 ? void 0 : dto.RedVectorOrganizationId) !== null && _6 !== void 0 ? _6 : null),
        /** Whether or not an organization can sell resale items in Portal */
        CanSellResale: new FormControl((_7 = dto === null || dto === void 0 ? void 0 : dto.CanSellResale) !== null && _7 !== void 0 ? _7 : null, [Validators.required]),
        /** Automatically Assign Custom Question from Partners */
        AutomaticallyAssignCustomContent: new FormControl((_8 = dto === null || dto === void 0 ? void 0 : dto.AutomaticallyAssignCustomContent) !== null && _8 !== void 0 ? _8 : null, [Validators.required]),
        /** Automatically Assign Accomplishments from Partners */
        AutomaticallyAssignAccomplishments: new FormControl((_9 = dto === null || dto === void 0 ? void 0 : dto.AutomaticallyAssignAccomplishments) !== null && _9 !== void 0 ? _9 : null, [Validators.required]),
        /** Tax Exemption Reasons */
        TaxExemptionReason: new FormControl((_10 = dto === null || dto === void 0 ? void 0 : dto.TaxExemptionReason) !== null && _10 !== void 0 ? _10 : null),
        /** Federal Id */
        FederalId: new FormControl((_11 = dto === null || dto === void 0 ? void 0 : dto.FederalId) !== null && _11 !== void 0 ? _11 : null),
        /** State Id */
        StateId: new FormControl((_12 = dto === null || dto === void 0 ? void 0 : dto.StateId) !== null && _12 !== void 0 ? _12 : null),
        /** Local Id */
        LocalId: new FormControl((_13 = dto === null || dto === void 0 ? void 0 : dto.LocalId) !== null && _13 !== void 0 ? _13 : null),
        /** Partner Invoice Types */
        PartnerInvoiceType: new FormControl((_14 = dto === null || dto === void 0 ? void 0 : dto.PartnerInvoiceType) !== null && _14 !== void 0 ? _14 : null, [Validators.required]),
        /** YouTube Client Id */
        YouTubeClientId: new FormControl((_15 = dto === null || dto === void 0 ? void 0 : dto.YouTubeClientId) !== null && _15 !== void 0 ? _15 : null),
        /** YouTube Client Secret */
        YouTubeClientSecret: new FormControl((_16 = dto === null || dto === void 0 ? void 0 : dto.YouTubeClientSecret) !== null && _16 !== void 0 ? _16 : null),
        /** YouTube Access Token */
        YouTubeAccessToken: new FormControl((_17 = dto === null || dto === void 0 ? void 0 : dto.YouTubeAccessToken) !== null && _17 !== void 0 ? _17 : null),
        /** YouTube One Time Auth Code for Offline Access */
        YouTubeAuthCode: new FormControl((_18 = dto === null || dto === void 0 ? void 0 : dto.YouTubeAuthCode) !== null && _18 !== void 0 ? _18 : null),
        /** YouTube User Id for Auth Code flow exchange */
        YouTubeUserId: new FormControl((_19 = dto === null || dto === void 0 ? void 0 : dto.YouTubeUserId) !== null && _19 !== void 0 ? _19 : null),
        /** Organization Partner Billing Type */
        BillingType: new FormControl((_20 = dto === null || dto === void 0 ? void 0 : dto.BillingType) !== null && _20 !== void 0 ? _20 : null),
        /** Can sell CADLearning Question */
        CADLearningContent: new FormControl((_21 = dto === null || dto === void 0 ? void 0 : dto.CADLearningContent) !== null && _21 !== void 0 ? _21 : null, [Validators.required]),
        /** Can Sell Bluebeam Question */
        BluebeamContent: new FormControl((_22 = dto === null || dto === void 0 ? void 0 : dto.BluebeamContent) !== null && _22 !== void 0 ? _22 : null, [Validators.required]),
        /** Third Party Rest API Endpoint */
        ThirdPartyRestEndpoint: new FormControl((_23 = dto === null || dto === void 0 ? void 0 : dto.ThirdPartyRestEndpoint) !== null && _23 !== void 0 ? _23 : null),
        /** Client Secret for communicating with rest endpoint */
        ClientSecret: new FormControl((_24 = dto === null || dto === void 0 ? void 0 : dto.ClientSecret) !== null && _24 !== void 0 ? _24 : null),
        /** Union Type */
        UnionType: new FormControl((_25 = dto === null || dto === void 0 ? void 0 : dto.UnionType) !== null && _25 !== void 0 ? _25 : null),
        /** Url Prefix for Created Domains */
        UrlPrefix: new FormControl((_26 = dto === null || dto === void 0 ? void 0 : dto.UrlPrefix) !== null && _26 !== void 0 ? _26 : null),
        /** Sub Org Price List Id */
        SubOrgPriceListId: new FormControl((_27 = dto === null || dto === void 0 ? void 0 : dto.SubOrgPriceListId) !== null && _27 !== void 0 ? _27 : null),
        /** Sub Org Price List */
        SubOrgPriceList: new FormControl((_28 = dto === null || dto === void 0 ? void 0 : dto.SubOrgPriceList) !== null && _28 !== void 0 ? _28 : null),
        /** Organization Types */
        SubOrgType: new FormControl((_29 = dto === null || dto === void 0 ? void 0 : dto.SubOrgType) !== null && _29 !== void 0 ? _29 : null, [Validators.required]),
        /** Chart Types */
        ScoreSettings: new FormControl((_30 = dto === null || dto === void 0 ? void 0 : dto.ScoreSettings) !== null && _30 !== void 0 ? _30 : null, [Validators.required])
    });
}
/**
/* Generates a form from a AdminResetPassword
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AdminResetPassword from which to create the form.
/* @returns FormGroup
 */
function GetAdminResetPasswordForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The User Id to reset */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Url the user should be redirected to */
        ResetEntryUrl: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ResetEntryUrl) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a AdminUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AdminUserDto from which to create the form.
/* @returns FormGroup
 */
function GetAdminUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** This is the Email Address - Required for Identity Framework */
        UserName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The user's first name */
        FirstName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** The user's last name */
        LastName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** The user's full name */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null),
        /** The user's email */
        Email: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(450), Validators.email, Validators.required]),
        /** Is the email address confirmed? */
        EmailConfirmed: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.EmailConfirmed) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Phone Number */
        PhoneNumber: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _h !== void 0 ? _h : null),
        /** Is the phone number confirmed? */
        PhoneNumberConfirmed: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PhoneNumberConfirmed) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Is the user active? */
        Active: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Creation Date */
        CreatedOn: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Description */
        Description: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _o !== void 0 ? _o : null),
        /** Tags */
        Tags: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _p !== void 0 ? _p : null),
        /** EduConfirmed */
        EduConfirmed: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.EduConfirmed) !== null && _q !== void 0 ? _q : null),
        /** User Expert Bot Escalation Availabilities */
        ExpertBotEscalationAvailability: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.ExpertBotEscalationAvailability) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** Available for Escalation */
        AvailableForEscalation: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.AvailableForEscalation) !== null && _s !== void 0 ? _s : null, [Validators.required]),
        /** Users selected language */
        LanguageCode: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _t !== void 0 ? _t : null, [Validators.minLength(0), Validators.maxLength(10)]),
        /** Tax Exemption Reasons */
        TaxExemptionReason: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.TaxExemptionReason) !== null && _u !== void 0 ? _u : null)
    });
}
/**
/* Generates a form from a AggregateCriteria
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AggregateCriteria from which to create the form.
/* @returns FormGroup
 */
function GetAggregateCriteriaForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /**  */
        FieldName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FieldName) !== null && _a !== void 0 ? _a : null),
        /**  */
        Aggregation: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Aggregation) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a AggregateResult
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AggregateResult from which to create the form.
/* @returns FormGroup
 */
function GetAggregateResultForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /**  */
        FieldName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FieldName) !== null && _a !== void 0 ? _a : null),
        /**  */
        Aggregation: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Aggregation) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /**  */
        Result: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Result) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a AnswerDisplayDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AnswerDisplayDto from which to create the form.
/* @returns FormGroup
 */
function GetAnswerDisplayDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Answer */
        Text: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a AnswerDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AnswerDto from which to create the form.
/* @returns FormGroup
 */
function GetAnswerDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question linked to the Answer */
        QuestionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Order of the answer on the question */
        Order: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The Answer */
        Text: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _d !== void 0 ? _d : null),
        /** How much of a credit do they get based on the answer? */
        PercentCredit: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.PercentCredit) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Is the answer published? */
        Active: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Answer is a premium answer that requires payment */
        Premium: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Premium) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a AnswerLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AnswerLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetAnswerLessonDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson ID */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Answer ID */
        AnswerId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a AnswerQuestionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AnswerQuestionDto from which to create the form.
/* @returns FormGroup
 */
function GetAnswerQuestionDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Question ID */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Answer ID */
        AnswerId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Question Question */
        Question: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Question) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a AnswerTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AnswerTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetAnswerTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Answer Id */
        AnswerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Answer in English */
        Answer: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Answer) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(10)]),
        /** Answer Text */
        AnswerText: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AnswerText) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a AssessmentDistributionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentDistributionDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentDistributionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** AssessmentId */
        AssessmenetId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmenetId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assessment Lesson */
        Assessment: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Assessment) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Lower Value (lowest score) */
        Lower: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Lower) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Upper Value (highest score) */
        Upper: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Upper) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Middle Value */
        Median: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Median) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Average */
        Mean: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Mean) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** 1st Quartile */
        Q1: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Q1) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** 2nd Quartile */
        Q2: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Q2) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** 3rd Quartile */
        Q3: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Q3) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Bell Curve Data */
        Curve: fb.array([])
    });
}
/**
/* Generates a form from a AssessmentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** An Enumeration of different types of assessments */
        Type: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The owner when creating a new custom assessment. If it's created from KAMS this will stay null. */
        OwningOrganizationId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _h !== void 0 ? _h : null),
        /** Set to true to make the assessment a branching assessment */
        FollowBranch: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.FollowBranch) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Set to true to allow the user to go back a question */
        AllowBack: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.AllowBack) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Is a dynamic assessment */
        Dynamic: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Dynamic) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Number of questions for a dynamic assessment */
        NumberOfQuestions: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.NumberOfQuestions) !== null && _m !== void 0 ? _m : null),
        /** Determines if assessment can be changed after publishing */
        Static: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Static) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** The role attached to the assessment, if applicable */
        JobId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _p !== void 0 ? _p : null)
    });
}
/**
/* Generates a form from a AssessmentDynamicItemsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentDynamicItemsDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentDynamicItemsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /**  */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /**  */
        AssessmentId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /**  */
        ConceptIds: fb.array([]),
        /**  */
        TopicIds: fb.array([])
    });
}
/**
/* Generates a form from a AssessmentInvitationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentInvitationDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentInvitationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assessment ID */
        AssessmentId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** User Assessment ID - The attached user assessment id that the user took */
        UserAssessmentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserAssessmentId) !== null && _c !== void 0 ? _c : null),
        /** Invitation User's Lesson */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null),
        /** User */
        UserId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Invitation URL */
        InvitationURL: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.InvitationURL) !== null && _f !== void 0 ? _f : null),
        /** Invite Code */
        InviteCode: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.InviteCode) !== null && _g !== void 0 ? _g : null),
        /** Status */
        Status: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Status) !== null && _h !== void 0 ? _h : null),
        /** First Name */
        FirstName: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _j !== void 0 ? _j : null),
        /** Last Name */
        LastName: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _k !== void 0 ? _k : null),
        /** Email */
        Email: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _l !== void 0 ? _l : null, [Validators.email])
    });
}
/**
/* Generates a form from a AssessmentReportCardDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentReportCardDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentReportCardDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Assessment Id */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assessment Lesson */
        AssessmentName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AssessmentName) !== null && _b !== void 0 ? _b : null),
        /** All questions on the assessment */
        Questions: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Questions) === null || _c === void 0 ? void 0 : _c.map(x => GetShortContentDtoForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /** Users who have taken it */
        Users: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Users) === null || _e === void 0 ? void 0 : _e.map(x => GetAssessmentReportCardUserDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a AssessmentReportCardQuestionResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentReportCardQuestionResultDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentReportCardQuestionResultDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Question Id */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question */
        Question: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Question) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Score */
        Score: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Out Of */
        OutOf: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OutOf) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a AssessmentReportCardUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentReportCardUserDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentReportCardUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Question Results */
        QuestionResults: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.QuestionResults) === null || _c === void 0 ? void 0 : _c.map(x => GetAssessmentReportCardQuestionResultDtoForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /** Score */
        Score: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Out Of */
        OutOf: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OutOf) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a AssessmentResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentResultDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentResultDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** The User Assessment Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the assessment */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Total possible score */
        OutOf: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OutOf) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** User's score */
        Score: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** User's total time taken to complete the assessment */
        TotalDuration: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalDuration) !== null && _e !== void 0 ? _e : null),
        /** Results are from a pre-hire assessment */
        IsPreHire: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.IsPreHire) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Incorrect Answers */
        IncorrectAnswers: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.IncorrectAnswers) === null || _g === void 0 ? void 0 : _g.map(x => GetWrongAnswerDtoForm(fb, x))) !== null && _h !== void 0 ? _h : [])
    });
}
/**
/* Generates a form from a AssessmentStructureForEditingWithParentItems
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentStructureForEditingWithParentItems from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentStructureForEditingWithParentItemsForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3;
    return fb.group({
        /** The identifier used for linking the tree. */
        Identifier: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Identifier) !== null && _a !== void 0 ? _a : null),
        /** Is the item expanded */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The parent Id */
        ParentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _c !== void 0 ? _c : null),
        /** The Item linked to */
        ItemId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Resource Types */
        ResourceType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ResourceType) !== null && _f !== void 0 ? _f : null),
        /** Lesson */
        Name: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _g !== void 0 ? _g : null),
        /** The description */
        Description: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _h !== void 0 ? _h : null),
        /** The length of the video associated */
        Length: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _j !== void 0 ? _j : null),
        /** The original Itme that this one is based upon */
        OriginalItemId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.OriginalItemId) !== null && _k !== void 0 ? _k : null),
        /** Item Change status for KAMS */
        EditingStatus: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EditingStatus) !== null && _l !== void 0 ? _l : null),
        /** Is this a new feature? */
        NewFeature: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.NewFeature) !== null && _m !== void 0 ? _m : null),
        /** Order */
        Order: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Workflow step name */
        WorkflowStep: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _p !== void 0 ? _p : null),
        /** Assignees for the step */
        Assignees: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Assignees) !== null && _q !== void 0 ? _q : null),
        /** Is the content the current organization's? */
        IsOwnContent: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.IsOwnContent) !== null && _r !== void 0 ? _r : null),
        /** Labels */
        Labels: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Labels) !== null && _s !== void 0 ? _s : null),
        /** Due Date */
        DueDate: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _t !== void 0 ? _t : null),
        /** Flagged */
        Flagged: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Importance */
        Importance: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _v !== void 0 ? _v : null),
        /** Number of Questions */
        Questions: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Questions) !== null && _w !== void 0 ? _w : null),
        /** Versions */
        Versions: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.Versions) !== null && _x !== void 0 ? _x : null),
        /** Is Waiting For Customer Approval */
        IsWaitingForCustomerApproval: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForCustomerApproval) !== null && _y !== void 0 ? _y : null),
        /** Is Waiting For Question Team */
        IsWaitingForContentTeam: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForContentTeam) !== null && _z !== void 0 ? _z : null),
        /** Topics */
        Topics: fb.array((_1 = (_0 = dto === null || dto === void 0 ? void 0 : dto.Topics) === null || _0 === void 0 ? void 0 : _0.map(x => GetShortContentDtoForm(fb, x))) !== null && _1 !== void 0 ? _1 : []),
        /** Lessons */
        Lessons: fb.array((_3 = (_2 = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _2 === void 0 ? void 0 : _2.map(x => GetLessonWithCourseInfoDtoForm(fb, x))) !== null && _3 !== void 0 ? _3 : [])
    });
}
/**
/* Generates a form from a AssessmentTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Lesson Id */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Assessment: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Assessment) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a AssessmentUserHistoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentUserHistoryDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentUserHistoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User's Name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Most Recent Score */
        MostRecentScore: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.MostRecentScore) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Scores over time */
        Scores: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Scores) === null || _d === void 0 ? void 0 : _d.map(x => GetAssessmentUserHistoryScoreDtoForm(fb, x))) !== null && _e !== void 0 ? _e : [])
    });
}
/**
/* Generates a form from a AssessmentUserHistoryScoreDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentUserHistoryScoreDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentUserHistoryScoreDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Completed On */
        CompletedOn: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CompletedOn) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Score */
        Score: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a AssessmentWithParentsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentWithParentsDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentWithParentsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** An Enumeration of different types of assessments */
        Type: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The owner when creating a new custom assessment. If it's created from KAMS this will stay null. */
        OwningOrganizationId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _h !== void 0 ? _h : null),
        /** Set to true to make the assessment a branching assessment */
        FollowBranch: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.FollowBranch) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Set to true to allow the user to go back a question */
        AllowBack: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.AllowBack) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Is a dynamic assessment */
        Dynamic: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Dynamic) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Number of questions for a dynamic assessment */
        NumberOfQuestions: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.NumberOfQuestions) !== null && _m !== void 0 ? _m : null),
        /** Determines if assessment can be changed after publishing */
        Static: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Static) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** The role attached to the assessment, if applicable */
        JobId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _p !== void 0 ? _p : null),
        /** The parents of the assessment in a list */
        Parents: fb.array([])
    });
}
/**
/* Generates a form from a AssessmentWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssessmentWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetAssessmentWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Assessment Id */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assessment Lesson */
        Assessment: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Assessment) !== null && _b !== void 0 ? _b : null),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null),
        /** User Lesson */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null),
        /** Role Id */
        RoleId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Role Lesson */
        Role: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _f !== void 0 ? _f : null),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a AssignRolesToUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssignRolesToUserDto from which to create the form.
/* @returns FormGroup
 */
function GetAssignRolesToUserDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Roles to Assign */
        Roles: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Roles) === null || _b === void 0 ? void 0 : _b.map(x => GetOrganizationUserRoleDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a AssignmentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AssignmentDto from which to create the form.
/* @returns FormGroup
 */
function GetAssignmentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** Item Assigned To */
        ItemId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Description */
        Description: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _d !== void 0 ? _d : null),
        /** Parent */
        Parent: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Parent) === null || _e === void 0 ? void 0 : _e.map(x => GetShortContentDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Workflow Step */
        WorkflowStep: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _g !== void 0 ? _g : null),
        /** Has the workflow sent this item back for correction? */
        Returned: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Returned) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Importance */
        Importance: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _j !== void 0 ? _j : null),
        /** Flagged */
        Flagged: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Due Date */
        DueDate: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _l !== void 0 ? _l : null)
    });
}
/**
/* Generates a form from a AudienceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AudienceDto from which to create the form.
/* @returns FormGroup
 */
function GetAudienceDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Identifier */
        Audience: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Audience) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(32), Validators.required]),
        /** Base 64 Secret for signing */
        Base64Secret: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Base64Secret) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(80), Validators.required]),
        /** The name of the audience */
        ClientId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required])
    });
}
/**
/* Generates a form from a AuthMethodAdminDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AuthMethodAdminDto from which to create the form.
/* @returns FormGroup
 */
function GetAuthMethodAdminDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The domain that the AuthMethod exists on */
        OrganizationDomainId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationDomainId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The name of the Auth Method for display if not standard service */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** Authorization Types supported by the domain */
        Type: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** The Url to the endpoint if not a standardized service such as google or facebook */
        IdPUrl: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.IdPUrl) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(500)]),
        /** Is the AuthMethod active? */
        Active: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** For oAuth 2 providers the Audience will be provided if applicable. For Azure Active Directory this is the Tennant */
        Audience: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Audience) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(200)]),
        /** For oAuth 2 providers this will be provided. */
        ClientId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Azure Tenant Id */
        TenantId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.TenantId) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Looks up Group Names for Azure SSO */
        LookUpGroupNames: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.LookUpGroupNames) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** The oAuth client secret if any */
        ClientSecret: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.ClientSecret) !== null && _l !== void 0 ? _l : null),
        /** Certificate Information */
        Certificate: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Certificate) !== null && _m !== void 0 ? _m : null, [Validators.minLength(0), Validators.maxLength(2000)]),
        /** Certificate Expiry Information */
        CertificateExpiresOn: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.CertificateExpiresOn) !== null && _o !== void 0 ? _o : null),
        /** Controls if the auth method allows signing up automatically on login. */
        AutoSignUpOnLogin: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.AutoSignUpOnLogin) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Context used to make the request unique */
        Context: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Context) !== null && _q !== void 0 ? _q : null, [Validators.minLength(0), Validators.maxLength(200)])
    });
}
/**
/* Generates a form from a AuthMethodDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original AuthMethodDto from which to create the form.
/* @returns FormGroup
 */
function GetAuthMethodDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The domain that the AuthMethod exists on */
        OrganizationDomainId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationDomainId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The name of the Auth Method for display if not standard service */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** Authorization Types supported by the domain */
        Type: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** The Url to the endpoint if not a standardized service such as google or facebook */
        IdPUrl: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.IdPUrl) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(500)]),
        /** Is the AuthMethod active? */
        Active: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** For oAuth 2 providers the Audience will be provided if applicable. For Azure Active Directory this is the Tennant */
        Audience: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Audience) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(200)]),
        /** For oAuth 2 providers this will be provided. */
        ClientId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Azure Tenant Id */
        TenantId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.TenantId) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Looks up Group Names for Azure SSO */
        LookUpGroupNames: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.LookUpGroupNames) !== null && _k !== void 0 ? _k : null, [Validators.required])
    });
}
/**
/* Generates a form from a BadgeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Owning Organization */
        OwningOrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Organization */
        OwningOrganization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _e !== void 0 ? _e : null),
        /** Created On */
        CreatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Display Image Id */
        DisplayImageId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _h !== void 0 ? _h : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _j !== void 0 ? _j : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _k !== void 0 ? _k : null)
    });
}
/**
/* Generates a form from a BadgeGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeGroupDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Badge id */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Group */
        GroupId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a BadgeHeaderLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeHeaderLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeHeaderLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Badge id */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Header Lesson Id */
        LessonId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Header Lesson Lesson */
        Lesson: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a BadgeLearningPathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeLearningPathDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeLearningPathDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** Is the Path Expanded? */
        Expanded: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Length of all incomplete lessons */
        Length: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Badge Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Badge Id */
        Id: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Total Number of Lessons */
        TotalLessons: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalLessons) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Completed Lessons */
        TotalCompletedLessons: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalCompletedLessons) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Badge Earned Date, if applicable */
        EarnedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _h !== void 0 ? _h : null),
        /** Order */
        Order: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Remaining Lessons with Questions to complete */
        Lessons: fb.array((_l = (_k = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _k === void 0 ? void 0 : _k.map(x => GetLessonPathDtoForm(fb, x))) !== null && _l !== void 0 ? _l : []),
        /** Medallions of which the badge is a part */
        ContributesToMedallions: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.ContributesToMedallions) === null || _m === void 0 ? void 0 : _m.map(x => GetMedallionPathDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** Disciplines of which the badge is a part */
        ContributesToDisciplines: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.ContributesToDisciplines) === null || _p === void 0 ? void 0 : _p.map(x => GetDisciplinePathDtoForm(fb, x))) !== null && _q !== void 0 ? _q : []),
        /** Badge Header Lessons */
        HeaderLessons: fb.array((_s = (_r = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _r === void 0 ? void 0 : _r.map(x => GetLessonDtoForm(fb, x))) !== null && _s !== void 0 ? _s : [])
    });
}
/**
/* Generates a form from a BadgeLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Lesson Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Lesson Length */
        Length: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Order */
        Order: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a BadgeSyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeSyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeSyndicationProviderDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Badge id */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Syndication Methods */
        Method: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Syndication Provider Id */
        SyndicationProviderId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Syndication Provider Lesson */
        SyndicationProvider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _f !== void 0 ? _f : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a BadgeTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Badge Id */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Badge Lesson */
        Badge: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Badge) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(250), Validators.required])
    });
}
/**
/* Generates a form from a BadgeUserEarnedDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeUserEarnedDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeUserEarnedDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Badge Id */
        BadgeId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Badge Lesson */
        Badge: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Badge) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** User Id */
        UserId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _e !== void 0 ? _e : null),
        /** Earned On */
        EarnedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Display Image Id */
        DisplayImageId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _g !== void 0 ? _g : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
    });
}
/**
/* Generates a form from a BadgeUserReportDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeUserReportDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeUserReportDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** User Lesson */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Date Achieved */
        DateAchieved: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.DateAchieved) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a BadgeWithUsersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BadgeWithUsersDto from which to create the form.
/* @returns FormGroup
 */
function GetBadgeWithUsersDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Badge Lesson */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Number of users achieved the badge */
        NumberOfUsersAchieved: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.NumberOfUsersAchieved) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Users that achieved the badge */
        Users: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Users) === null || _c === void 0 ? void 0 : _c.map(x => GetBadgeUserReportDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a BotConversationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BotConversationDto from which to create the form.
/* @returns FormGroup
 */
function GetBotConversationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Id of the conversation */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** User */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The organization that the user was logged in as when they were talking to the bot */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null),
        /** The Context of the conversation i.e. "I'm working in Revit 2023" */
        Context: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Context) !== null && _d !== void 0 ? _d : null),
        /** The Product that is being used */
        ProductId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _e !== void 0 ? _e : null),
        /** The version of the product being used */
        VersionId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _f !== void 0 ? _f : null),
        /** When did the conversation start? */
        StartedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** When did it end if it is not still in progress? */
        EndedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EndedOn) !== null && _h !== void 0 ? _h : null),
        /** The elements of the conversation */
        Conversation: fb.array((_k = (_j = dto === null || dto === void 0 ? void 0 : dto.Conversation) === null || _j === void 0 ? void 0 : _j.map(x => GetBotConversationElementDtoForm(fb, x))) !== null && _k !== void 0 ? _k : [])
    });
}
/**
/* Generates a form from a BotConversationElementDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BotConversationElementDto from which to create the form.
/* @returns FormGroup
 */
function GetBotConversationElementDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Who communicated */
        Source: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Source) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** What was the communication? */
        Content: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Content) !== null && _b !== void 0 ? _b : null),
        /** When? */
        DateTime: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.DateTime) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a BotConversationRefDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BotConversationRefDto from which to create the form.
/* @returns FormGroup
 */
function GetBotConversationRefDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Id of the conversation */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** User */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The organization that the user was logged in as when they were talking to the bot */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null),
        /** When did the conversation start? */
        StartedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When did it end if it is not still in progress? */
        EndedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.EndedOn) !== null && _e !== void 0 ? _e : null),
        /** The elements of the conversation */
        InitialQuestion: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.InitialQuestion) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a BotResponseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BotResponseDto from which to create the form.
/* @returns FormGroup
 */
function GetBotResponseDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Who communicated */
        Source: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Source) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** What was the communication? */
        Content: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Content) !== null && _b !== void 0 ? _b : null),
        /** When? */
        DateTime: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.DateTime) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The conversation Id that the response is for. */
        ConversationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ConversationId) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a BulkCreateEntitlementsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original BulkCreateEntitlementsDto from which to create the form.
/* @returns FormGroup
 */
function GetBulkCreateEntitlementsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Inventory Id */
        InventoryId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.InventoryId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Inventory Item Id */
        InventoryItemId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InventoryItemId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Starts On */
        StartsOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Units */
        Units: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Units) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a CampaignDripDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CampaignDripDto from which to create the form.
/* @returns FormGroup
 */
function GetCampaignDripDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Campaign Id */
        CampaignId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CampaignId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Campaign */
        Campaign: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Campaign) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Subject */
        Subject: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Subject) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Units from Start */
        UnitsFromStart: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.UnitsFromStart) !== null && _e !== void 0 ? _e : null),
        /** Campaign Drip Units */
        UnitType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UnitType) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Created On */
        CreatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Release On */
        ReleaseOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ReleaseOn) !== null && _j !== void 0 ? _j : null),
        /** Message */
        Message: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Message) !== null && _k !== void 0 ? _k : null, [Validators.minLength(1), Validators.required]),
        /** Active */
        Active: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** PlayList Id */
        PlayListId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _m !== void 0 ? _m : null),
        /** PlayList Lesson */
        PlayList: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.PlayList) !== null && _o !== void 0 ? _o : null)
    });
}
/**
/* Generates a form from a CampaignDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CampaignDto from which to create the form.
/* @returns FormGroup
 */
function GetCampaignDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Created On */
        CreatedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Campaign Types */
        CampaignType: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CampaignType) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Owning Organization Id */
        OwningOrganizationId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _h !== void 0 ? _h : null),
        /** Owning Organization */
        OwningOrganization: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _j !== void 0 ? _j : null)
    });
}
/**
/* Generates a form from a CampaignSubscriptionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CampaignSubscriptionDto from which to create the form.
/* @returns FormGroup
 */
function GetCampaignSubscriptionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Campaign Id */
        CampaignId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CampaignId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Campaign */
        Campaign: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Campaign) !== null && _b !== void 0 ? _b : null),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** User */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null),
        /** signed Up On */
        SignedUpOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SignedUpOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Subscription Types */
        SubscriptionType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SubscriptionType) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a CaptionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CaptionDto from which to create the form.
/* @returns FormGroup
 */
function GetCaptionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** the video that the caption is associated with */
        VideoId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VideoId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The language Code of the caption */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null),
        /** The full script in html format */
        Script: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Script) !== null && _d !== void 0 ? _d : null),
        /** Any external link */
        ExternalId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ExternalId) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a CaptionWithUrlDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CaptionWithUrlDto from which to create the form.
/* @returns FormGroup
 */
function GetCaptionWithUrlDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** the video that the caption is associated with */
        VideoId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VideoId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The language Code of the caption */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null),
        /** The full script in html format */
        Script: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Script) !== null && _d !== void 0 ? _d : null),
        /** Any external link */
        ExternalId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ExternalId) !== null && _e !== void 0 ? _e : null),
        /** Url to caption file */
        Url: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Url) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a ChangePasswordDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ChangePasswordDto from which to create the form.
/* @returns FormGroup
 */
function GetChangePasswordDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The ID of the user to change. This should match the current user authentication and is used as a checksum. */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The current password. This will be validated before the password can be changed. */
        CurrentPassword: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CurrentPassword) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The new password */
        Password: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _c !== void 0 ? _c : null, [Validators.minLength(6), Validators.maxLength(15), IsValidPassword, Validators.required]),
        /** The password repeated for confirmation */
        ConfirmPassword: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _d !== void 0 ? _d : null, [Validators.minLength(6), Validators.maxLength(15), Validators.required])
    });
}
/**
/* Generates a form from a ChartDetail
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ChartDetail from which to create the form.
/* @returns FormGroup
 */
function GetChartDetailForm(fb, dto) {
    var _a;
    return fb.group({
        /** Chart Types */
        ChartType: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ChartType) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /**  */
        Axis: GetGroupCriteriaForm(fb, dto === null || dto === void 0 ? void 0 : dto.Axis),
    });
}
/**
/* Generates a form from a ChildResourceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ChildResourceDto from which to create the form.
/* @returns FormGroup
 */
function GetChildResourceDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the resource */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Resource Types */
        Type: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ChurnRateByDateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ChurnRateByDateDto from which to create the form.
/* @returns FormGroup
 */
function GetChurnRateByDateDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Date */
        Date: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Details */
        Details: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Details) === null || _b === void 0 ? void 0 : _b.map(x => GetChurnRateDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a ChurnRateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ChurnRateDto from which to create the form.
/* @returns FormGroup
 */
function GetChurnRateDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** Billing Recurring Periods */
        RecurringPeriod: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.RecurringPeriod) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Inventory Item Types */
        InventoryType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InventoryType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Sku */
        SKU: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _c !== void 0 ? _c : null),
        /** Inventory */
        Inventory: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Inventory) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Current Amount */
        CurrentValue: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CurrentValue) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Current Count */
        CurrentCount: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CurrentCount) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Previous Amount */
        PreviousValue: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PreviousValue) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Previous Count */
        PreviousCount: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PreviousCount) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Change in Amount */
        ValueDelta: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ValueDelta) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Count Delta */
        CountDelta: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.CountDelta) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Ended Count */
        EndedCount: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EndedCount) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Ended Amount */
        EndedValue: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.EndedValue) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Started Count */
        StartedCount: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.StartedCount) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Started Amount */
        StartedValue: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.StartedValue) !== null && _p !== void 0 ? _p : null, [Validators.required])
    });
}
/**
/* Generates a form from a ClientDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ClientDto from which to create the form.
/* @returns FormGroup
 */
function GetClientDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(128), Validators.required]),
        /** Secret */
        Secret: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Secret) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** Application Types */
        ApplicationType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ApplicationType) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Refresh token lifetime in seconds */
        RefreshTokenLifeTime: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.RefreshTokenLifeTime) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Allow Origin (Default is *) */
        AllowedOrigin: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.AllowedOrigin) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** Release Version */
        ReleaseVersion: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ReleaseVersion) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(20)]),
        /** Beta Version */
        BetaVersion: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.BetaVersion) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(20)]),
        /** Internal Version */
        InternalVersion: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.InternalVersion) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(20)])
    });
}
/**
/* Generates a form from a ColumnDetail
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ColumnDetail from which to create the form.
/* @returns FormGroup
 */
function GetColumnDetailForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Field Lesson */
        FieldName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FieldName) !== null && _a !== void 0 ? _a : null),
        /** Order of column */
        Order: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Is the column frozen while being placed in a grid */
        Frozen: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Frozen) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Is the column visible? */
        Visible: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Visible) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Width */
        Width: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Width) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a CommandNotificationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CommandNotificationDto from which to create the form.
/* @returns FormGroup
 */
function GetCommandNotificationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null),
        /** Product Lesson */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null),
        /** Version Id */
        VersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _c !== void 0 ? _c : null),
        /** Version Lesson */
        Version: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _d !== void 0 ? _d : null),
        /** Command */
        Command: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _e !== void 0 ? _e : null),
        /** Plugin Command Notification Types */
        NotificationType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.NotificationType) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Lessons */
        Lessons: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _g === void 0 ? void 0 : _g.map(x => GetShortContentDtoForm(fb, x))) !== null && _h !== void 0 ? _h : []),
        /** Suggested workflows */
        Workflows: fb.array((_k = (_j = dto === null || dto === void 0 ? void 0 : dto.Workflows) === null || _j === void 0 ? void 0 : _j.map(x => GetShortCourseDtoForm(fb, x))) !== null && _k !== void 0 ? _k : [])
    });
}
/**
/* Generates a form from a CompetenciesAchievedDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompetenciesAchievedDto from which to create the form.
/* @returns FormGroup
 */
function GetCompetenciesAchievedDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Medallion Lesson */
        MedallionName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionName) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Number of Users With Medallion */
        NumberOfUsersWithMedallion: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.NumberOfUsersWithMedallion) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Comptencies Achieved History */
        History: GetCompetenciesAchievedHistoryDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.History),
        /** Users with medallion and if achieved */
        Users: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Users) === null || _c === void 0 ? void 0 : _c.map(x => GetCompetenciesAchievedUserDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a CompetenciesAchievedHistoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompetenciesAchievedHistoryDto from which to create the form.
/* @returns FormGroup
 */
function GetCompetenciesAchievedHistoryDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Date */
        Date: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a CompetenciesAchievedUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompetenciesAchievedUserDto from which to create the form.
/* @returns FormGroup
 */
function GetCompetenciesAchievedUserDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** User Lesson */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Users achieved badges within medallion */
        Score: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Total badges in medallion */
        OutOf: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OutOf) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Date Achieved */
        DateAchieved: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.DateAchieved) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a CompleteAssessmentInviteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompleteAssessmentInviteDto from which to create the form.
/* @returns FormGroup
 */
function GetCompleteAssessmentInviteDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The assignment id */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The email/user name */
        Email: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** The first name */
        FirstName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Last name */
        LastName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Security Code */
        Code: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Code) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required]),
        /** Phone Number */
        PhoneNumber: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a CompleteBotConversationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompleteBotConversationDto from which to create the form.
/* @returns FormGroup
 */
function GetCompleteBotConversationDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The Id of the conversation to complete */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null)
    });
}
/**
/* Generates a form from a CompleteInviteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompleteInviteDto from which to create the form.
/* @returns FormGroup
 */
function GetCompleteInviteDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The email/user name */
        Email: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** The first name */
        FirstName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Last name */
        LastName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Security Code */
        Code: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Code) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Password */
        Password: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), IsValidPassword, Validators.required])
    });
}
/**
/* Generates a form from a CompletePartnerInviteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompletePartnerInviteDto from which to create the form.
/* @returns FormGroup
 */
function GetCompletePartnerInviteDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The email/user name */
        Email: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Security Code */
        Code: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Code) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Password */
        Password: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), IsValidPassword, Validators.required]),
        /** Password */
        PartnerId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a CompletePartnerSubscriptionOrganizationRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompletePartnerSubscriptionOrganizationRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetCompletePartnerSubscriptionOrganizationRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** Organization Id to complete the deal */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Partner of record on the deal */
        PartnerId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Email of the user */
        Email: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Password */
        Password: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), IsValidPassword, Validators.required]),
        /** Confirm Password */
        ConfirmPassword: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required]),
        /** SKU */
        SKU: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _f !== void 0 ? _f : null, [Validators.minLength(1), Validators.required]),
        /** Billing Street Address */
        BillingStreetAddress: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.BillingStreetAddress) !== null && _g !== void 0 ? _g : null),
        /** Billing Street Address 2 */
        BillingStreetAddress2: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.BillingStreetAddress2) !== null && _h !== void 0 ? _h : null),
        /** Billing TownCity */
        BillingTownCity: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.BillingTownCity) !== null && _j !== void 0 ? _j : null),
        /** Billing Postal Code */
        BillingPostalCode: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.BillingPostalCode) !== null && _k !== void 0 ? _k : null),
        /** Billing State */
        BillingState: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.BillingState) !== null && _l !== void 0 ? _l : null),
        /** Billing Country */
        BillingCountry: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.BillingCountry) !== null && _m !== void 0 ? _m : null),
        /** The credit card details for a payment by credit card */
        CardDetails: GetMakePaymentCardDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.CardDetails),
        /** Account details for a payment made by bank draft */
        AccountDetails: GetMakePaymentAccountDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.AccountDetails),
        /** Payment Method */
        PaymentMethodId: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.PaymentMethodId) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Additional Users to add to the organization */
        Users: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.Users) === null || _p === void 0 ? void 0 : _p.map(x => GetUserDtoForm(fb, x))) !== null && _q !== void 0 ? _q : [])
    });
}
/**
/* Generates a form from a CompletionHistoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CompletionHistoryDto from which to create the form.
/* @returns FormGroup
 */
function GetCompletionHistoryDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Date of History Reading */
        Date: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Completion percentage at date */
        PercentComplete: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Parent Item */
        ItemId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _c !== void 0 ? _c : null),
        /** The Type of the parent that kicked off the assessment */
        ItemType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a ContactDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ContactDto from which to create the form.
/* @returns FormGroup
 */
function GetContactDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** This is the Email Address */
        Email: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _b !== void 0 ? _b : null, [Validators.email]),
        /** The user's first name */
        FirstName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _c !== void 0 ? _c : null),
        /** The user's last name */
        LastName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _d !== void 0 ? _d : null),
        /** The user's full name */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null),
        /** Contact Created On */
        CreatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Contact Updated On */
        UpdatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a ContentItemDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ContentItemDto from which to create the form.
/* @returns FormGroup
 */
function GetContentItemDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** Parent Id */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ParentType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Item Id */
        ItemId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** New Feature */
        NewFeature: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.NewFeature) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _f !== void 0 ? _f : null),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null),
        /** Length */
        Length: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _j !== void 0 ? _j : null),
        /** Resource Types */
        ResourceType: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.ResourceType) !== null && _k !== void 0 ? _k : null),
        /** Rating */
        Rating: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Rating) !== null && _l !== void 0 ? _l : null),
        /** User Rating */
        UserRating: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.UserRating) !== null && _m !== void 0 ? _m : null),
        /** Percent Complete */
        PercentComplete: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _o !== void 0 ? _o : null),
        /** Earliest lesson on data item if it's a lesson */
        EarliestLesson: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.EarliestLesson) !== null && _p !== void 0 ? _p : null),
        /** The Url if Type = Uri */
        Url: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Url) !== null && _q !== void 0 ? _q : null)
    });
}
/**
/* Generates a form from a ContentItemWithChildrenDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ContentItemWithChildrenDto from which to create the form.
/* @returns FormGroup
 */
function GetContentItemWithChildrenDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
    return fb.group({
        /** Parent Id */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ParentType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Item Id */
        ItemId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** New Feature */
        NewFeature: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.NewFeature) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _f !== void 0 ? _f : null),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null),
        /** Length */
        Length: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _j !== void 0 ? _j : null),
        /** Resource Types */
        ResourceType: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.ResourceType) !== null && _k !== void 0 ? _k : null),
        /** Rating */
        Rating: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Rating) !== null && _l !== void 0 ? _l : null),
        /** User Rating */
        UserRating: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.UserRating) !== null && _m !== void 0 ? _m : null),
        /** Percent Complete */
        PercentComplete: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _o !== void 0 ? _o : null),
        /** Earliest lesson on data item if it's a lesson */
        EarliestLesson: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.EarliestLesson) !== null && _p !== void 0 ? _p : null),
        /** The Url if Type = Uri */
        Url: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Url) !== null && _q !== void 0 ? _q : null),
        /** Expanded */
        Expanded: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** Children */
        Children: fb.array((_t = (_s = dto === null || dto === void 0 ? void 0 : dto.Children) === null || _s === void 0 ? void 0 : _s.map(x => GetContentItemWithChildrenDtoForm(fb, x))) !== null && _t !== void 0 ? _t : [])
    });
}
/**
/* Generates a form from a ContentSearchResponseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ContentSearchResponseDto from which to create the form.
/* @returns FormGroup
 */
function GetContentSearchResponseDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Total Results including those not in the current page */
        TotalResults: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TotalResults) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All Results */
        Results: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Results) === null || _b === void 0 ? void 0 : _b.map(x => GetContentSearchResultDtoForm(fb, x))) !== null && _c !== void 0 ? _c : []),
        /** Owned */
        Owned: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Owned) === null || _d === void 0 ? void 0 : _d.map(x => GetSearchFilterDtoForm(fb, x))) !== null && _e !== void 0 ? _e : []),
        /** Products represented in the results */
        Products: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _f === void 0 ? void 0 : _f.map(x => GetSearchFilterDtoForm(fb, x))) !== null && _g !== void 0 ? _g : []),
        /** Languages represented in the results */
        Languages: fb.array((_j = (_h = dto === null || dto === void 0 ? void 0 : dto.Languages) === null || _h === void 0 ? void 0 : _h.map(x => GetSearchFilterDtoForm(fb, x))) !== null && _j !== void 0 ? _j : [])
    });
}
/**
/* Generates a form from a ContentSearchResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ContentSearchResultDto from which to create the form.
/* @returns FormGroup
 */
function GetContentSearchResultDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Any tags on the item */
        Tags: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _d !== void 0 ? _d : null),
        /** When the item was created */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When the item was updated */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** The language key of the item */
        LanguageId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.LanguageId) !== null && _g !== void 0 ? _g : null),
        /** A json encoded object with a list of courses on the lesson */
        CourseInfo: fb.array((_j = (_h = dto === null || dto === void 0 ? void 0 : dto.CourseInfo) === null || _h === void 0 ? void 0 : _h.map(x => GetShortContentDtoForm(fb, x))) !== null && _j !== void 0 ? _j : []),
        /** The product Ids that are associated with the item */
        Products: fb.array((_l = (_k = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _k === void 0 ? void 0 : _k.map(x => GetProductVersionDtoForm(fb, x))) !== null && _l !== void 0 ? _l : []),
        /** Search probability of match */
        Rank: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Rank) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** How long the item is */
        Length: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Do you own this product? */
        Owned: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Owned) !== null && _p !== void 0 ? _p : null, [Validators.required])
    });
}
/**
/* Generates a form from a ContentSearchResultsWithUserInfoDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ContentSearchResultsWithUserInfoDto from which to create the form.
/* @returns FormGroup
 */
function GetContentSearchResultsWithUserInfoDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Any tags on the item */
        Tags: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _d !== void 0 ? _d : null),
        /** When the item was created */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When the item was updated */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** The language key of the item */
        LanguageId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.LanguageId) !== null && _g !== void 0 ? _g : null),
        /** A json encoded object with a list of courses on the lesson */
        CourseInfo: fb.array((_j = (_h = dto === null || dto === void 0 ? void 0 : dto.CourseInfo) === null || _h === void 0 ? void 0 : _h.map(x => GetShortContentDtoForm(fb, x))) !== null && _j !== void 0 ? _j : []),
        /** The product Ids that are associated with the item */
        Products: fb.array((_l = (_k = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _k === void 0 ? void 0 : _k.map(x => GetProductVersionDtoForm(fb, x))) !== null && _l !== void 0 ? _l : []),
        /** Search probability of match */
        Rank: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Rank) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** How long the item is */
        Length: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Do you own this product? */
        Owned: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Owned) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** How far the user has gotten in the lesson */
        PercentComplete: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _q !== void 0 ? _q : null, [Validators.required])
    });
}
/**
/* Generates a form from a CopyLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CopyLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetCopyLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The Lesson to copy */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Id of the Parent. If none specified then all parents will be affected. */
        ParentId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _b !== void 0 ? _b : null),
        /** Question Item Types */
        ParentType: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentType) !== null && _c !== void 0 ? _c : null),
        /** The workflow step to put the copied lesson as. */
        WorkflowStepId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.WorkflowStepId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Reason */
        Reason: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Reason) !== null && _e !== void 0 ? _e : null),
        /** Versions */
        Versions: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Versions) === null || _f === void 0 ? void 0 : _f.map(x => GetProductVersionDetailsDtoForm(fb, x))) !== null && _g !== void 0 ? _g : [])
    });
}
/**
/* Generates a form from a CopyQuoteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CopyQuoteDto from which to create the form.
/* @returns FormGroup
 */
function GetCopyQuoteDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Quote being rejected */
        QuoteId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuoteId) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a CopyStaticPageTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CopyStaticPageTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetCopyStaticPageTranslationDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Page Lesson */
        PageName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PageName) !== null && _a !== void 0 ? _a : null),
        /** From Language */
        FromLanguage: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FromLanguage) !== null && _b !== void 0 ? _b : null),
        /** To Language */
        ToLanguage: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ToLanguage) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a CourseActivityDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseActivityDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseActivityDetailDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Length of Course */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a CourseAdminDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseAdminDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseAdminDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** Length */
        Length: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _j !== void 0 ? _j : null),
        /** Contet Preface */
        Introduction: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Introduction) !== null && _k !== void 0 ? _k : null),
        /** The conclusion of the item */
        Conclusion: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Conclusion) !== null && _l !== void 0 ? _l : null),
        /** The Organization that owns the course */
        OwningOrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _m !== void 0 ? _m : null),
        /** External Partner Id - When Working on courses that aren't owned by the partner but are monitored by them. */
        ExternalPartnerId: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ExternalPartnerId) !== null && _o !== void 0 ? _o : null),
        /** The featured lesson used for the home page */
        FeaturedLessonId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.FeaturedLessonId) !== null && _p !== void 0 ? _p : null),
        /** Marketing Description */
        Marketing: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _q !== void 0 ? _q : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _r !== void 0 ? _r : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _s !== void 0 ? _s : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Is the course a workflow */
        Workflow: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.Workflow) !== null && _t !== void 0 ? _t : null, [Validators.required]),
        /** Restrict Course from All Access Entitlements */
        RestrictFromAllAccess: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.RestrictFromAllAccess) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Question Fore Hire */
        ForHire: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.ForHire) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** Course requires script approval */
        RequireScriptApproval: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.RequireScriptApproval) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** Course requires narration approval */
        RequireNarrationApproval: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.RequireNarrationApproval) !== null && _x !== void 0 ? _x : null, [Validators.required]),
        /** Course requires question approval */
        RequireQuestionApproval: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.RequireQuestionApproval) !== null && _y !== void 0 ? _y : null, [Validators.required]),
        /** Course requires final approval */
        RequireFinalApproval: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.RequireFinalApproval) !== null && _z !== void 0 ? _z : null, [Validators.required]),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _0 !== void 0 ? _0 : null),
        /** Started On */
        StartedOn: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _1 !== void 0 ? _1 : null),
        /** Due Date */
        DueDate: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _2 !== void 0 ? _2 : null),
        /** Estimated Completion Date */
        EstCompletionDate: new FormControl((_3 = dto === null || dto === void 0 ? void 0 : dto.EstCompletionDate) !== null && _3 !== void 0 ? _3 : null),
        /** Importance */
        Importance: new FormControl((_4 = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _4 !== void 0 ? _4 : null),
        /** Flagged */
        Flagged: new FormControl((_5 = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _5 !== void 0 ? _5 : null, [Validators.required])
    });
}
/**
/* Generates a form from a CourseApprovalCompletionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseApprovalCompletionDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseApprovalCompletionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The length of video for the content item */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Percentage course is complete */
        PercentageComplete: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PercentageComplete) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Is the org an owner of the course */
        Owner: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Owner) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Does course have rejections */
        HasRejections: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.HasRejections) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Number of Lessons in Question Approval Workflow */
        NumberOfLessonsInQuestionApproval: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.NumberOfLessonsInQuestionApproval) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Number of Lessons in Script Approval Workflow */
        NumberOfLessonsInScriptApproval: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.NumberOfLessonsInScriptApproval) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Number of Lessons in Narration Approval Workflow */
        NumberOfLessonsInNarrationApproval: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.NumberOfLessonsInNarrationApproval) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Number of Lessons in Final Approval Workflow */
        NumberOfLessonsInFinalApproval: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.NumberOfLessonsInFinalApproval) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Total Number of Lessons */
        TotalLessons: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.TotalLessons) !== null && _o !== void 0 ? _o : null, [Validators.required])
    });
}
/**
/* Generates a form from a CourseAssignedOrganizationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseAssignedOrganizationsDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseAssignedOrganizationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a CourseAtAGlanceReportDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseAtAGlanceReportDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseAtAGlanceReportDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Course Lesson */
        Course: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Course) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Course Id */
        CourseId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Course WOrkflow Step */
        CourseWorkflowStep: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CourseWorkflowStep) !== null && _c !== void 0 ? _c : null),
        /** Course Workflow Step Id */
        CourseWorkflowStepId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CourseWorkflowStepId) !== null && _d !== void 0 ? _d : null),
        /** Start Date */
        StartDate: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.StartDate) !== null && _e !== void 0 ? _e : null),
        /** Estimated Completion Date */
        EstCompletionDate: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EstCompletionDate) !== null && _f !== void 0 ? _f : null),
        /** Due Date */
        DueDate: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _g !== void 0 ? _g : null),
        /** Topics */
        Topics: fb.array((_j = (_h = dto === null || dto === void 0 ? void 0 : dto.Topics) === null || _h === void 0 ? void 0 : _h.map(x => GetTopicAtAGlanceReportDtoForm(fb, x))) !== null && _j !== void 0 ? _j : [])
    });
}
/**
/* Generates a form from a CourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** Length */
        Length: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _j !== void 0 ? _j : null),
        /** Contet Preface */
        Introduction: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Introduction) !== null && _k !== void 0 ? _k : null),
        /** The conclusion of the item */
        Conclusion: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Conclusion) !== null && _l !== void 0 ? _l : null),
        /** The Organization that owns the course */
        OwningOrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _m !== void 0 ? _m : null),
        /** External Partner Id - When Working on courses that aren't owned by the partner but are monitored by them. */
        ExternalPartnerId: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ExternalPartnerId) !== null && _o !== void 0 ? _o : null),
        /** The featured lesson used for the home page */
        FeaturedLessonId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.FeaturedLessonId) !== null && _p !== void 0 ? _p : null),
        /** Marketing Description */
        Marketing: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _q !== void 0 ? _q : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _r !== void 0 ? _r : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _s !== void 0 ? _s : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Is the course a workflow */
        Workflow: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.Workflow) !== null && _t !== void 0 ? _t : null, [Validators.required]),
        /** Restrict Course from All Access Entitlements */
        RestrictFromAllAccess: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.RestrictFromAllAccess) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Question Fore Hire */
        ForHire: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.ForHire) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** Course requires script approval */
        RequireScriptApproval: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.RequireScriptApproval) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** Course requires narration approval */
        RequireNarrationApproval: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.RequireNarrationApproval) !== null && _x !== void 0 ? _x : null, [Validators.required]),
        /** Course requires question approval */
        RequireQuestionApproval: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.RequireQuestionApproval) !== null && _y !== void 0 ? _y : null, [Validators.required]),
        /** Course requires final approval */
        RequireFinalApproval: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.RequireFinalApproval) !== null && _z !== void 0 ? _z : null, [Validators.required]),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _0 !== void 0 ? _0 : null)
    });
}
/**
/* Generates a form from a CourseGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseGroupDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Group */
        GroupId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a CourseNextAndPreviousLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseNextAndPreviousLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseNextAndPreviousLessonsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Next Lesson Id */
        NextLessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.NextLessonId) !== null && _a !== void 0 ? _a : null),
        /** Next Lesson Lesson */
        NextLesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.NextLesson) !== null && _b !== void 0 ? _b : null),
        /** Previous Lesson Id */
        PreviousLessonId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.PreviousLessonId) !== null && _c !== void 0 ? _c : null),
        /** Previous Lesson Lesson */
        PreviousLesson: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PreviousLesson) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a CoursePathItemDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CoursePathItemDto from which to create the form.
/* @returns FormGroup
 */
function GetCoursePathItemDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** Id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Parent Course Path Item */
        ParentCoursePathItemId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentCoursePathItemId) !== null && _b !== void 0 ? _b : null),
        /** Lesson of the Decision Point */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Command */
        Command: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _d !== void 0 ? _d : null),
        /** Product Id */
        ProductId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _e !== void 0 ? _e : null),
        /** Product Lesson */
        Product: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _f !== void 0 ? _f : null),
        /** Version Id */
        VersionId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _g !== void 0 ? _g : null),
        /** Version */
        Version: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _h !== void 0 ? _h : null),
        /** Description */
        Description: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _j !== void 0 ? _j : null),
        /** Lessons */
        Lessons: fb.array((_l = (_k = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _k === void 0 ? void 0 : _k.map(x => GetShortContentDtoForm(fb, x))) !== null && _l !== void 0 ? _l : []),
        /** Associated Resources */
        Resources: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.Resources) === null || _m === void 0 ? void 0 : _m.map(x => GetResourceDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** Course Path Items */
        Items: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _p === void 0 ? void 0 : _p.map(x => GetCoursePathItemDtoForm(fb, x))) !== null && _q !== void 0 ? _q : [])
    });
}
/**
/* Generates a form from a CoursePathsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CoursePathsDto from which to create the form.
/* @returns FormGroup
 */
function GetCoursePathsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The workflow layout */
        WorkflowLayout: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.WorkflowLayout) !== null && _b !== void 0 ? _b : null),
        /** The Items in the workflow */
        Items: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _c === void 0 ? void 0 : _c.map(x => GetCoursePathItemDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a CourseStructureForEditingDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseStructureForEditingDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseStructureForEditingDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z;
    return fb.group({
        /** The identifier used for linking the tree. */
        Identifier: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Identifier) !== null && _a !== void 0 ? _a : null),
        /** Is the item expanded */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The parent Id */
        ParentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _c !== void 0 ? _c : null),
        /** The Item linked to */
        ItemId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Resource Types */
        ResourceType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ResourceType) !== null && _f !== void 0 ? _f : null),
        /** Lesson */
        Name: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _g !== void 0 ? _g : null),
        /** The description */
        Description: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _h !== void 0 ? _h : null),
        /** The length of the video associated */
        Length: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _j !== void 0 ? _j : null),
        /** The original Itme that this one is based upon */
        OriginalItemId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.OriginalItemId) !== null && _k !== void 0 ? _k : null),
        /** Item Change status for KAMS */
        EditingStatus: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EditingStatus) !== null && _l !== void 0 ? _l : null),
        /** Is this a new feature? */
        NewFeature: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.NewFeature) !== null && _m !== void 0 ? _m : null),
        /** Order */
        Order: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Workflow step name */
        WorkflowStep: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _p !== void 0 ? _p : null),
        /** Assignees for the step */
        Assignees: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Assignees) !== null && _q !== void 0 ? _q : null),
        /** Is the content the current organization's? */
        IsOwnContent: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.IsOwnContent) !== null && _r !== void 0 ? _r : null),
        /** Labels */
        Labels: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Labels) !== null && _s !== void 0 ? _s : null),
        /** Due Date */
        DueDate: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _t !== void 0 ? _t : null),
        /** Flagged */
        Flagged: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Importance */
        Importance: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _v !== void 0 ? _v : null),
        /** Number of Questions */
        Questions: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Questions) !== null && _w !== void 0 ? _w : null),
        /** Versions */
        Versions: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.Versions) !== null && _x !== void 0 ? _x : null),
        /** Is Waiting For Customer Approval */
        IsWaitingForCustomerApproval: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForCustomerApproval) !== null && _y !== void 0 ? _y : null),
        /** Is Waiting For Question Team */
        IsWaitingForContentTeam: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForContentTeam) !== null && _z !== void 0 ? _z : null)
    });
}
/**
/* Generates a form from a CourseStructureForEditingWithChildrenDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseStructureForEditingWithChildrenDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseStructureForEditingWithChildrenDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1;
    return fb.group({
        /** The identifier used for linking the tree. */
        Identifier: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Identifier) !== null && _a !== void 0 ? _a : null),
        /** Is the item expanded */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The parent Id */
        ParentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _c !== void 0 ? _c : null),
        /** The Item linked to */
        ItemId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Resource Types */
        ResourceType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ResourceType) !== null && _f !== void 0 ? _f : null),
        /** Lesson */
        Name: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _g !== void 0 ? _g : null),
        /** The description */
        Description: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _h !== void 0 ? _h : null),
        /** The length of the video associated */
        Length: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _j !== void 0 ? _j : null),
        /** The original Itme that this one is based upon */
        OriginalItemId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.OriginalItemId) !== null && _k !== void 0 ? _k : null),
        /** Item Change status for KAMS */
        EditingStatus: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EditingStatus) !== null && _l !== void 0 ? _l : null),
        /** Is this a new feature? */
        NewFeature: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.NewFeature) !== null && _m !== void 0 ? _m : null),
        /** Order */
        Order: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Workflow step name */
        WorkflowStep: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _p !== void 0 ? _p : null),
        /** Assignees for the step */
        Assignees: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Assignees) !== null && _q !== void 0 ? _q : null),
        /** Is the content the current organization's? */
        IsOwnContent: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.IsOwnContent) !== null && _r !== void 0 ? _r : null),
        /** Labels */
        Labels: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Labels) !== null && _s !== void 0 ? _s : null),
        /** Due Date */
        DueDate: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _t !== void 0 ? _t : null),
        /** Flagged */
        Flagged: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Importance */
        Importance: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _v !== void 0 ? _v : null),
        /** Number of Questions */
        Questions: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Questions) !== null && _w !== void 0 ? _w : null),
        /** Versions */
        Versions: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.Versions) !== null && _x !== void 0 ? _x : null),
        /** Is Waiting For Customer Approval */
        IsWaitingForCustomerApproval: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForCustomerApproval) !== null && _y !== void 0 ? _y : null),
        /** Is Waiting For Question Team */
        IsWaitingForContentTeam: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForContentTeam) !== null && _z !== void 0 ? _z : null),
        /** Child Items */
        ChildItems: fb.array((_1 = (_0 = dto === null || dto === void 0 ? void 0 : dto.ChildItems) === null || _0 === void 0 ? void 0 : _0.map(x => GetCourseStructureForEditingDtoForm(fb, x))) !== null && _1 !== void 0 ? _1 : [])
    });
}
/**
/* Generates a form from a CourseSyndicationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseSyndicationDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseSyndicationDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Course id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Syndication Types */
        Type: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a CourseSyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseSyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseSyndicationProviderDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Course id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Syndication Methods */
        Method: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Syndication Provider Id */
        SyndicationProviderId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Syndication Provider Lesson */
        SyndicationProvider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a CourseTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Course: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Course) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null),
        /** Lesson */
        Name: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null),
        /** Preface */
        Introduction: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Introduction) !== null && _h !== void 0 ? _h : null),
        /** Postface */
        Conclusion: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Conclusion) !== null && _j !== void 0 ? _j : null),
        /** Marketing */
        Marketing: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _k !== void 0 ? _k : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _l !== void 0 ? _l : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _m !== void 0 ? _m : null, [Validators.minLength(0), Validators.maxLength(255)])
    });
}
/**
/* Generates a form from a CourseWithUserInfoDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseWithUserInfoDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseWithUserInfoDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** Length */
        Length: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _j !== void 0 ? _j : null),
        /** Contet Preface */
        Introduction: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Introduction) !== null && _k !== void 0 ? _k : null),
        /** The conclusion of the item */
        Conclusion: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Conclusion) !== null && _l !== void 0 ? _l : null),
        /** The Organization that owns the course */
        OwningOrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _m !== void 0 ? _m : null),
        /** External Partner Id - When Working on courses that aren't owned by the partner but are monitored by them. */
        ExternalPartnerId: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ExternalPartnerId) !== null && _o !== void 0 ? _o : null),
        /** The featured lesson used for the home page */
        FeaturedLessonId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.FeaturedLessonId) !== null && _p !== void 0 ? _p : null),
        /** Marketing Description */
        Marketing: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _q !== void 0 ? _q : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _r !== void 0 ? _r : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _s !== void 0 ? _s : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Is the course a workflow */
        Workflow: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.Workflow) !== null && _t !== void 0 ? _t : null, [Validators.required]),
        /** Restrict Course from All Access Entitlements */
        RestrictFromAllAccess: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.RestrictFromAllAccess) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Question Fore Hire */
        ForHire: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.ForHire) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** Course requires script approval */
        RequireScriptApproval: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.RequireScriptApproval) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** Course requires narration approval */
        RequireNarrationApproval: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.RequireNarrationApproval) !== null && _x !== void 0 ? _x : null, [Validators.required]),
        /** Course requires question approval */
        RequireQuestionApproval: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.RequireQuestionApproval) !== null && _y !== void 0 ? _y : null, [Validators.required]),
        /** Course requires final approval */
        RequireFinalApproval: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.RequireFinalApproval) !== null && _z !== void 0 ? _z : null, [Validators.required]),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _0 !== void 0 ? _0 : null),
        /** Total Lessons */
        TotalLessons: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.TotalLessons) !== null && _1 !== void 0 ? _1 : null, [Validators.required]),
        /** Total Viewed */
        TotalViewed: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.TotalViewed) !== null && _2 !== void 0 ? _2 : null, [Validators.required]),
        /** Total Length Viewed */
        TotalLengthViewed: new FormControl((_3 = dto === null || dto === void 0 ? void 0 : dto.TotalLengthViewed) !== null && _3 !== void 0 ? _3 : null, [Validators.required])
    });
}
/**
/* Generates a form from a CourseWithVersionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseWithVersionsDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseWithVersionsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The length of video for the content item */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Featured Lesson */
        FeaturedLessonId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.FeaturedLessonId) !== null && _f !== void 0 ? _f : null),
        /** Is The course a workflow? */
        Workflow: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Workflow) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Owning Organization Id */
        OwningOrganizationId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _h !== void 0 ? _h : null),
        /** Lesson of the owning organization */
        OwningOrganization: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _j !== void 0 ? _j : null),
        /** Versions applicable to the course */
        Versions: fb.array([])
    });
}
/**
/* Generates a form from a CourseWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CourseWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetCourseWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Course Lesson */
        Course: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Course) !== null && _b !== void 0 ? _b : null),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null),
        /** Role Id */
        RoleId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Role Lesson */
        Role: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _f !== void 0 ? _f : null),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a CoursesByProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CoursesByProductDto from which to create the form.
/* @returns FormGroup
 */
function GetCoursesByProductDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Product Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** Product Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Courses */
        Courses: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Courses) === null || _c === void 0 ? void 0 : _c.map(x => GetCourseDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a CreateCaptionsFromScriptDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateCaptionsFromScriptDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateCaptionsFromScriptDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Video Id */
        VideoId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VideoId) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a CreateCourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateCourseDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateCourseDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The name of the new course */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null),
        /** The Course for which this course will be based on with all structure and resources copied into the new course */
        BaseOnCourseId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.BaseOnCourseId) !== null && _b !== void 0 ? _b : null),
        /** The product and version associated with the new course */
        ProductVersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ProductVersionId) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a CreateCourseLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateCourseLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateCourseLessonDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Topic Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Topic Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a CreateCourseTopicDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateCourseTopicDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateCourseTopicDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Topic Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Topic Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a CreateCustomCourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateCustomCourseDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateCustomCourseDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a CreateCustomLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateCustomLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateCustomLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Course Id */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ParentType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Description */
        Description: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a CreateCustomProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateCustomProductDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateCustomProductDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a CreateCustomTopicDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateCustomTopicDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateCustomTopicDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a CreateTopicLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateTopicLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateTopicLessonDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The associated Topic */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Lesson Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a CreateVideoFromResourcesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original CreateVideoFromResourcesDto from which to create the form.
/* @returns FormGroup
 */
function GetCreateVideoFromResourcesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Parent Item that the video will be attached to */
        ParentItemId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentItemId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ParentItemType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentItemType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The video resource to use */
        VideoResourceId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VideoResourceId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The language associated with the media */
        LanguageCode: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _d !== void 0 ? _d : null),
        /** The audio resources to use if any (for multi-language) */
        AudioResourceIds: fb.array([]),
        /** The captions to associate with the video resource */
        CaptionResourceIds: fb.array([]),
        /** Is Video Public */
        Public: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Public) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a DecimalNameValueDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DecimalNameValueDto from which to create the form.
/* @returns FormGroup
 */
function GetDecimalNameValueDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson of the item */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Value of the Item */
        Value: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Value) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a DisciplineAssignedOrganizationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineAssignedOrganizationsDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineAssignedOrganizationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a DisciplineAverageScoreDisciplineDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineAverageScoreDisciplineDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineAverageScoreDisciplineDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Discipline Lesson */
        Discipline: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Discipline) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Organization Average Score */
        OrganizationScore: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationScore) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Industry Average Score */
        IndustryScore: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.IndustryScore) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Users own Score */
        OwnScore: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwnScore) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a DisciplineAverageScoresDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineAverageScoresDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineAverageScoresDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Include Organizational Score */
        IncludeOrganizationScore: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.IncludeOrganizationScore) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Include Industry Score */
        IncludeIndustryScore: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.IncludeIndustryScore) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Disciplines */
        Disciplines: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _c === void 0 ? void 0 : _c.map(x => GetDisciplineAverageScoreDisciplineDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a DisciplineDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Was the discipline added by a job */
        AddedByJob: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AddedByJob) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null),
        /** Owning Organization */
        OwningOrganizationId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _e !== void 0 ? _e : null),
        /** Organization */
        OwningOrganization: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _f !== void 0 ? _f : null),
        /** Created On */
        CreatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Display	Image Id */
        DisplayImageId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _j !== void 0 ? _j : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _k !== void 0 ? _k : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _l !== void 0 ? _l : null)
    });
}
/**
/* Generates a form from a DisciplineGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineGroupDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Discipline id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Group */
        GroupId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a DisciplineHeaderLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineHeaderLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineHeaderLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Discipline id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Header Lesson Id */
        LessonId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Header Lesson Lesson */
        Lesson: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a DisciplineIndustryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineIndustryDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineIndustryDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Industry Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Industry Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a DisciplineLearningPathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineLearningPathDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineLearningPathDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;
    return fb.group({
        /** Length of all incomplete lessons */
        Length: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the Path Expanded? */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Discipline Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Discipline Id */
        Id: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Total Number of Medallions */
        TotalMedallions: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalMedallions) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Number of Completed Medallions */
        TotalCompletedMedallions: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalCompletedMedallions) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Total # of Badges */
        TotalBadges: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.TotalBadges) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** When the Discipline was started. */
        StartedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** When will the trend hit 0? */
        TrendZeroOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.TrendZeroOn) !== null && _j !== void 0 ? _j : null),
        /** Percent Complete */
        PercentComplete: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Discipline Earned Date, if applicable */
        EarnedOn: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _l !== void 0 ? _l : null),
        /** History of completion */
        History: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.History) === null || _m === void 0 ? void 0 : _m.map(x => GetLearningPathHistoryDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** Order */
        Order: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Was the discipline added by a job? */
        AddedByJob: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.AddedByJob) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** Medallions */
        Medallions: fb.array((_s = (_r = dto === null || dto === void 0 ? void 0 : dto.Medallions) === null || _r === void 0 ? void 0 : _r.map(x => GetMedallionLearningPathDtoForm(fb, x))) !== null && _s !== void 0 ? _s : []),
        /** Discipline Header Lessons */
        HeaderLessons: fb.array((_u = (_t = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _t === void 0 ? void 0 : _t.map(x => GetLessonDtoForm(fb, x))) !== null && _u !== void 0 ? _u : [])
    });
}
/**
/* Generates a form from a DisciplineMedallionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineMedallionDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineMedallionDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Medallion Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Medallion Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Order */
        Order: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a DisciplinePathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplinePathDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplinePathDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** Length of all incomplete lessons */
        Length: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the Path Expanded? */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Discipline Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Discipline Id */
        Id: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Total Number of Medallions */
        TotalMedallions: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalMedallions) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Number of Completed Medallions */
        TotalCompletedMedallions: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalCompletedMedallions) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Total # of Badges */
        TotalBadges: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.TotalBadges) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** When the Discipline was started. */
        StartedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** When will the trend hit 0? */
        TrendZeroOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.TrendZeroOn) !== null && _j !== void 0 ? _j : null),
        /** Percent Complete */
        PercentComplete: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Discipline Earned Date, if applicable */
        EarnedOn: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _l !== void 0 ? _l : null),
        /** History of completion */
        History: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.History) === null || _m === void 0 ? void 0 : _m.map(x => GetLearningPathHistoryDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** Order */
        Order: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _p !== void 0 ? _p : null, [Validators.required])
    });
}
/**
/* Generates a form from a DisciplineProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineProductDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineProductDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Id */
        ProductId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Product */
        Product: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _c !== void 0 ? _c : null),
        /** Version Id */
        VersionId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Version */
        Version: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a DisciplineProductVersionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineProductVersionDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineProductVersionDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Product */
        Product: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _a !== void 0 ? _a : null),
        /** Product Id */
        ProductId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _b !== void 0 ? _b : null),
        /** Version */
        Version: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _c !== void 0 ? _c : null),
        /** Version Id */
        VersionId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a DisciplineSyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineSyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineSyndicationProviderDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Discipline id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Syndication Methods */
        Method: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Syndication Provider Id */
        SyndicationProviderId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Syndication Provider Lesson */
        SyndicationProvider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a DisciplineTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Discipline Lesson */
        Discipline: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Discipline) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(250), Validators.required])
    });
}
/**
/* Generates a form from a DisciplineUserEarnedDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineUserEarnedDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineUserEarnedDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Discipline Id */
        DisciplineId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Discipline Lesson */
        Discipline: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Discipline) !== null && _c !== void 0 ? _c : null),
        /** User Id */
        UserId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _e !== void 0 ? _e : null),
        /** Earned On */
        EarnedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Display Image Id */
        DisplayImageId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _g !== void 0 ? _g : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
    });
}
/**
/* Generates a form from a DisciplineWithProductsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisciplineWithProductsDto from which to create the form.
/* @returns FormGroup
 */
function GetDisciplineWithProductsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Was the discipline added by a job */
        AddedByJob: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AddedByJob) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null),
        /** Owning Organization */
        OwningOrganizationId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _e !== void 0 ? _e : null),
        /** Organization */
        OwningOrganization: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _f !== void 0 ? _f : null),
        /** Created On */
        CreatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Display	Image Id */
        DisplayImageId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _j !== void 0 ? _j : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _k !== void 0 ? _k : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _l !== void 0 ? _l : null),
        /** Products and Versions */
        Products: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _m === void 0 ? void 0 : _m.map(x => GetDisciplineProductVersionDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** When the user started */
        StartedOn: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _p !== void 0 ? _p : null),
        /** Is Preferred By the User */
        IsPreferred: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.IsPreferred) !== null && _q !== void 0 ? _q : null, [Validators.required])
    });
}
/**
/* Generates a form from a DisputeInvoiceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DisputeInvoiceDto from which to create the form.
/* @returns FormGroup
 */
function GetDisputeInvoiceDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Invoice Id to dispute */
        InvoiceId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Line items on the invoice */
        LineItems: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.LineItems) === null || _b === void 0 ? void 0 : _b.map(x => GetInvoiceInventoryDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a DocumentCategoriesWithDocumentsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DocumentCategoriesWithDocumentsDto from which to create the form.
/* @returns FormGroup
 */
function GetDocumentCategoriesWithDocumentsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The category name */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** The documents in the category */
        Documents: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Documents) === null || _b === void 0 ? void 0 : _b.map(x => GetDocumentDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a DocumentCategoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DocumentCategoryDto from which to create the form.
/* @returns FormGroup
 */
function GetDocumentCategoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Category Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Category Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Category Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Category is Featured */
        Featured: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Featured) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Category Featured sort order */
        FeaturedSortOrder: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.FeaturedSortOrder) !== null && _e !== void 0 ? _e : null),
        /** Category Branding color */
        BrandingColor: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.BrandingColor) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a DocumentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DocumentDto from which to create the form.
/* @returns FormGroup
 */
function GetDocumentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** The language of the item */
        LanguageCode: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _g !== void 0 ? _g : null),
        /** Url */
        Uri: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Uri) !== null && _h !== void 0 ? _h : null),
        /** Resource Types */
        Type: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** The file name if any of the resource */
        FileName: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.FileName) !== null && _k !== void 0 ? _k : null),
        /** The size of the resource */
        Size: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Size) !== null && _l !== void 0 ? _l : null),
        /** the last time it was uploaded */
        DateTimeFileUpdated: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.DateTimeFileUpdated) !== null && _m !== void 0 ? _m : null),
        /** Resource Locations */
        Location: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Any child resources of this parent */
        ChildResources: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.ChildResources) === null || _p === void 0 ? void 0 : _p.map(x => GetChildResourceDtoForm(fb, x))) !== null && _q !== void 0 ? _q : []),
        /** The Organization that owns the course */
        OwningOrganizationId: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _r !== void 0 ? _r : null),
        /** Document Category Id */
        DocumentCategoryId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.DocumentCategoryId) !== null && _s !== void 0 ? _s : null),
        /** Document Category Lesson */
        DocumentCategory: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.DocumentCategory) !== null && _t !== void 0 ? _t : null)
    });
}
/**
/* Generates a form from a DocumentLinkDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DocumentLinkDto from which to create the form.
/* @returns FormGroup
 */
function GetDocumentLinkDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Document Category Id */
        DocumentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DocumentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Item Resource Id */
        ItemId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Item Lesson */
        ItemName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ItemName) !== null && _c !== void 0 ? _c : null),
        /** Question Item Types */
        Type: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Permissions for Document */
        Permissions: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Permissions) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a DomainAndAuthMethodsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DomainAndAuthMethodsDto from which to create the form.
/* @returns FormGroup
 */
function GetDomainAndAuthMethodsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the domain */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** Is the domain active? */
        Active: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** When was it created? */
        CreatedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was it updated? */
        UpdatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Description */
        Description: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _f !== void 0 ? _f : null),
        /** The Organization that the domain is associated with */
        OrganizationId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The Url for the portal site that goes with the domain */
        PortalUrl: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PortalUrl) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Defines if Request Access will be displayed on the login page of the site. */
        ShowRequestAccess: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ShowRequestAccess) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Limit Logins to the domain's Organization Users */
        LimitLoginsToOrganizationUsers: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.LimitLoginsToOrganizationUsers) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Allow sign up from login */
        AllowSignUp: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.AllowSignUp) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Only allow signup from domains with linked email address. */
        SignUpOnlyLinkedEmailDomains: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.SignUpOnlyLinkedEmailDomains) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Automatically Assign Entitlements As Neccessary */
        AutomaticallyAssignEntitlementsAsNecessary: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.AutomaticallyAssignEntitlementsAsNecessary) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Site */
        SiteId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.SiteId) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Site */
        Site: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Site) !== null && _q !== void 0 ? _q : null),
        /** Auth Methods */
        AuthMethods: fb.array((_s = (_r = dto === null || dto === void 0 ? void 0 : dto.AuthMethods) === null || _r === void 0 ? void 0 : _r.map(x => GetAuthMethodDtoForm(fb, x))) !== null && _s !== void 0 ? _s : [])
    });
}
/**
/* Generates a form from a DomainDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DomainDto from which to create the form.
/* @returns FormGroup
 */
function GetDomainDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the domain */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** Is the domain active? */
        Active: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** When was it created? */
        CreatedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was it updated? */
        UpdatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Description */
        Description: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _f !== void 0 ? _f : null),
        /** The Organization that the domain is associated with */
        OrganizationId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The Url for the portal site that goes with the domain */
        PortalUrl: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PortalUrl) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Defines if Request Access will be displayed on the login page of the site. */
        ShowRequestAccess: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ShowRequestAccess) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Limit Logins to the domain's Organization Users */
        LimitLoginsToOrganizationUsers: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.LimitLoginsToOrganizationUsers) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Allow sign up from login */
        AllowSignUp: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.AllowSignUp) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Only allow signup from domains with linked email address. */
        SignUpOnlyLinkedEmailDomains: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.SignUpOnlyLinkedEmailDomains) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Automatically Assign Entitlements As Neccessary */
        AutomaticallyAssignEntitlementsAsNecessary: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.AutomaticallyAssignEntitlementsAsNecessary) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Site */
        SiteId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.SiteId) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Site */
        Site: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Site) !== null && _q !== void 0 ? _q : null)
    });
}
/**
/* Generates a form from a DownloadAssessmentDataDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DownloadAssessmentDataDto from which to create the form.
/* @returns FormGroup
 */
function GetDownloadAssessmentDataDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
    return fb.group({
        /** User id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        UserName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _b !== void 0 ? _b : null),
        /** Group */
        Group: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _c !== void 0 ? _c : null),
        /** Department */
        Division: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _d !== void 0 ? _d : null),
        /** Country */
        Country: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _e !== void 0 ? _e : null),
        /** Location */
        Location: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _f !== void 0 ? _f : null),
        /** Level */
        Level: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Level) !== null && _g !== void 0 ? _g : null),
        /** Goal */
        Goal: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Goal) !== null && _h !== void 0 ? _h : null),
        /** Title */
        Title: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _j !== void 0 ? _j : null),
        /** Completed On */
        CompletedOn: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.CompletedOn) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Assessment Id */
        AssessmentId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _l !== void 0 ? _l : null),
        /** Assessment Lesson */
        Assessment: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Assessment) !== null && _m !== void 0 ? _m : null),
        /** Play List Id */
        PlayListId: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _o !== void 0 ? _o : null),
        /** Play List Lesson */
        PlayList: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.PlayList) !== null && _p !== void 0 ? _p : null),
        /** Question Id */
        QuestionId: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** Question */
        Question: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Question) !== null && _r !== void 0 ? _r : null),
        /** Answer Id */
        AnswerId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _s !== void 0 ? _s : null, [Validators.required]),
        /** Answer */
        Answer: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.Answer) !== null && _t !== void 0 ? _t : null),
        /** Correct Answer */
        CorrectAnswerId: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.CorrectAnswerId) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Correct Answer */
        CorrectAnswer: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.CorrectAnswer) !== null && _v !== void 0 ? _v : null),
        /** Score */
        Score: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _w !== void 0 ? _w : null, [Validators.required])
    });
}
/**
/* Generates a form from a DownloadGoalDataDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DownloadGoalDataDto from which to create the form.
/* @returns FormGroup
 */
function GetDownloadGoalDataDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Username */
        Username: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Username) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Location */
        Location: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _c !== void 0 ? _c : null),
        /** Group */
        Group: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _d !== void 0 ? _d : null),
        /** Goal */
        Goal: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Goal) !== null && _e !== void 0 ? _e : null),
        /** Goal Percent */
        GoalPercent: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.GoalPercent) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Medallion Lesson */
        Medallion: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Medallion) !== null && _g !== void 0 ? _g : null, [Validators.minLength(1), Validators.required]),
        /** Medallion Percent */
        MedallionPercent: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.MedallionPercent) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Badge Lesson */
        Badge: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Badge) !== null && _j !== void 0 ? _j : null, [Validators.minLength(1), Validators.required]),
        /** Badge Percent */
        BadgePercent: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.BadgePercent) !== null && _k !== void 0 ? _k : null, [Validators.required])
    });
}
/**
/* Generates a form from a DownloadRoleDataDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original DownloadRoleDataDto from which to create the form.
/* @returns FormGroup
 */
function GetDownloadRoleDataDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Username */
        Username: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Username) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Location */
        Location: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _c !== void 0 ? _c : null),
        /** Group */
        Group: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _d !== void 0 ? _d : null),
        /** Role */
        Role: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _e !== void 0 ? _e : null),
        /** Goal */
        Goal: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Goal) !== null && _f !== void 0 ? _f : null, [Validators.minLength(1), Validators.required]),
        /** Goal Percent */
        GoalPercent: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.GoalPercent) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Medallion Lesson */
        Medallion: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Medallion) !== null && _h !== void 0 ? _h : null, [Validators.minLength(1), Validators.required]),
        /** Medallion Percent */
        MedallionPercent: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.MedallionPercent) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Badge Lesson */
        Badge: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Badge) !== null && _k !== void 0 ? _k : null, [Validators.minLength(1), Validators.required]),
        /** Badge Percent */
        BadgePercent: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.BadgePercent) !== null && _l !== void 0 ? _l : null, [Validators.required])
    });
}
/**
/* Generates a form from a EditProductionLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EditProductionLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetEditProductionLessonDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Workflow Step to Assign */
        WorkflowStepId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.WorkflowStepId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Reason for removing it from production. */
        Reason: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Reason) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a EduAddSubscriptionRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EduAddSubscriptionRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetEduAddSubscriptionRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return fb.group({
        /** The User to add the trial to. If this is null then the other fields for the user must be filled in. */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** Email Address */
        Email: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _b !== void 0 ? _b : null, [Validators.email]),
        /** Password */
        Password: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), IsValidPassword, Validators.required]),
        /** Confirmation Password */
        ConfirmPassword: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _d !== void 0 ? _d : null),
        /** First Lesson */
        FirstName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _e !== void 0 ? _e : null),
        /** Last Lesson */
        LastName: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _f !== void 0 ? _f : null),
        /** Phone Number */
        PhoneNumber: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _g !== void 0 ? _g : null),
        /** Provider */
        Provider: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _h !== void 0 ? _h : null),
        /** Unique Provider Key that links the provider to the user. */
        ProviderKey: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ProviderKey) !== null && _j !== void 0 ? _j : null),
        /** External Access Token */
        ExternalAccessToken: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.ExternalAccessToken) !== null && _k !== void 0 ? _k : null),
        /** Organization Lesson */
        EducationalInstitution: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EducationalInstitution) !== null && _l !== void 0 ? _l : null, [Validators.minLength(1), Validators.required]),
        /** Entitlement Quantity */
        EntitlementQuantity: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.EntitlementQuantity) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Edu Verification Code */
        Code: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Code) !== null && _o !== void 0 ? _o : null)
    });
}
/**
/* Generates a form from a EduAddSubscriptionResponseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EduAddSubscriptionResponseDto from which to create the form.
/* @returns FormGroup
 */
function GetEduAddSubscriptionResponseDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Error Message */
        ErrorMessage: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ErrorMessage) !== null && _a !== void 0 ? _a : null),
        /** Edu Subscription Status Codes */
        Result: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Result) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The main Dto that describes a user */
        User: GetUserDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.User),
        /** Organization Id */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null),
        /** Description */
        Description: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _d !== void 0 ? _d : null),
        /** Invoice Id */
        InvoiceId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a EduDomainDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EduDomainDto from which to create the form.
/* @returns FormGroup
 */
function GetEduDomainDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The domain */
        Domain: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Domain) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a EduSubscriptionPaymentRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EduSubscriptionPaymentRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetEduSubscriptionPaymentRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** The User to add the edu subscription to. */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** First Lesson */
        FirstName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _b !== void 0 ? _b : null),
        /** Last Lesson */
        LastName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _c !== void 0 ? _c : null),
        /** Phone Number */
        PhoneNumber: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _d !== void 0 ? _d : null),
        /** Street 1 */
        Street1: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Street1) !== null && _e !== void 0 ? _e : null),
        /** Street 2 */
        Street2: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Street2) !== null && _f !== void 0 ? _f : null),
        /** City or Town */
        City: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.City) !== null && _g !== void 0 ? _g : null),
        /** State */
        State: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.State) !== null && _h !== void 0 ? _h : null),
        /** Postal Code */
        PostalCode: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PostalCode) !== null && _j !== void 0 ? _j : null),
        /** Country Code */
        CountryCode: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.CountryCode) !== null && _k !== void 0 ? _k : null),
        /**  */
        PaymentMethodId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.PaymentMethodId) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** The credit card details for a payment by credit card */
        CardDetails: GetMakePaymentCardDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.CardDetails),
        /** Account details for a payment made by bank draft */
        AccountDetails: GetMakePaymentAccountDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.AccountDetails),
    });
}
/**
/* Generates a form from a EmailDomainBlackListItemDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmailDomainBlackListItemDto from which to create the form.
/* @returns FormGroup
 */
function GetEmailDomainBlackListItemDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The domain */
        Domain: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Domain) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Block Email Domain Registration */
        BlockEmailDomainRegistration: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.BlockEmailDomainRegistration) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Block Purchase from this domain */
        BlockPurchase: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.BlockPurchase) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a EmailTemplateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmailTemplateDto from which to create the form.
/* @returns FormGroup
 */
function GetEmailTemplateDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The key of the email template */
        Key: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Key) !== null && _a !== void 0 ? _a : null),
        /** The friendly name of the email template */
        FriendlyName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FriendlyName) !== null && _b !== void 0 ? _b : null),
        /** The subject of the e-mail */
        Subject: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Subject) !== null && _c !== void 0 ? _c : null),
        /** The default html of the template */
        DefaultTemplate: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.DefaultTemplate) !== null && _d !== void 0 ? _d : null),
        /** Bit value indicating whether or not the email template is internal to CADLearning */
        Internal: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Internal) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a EmployeeActivityDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmployeeActivityDto from which to create the form.
/* @returns FormGroup
 */
function GetEmployeeActivityDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Date and Time of the activity */
        DateTime: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DateTime) !== null && _a !== void 0 ? _a : null),
        /** IP Address of the activity */
        Origin: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Origin) !== null && _b !== void 0 ? _b : null),
        /** Client that was used to view the activity */
        ClientId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _c !== void 0 ? _c : null),
        /** User Details */
        Employee: GetUserActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Employee),
        /** Organization Details */
        Organization: GetOrganizationActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Organization),
        /** Course Activity Details */
        Course: GetCourseActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Course),
        /** Topic Details */
        Topic: GetTopicActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Topic),
        /** Lesson Detail */
        Lesson: GetLessonActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Lesson),
        /** Product Details */
        Product: GetProductActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Product),
        /** Project Details */
        Project: GetProjectActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Project),
        /** Play List Details */
        PlayList: GetPlaylistActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.PlayList),
    });
}
/**
/* Generates a form from a EmployeeAssignedToItemDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmployeeAssignedToItemDto from which to create the form.
/* @returns FormGroup
 */
function GetEmployeeAssignedToItemDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Employee Id */
        EmployeeId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EmployeeId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Employee Name */
        EmployeeName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.EmployeeName) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Email Address */
        EmployeeEmailAddress: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.EmployeeEmailAddress) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required]),
        /** Score */
        EmployeeScore: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EmployeeScore) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** OutOf */
        EmployeeOutOf: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.EmployeeOutOf) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Percent */
        EmployeePercent: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EmployeePercent) !== null && _h !== void 0 ? _h : null, [Validators.required])
    });
}
/**
/* Generates a form from a EmployeeItemCompletionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmployeeItemCompletionDto from which to create the form.
/* @returns FormGroup
 */
function GetEmployeeItemCompletionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Lesson */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Items */
        Items: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _d === void 0 ? void 0 : _d.map(x => GetItemCompletionDtoForm(fb, x))) !== null && _e !== void 0 ? _e : [])
    });
}
/**
/* Generates a form from a EmployeeItemCompletionFlattenedDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmployeeItemCompletionFlattenedDto from which to create the form.
/* @returns FormGroup
 */
function GetEmployeeItemCompletionFlattenedDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** Lesson */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _c !== void 0 ? _c : null, [Validators.email]),
        /** Lesson */
        GoalId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.GoalId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lesson */
        Goal: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Goal) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required]),
        /** Score */
        Score: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** OutOf */
        OutOf: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OutOf) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Percent */
        Percent: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Percent) !== null && _h !== void 0 ? _h : null, [Validators.required])
    });
}
/**
/* Generates a form from a EmployeeScoreChangeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmployeeScoreChangeDto from which to create the form.
/* @returns FormGroup
 */
function GetEmployeeScoreChangeDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Id of the employee */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson of the employee */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** History of results */
        Change: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Change) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a EmployeeWithEngagementDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmployeeWithEngagementDto from which to create the form.
/* @returns FormGroup
 */
function GetEmployeeWithEngagementDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** User Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Engagement Ratio calculation result */
        EngagementRatio: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EngagementRatio) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a EmployeeWithOverallGoalCompletionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EmployeeWithOverallGoalCompletionDto from which to create the form.
/* @returns FormGroup
 */
function GetEmployeeWithOverallGoalCompletionDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** User Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Completion Percentage */
        CompletionPercentage: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CompletionPercentage) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a EngagementTrendsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EngagementTrendsDto from which to create the form.
/* @returns FormGroup
 */
function GetEngagementTrendsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Date of the Measurement */
        Date: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Percentage of Emploeyes who engaged with the system in the past month */
        Percentage: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Percentage) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a EnterpriseRequestInformationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EnterpriseRequestInformationDto from which to create the form.
/* @returns FormGroup
 */
function GetEnterpriseRequestInformationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Partner Id */
        PartnerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _a !== void 0 ? _a : null),
        /** Organization Types */
        OrganizationSize: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationSize) !== null && _b !== void 0 ? _b : null),
        /** Organization Lesson */
        OrganizationName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(450), Validators.email, Validators.required]),
        /** First Lesson */
        FirstName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** Last Lesson */
        LastName: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** Country */
        Country: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _g !== void 0 ? _g : null, [Validators.minLength(2), Validators.maxLength(2), Validators.required]),
        /** Phone Number */
        PhoneNumber: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _h !== void 0 ? _h : null, [Validators.minLength(1), Validators.required]),
        /** Message */
        Message: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Message) !== null && _j !== void 0 ? _j : null)
    });
}
/**
/* Generates a form from a EntitlementDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EntitlementDto from which to create the form.
/* @returns FormGroup
 */
function GetEntitlementDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assigned to User Id */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null),
        /** Assigned to user name */
        User: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _c !== void 0 ? _c : null),
        /** Assigned to an organization id */
        OrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Assigned to an Organization name */
        Organization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _e !== void 0 ? _e : null),
        /** The token id that created the entitlement if any */
        TokenId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TokenId) !== null && _f !== void 0 ? _f : null),
        /** Starts on */
        StartsOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _g !== void 0 ? _g : null),
        /** Ends on */
        EndsOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _h !== void 0 ? _h : null),
        /** What is the item in question? */
        InventoryItemId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.InventoryItemId) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** The name of the inventory item associated with the entitlement */
        InventoryItem: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.InventoryItem) !== null && _k !== void 0 ? _k : null),
        /** Inventory Item Types */
        InventoryItemType: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.InventoryItemType) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** The inventory associated with the entitlement */
        InventoryId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.InventoryId) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** The name of the inventory associated with the entitlement */
        Inventory: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Inventory) !== null && _o !== void 0 ? _o : null),
        /** When was it cancelled */
        CancelledOn: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.CancelledOn) !== null && _p !== void 0 ? _p : null),
        /** Billing Recurring Periods */
        RecurringPeriod: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.RecurringPeriod) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** The last time a payment was made */
        LastPaymentOn: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.LastPaymentOn) !== null && _r !== void 0 ? _r : null),
        /** Next Payment On */
        NextPaymentOn: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.NextPaymentOn) !== null && _s !== void 0 ? _s : null),
        /** Payment Credentials for recurring billing */
        PaymentCredentialsId: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.PaymentCredentialsId) !== null && _t !== void 0 ? _t : null),
        /** The name of the Payment credentials for recurring billing */
        PaymentCredentials: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.PaymentCredentials) !== null && _u !== void 0 ? _u : null),
        /** Determines whether an entitlement is active or not */
        Active: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** Serial Number */
        SerialNumber: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.SerialNumber) !== null && _w !== void 0 ? _w : null, [Validators.minLength(0), Validators.maxLength(36)])
    });
}
/**
/* Generates a form from a EntitlementPaymentHistoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original EntitlementPaymentHistoryDto from which to create the form.
/* @returns FormGroup
 */
function GetEntitlementPaymentHistoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Entitlement Id */
        EntitlementId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.EntitlementId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Invoice Id */
        InvoiceId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Invoice Date */
        InvoiceDate: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.InvoiceDate) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Invoice Total */
        InvoiceTotal: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.InvoiceTotal) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Payment Id */
        PaymentId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.PaymentId) !== null && _e !== void 0 ? _e : null),
        /** Payment Date */
        PaymentDate: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PaymentDate) !== null && _f !== void 0 ? _f : null),
        /** Payment Total */
        PaymentTotal: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PaymentTotal) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a ErrorLogDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ErrorLogDto from which to create the form.
/* @returns FormGroup
 */
function GetErrorLogDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** Source File Path */
        SourceFilePath: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SourceFilePath) !== null && _a !== void 0 ? _a : null),
        /** Source Line Number */
        SourceLineNumber: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.SourceLineNumber) !== null && _b !== void 0 ? _b : null),
        /** Source Member Lesson */
        SourceMemberName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.SourceMemberName) !== null && _c !== void 0 ? _c : null),
        /** Error Message */
        ErrorMessage: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ErrorMessage) !== null && _d !== void 0 ? _d : null),
        /** Additional Details */
        AdditionalDetails: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.AdditionalDetails) !== null && _e !== void 0 ? _e : null),
        /** Stack Trace */
        StackTrace: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.StackTrace) !== null && _f !== void 0 ? _f : null),
        /** Client Id */
        ClientId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _g !== void 0 ? _g : null),
        /** Client Secret */
        ClientSecret: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ClientSecret) !== null && _h !== void 0 ? _h : null)
    });
}
/**
/* Generates a form from a ExpiredUserEntitlementDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ExpiredUserEntitlementDto from which to create the form.
/* @returns FormGroup
 */
function GetExpiredUserEntitlementDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Is a trial entitlement */
        IsTrial: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.IsTrial) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is owned by an organization */
        IsOrganizationOwned: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.IsOrganizationOwned) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The ending date of the last entitlement */
        EndsOn: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ExpiringEntitlementDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ExpiringEntitlementDto from which to create the form.
/* @returns FormGroup
 */
function GetExpiringEntitlementDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assigned to User Id */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null),
        /** Assigned to user name */
        User: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _c !== void 0 ? _c : null),
        /** Assigned to an organization id */
        OrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Assigned to an Organization name */
        Organization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _e !== void 0 ? _e : null),
        /** The token id that created the entitlement if any */
        TokenId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TokenId) !== null && _f !== void 0 ? _f : null),
        /** Starts on */
        StartsOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _g !== void 0 ? _g : null),
        /** Ends on */
        EndsOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _h !== void 0 ? _h : null),
        /** What is the item in question? */
        InventoryItemId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.InventoryItemId) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** The name of the inventory item associated with the entitlement */
        InventoryItem: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.InventoryItem) !== null && _k !== void 0 ? _k : null),
        /** Inventory Item Types */
        InventoryItemType: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.InventoryItemType) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** The inventory associated with the entitlement */
        InventoryId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.InventoryId) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** The name of the inventory associated with the entitlement */
        Inventory: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Inventory) !== null && _o !== void 0 ? _o : null),
        /** When was it cancelled */
        CancelledOn: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.CancelledOn) !== null && _p !== void 0 ? _p : null),
        /** Billing Recurring Periods */
        RecurringPeriod: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.RecurringPeriod) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** The last time a payment was made */
        LastPaymentOn: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.LastPaymentOn) !== null && _r !== void 0 ? _r : null),
        /** Next Payment On */
        NextPaymentOn: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.NextPaymentOn) !== null && _s !== void 0 ? _s : null),
        /** Payment Credentials for recurring billing */
        PaymentCredentialsId: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.PaymentCredentialsId) !== null && _t !== void 0 ? _t : null),
        /** The name of the Payment credentials for recurring billing */
        PaymentCredentials: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.PaymentCredentials) !== null && _u !== void 0 ? _u : null),
        /** Determines whether an entitlement is active or not */
        Active: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** Serial Number */
        SerialNumber: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.SerialNumber) !== null && _w !== void 0 ? _w : null, [Validators.minLength(0), Validators.maxLength(36)]),
        /** Email Address */
        Email: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _x !== void 0 ? _x : null, [Validators.email])
    });
}
/**
/* Generates a form from a FileUploadWithParentDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original FileUploadWithParentDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetFileUploadWithParentDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The URI if the Type is Link. The Filename otherwise */
        Uri: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Uri) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(500), Validators.required]),
        /** The Lesson of the resource. */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Resource Types */
        Type: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** The language associated with the resource. */
        LanguageCode: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(10), Validators.required]),
        /** If Type != Url then the file that will be posted. */
        File: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.File) !== null && _f !== void 0 ? _f : null),
        /** The Parent to the file that is being uploaded */
        ParentId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a FilterCriteria
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original FilterCriteria from which to create the form.
/* @returns FormGroup
 */
function GetFilterCriteriaForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /**  */
        FieldName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FieldName) !== null && _a !== void 0 ? _a : null),
        /**  */
        Op: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Op) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /**  */
        Relation: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Relation) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /**  */
        Values: fb.array([])
    });
}
/**
/* Generates a form from a GamificationStructureForEditingDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GamificationStructureForEditingDto from which to create the form.
/* @returns FormGroup
 */
function GetGamificationStructureForEditingDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The identifier used for linking the tree. */
        Identifier: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Identifier) !== null && _a !== void 0 ? _a : null),
        /** Is the item expanded */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The parent Id */
        ParentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _c !== void 0 ? _c : null),
        /** The Item linked to */
        ItemId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _f !== void 0 ? _f : null),
        /** The length of the video associated */
        Length: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The original Item that this one is based upon */
        OriginalItemId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.OriginalItemId) !== null && _h !== void 0 ? _h : null),
        /** Order */
        Order: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Is the content the current organization's? */
        IsOwnContent: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.IsOwnContent) !== null && _k !== void 0 ? _k : null, [Validators.required])
    });
}
/**
/* Generates a form from a GamificationStructureForEditingWithChildrenDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GamificationStructureForEditingWithChildrenDto from which to create the form.
/* @returns FormGroup
 */
function GetGamificationStructureForEditingWithChildrenDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** The identifier used for linking the tree. */
        Identifier: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Identifier) !== null && _a !== void 0 ? _a : null),
        /** Is the item expanded */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The parent Id */
        ParentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _c !== void 0 ? _c : null),
        /** The Item linked to */
        ItemId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _f !== void 0 ? _f : null),
        /** The length of the video associated */
        Length: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The original Item that this one is based upon */
        OriginalItemId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.OriginalItemId) !== null && _h !== void 0 ? _h : null),
        /** Order */
        Order: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Is the content the current organization's? */
        IsOwnContent: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.IsOwnContent) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Child Items */
        ChildItems: fb.array((_m = (_l = dto === null || dto === void 0 ? void 0 : dto.ChildItems) === null || _l === void 0 ? void 0 : _l.map(x => GetGamificationStructureForEditingWithChildrenDtoForm(fb, x))) !== null && _m !== void 0 ? _m : [])
    });
}
/**
/* Generates a form from a GamificationUserEarnedDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GamificationUserEarnedDto from which to create the form.
/* @returns FormGroup
 */
function GetGamificationUserEarnedDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null),
        /** Badges */
        Badges: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Badges) === null || _c === void 0 ? void 0 : _c.map(x => GetBadgeUserEarnedDtoForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /** Medallions */
        Medallions: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Medallions) === null || _e === void 0 ? void 0 : _e.map(x => GetMedallionUserEarnedDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Disciplines */
        Disciplines: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _g === void 0 ? void 0 : _g.map(x => GetDisciplineUserEarnedDtoForm(fb, x))) !== null && _h !== void 0 ? _h : [])
    });
}
/**
/* Generates a form from a GenerateAssessmentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GenerateAssessmentDto from which to create the form.
/* @returns FormGroup
 */
function GetGenerateAssessmentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The assessment id */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null),
        /** The assessment name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The number of questions to generate in the assessment */
        Questions: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Questions) !== null && _c !== void 0 ? _c : null, [Validators.max(100), Validators.min(1), Validators.required]),
        /** The concept ids to generate the assessment from */
        ConceptIds: fb.array([]),
        /** The topic ids to generate the assessment from */
        TopicIds: fb.array([]),
        /** Course Id */
        CourseId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _d !== void 0 ? _d : null),
        /** Owning Organization Id */
        OwningOrganizationId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _e !== void 0 ? _e : null),
        /** An Enumeration of different types of assessments */
        AssessmentType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.AssessmentType) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a GenerateAssessmentGamificationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GenerateAssessmentGamificationDto from which to create the form.
/* @returns FormGroup
 */
function GetGenerateAssessmentGamificationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The assessment id */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null),
        /** The assessment name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The number of questions to generate in the assessment */
        Questions: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Questions) !== null && _c !== void 0 ? _c : null, [Validators.max(100), Validators.min(1), Validators.required]),
        /** The badge ids to generate the assessment from */
        BadgeIds: fb.array([]),
        /** The medallion ids to generate the assessment from */
        MedallionIds: fb.array([]),
        /** Role Id */
        RoleId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _d !== void 0 ? _d : null),
        /** Owning Organization Id */
        OwningOrganizationId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _e !== void 0 ? _e : null),
        /** An Enumeration of different types of assessments */
        AssessmentType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.AssessmentType) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a GenerateGapAssessmentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GenerateGapAssessmentDto from which to create the form.
/* @returns FormGroup
 */
function GetGenerateGapAssessmentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The assessment id */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null),
        /** The assessment name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The number of questions to generate in the assessment */
        Questions: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Questions) !== null && _c !== void 0 ? _c : null, [Validators.max(100), Validators.min(1), Validators.required]),
        /** The concept ids to generate the assessment from */
        ConceptIds: fb.array([]),
        /** The topic ids to generate the assessment from */
        TopicIds: fb.array([]),
        /** Course Id */
        CourseId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _d !== void 0 ? _d : null),
        /** Owning Organization Id */
        OwningOrganizationId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _e !== void 0 ? _e : null),
        /** An Enumeration of different types of assessments */
        AssessmentType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.AssessmentType) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Product Id */
        ProductId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Version Id */
        VersionId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Version 2 Id */
        Version2Id: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Version2Id) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a GenerateProjectPreHireAssessmentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GenerateProjectPreHireAssessmentDto from which to create the form.
/* @returns FormGroup
 */
function GetGenerateProjectPreHireAssessmentDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Project Job id */
        ProjectJobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProjectJobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Assessment Lesson */
        AssessmentName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.AssessmentName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Number Of Questions */
        NumberOfQuestions: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.NumberOfQuestions) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a GetBotConversationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GetBotConversationDto from which to create the form.
/* @returns FormGroup
 */
function GetGetBotConversationDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The Id of the conversation to retrieve */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null)
    });
}
/**
/* Generates a form from a GroupCriteria
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GroupCriteria from which to create the form.
/* @returns FormGroup
 */
function GetGroupCriteriaForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /**  */
        FieldName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FieldName) !== null && _a !== void 0 ? _a : null),
        /**  */
        Direction: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Direction) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /**  */
        Aggregates: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Aggregates) === null || _c === void 0 ? void 0 : _c.map(x => GetAggregateCriteriaForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /**  */
        SubGroup: GetGroupCriteriaForm(fb, dto === null || dto === void 0 ? void 0 : dto.SubGroup),
    });
}
/**
/* Generates a form from a GroupResult
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original GroupResult from which to create the form.
/* @returns FormGroup
 */
function GetGroupResultForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /**  */
        FieldName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FieldName) !== null && _a !== void 0 ? _a : null),
        /**  */
        Value: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Value) !== null && _b !== void 0 ? _b : null),
        /**  */
        Aggregates: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Aggregates) === null || _c === void 0 ? void 0 : _c.map(x => GetAggregateResultForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /**  */
        SubGroupResults: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.SubGroupResults) === null || _e === void 0 ? void 0 : _e.map(x => GetGroupResultForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a HelpQuestionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original HelpQuestionDto from which to create the form.
/* @returns FormGroup
 */
function GetHelpQuestionDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The text of the question */
        Text: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a ImageUploadDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ImageUploadDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetImageUploadDetailsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The Parent to the file that is being uploaded */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Image that will be uploaded */
        File: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.File) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a ImportCourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ImportCourseDto from which to create the form.
/* @returns FormGroup
 */
function GetImportCourseDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The Id of the course that the items will be imported from */
        SourceCourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SourceCourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Id of the course that the items will be imported into. */
        DestinationCourseId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.DestinationCourseId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The items to be imported */
        Items: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _c === void 0 ? void 0 : _c.map(x => GetCourseStructureForEditingWithChildrenDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a ImportQuestionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ImportQuestionDto from which to create the form.
/* @returns FormGroup
 */
function GetImportQuestionDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The question id */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The assessment id */
        AssessmentId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _b !== void 0 ? _b : null),
        /** The organization id */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null),
        /** The order of the question */
        Order: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a ImportResourceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ImportResourceDto from which to create the form.
/* @returns FormGroup
 */
function GetImportResourceDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The parent item that will have a link to the given resource */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null),
        /** Question Item Types */
        ParentType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentType) !== null && _b !== void 0 ? _b : null),
        /** The Resource to be imported */
        ResourceId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ResourceId) !== null && _c !== void 0 ? _c : null),
        /** Directions for use if any */
        Directions: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Directions) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a IndustryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original IndustryDto from which to create the form.
/* @returns FormGroup
 */
function GetIndustryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Owning Organization */
        OwningOrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Organization */
        OwningOrganization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _e !== void 0 ? _e : null),
        /** Created On */
        CreatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Description */
        Description: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _h !== void 0 ? _h : null)
    });
}
/**
/* Generates a form from a Int32NameValueDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original Int32NameValueDto from which to create the form.
/* @returns FormGroup
 */
function GetInt32NameValueDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson of the item */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Value of the Item */
        Value: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Value) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a InventoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InventoryDto from which to create the form.
/* @returns FormGroup
 */
function GetInventoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Keywords */
        Keywords: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Keywords) !== null && _d !== void 0 ? _d : null),
        /** Starts On */
        StartsOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Ends On */
        EndsOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _f !== void 0 ? _f : null),
        /** SKU */
        SKU: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Show on web */
        ShowOnWeb: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ShowOnWeb) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Is the inventory item active */
        Active: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a InventoryItemDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InventoryItemDto from which to create the form.
/* @returns FormGroup
 */
function GetInventoryItemDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Inventory Identifier */
        InventoryId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InventoryId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Inventory Lesson */
        Inventory: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Inventory) !== null && _c !== void 0 ? _c : null),
        /** The Id of the item */
        ItemId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _d !== void 0 ? _d : null),
        /** The name of the item */
        Item: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Item) !== null && _e !== void 0 ? _e : null),
        /** Inventory Item Types */
        Type: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Billing Recurring Periods */
        RecurringPeriod: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.RecurringPeriod) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Requires Shipping */
        RequiresShipping: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.RequiresShipping) !== null && _h !== void 0 ? _h : null, [Validators.required])
    });
}
/**
/* Generates a form from a InventoryWithPriceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InventoryWithPriceDto from which to create the form.
/* @returns FormGroup
 */
function GetInventoryWithPriceDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Keywords */
        Keywords: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Keywords) !== null && _d !== void 0 ? _d : null),
        /** Starts On */
        StartsOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Ends On */
        EndsOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _f !== void 0 ? _f : null),
        /** SKU */
        SKU: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Show on web */
        ShowOnWeb: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ShowOnWeb) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Price */
        Price: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Price) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a InvitePlayListEmailAddressesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvitePlayListEmailAddressesDto from which to create the form.
/* @returns FormGroup
 */
function GetInvitePlayListEmailAddressesDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The url of the site that users will be directed to, to view the play list and or accept/reject it. */
        SiteUrl: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SiteUrl) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** The play list to invite into */
        PlayListId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** A list of email addresses to invite */
        EmailAddresses: fb.array([])
    });
}
/**
/* Generates a form from a InvitePlayListUsersByGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvitePlayListUsersByGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetInvitePlayListUsersByGroupDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The url of the site that users will be directed to, to view the play list and or accept/reject it. */
        SiteUrl: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SiteUrl) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** The play list to invite into */
        PlayListId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization Id for groups */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** A list of UserIds to invite */
        Groups: fb.array([])
    });
}
/**
/* Generates a form from a InvitePlayListUsersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvitePlayListUsersDto from which to create the form.
/* @returns FormGroup
 */
function GetInvitePlayListUsersDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The url of the site that users will be directed to, to view the play list and or accept/reject it. */
        SiteUrl: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SiteUrl) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** The play list to invite into */
        PlayListId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** A list of UserIds to invite */
        UserIds: fb.array([])
    });
}
/**
/* Generates a form from a InvitePreHireUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvitePreHireUserDto from which to create the form.
/* @returns FormGroup
 */
function GetInvitePreHireUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The assessment to invite them to */
        AssessmentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Phone Number */
        SendEmail: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SendEmail) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Invitation URL */
        InvitationURL: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.InvitationURL) !== null && _f !== void 0 ? _f : null, [Validators.minLength(1), Validators.required]),
        /** The main Dto that describes a user */
        User: GetUserDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.User),
    });
}
/**
/* Generates a form from a InviteUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InviteUserDto from which to create the form.
/* @returns FormGroup
 */
function GetInviteUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
    return fb.group({
        /** Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The portal to invite them to */
        PortalId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PortalId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** First Lesson */
        FirstName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Last Lesson */
        LastName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Phone Number */
        PhoneNumber: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _f !== void 0 ? _f : null),
        /** Phone Extension */
        PhoneExt: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PhoneExt) !== null && _g !== void 0 ? _g : null),
        /** Division */
        Division: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _h !== void 0 ? _h : null),
        /** Location */
        Location: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _j !== void 0 ? _j : null),
        /** Country */
        Country: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _k !== void 0 ? _k : null),
        /** Group */
        GroupId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _l !== void 0 ? _l : null),
        /** Goal */
        Goal: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Goal) !== null && _m !== void 0 ? _m : null),
        /** Send invite email */
        SendEmail: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.SendEmail) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Personal Login to invite existing user */
        PersonalLogin: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.PersonalLogin) !== null && _p !== void 0 ? _p : null),
        /** Title */
        Title: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _q !== void 0 ? _q : null),
        /** Sku to give to the invited user */
        SKU: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _r !== void 0 ? _r : null)
    });
}
/**
/* Generates a form from a InvoiceDisplayDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvoiceDisplayDto from which to create the form.
/* @returns FormGroup
 */
function GetInvoiceDisplayDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The originating Organization Id */
        FromOrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FromOrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The user to email when a quote is submitted */
        FromOrganizationUserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FromOrganizationUserId) !== null && _c !== void 0 ? _c : null),
        /** The name of the originating organization */
        FromOrganization: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.FromOrganization) !== null && _d !== void 0 ? _d : null),
        /** Who is being invoiced/billed/POed */
        ToContactId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ToContactId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Contact Types */
        ToContactType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ToContactType) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Invoice Types */
        Type: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** A link to a purchase order if this invoice was created from one. */
        PurchaseOrderId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PurchaseOrderId) !== null && _h !== void 0 ? _h : null),
        /** the date of the invoice */
        Date: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** the subtotal of all line items */
        SubTotal: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.SubTotal) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** The sales tax that is applied */
        SalesTax1Id: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.SalesTax1Id) !== null && _l !== void 0 ? _l : null),
        /** The name of the sales tax applied */
        SalesTax1: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.SalesTax1) !== null && _m !== void 0 ? _m : null),
        /** The amount of the first sales tax */
        SalesTax1Amount: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.SalesTax1Amount) !== null && _o !== void 0 ? _o : null),
        /** The second sales tax applied */
        SalesTax2Id: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.SalesTax2Id) !== null && _p !== void 0 ? _p : null),
        /** The name of the second sales tax */
        SalesTax2: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.SalesTax2) !== null && _q !== void 0 ? _q : null),
        /** The amount of the second sales tax */
        SalesTax2Amount: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.SalesTax2Amount) !== null && _r !== void 0 ? _r : null),
        /** The name of the shipping method */
        ShippingMethodId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.ShippingMethodId) !== null && _s !== void 0 ? _s : null),
        /** The name of the shipping method */
        ShippingMethod: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.ShippingMethod) !== null && _t !== void 0 ? _t : null),
        /** The amount of the shipping */
        Shipping: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Shipping) !== null && _u !== void 0 ? _u : null),
        /** The grand total of the invoice all inclusive */
        GrandTotal: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.GrandTotal) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** The current balance of the invoice */
        Balance: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Balance) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** The id of the Billing Address for the invoice */
        BillingAddressId: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _x !== void 0 ? _x : null),
        /** The shipping Address for the invoice if applicable */
        ShippingAddressId: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.ShippingAddressId) !== null && _y !== void 0 ? _y : null),
        /** Invoice # */
        InvoiceNumber: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.InvoiceNumber) !== null && _z !== void 0 ? _z : null, [Validators.required]),
        /** The Number of the bill */
        BillNumber: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.BillNumber) !== null && _0 !== void 0 ? _0 : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Purchase Order # */
        PurchaseOrderNumber: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.PurchaseOrderNumber) !== null && _1 !== void 0 ? _1 : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Invoice Statuses */
        Status: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.Status) !== null && _2 !== void 0 ? _2 : null, [Validators.required]),
        /** Notes field */
        Notes: new FormControl((_3 = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _3 !== void 0 ? _3 : null),
        /** Lesson of the contact */
        ToContact: new FormControl((_4 = dto === null || dto === void 0 ? void 0 : dto.ToContact) !== null && _4 !== void 0 ? _4 : null)
    });
}
/**
/* Generates a form from a InvoiceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvoiceDto from which to create the form.
/* @returns FormGroup
 */
function GetInvoiceDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The originating Organization Id */
        FromOrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FromOrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The user to email when a quote is submitted */
        FromOrganizationUserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FromOrganizationUserId) !== null && _c !== void 0 ? _c : null),
        /** The name of the originating organization */
        FromOrganization: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.FromOrganization) !== null && _d !== void 0 ? _d : null),
        /** Who is being invoiced/billed/POed */
        ToContactId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ToContactId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Contact Types */
        ToContactType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ToContactType) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Invoice Types */
        Type: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** A link to a purchase order if this invoice was created from one. */
        PurchaseOrderId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PurchaseOrderId) !== null && _h !== void 0 ? _h : null),
        /** the date of the invoice */
        Date: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** the subtotal of all line items */
        SubTotal: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.SubTotal) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** The sales tax that is applied */
        SalesTax1Id: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.SalesTax1Id) !== null && _l !== void 0 ? _l : null),
        /** The name of the sales tax applied */
        SalesTax1: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.SalesTax1) !== null && _m !== void 0 ? _m : null),
        /** The amount of the first sales tax */
        SalesTax1Amount: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.SalesTax1Amount) !== null && _o !== void 0 ? _o : null),
        /** The second sales tax applied */
        SalesTax2Id: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.SalesTax2Id) !== null && _p !== void 0 ? _p : null),
        /** The name of the second sales tax */
        SalesTax2: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.SalesTax2) !== null && _q !== void 0 ? _q : null),
        /** The amount of the second sales tax */
        SalesTax2Amount: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.SalesTax2Amount) !== null && _r !== void 0 ? _r : null),
        /** The name of the shipping method */
        ShippingMethodId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.ShippingMethodId) !== null && _s !== void 0 ? _s : null),
        /** The name of the shipping method */
        ShippingMethod: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.ShippingMethod) !== null && _t !== void 0 ? _t : null),
        /** The amount of the shipping */
        Shipping: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Shipping) !== null && _u !== void 0 ? _u : null),
        /** The grand total of the invoice all inclusive */
        GrandTotal: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.GrandTotal) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** The current balance of the invoice */
        Balance: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Balance) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** The id of the Billing Address for the invoice */
        BillingAddressId: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _x !== void 0 ? _x : null),
        /** The shipping Address for the invoice if applicable */
        ShippingAddressId: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.ShippingAddressId) !== null && _y !== void 0 ? _y : null),
        /** Invoice # */
        InvoiceNumber: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.InvoiceNumber) !== null && _z !== void 0 ? _z : null, [Validators.required]),
        /** The Number of the bill */
        BillNumber: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.BillNumber) !== null && _0 !== void 0 ? _0 : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Purchase Order # */
        PurchaseOrderNumber: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.PurchaseOrderNumber) !== null && _1 !== void 0 ? _1 : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Invoice Statuses */
        Status: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.Status) !== null && _2 !== void 0 ? _2 : null, [Validators.required]),
        /** Notes field */
        Notes: new FormControl((_3 = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _3 !== void 0 ? _3 : null)
    });
}
/**
/* Generates a form from a InvoiceInventoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvoiceInventoryDto from which to create the form.
/* @returns FormGroup
 */
function GetInvoiceInventoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Invoice Id */
        InvoiceId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Inventory Id */
        InventoryId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.InventoryId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Inventory Lesson */
        InventoryName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.InventoryName) !== null && _d !== void 0 ? _d : null),
        /** Units */
        Units: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Units) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Price */
        Price: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Price) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Create Token */
        CreateToken: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CreateToken) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** If Create Token, also allow configuration of token expiration date */
        TokenExpirationDate: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.TokenExpirationDate) !== null && _h !== void 0 ? _h : null),
        /** Disputed? */
        Disputed: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Disputed) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Dispute Reason */
        DisputeReason: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.DisputeReason) !== null && _k !== void 0 ? _k : null),
        /** Entitlements */
        Entitlements: fb.array((_m = (_l = dto === null || dto === void 0 ? void 0 : dto.Entitlements) === null || _l === void 0 ? void 0 : _l.map(x => GetInvoiceInventoryEntitlementDtoForm(fb, x))) !== null && _m !== void 0 ? _m : [])
    });
}
/**
/* Generates a form from a InvoiceInventoryEntitlementDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvoiceInventoryEntitlementDto from which to create the form.
/* @returns FormGroup
 */
function GetInvoiceInventoryEntitlementDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** Invoice Inventory Id */
        InvoiceInventoryId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.InvoiceInventoryId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Entitlement Id */
        EntitlementId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.EntitlementId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Description of the entitlement */
        Entitlement: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Entitlement) !== null && _c !== void 0 ? _c : null),
        /** Organization Id */
        OrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Organization */
        Organization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _e !== void 0 ? _e : null),
        /** User Id */
        UserId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _f !== void 0 ? _f : null),
        /** User name */
        User: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _g !== void 0 ? _g : null),
        /** Org User */
        InvoiceNumber: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.InvoiceNumber) !== null && _h !== void 0 ? _h : null)
    });
}
/**
/* Generates a form from a InvoicePaymentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvoicePaymentDto from which to create the form.
/* @returns FormGroup
 */
function GetInvoicePaymentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** the invoice Id */
        InvoiceId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Payment Id */
        PaymentId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PaymentId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Date of payment */
        Date: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Payment Total */
        PaymentTotal: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PaymentTotal) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** How much of the payment total was applied to the specified invoice */
        InvoiceAmountPaid: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.InvoiceAmountPaid) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Payment Method Id */
        PaymentMethodId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PaymentMethodId) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Payment Method */
        PaymentMethod: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PaymentMethod) !== null && _g !== void 0 ? _g : null),
        /** Payemnt Statuses */
        Status: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Status) !== null && _h !== void 0 ? _h : null, [Validators.required])
    });
}
/**
/* Generates a form from a InvoiceWithInventoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original InvoiceWithInventoryDto from which to create the form.
/* @returns FormGroup
 */
function GetInvoiceWithInventoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The originating Organization Id */
        FromOrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FromOrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The user to email when a quote is submitted */
        FromOrganizationUserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FromOrganizationUserId) !== null && _c !== void 0 ? _c : null),
        /** The name of the originating organization */
        FromOrganization: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.FromOrganization) !== null && _d !== void 0 ? _d : null),
        /** Who is being invoiced/billed/POed */
        ToContactId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ToContactId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Contact Types */
        ToContactType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ToContactType) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Invoice Types */
        Type: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** A link to a purchase order if this invoice was created from one. */
        PurchaseOrderId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PurchaseOrderId) !== null && _h !== void 0 ? _h : null),
        /** the date of the invoice */
        Date: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** the subtotal of all line items */
        SubTotal: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.SubTotal) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** The sales tax that is applied */
        SalesTax1Id: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.SalesTax1Id) !== null && _l !== void 0 ? _l : null),
        /** The name of the sales tax applied */
        SalesTax1: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.SalesTax1) !== null && _m !== void 0 ? _m : null),
        /** The amount of the first sales tax */
        SalesTax1Amount: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.SalesTax1Amount) !== null && _o !== void 0 ? _o : null),
        /** The second sales tax applied */
        SalesTax2Id: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.SalesTax2Id) !== null && _p !== void 0 ? _p : null),
        /** The name of the second sales tax */
        SalesTax2: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.SalesTax2) !== null && _q !== void 0 ? _q : null),
        /** The amount of the second sales tax */
        SalesTax2Amount: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.SalesTax2Amount) !== null && _r !== void 0 ? _r : null),
        /** The name of the shipping method */
        ShippingMethodId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.ShippingMethodId) !== null && _s !== void 0 ? _s : null),
        /** The name of the shipping method */
        ShippingMethod: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.ShippingMethod) !== null && _t !== void 0 ? _t : null),
        /** The amount of the shipping */
        Shipping: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Shipping) !== null && _u !== void 0 ? _u : null),
        /** The grand total of the invoice all inclusive */
        GrandTotal: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.GrandTotal) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** The current balance of the invoice */
        Balance: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Balance) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** The id of the Billing Address for the invoice */
        BillingAddressId: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _x !== void 0 ? _x : null),
        /** The shipping Address for the invoice if applicable */
        ShippingAddressId: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.ShippingAddressId) !== null && _y !== void 0 ? _y : null),
        /** Invoice # */
        InvoiceNumber: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.InvoiceNumber) !== null && _z !== void 0 ? _z : null, [Validators.required]),
        /** The Number of the bill */
        BillNumber: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.BillNumber) !== null && _0 !== void 0 ? _0 : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Purchase Order # */
        PurchaseOrderNumber: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.PurchaseOrderNumber) !== null && _1 !== void 0 ? _1 : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Invoice Statuses */
        Status: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.Status) !== null && _2 !== void 0 ? _2 : null, [Validators.required]),
        /** Notes field */
        Notes: new FormControl((_3 = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _3 !== void 0 ? _3 : null),
        /** Inventory Items */
        Items: fb.array((_5 = (_4 = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _4 === void 0 ? void 0 : _4.map(x => GetInvoiceInventoryDtoForm(fb, x))) !== null && _5 !== void 0 ? _5 : [])
    });
}
/**
/* Generates a form from a ItemCompletionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ItemCompletionDto from which to create the form.
/* @returns FormGroup
 */
function GetItemCompletionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Lesson */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Item Name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Score */
        Score: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** OutOf */
        OutOf: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OutOf) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Percent */
        Percent: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Percent) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a JobAssignedOrganizationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobAssignedOrganizationsDto from which to create the form.
/* @returns FormGroup
 */
function GetJobAssignedOrganizationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a JobAverageScoreJobDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobAverageScoreJobDto from which to create the form.
/* @returns FormGroup
 */
function GetJobAverageScoreJobDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Job Lesson */
        Job: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Job) !== null && _b !== void 0 ? _b : null),
        /** Organization Average Score */
        OrganizationScore: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationScore) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Industry Average Score */
        IndustryScore: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.IndustryScore) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Users own Score */
        OwnScore: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwnScore) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a JobAverageScoresDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobAverageScoresDto from which to create the form.
/* @returns FormGroup
 */
function GetJobAverageScoresDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Include Organizational Score */
        IncludeOrganizationScore: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.IncludeOrganizationScore) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Include Industry Score */
        IncludeIndustryScore: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.IncludeIndustryScore) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Jobs */
        Jobs: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Jobs) === null || _c === void 0 ? void 0 : _c.map(x => GetJobAverageScoreJobDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a JobDisciplineDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobDisciplineDto from which to create the form.
/* @returns FormGroup
 */
function GetJobDisciplineDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Discipline Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Discipline Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a JobDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobDto from which to create the form.
/* @returns FormGroup
 */
function GetJobDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Owning Organization */
        OwningOrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Organization */
        OwningOrganization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _e !== void 0 ? _e : null),
        /** Created On */
        CreatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Display Image Id */
        DisplayImageId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _h !== void 0 ? _h : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _j !== void 0 ? _j : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _k !== void 0 ? _k : null)
    });
}
/**
/* Generates a form from a JobGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetJobGroupDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Job id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Group */
        GroupId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Group Lesson */
        GroupName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.GroupName) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a JobHeaderLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobHeaderLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetJobHeaderLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Job id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Header Lesson Id */
        LessonId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Header Lesson Lesson */
        Lesson: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a JobIndustryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobIndustryDto from which to create the form.
/* @returns FormGroup
 */
function GetJobIndustryDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Industry Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Industry Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a JobLearningPathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobLearningPathDto from which to create the form.
/* @returns FormGroup
 */
function GetJobLearningPathDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** Is the Path Expanded? */
        Expanded: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Length of all incomplete lessons */
        Length: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Discipline Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Discipline Id */
        Id: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Total Number of Disciplines */
        TotalDisciplines: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalDisciplines) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Number of Completed Medallions */
        TotalCompletedDisciplines: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalCompletedDisciplines) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Total # of Badges */
        TotalBadges: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.TotalBadges) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** When the Job was started. */
        StartedOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** When will the trend line hit 0? */
        TrendZeroOn: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.TrendZeroOn) !== null && _k !== void 0 ? _k : null),
        /** Discipline Earned Date, if applicable */
        EarnedOn: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _l !== void 0 ? _l : null),
        /** History of completion */
        History: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.History) === null || _m === void 0 ? void 0 : _m.map(x => GetLearningPathHistoryDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** Organization */
        Organization: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _p !== void 0 ? _p : null),
        /** Organization Id */
        OrganizationId: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _q !== void 0 ? _q : null),
        /** Disciplines */
        Disciplines: fb.array((_s = (_r = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _r === void 0 ? void 0 : _r.map(x => GetDisciplineLearningPathDtoForm(fb, x))) !== null && _s !== void 0 ? _s : [])
    });
}
/**
/* Generates a form from a JobProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobProductDto from which to create the form.
/* @returns FormGroup
 */
function GetJobProductDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Id */
        ProductId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Product */
        Product: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _c !== void 0 ? _c : null),
        /** Version Id */
        VersionId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Version */
        Version: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a JobSyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobSyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetJobSyndicationProviderDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Job id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Syndication Methods */
        Method: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Syndication Provider Id */
        SyndicationProviderId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Syndication Provider Lesson */
        SyndicationProvider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a JobTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetJobTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Job Lesson */
        Job: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Job) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(250), Validators.required])
    });
}
/**
/* Generates a form from a JobWithDisciplineIdsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobWithDisciplineIdsDto from which to create the form.
/* @returns FormGroup
 */
function GetJobWithDisciplineIdsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The length of video for the content item */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Discipline Ids in the Job */
        DisciplineIds: fb.array([])
    });
}
/**
/* Generates a form from a JobWithProductsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original JobWithProductsDto from which to create the form.
/* @returns FormGroup
 */
function GetJobWithProductsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Owning Organization */
        OwningOrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Organization */
        OwningOrganization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _e !== void 0 ? _e : null),
        /** Created On */
        CreatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Display Image Id */
        DisplayImageId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _h !== void 0 ? _h : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _j !== void 0 ? _j : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _k !== void 0 ? _k : null),
        /** Products */
        Products: fb.array((_m = (_l = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _l === void 0 ? void 0 : _l.map(x => GetJobProductDtoForm(fb, x))) !== null && _m !== void 0 ? _m : [])
    });
}
/**
/* Generates a form from a LanguageImportDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LanguageImportDto from which to create the form.
/* @returns FormGroup
 */
function GetLanguageImportDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Is a test run */
        Test: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Test) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Imported/Updated items */
        Items: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _b === void 0 ? void 0 : _b.map(x => GetLanguageImportItemDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a LanguageImportItemDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LanguageImportItemDto from which to create the form.
/* @returns FormGroup
 */
function GetLanguageImportItemDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Page Lesson */
        Page: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Page) !== null && _a !== void 0 ? _a : null),
        /** Lookup Key */
        Key: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Key) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null),
        /** Before Import */
        BeforeValue: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.BeforeValue) !== null && _d !== void 0 ? _d : null),
        /** After Import */
        AfterValue: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.AfterValue) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a LearningPathHistoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LearningPathHistoryDto from which to create the form.
/* @returns FormGroup
 */
function GetLearningPathHistoryDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Date with remaining */
        Date: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remaining Badges */
        Remaining: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Remaining) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a LessonActivityDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonActivityDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonActivityDetailDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Length */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(450)])
    });
}
/**
/* Generates a form from a LessonAdminDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonAdminDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonAdminDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** The body of the item */
        Content: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Content) !== null && _h !== void 0 ? _h : null),
        /** Rating */
        Rating: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Rating) !== null && _j !== void 0 ? _j : null),
        /** Length */
        Length: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _l !== void 0 ? _l : null),
        /** The Organization that owns the lesson */
        OwningOrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _m !== void 0 ? _m : null),
        /** Marketing Description */
        Marketing: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _o !== void 0 ? _o : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _p !== void 0 ? _p : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _q !== void 0 ? _q : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Is Lesson Obsolete */
        Obsolete: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Obsolete) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** Cover Art Thumbnail */
        CoverArtUri: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.CoverArtUri) !== null && _s !== void 0 ? _s : null),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _t !== void 0 ? _t : null),
        /** Has Viewed Lesson In Production */
        ViewedInProduction: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.ViewedInProduction) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _v !== void 0 ? _v : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _w !== void 0 ? _w : null),
        /** Started On */
        StartedOn: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _x !== void 0 ? _x : null),
        /** Due Date */
        DueDate: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _y !== void 0 ? _y : null),
        /** Estimated Completion Date */
        EstCompletionDate: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.EstCompletionDate) !== null && _z !== void 0 ? _z : null),
        /** Importance */
        Importance: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _0 !== void 0 ? _0 : null),
        /** Flagged */
        Flagged: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _1 !== void 0 ? _1 : null, [Validators.required])
    });
}
/**
/* Generates a form from a LessonBadgeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonBadgeDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonBadgeDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** Badge Id */
        BadgeId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Badge Lesson */
        Badge: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Badge) !== null && _d !== void 0 ? _d : null),
        /** User Assigned To Id */
        AssignedToId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _e !== void 0 ? _e : null),
        /** user Lesson Assigned To */
        AssignedTo: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a LessonCommandDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonCommandDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonCommandDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Command */
        Command: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a LessonDependencyDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonDependencyDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonDependencyDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Depends On Lesson Id */
        DependsOnLessonId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.DependsOnLessonId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Depends On Lesson Lesson */
        DependsOnLesson: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.DependsOnLesson) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a LessonDetailsWithUserInfoDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonDetailsWithUserInfoDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonDetailsWithUserInfoDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** The body of the item */
        Content: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Content) !== null && _h !== void 0 ? _h : null),
        /** Rating */
        Rating: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Rating) !== null && _j !== void 0 ? _j : null),
        /** Length */
        Length: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _l !== void 0 ? _l : null),
        /** The Organization that owns the lesson */
        OwningOrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _m !== void 0 ? _m : null),
        /** Marketing Description */
        Marketing: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _o !== void 0 ? _o : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _p !== void 0 ? _p : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _q !== void 0 ? _q : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Is Lesson Obsolete */
        Obsolete: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Obsolete) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** Cover Art Thumbnail */
        CoverArtUri: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.CoverArtUri) !== null && _s !== void 0 ? _s : null),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _t !== void 0 ? _t : null),
        /** Has Viewed Lesson In Production */
        ViewedInProduction: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.ViewedInProduction) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _v !== void 0 ? _v : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _w !== void 0 ? _w : null),
        /** Percent Complete */
        PercentComplete: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _x !== void 0 ? _x : null, [Validators.required]),
        /** User's rating */
        UserRating: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.UserRating) !== null && _y !== void 0 ? _y : null)
    });
}
/**
/* Generates a form from a LessonDisciplineDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonDisciplineDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonDisciplineDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** Discipline Id */
        DisciplineId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Discipline Lesson */
        Discipline: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Discipline) !== null && _d !== void 0 ? _d : null),
        /** User Assigned To Id */
        AssignedToId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _e !== void 0 ? _e : null),
        /** user Lesson Assigned To */
        AssignedTo: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a LessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** The body of the item */
        Content: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Content) !== null && _h !== void 0 ? _h : null),
        /** Rating */
        Rating: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Rating) !== null && _j !== void 0 ? _j : null),
        /** Length */
        Length: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _l !== void 0 ? _l : null),
        /** The Organization that owns the lesson */
        OwningOrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _m !== void 0 ? _m : null),
        /** Marketing Description */
        Marketing: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _o !== void 0 ? _o : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _p !== void 0 ? _p : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _q !== void 0 ? _q : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Is Lesson Obsolete */
        Obsolete: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Obsolete) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** Cover Art Thumbnail */
        CoverArtUri: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.CoverArtUri) !== null && _s !== void 0 ? _s : null),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _t !== void 0 ? _t : null),
        /** Has Viewed Lesson In Production */
        ViewedInProduction: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.ViewedInProduction) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _v !== void 0 ? _v : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _w !== void 0 ? _w : null)
    });
}
/**
/* Generates a form from a LessonJobDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonJobDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonJobDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** Job Id */
        JobId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Job Lesson */
        Job: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Job) !== null && _d !== void 0 ? _d : null),
        /** User Assigned To Id */
        AssignedToId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _e !== void 0 ? _e : null),
        /** user Lesson Assigned To */
        AssignedTo: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a LessonLabelDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonLabelDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonLabelDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Label */
        Label: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Label) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required])
    });
}
/**
/* Generates a form from a LessonMedallionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonMedallionDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonMedallionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** Medallion Id */
        MedallionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Medallion Lesson */
        Medallion: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Medallion) !== null && _d !== void 0 ? _d : null),
        /** User Assigned To Id */
        AssignedToId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _e !== void 0 ? _e : null),
        /** user Lesson Assigned To */
        AssignedTo: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a LessonPathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonPathDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonPathDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Lesson Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Lesson Length */
        Length: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Order */
        Order: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Has the lesson been earned? */
        Earned: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Earned) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a LessonPublicationStatusDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonPublicationStatusDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonPublicationStatusDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Has Commands */
        HasCommands: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.HasCommands) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Has Dependencies */
        HasDependencies: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.HasDependencies) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Has Lesson */
        HasName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.HasName) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Has Description */
        HasDescription: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.HasDescription) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Has Questions */
        HasQuestions: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.HasQuestions) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Has Video */
        HasVideo: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.HasVideo) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Has Resources */
        HasResources: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.HasResources) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Has Badges */
        HasBadges: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.HasBadges) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Has Open Jira Subtasks */
        HasOpenJiraSubtasks: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.HasOpenJiraSubtasks) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Has Viewed Lesson In Production */
        HasViwedInProduction: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.HasViwedInProduction) !== null && _k !== void 0 ? _k : null, [Validators.required])
    });
}
/**
/* Generates a form from a LessonSyndicationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonSyndicationDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonSyndicationDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Lesson id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndication Types */
        Type: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a LessonSyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonSyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonSyndicationProviderDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Lesson id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Syndication Methods */
        Method: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Syndication Provider Id */
        SyndicationProviderId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Syndication Provider Lesson */
        SyndicationProvider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a LessonTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null),
        /** Lesson */
        Name: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null),
        /** Question */
        Content: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Content) !== null && _h !== void 0 ? _h : null),
        /** Marketing */
        Marketing: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _j !== void 0 ? _j : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _l !== void 0 ? _l : null, [Validators.minLength(0), Validators.maxLength(255)])
    });
}
/**
/* Generates a form from a LessonVideoDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonVideoDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonVideoDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The Lesson Viewed */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The originating Course */
        CourseId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _b !== void 0 ? _b : null),
        /** The Topic */
        TopicId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _c !== void 0 ? _c : null),
        /** Product Id */
        ProductId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _d !== void 0 ? _d : null),
        /** Version Id */
        VersionId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _e !== void 0 ? _e : null),
        /** Project Id */
        ProjectId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ProjectId) !== null && _f !== void 0 ? _f : null),
        /** Playlist Id */
        PlaylistId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PlaylistId) !== null && _g !== void 0 ? _g : null),
        /** The client viewing the lesson */
        ClientId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _h !== void 0 ? _h : null),
        /** Resource Id */
        ResourceId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ResourceId) !== null && _j !== void 0 ? _j : null)
    });
}
/**
/* Generates a form from a LessonWithCourseInfoDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonWithCourseInfoDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonWithCourseInfoDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** The body of the item */
        Content: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Content) !== null && _h !== void 0 ? _h : null),
        /** Rating */
        Rating: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Rating) !== null && _j !== void 0 ? _j : null),
        /** Length */
        Length: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _l !== void 0 ? _l : null),
        /** The Organization that owns the lesson */
        OwningOrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _m !== void 0 ? _m : null),
        /** Marketing Description */
        Marketing: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _o !== void 0 ? _o : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _p !== void 0 ? _p : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _q !== void 0 ? _q : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Is Lesson Obsolete */
        Obsolete: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Obsolete) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** Cover Art Thumbnail */
        CoverArtUri: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.CoverArtUri) !== null && _s !== void 0 ? _s : null),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _t !== void 0 ? _t : null),
        /** Has Viewed Lesson In Production */
        ViewedInProduction: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.ViewedInProduction) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _v !== void 0 ? _v : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _w !== void 0 ? _w : null),
        /** The courses associated with the current lesson */
        Courses: fb.array([])
    });
}
/**
/* Generates a form from a LessonWithQuestionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonWithQuestionsDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonWithQuestionsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** Questions */
        Questions: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Questions) === null || _c === void 0 ? void 0 : _c.map(x => GetQuestionDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a LessonWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LessonWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetLessonWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Lesson Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null),
        /** User Lesson */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null),
        /** Role Id */
        RoleId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Role Lesson */
        Role: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _f !== void 0 ? _f : null),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a ListBotConversationsRequest
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ListBotConversationsRequest from which to create the form.
/* @returns FormGroup
 */
function GetListBotConversationsRequestForm(fb, dto) {
    return fb.group({
        /**  */
        Criteria: GetLoadCriteriaForm(fb, dto === null || dto === void 0 ? void 0 : dto.Criteria),
    });
}
/**
/* Generates a form from a LoadCriteria
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original LoadCriteria from which to create the form.
/* @returns FormGroup
 */
function GetLoadCriteriaForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /**  */
        Skip: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Skip) !== null && _a !== void 0 ? _a : null),
        /**  */
        Take: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Take) !== null && _b !== void 0 ? _b : null),
        /**  */
        FilterBy: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.FilterBy) === null || _c === void 0 ? void 0 : _c.map(x => GetFilterCriteriaForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /**  */
        OrderBy: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.OrderBy) === null || _e === void 0 ? void 0 : _e.map(x => GetOrderCriteriaForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /**  */
        GroupBy: GetGroupCriteriaForm(fb, dto === null || dto === void 0 ? void 0 : dto.GroupBy),
        /**  */
        Aggregates: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.Aggregates) === null || _g === void 0 ? void 0 : _g.map(x => GetAggregateCriteriaForm(fb, x))) !== null && _h !== void 0 ? _h : [])
    });
}
/**
/* Generates a form from a MakePaymentAccountDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MakePaymentAccountDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetMakePaymentAccountDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Lesson on Account */
        NameOnAccount: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.NameOnAccount) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Routing # */
        RoutingNumber: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RoutingNumber) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(15), Validators.required]),
        /** Account # */
        AccountNumber: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.AccountNumber) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(25), Validators.required]),
        /** External Account Types */
        Type: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Phone Number */
        PhoneNumber: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a MakePaymentCardDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MakePaymentCardDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetMakePaymentCardDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Lesson on Card */
        NameOnCard: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.NameOnCard) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Expiry Month */
        ExpiryMonth: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ExpiryMonth) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Expiry Year */
        ExpiryYear: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ExpiryYear) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** CVV2 from back of the card */
        CVV2: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CVV2) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(4), Validators.required]),
        /** Card # */
        CardNumber: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CardNumber) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(25), Validators.required])
    });
}
/**
/* Generates a form from a MakePaymentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MakePaymentDto from which to create the form.
/* @returns FormGroup
 */
function GetMakePaymentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The payment Method used */
        PaymentMethodId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PaymentMethodId) !== null && _a !== void 0 ? _a : null),
        /** The stored credentials to use */
        StoredPaymentCredentialId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.StoredPaymentCredentialId) !== null && _b !== void 0 ? _b : null),
        /** The payment amount */
        Amount: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Amount) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The credit card details for a payment by credit card */
        CardDetails: GetMakePaymentCardDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.CardDetails),
        /** Account details for a payment made by bank draft */
        AccountDetails: GetMakePaymentAccountDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.AccountDetails),
        /** Details about the Invoice allocations for the payment */
        InvoiceDetails: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.InvoiceDetails) === null || _d === void 0 ? void 0 : _d.map(x => GetMakePaymentInvoiceDetailDtoForm(fb, x))) !== null && _e !== void 0 ? _e : []),
        /** The billing address of the contact */
        BillingAddressId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** The shipping address of the contact */
        ShippingAddressId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ShippingAddressId) !== null && _g !== void 0 ? _g : null),
        /** If using new payment credentials, specify if they should be stored for later use. */
        StorePaymentCredentials: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.StorePaymentCredentials) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Date of the Payment */
        Date: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a MakePaymentInvoiceDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MakePaymentInvoiceDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetMakePaymentInvoiceDetailDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The invoice Id */
        InvoiceId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Amount allocated to the invoice */
        Amount: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Amount) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a MedallionBadgeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionBadgeDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionBadgeDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Badge Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Badge Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Order */
        Order: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a MedallionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Active */
        Active: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Owning Organization */
        OwningOrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Organization */
        OwningOrganization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _e !== void 0 ? _e : null),
        /** Created On */
        CreatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Display Image Id */
        DisplayImageId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _h !== void 0 ? _h : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Contractor Assigned To */
        AssignedToId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.AssignedToId) !== null && _j !== void 0 ? _j : null),
        /** Contractor Assigned To Lesson */
        AssignedTo: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.AssignedTo) !== null && _k !== void 0 ? _k : null)
    });
}
/**
/* Generates a form from a MedallionGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionGroupDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Medallion id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Group */
        GroupId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Group Lesson */
        GroupName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.GroupName) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a MedallionHeaderLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionHeaderLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionHeaderLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Medallion id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Header Lesson Id */
        LessonId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Header Lesson Lesson */
        Lesson: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a MedallionLearningPathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionLearningPathDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionLearningPathDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** Is the Path Expanded? */
        Expanded: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Length of all incomplete lessons */
        Length: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Medallion Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Medallion Id */
        Id: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Total Number of Disciplines */
        TotalBadges: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalBadges) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Number of Completed Disciplines */
        TotalCompletedBadges: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalCompletedBadges) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Medallion Earned Date, if applicable */
        EarnedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _h !== void 0 ? _h : null),
        /** Order */
        Order: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Badges that make up the medallion */
        Badges: fb.array((_l = (_k = dto === null || dto === void 0 ? void 0 : dto.Badges) === null || _k === void 0 ? void 0 : _k.map(x => GetBadgeLearningPathDtoForm(fb, x))) !== null && _l !== void 0 ? _l : []),
        /** Remaining Disciplines to complete */
        ContributesToDisciplines: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.ContributesToDisciplines) === null || _m === void 0 ? void 0 : _m.map(x => GetDisciplinePathDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** Medallion Header Lessons */
        HeaderLessons: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _p === void 0 ? void 0 : _p.map(x => GetLessonDtoForm(fb, x))) !== null && _q !== void 0 ? _q : [])
    });
}
/**
/* Generates a form from a MedallionPathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionPathDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionPathDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Is the Path Expanded? */
        Expanded: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Length of all incomplete lessons */
        Length: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Medallion Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Medallion Id */
        Id: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Total Number of Disciplines */
        TotalBadges: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalBadges) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Number of Completed Disciplines */
        TotalCompletedBadges: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalCompletedBadges) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Medallion Earned Date, if applicable */
        EarnedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _h !== void 0 ? _h : null),
        /** Order */
        Order: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a MedallionSyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionSyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionSyndicationProviderDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Medallion id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Syndication Methods */
        Method: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Syndication Provider Id */
        SyndicationProviderId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Syndication Provider Lesson */
        SyndicationProvider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a MedallionTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Medallion Id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Medallion Lesson */
        Medallion: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Medallion) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(250), Validators.required])
    });
}
/**
/* Generates a form from a MedallionUserEarnedDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MedallionUserEarnedDto from which to create the form.
/* @returns FormGroup
 */
function GetMedallionUserEarnedDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Medallion Id */
        MedallionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Medallion Lesson */
        Medallion: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Medallion) !== null && _c !== void 0 ? _c : null),
        /** User Id */
        UserId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _e !== void 0 ? _e : null),
        /** Earned On */
        EarnedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Display Image Id */
        DisplayImageId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _g !== void 0 ? _g : null),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
    });
}
/**
/* Generates a form from a MergeFieldDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original MergeFieldDto from which to create the form.
/* @returns FormGroup
 */
function GetMergeFieldDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The key of the email template */
        EmailTemplateId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.EmailTemplateId) !== null && _a !== void 0 ? _a : null),
        /** The field to be merged */
        Field: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Field) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a NextQuestionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original NextQuestionDto from which to create the form.
/* @returns FormGroup
 */
function GetNextQuestionDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The question id */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** A question for a user assessment */
        Question: GetUserAssessmentQuestionDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Question),
        /** Was the previous answer correct? */
        Correct: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Correct) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a NotificationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original NotificationDto from which to create the form.
/* @returns FormGroup
 */
function GetNotificationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Title */
        Title: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _a !== void 0 ? _a : null),
        /** Message */
        Message: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Message) !== null && _b !== void 0 ? _b : null),
        /** Url to act on the message */
        Url: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Url) !== null && _c !== void 0 ? _c : null),
        /** Notification Message Types */
        MessageType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.MessageType) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Custom message image url */
        ImageUrl: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ImageUrl) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a OrderCriteria
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrderCriteria from which to create the form.
/* @returns FormGroup
 */
function GetOrderCriteriaForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /**  */
        FieldName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FieldName) !== null && _a !== void 0 ? _a : null),
        /**  */
        Direction: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Direction) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrgUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrgUserDto from which to create the form.
/* @returns FormGroup
 */
function GetOrgUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The user's first name */
        FirstName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _b !== void 0 ? _b : null),
        /** The user's last name */
        LastName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _c !== void 0 ? _c : null),
        /** The full name of the user */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null),
        /** The user's email address */
        Email: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _e !== void 0 ? _e : null, [Validators.email]),
        /** The user's phone number */
        PhoneNumber: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _f !== void 0 ? _f : null),
        /** The user's phone number extension */
        PhoneNumberExt: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PhoneNumberExt) !== null && _g !== void 0 ? _g : null),
        /** Is the user active? */
        Active: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Division */
        Division: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _j !== void 0 ? _j : null),
        /** Location */
        Location: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _k !== void 0 ? _k : null),
        /** Group */
        GroupId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _l !== void 0 ? _l : null),
        /** Group Lesson */
        GroupName: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.GroupName) !== null && _m !== void 0 ? _m : null),
        /** Level */
        Level: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Level) !== null && _o !== void 0 ? _o : null),
        /** Goal */
        Goal: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Goal) !== null && _p !== void 0 ? _p : null),
        /** Title */
        Title: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _q !== void 0 ? _q : null),
        /** Invoice Number */
        InvoiceNumber: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.InvoiceNumber) !== null && _r !== void 0 ? _r : null),
        /** Description */
        Description: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _s !== void 0 ? _s : null),
        /** Restrict Reporting to Groups */
        RestrictReportingToGroups: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.RestrictReportingToGroups) !== null && _t !== void 0 ? _t : null, [Validators.required]),
        /** Restrict User Admin User List to Groups */
        RestrictUserAdminUserListToGroups: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.RestrictUserAdminUserListToGroups) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Restrict Question Admin to Groups */
        RestrictContentAdminToGroups: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.RestrictContentAdminToGroups) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** Restrict Learning Path to Groups */
        RestrictLearningPathToGroups: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.RestrictLearningPathToGroups) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** User's organizational roles */
        Roles: fb.array([])
    });
}
/**
/* Generates a form from a OrgUserWithOrganizationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrgUserWithOrganizationDto from which to create the form.
/* @returns FormGroup
 */
function GetOrgUserWithOrganizationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The user's first name */
        FirstName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _b !== void 0 ? _b : null),
        /** The user's last name */
        LastName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _c !== void 0 ? _c : null),
        /** The full name of the user */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null),
        /** The user's email address */
        Email: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _e !== void 0 ? _e : null, [Validators.email]),
        /** The user's phone number */
        PhoneNumber: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _f !== void 0 ? _f : null),
        /** The user's phone number extension */
        PhoneNumberExt: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PhoneNumberExt) !== null && _g !== void 0 ? _g : null),
        /** Is the user active? */
        Active: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Division */
        Division: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _j !== void 0 ? _j : null),
        /** Location */
        Location: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _k !== void 0 ? _k : null),
        /** Group */
        GroupId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _l !== void 0 ? _l : null),
        /** Group Lesson */
        GroupName: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.GroupName) !== null && _m !== void 0 ? _m : null),
        /** Level */
        Level: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Level) !== null && _o !== void 0 ? _o : null),
        /** Goal */
        Goal: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Goal) !== null && _p !== void 0 ? _p : null),
        /** Title */
        Title: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _q !== void 0 ? _q : null),
        /** Invoice Number */
        InvoiceNumber: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.InvoiceNumber) !== null && _r !== void 0 ? _r : null),
        /** Description */
        Description: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _s !== void 0 ? _s : null),
        /** Restrict Reporting to Groups */
        RestrictReportingToGroups: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.RestrictReportingToGroups) !== null && _t !== void 0 ? _t : null, [Validators.required]),
        /** Restrict User Admin User List to Groups */
        RestrictUserAdminUserListToGroups: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.RestrictUserAdminUserListToGroups) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Restrict Question Admin to Groups */
        RestrictContentAdminToGroups: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.RestrictContentAdminToGroups) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** Restrict Learning Path to Groups */
        RestrictLearningPathToGroups: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.RestrictLearningPathToGroups) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** User's organizational roles */
        Roles: fb.array([]),
        /** Organization */
        Organization: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _x !== void 0 ? _x : null, [Validators.minLength(1), Validators.required]),
        /** Organization Id to set */
        OrganizationId: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _y !== void 0 ? _y : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationActivityDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationActivityDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationActivityDetailDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Organization Types */
        OrganizationType: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationType) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Division */
        Division: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _d !== void 0 ? _d : null),
        /** Group */
        Group: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _e !== void 0 ? _e : null),
        /** The groups the user is part of */
        Groups: fb.array([]),
        /** Level */
        Level: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Level) !== null && _f !== void 0 ? _f : null),
        /** Country */
        Country: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _g !== void 0 ? _g : null),
        /** Location */
        Location: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _h !== void 0 ? _h : null),
        /** Title */
        Title: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _j !== void 0 ? _j : null)
    });
}
/**
/* Generates a form from a OrganizationAddSubscriptionRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationAddSubscriptionRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationAddSubscriptionRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1;
    return fb.group({
        /** The organization which to add the subscription. If this is null then the other fields for the user must be filled in. */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null),
        /** The User which to add the subscription. If this is null then the other fields for the user must be filled in. */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null),
        /** Email Address */
        Email: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _c !== void 0 ? _c : null, [Validators.email]),
        /** Password */
        Password: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _d !== void 0 ? _d : null, [IsValidPassword]),
        /** Confirmation Password */
        ConfirmPassword: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _e !== void 0 ? _e : null),
        /** First Lesson */
        FirstName: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _f !== void 0 ? _f : null),
        /** Phone Number */
        PhoneNumber: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _g !== void 0 ? _g : null),
        /** Last Lesson */
        LastName: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _h !== void 0 ? _h : null),
        /** Provider */
        Provider: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _j !== void 0 ? _j : null),
        /** Unique Provider Key that links the provider to the user. */
        ProviderKey: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.ProviderKey) !== null && _k !== void 0 ? _k : null),
        /** External Access Token */
        ExternalAccessToken: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.ExternalAccessToken) !== null && _l !== void 0 ? _l : null),
        /** Billing Street Address */
        BillingStreetAddress: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.BillingStreetAddress) !== null && _m !== void 0 ? _m : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Billing Street Address 2 */
        BillingStreetAddress2: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.BillingStreetAddress2) !== null && _o !== void 0 ? _o : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Billing TownCity */
        BillingTownCity: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.BillingTownCity) !== null && _p !== void 0 ? _p : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Billing Postal Code */
        BillingPostalCode: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.BillingPostalCode) !== null && _q !== void 0 ? _q : null, [Validators.minLength(0), Validators.maxLength(15)]),
        /** Billing State */
        BillingState: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.BillingState) !== null && _r !== void 0 ? _r : null, [Validators.minLength(0), Validators.maxLength(3)]),
        /** Billing Country */
        BillingCountry: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.BillingCountry) !== null && _s !== void 0 ? _s : null, [Validators.minLength(0), Validators.maxLength(2)]),
        /** Marketing Campaign Sources (How did you hear about us?) */
        HowDidYouHearAboutUs: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUs) !== null && _t !== void 0 ? _t : null, [Validators.required]),
        /** Additional information about how the user heard about us */
        HowDidYouHearAboutUsOther: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUsOther) !== null && _u !== void 0 ? _u : null),
        /** The credit card details for a payment by credit card */
        CardDetails: GetMakePaymentCardDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.CardDetails),
        /** Account details for a payment made by bank draft */
        AccountDetails: GetMakePaymentAccountDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.AccountDetails),
        /**  */
        PaymentMethodId: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.PaymentMethodId) !== null && _v !== void 0 ? _v : null),
        /** The SKU to use for the trial */
        SKU: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _w !== void 0 ? _w : null, [Validators.minLength(1), Validators.required]),
        /** Reseller Id. Used for setting associated organization */
        ResellerId: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.ResellerId) !== null && _x !== void 0 ? _x : null),
        /** Organization Lesson */
        OrganizationName: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.OrganizationName) !== null && _y !== void 0 ? _y : null, [Validators.minLength(1), Validators.required]),
        /** Organization Size */
        OrganizationSize: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.OrganizationSize) !== null && _z !== void 0 ? _z : null, [Validators.required]),
        /** Organization Domain */
        OrganizationDomain: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.OrganizationDomain) !== null && _0 !== void 0 ? _0 : null, [Validators.minLength(1), Validators.required]),
        /** Entitlement Quantity */
        EntitlementQuantity: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.EntitlementQuantity) !== null && _1 !== void 0 ? _1 : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationAddSubscriptionResponseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationAddSubscriptionResponseDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationAddSubscriptionResponseDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Error Message */
        ErrorMessage: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ErrorMessage) !== null && _a !== void 0 ? _a : null),
        /** User Subscription Creation Result Codes */
        Result: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Result) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The main Dto that describes a user */
        User: GetUserDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.User),
        /** Organization */
        Organization: GetOrganizationDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Organization),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Invoice Id */
        InvoiceId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a OrganizationAddressDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationAddressDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationAddressDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the address the default for the user */
        Default: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Default) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Is the address the billing address for the user */
        Billing: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Billing) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Is the address the shipping address for the user */
        Shipping: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Shipping) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Street 1 */
        Street1: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Street1) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Street 2 */
        Street2: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Street2) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** City */
        City: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.City) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** State */
        State: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.State) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(3)]),
        /** Postal/Zip Code */
        PostalCode: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PostalCode) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(15)]),
        /** Country */
        Country: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(2), Validators.required]),
        /** The organization Id */
        OrganizationId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** The name of the organization */
        Organization: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _m !== void 0 ? _m : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a OrganizationContentCapabilitiesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationContentCapabilitiesDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationContentCapabilitiesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Can the Organization create custom resources */
        CanCreateCustomResources: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CanCreateCustomResources) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Can the organization create custom Video Lessons */
        CanCreateVideoLessons: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CanCreateVideoLessons) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Can share the course */
        CanShare: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CanShare) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationContentOptionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationContentOptionsDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationContentOptionsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** CADLearning Question */
        CADLearningContent: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CADLearningContent) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Bluebeam Question */
        BluebeamContent: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.BluebeamContent) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the organization an active customer */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the organization created */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the organization updated */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags associated with the organization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** Option to show only organization assessments */
        ShowOnlyOrgAssessments: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ShowOnlyOrgAssessments) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Indicates whether or not the organization is a lead prospect for a partner */
        Lead: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Lead) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Sales Rep Id */
        SalesRepId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.SalesRepId) !== null && _k !== void 0 ? _k : null),
        /** Partner */
        PartnerOrganizationId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.PartnerOrganizationId) !== null && _l !== void 0 ? _l : null),
        /** Partner Organization */
        PartnerOrganization: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.PartnerOrganization) !== null && _m !== void 0 ? _m : null),
        /** Organization Partner Billing Type */
        BillingType: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.BillingType) !== null && _o !== void 0 ? _o : null),
        /** Organization Answer Sharing Options */
        AnswerSharingOption: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.AnswerSharingOption) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Organization Bot Escalation Rules */
        BotEscalationRule: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.BotEscalationRule) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** Chart Types */
        ScoreSettings: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.ScoreSettings) !== null && _r !== void 0 ? _r : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationEmailDomainDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationEmailDomainDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationEmailDomainDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Organization id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Domain in the format "cadlearning.com" */
        Domain: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Domain) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Domain Admin Email Address */
        DomainAdminEmailAddress: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.DomainAdminEmailAddress) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Specifies if entitlements will be assigned from a pool of available entitlements automatically when a user registers on the site. */
        AllowAutomaticEntitlementAssignment: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AllowAutomaticEntitlementAssignment) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** The Domain associated with the Email Domain. If not specified, the email address is entitled to register on any site associated with the organization */
        OrganizationDomainId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OrganizationDomainId) !== null && _e !== void 0 ? _e : null),
        /** The name of the domain associated with the email domain. */
        OrganizationDomain: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OrganizationDomain) !== null && _f !== void 0 ? _f : null),
        /** Verified */
        Verified: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Verified) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationEmailTemplateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationEmailTemplateDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationEmailTemplateDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The email template id */
        EmailTemplateId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.EmailTemplateId) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Friendly Lesson */
        FriendlyName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FriendlyName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** The html */
        Html: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Html) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** The subject */
        Subject: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Subject) !== null && _e !== void 0 ? _e : null),
        /** Base configuration template is internal or not */
        Internal: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Internal) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationFeaturesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationFeaturesDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationFeaturesDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Organization access to projects */
        Projects: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Projects) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization access to bot escalation */
        BotEscalation: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.BotEscalation) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization access to accomplishments */
        Accomplishments: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Accomplishments) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Partner Organization access to Accomplishments */
        PartnerAccomplishments: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PartnerAccomplishments) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Languages supported by the organization */
        Languages: fb.array([])
    });
}
/**
/* Generates a form from a OrganizationGroupCoursesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationGroupCoursesDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationGroupCoursesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The organization applying the group mapping */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Group Id */
        GroupId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** the Organization Group */
        Group: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _c !== void 0 ? _c : null),
        /** The course id mapped to the group */
        CourseId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _d !== void 0 ? _d : null),
        /** The course name assigned to the group */
        CourseName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CourseName) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a OrganizationGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationGroupDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The organization applying the group mapping */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Group Lesson */
        Group: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _c !== void 0 ? _c : null),
        /** Logo Url */
        LogoUrl: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LogoUrl) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a OrganizationLessonNoteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationLessonNoteDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationLessonNoteDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Organization Lesson */
        Organization: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _a !== void 0 ? _a : null),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _c !== void 0 ? _c : null),
        /** Lesson Id */
        LessonId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Note for Lesson */
        Note: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Note) !== null && _e !== void 0 ? _e : null),
        /** Creator of Note Id */
        CreatedById: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CreatedById) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Lesson of Creator */
        CreatedBy: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CreatedBy) !== null && _g !== void 0 ? _g : null),
        /** Created On date */
        CreatedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Updated on Date */
        UpdatedOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationMessageDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationMessageDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationMessageDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** the id of the organization */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The organization's name */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** The message */
        Message: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Message) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** When the message will start to display */
        StartOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.StartOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When the message will end display */
        EndOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EndOn) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a OrganizationPermissionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationPermissionsDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationPermissionsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** Organization Id with alotted permissions */
        FromOrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FromOrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** From Organization Lesson */
        FromOrganization: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FromOrganization) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Requestee Id */
        RequesteeId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.RequesteeId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Contact Types */
        RequesteeType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RequesteeType) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** From Organization can access Custom Question */
        CustomContent: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CustomContent) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** From Organization can access PlayLists */
        PlayLists: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PlayLists) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** From Organization can create Users */
        CreateUsers: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CreateUsers) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** From Organization can Update Users */
        UpdateUsers: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.UpdateUsers) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Organization can view users */
        ViewUsers: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ViewUsers) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** From Organization can Delete Users */
        DeleteUsers: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.DeleteUsers) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** From Organization can View Reports */
        ViewReports: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.ViewReports) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Request Date */
        RequestDate: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.RequestDate) !== null && _m !== void 0 ? _m : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationPriceListInventoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationPriceListInventoryDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationPriceListInventoryDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Inventory Lesson */
        Inventory: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Inventory) !== null && _a !== void 0 ? _a : null),
        /** SKU */
        SKU: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a OrganizationProjectRoleDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationProjectRoleDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationProjectRoleDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization Lesson */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Role Lesson */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a OrganizationReportGroupRule
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationReportGroupRule from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationReportGroupRuleForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Id of the Group */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** Should the report automatically be filtered by the criteria? */
        Filtered: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Filtered) !== null && _b !== void 0 ? _b : null),
        /** Can this group edit this report? */
        Editable: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Editable) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a OrganizationShortDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationShortDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationShortDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Organization Partner Billing Type */
        BillingType: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BillingType) !== null && _a !== void 0 ? _a : null)
    });
}
/**
/* Generates a form from a OrganizationStatsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationStatsDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationStatsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Badges In Progress */
        BadgesInProgress: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgesInProgress) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Completed Badges */
        CompletedBadges: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CompletedBadges) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Medallions in Progress */
        MedallionsInProgress: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.MedallionsInProgress) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Completed Medallions */
        CompletedMedallions: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CompletedMedallions) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Total Time spent watching Lessons */
        TotalLessonTime: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalLessonTime) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Average completion of roles assigned by the organization */
        AverageRoleCompletionPercentage: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.AverageRoleCompletionPercentage) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Active Users in the last month */
        ActiveUsersInLastMonth: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ActiveUsersInLastMonth) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Badge Completion Percentage */
        BadgeCompletionPercentage: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.BadgeCompletionPercentage) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Medallion Completion Percentage */
        MedallionCompletionPercentage: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.MedallionCompletionPercentage) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationUserDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** Active */
        Active: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null),
        /** Email Address */
        EmailAddress: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _e !== void 0 ? _e : null, [Validators.email]),
        /** Phone Number */
        PhoneNumber: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _f !== void 0 ? _f : null),
        /** Phone Ext. */
        PhoneExt: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PhoneExt) !== null && _g !== void 0 ? _g : null),
        /** Division */
        Division: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _h !== void 0 ? _h : null),
        /** Title */
        Title: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _j !== void 0 ? _j : null),
        /** Location */
        Location: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _k !== void 0 ? _k : null),
        /** Group */
        Group: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _l !== void 0 ? _l : null),
        /** Restrict Reporting to Groups */
        RestrictReportingToGroups: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.RestrictReportingToGroups) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Roles */
        RoleIds: fb.array([]),
        /** Relationship between an organization and a user */
        Relationship: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Relationship) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** System Support Agent */
        AvailableForSystemSupport: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.AvailableForSystemSupport) !== null && _p !== void 0 ? _p : null, [Validators.required])
    });
}
/**
/* Generates a form from a OrganizationUserFieldsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationUserFieldsDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationUserFieldsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Groups */
        Groups: fb.array((_b = (_a = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _a === void 0 ? void 0 : _a.map(x => GetOrganizationGroupDtoForm(fb, x))) !== null && _b !== void 0 ? _b : []),
        /** Divisions */
        Divisions: fb.array([]),
        /** Locations */
        Locations: fb.array([]),
        /** Goals */
        Goals: fb.array([]),
        /** Levels */
        Levels: fb.array([])
    });
}
/**
/* Generates a form from a OrganizationUserGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationUserGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationUserGroupDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Organization Lesson */
        Organization: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _d !== void 0 ? _d : null),
        /** Group */
        OrganizationGroupId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OrganizationGroupId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Group Lesson */
        OrganizationGroupName: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OrganizationGroupName) !== null && _f !== void 0 ? _f : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a OrganizationUserRoleDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationUserRoleDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationUserRoleDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** User */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Role Id */
        RoleId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Role */
        Role: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _f !== void 0 ? _f : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a OrganizationxApiCredentialsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original OrganizationxApiCredentialsDto from which to create the form.
/* @returns FormGroup
 */
function GetOrganizationxApiCredentialsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Organization id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Uri */
        Uri: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Uri) !== null && _b !== void 0 ? _b : null),
        /** User Lesson */
        UserName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _c !== void 0 ? _c : null),
        /** Password */
        Password: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _d !== void 0 ? _d : null, [IsValidPassword])
    });
}
/**
/* Generates a form from a PartnerOrganizationGroupDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PartnerOrganizationGroupDto from which to create the form.
/* @returns FormGroup
 */
function GetPartnerOrganizationGroupDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Organization Lesson */
        Organization: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Groups */
        Groups: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _c === void 0 ? void 0 : _c.map(x => GetOrganizationGroupDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a PartnerProspectDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PartnerProspectDto from which to create the form.
/* @returns FormGroup
 */
function GetPartnerProspectDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Partner Organization Id */
        PartnerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Prospect Organization Id */
        ProspectId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ProspectId) !== null && _b !== void 0 ? _b : null),
        /** Proespect organization name */
        ProspectName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ProspectName) !== null && _c !== void 0 ? _c : null),
        /** Estimated close date */
        EstClosedDate: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.EstClosedDate) !== null && _d !== void 0 ? _d : null),
        /** Key Stakeholder Contact (User in Prospect Organization) */
        KeyContact: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.KeyContact) !== null && _e !== void 0 ? _e : null),
        /** Sales Rep User Id (User in Partner Organization) */
        SalesRep: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SalesRep) !== null && _f !== void 0 ? _f : null),
        /** Existing Customer */
        ExistingCustomer: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ExistingCustomer) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Deal Size (Money at List Price) */
        DealSize: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DealSize) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Probability to close */
        CloseProbability: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.CloseProbability) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a PaymentMethodDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PaymentMethodDto from which to create the form.
/* @returns FormGroup
 */
function GetPaymentMethodDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Payment Methods */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** The provider */
        PaymentProviderId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PaymentProviderId) !== null && _f !== void 0 ? _f : null),
        /** The Provider's name */
        PaymentProvider: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PaymentProvider) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a PaymentProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PaymentProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetPaymentProviderDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required])
    });
}
/**
/* Generates a form from a PaymentProviderImplementationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PaymentProviderImplementationDto from which to create the form.
/* @returns FormGroup
 */
function GetPaymentProviderImplementationDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The payment provider id */
        PaymentProviderId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PaymentProviderId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the payment provider */
        PaymentProvider: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PaymentProvider) !== null && _b !== void 0 ? _b : null),
        /** Payment Methods */
        Method: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The Interface used to execute these types of payments */
        Interface: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Interface) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required])
    });
}
/**
/* Generates a form from a PingDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PingDto from which to create the form.
/* @returns FormGroup
 */
function GetPingDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Message Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** Message */
        Message: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Message) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a PlatformReportDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PlatformReportDto from which to create the form.
/* @returns FormGroup
 */
function GetPlatformReportDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Report Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** Is the report active? */
        IsActive: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.IsActive) !== null && _b !== void 0 ? _b : null),
        /** Organization Limits */
        Organizations: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Organizations) === null || _c === void 0 ? void 0 : _c.map(x => GetPlatformReportOrganizationDetailsForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /** User Limits */
        Users: fb.array([]),
        /** How reports should be persisted to the database for recovery with custom reports etc. */
        Report: GetReportDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Report),
    });
}
/**
/* Generates a form from a PlatformReportOrganizationDetails
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PlatformReportOrganizationDetails from which to create the form.
/* @returns FormGroup
 */
function GetPlatformReportOrganizationDetailsForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null),
        /** Divisions that can access the report */
        Divisions: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Divisions) === null || _b === void 0 ? void 0 : _b.map(x => GetOrganizationReportGroupRuleForm(fb, x))) !== null && _c !== void 0 ? _c : []),
        /** Groups that can access the report */
        Groups: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _d === void 0 ? void 0 : _d.map(x => GetOrganizationReportGroupRuleForm(fb, x))) !== null && _e !== void 0 ? _e : []),
        /** Users that can access the report */
        Users: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Users) === null || _f === void 0 ? void 0 : _f.map(x => GetOrganizationReportGroupRuleForm(fb, x))) !== null && _g !== void 0 ? _g : [])
    });
}
/**
/* Generates a form from a PlayListContentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PlayListContentDto from which to create the form.
/* @returns FormGroup
 */
function GetPlayListContentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Play List Id */
        PlayListId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question ItemId */
        ContentItemId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ContentItemId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Question Item Lesson */
        ContentItemName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ContentItemName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Question Item Types */
        ContentItemType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ContentItemType) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Length */
        Length: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Question Order in Play List */
        Order: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a PlayListHeaderLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PlayListHeaderLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetPlayListHeaderLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** PlayList id */
        PlayListId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Header Lesson Id */
        LessonId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Header Lesson Lesson */
        Lesson: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a PlayListSyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PlayListSyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetPlayListSyndicationProviderDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** PlayList id */
        PlayListId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Syndication Methods */
        Method: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Syndication Provider Id */
        SyndicationProviderId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Syndication Provider Lesson */
        SyndicationProvider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a PlayListUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PlayListUserDto from which to create the form.
/* @returns FormGroup
 */
function GetPlayListUserDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Play list Id */
        PlayListId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Id */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null),
        /** User */
        User: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a PlayListWithContentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PlayListWithContentDto from which to create the form.
/* @returns FormGroup
 */
function GetPlayListWithContentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the playlist */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The description if any */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The owner of the playlist */
        OwnerId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OwnerId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** The owner's name */
        Owner: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Owner) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required]),
        /** Owning Organization Id */
        OwningOrganizationId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _f !== void 0 ? _f : null),
        /** Owning Organization Lesson */
        OwningOrganization: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _g !== void 0 ? _g : null),
        /** Contents of the playlist */
        Contents: fb.array((_j = (_h = dto === null || dto === void 0 ? void 0 : dto.Contents) === null || _h === void 0 ? void 0 : _h.map(x => GetPlayListContentDtoForm(fb, x))) !== null && _j !== void 0 ? _j : [])
    });
}
/**
/* Generates a form from a PlaylistActivityDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PlaylistActivityDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetPlaylistActivityDetailDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a PluginNotifyCommandDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PluginNotifyCommandDto from which to create the form.
/* @returns FormGroup
 */
function GetPluginNotifyCommandDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Product Identifier */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Product Reported Version */
        VersionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Command */
        Command: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Plugin Command Notification Types */
        NotificationType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.NotificationType) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a PluginNotifyPageCommandDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PluginNotifyPageCommandDto from which to create the form.
/* @returns FormGroup
 */
function GetPluginNotifyPageCommandDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Product Identifier */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Product Reported Version */
        VersionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Domain */
        Url: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Url) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** The command on the page */
        Command: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a PluginNotifyPageDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PluginNotifyPageDto from which to create the form.
/* @returns FormGroup
 */
function GetPluginNotifyPageDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Product Identifier */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Product Reported Version */
        VersionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Domain */
        Url: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Url) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a PossibleLessonVersionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PossibleLessonVersionsDto from which to create the form.
/* @returns FormGroup
 */
function GetPossibleLessonVersionsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** Version Id */
        VersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Version */
        Version: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _d !== void 0 ? _d : null),
        /** Product Id */
        ProductId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Product */
        Product: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a PriceListDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PriceListDto from which to create the form.
/* @returns FormGroup
 */
function GetPriceListDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The organization that controls this price list */
        OwningOrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The name of the organization that controls this price list */
        OwningOrganization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _c !== void 0 ? _c : null),
        /** The Lesson of the price list */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** The description of the price list */
        Description: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _e !== void 0 ? _e : null),
        /** Price List Types */
        Type: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a PriceListRevisionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PriceListRevisionDto from which to create the form.
/* @returns FormGroup
 */
function GetPriceListRevisionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Id of the parent price list */
        PriceListId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PriceListId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The name of the parent price list */
        PriceList: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.PriceList) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** When the revision takes effect */
        StartOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.StartOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** The optional expiration date on the revision */
        EndOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.EndOn) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a PriceListRevisionInventoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PriceListRevisionInventoryDto from which to create the form.
/* @returns FormGroup
 */
function GetPriceListRevisionInventoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The Revision associated with this item */
        PriceListRevisionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PriceListRevisionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The inventory item associated with this item */
        InventoryId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InventoryId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The name of the inventory item */
        Inventory: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Inventory) !== null && _c !== void 0 ? _c : null),
        /** Sku of inventory item */
        SKU: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _d !== void 0 ? _d : null),
        /** The price of this item (optional only used for non-partner price lists) */
        Price: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Price) !== null && _e !== void 0 ? _e : null),
        /** The Percent of original sale price (optional, used for Partner price lists) */
        PercentOfSalePrice: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PercentOfSalePrice) !== null && _f !== void 0 ? _f : null),
        /** Inventory Items that are billable when this item is sold. */
        BillableInventory: fb.array([])
    });
}
/**
/* Generates a form from a ProductActivityDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductActivityDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetProductActivityDetailDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Version Id */
        VersionId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _d !== void 0 ? _d : null),
        /** Version Lesson */
        Version: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a ProductAndVersionIdDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductAndVersionIdDto from which to create the form.
/* @returns FormGroup
 */
function GetProductAndVersionIdDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Version Id */
        VersionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a ProductCategoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductCategoryDto from which to create the form.
/* @returns FormGroup
 */
function GetProductCategoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Featured */
        Featured: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Featured) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Featured Sort Order */
        FeaturedSortOrder: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.FeaturedSortOrder) !== null && _e !== void 0 ? _e : null),
        /** Branding Color */
        BrandingColor: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.BrandingColor) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(10)])
    });
}
/**
/* Generates a form from a ProductCommandLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductCommandLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetProductCommandLessonsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The version associated with the commands */
        Version: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** The version id associated with the commands */
        VersionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The list of commands associated with a particular version */
        Commands: fb.array([])
    });
}
/**
/* Generates a form from a ProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductDto from which to create the form.
/* @returns FormGroup
 */
function GetProductDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The External Short Form that will be used. */
        ExternalId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ExternalId) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** The name of the product */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the product */
        Description: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _d !== void 0 ? _d : null),
        /** Any tags for searching for the product */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null),
        /** A flag for if the product is active and will return anywhere on the public portal. */
        Active: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** When was the product created? */
        CreatedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** When was it last updated? */
        UpdatedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** The color for branding purposes in #RRGGBBAA format */
        BrandingColor: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.BrandingColor) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(10)]),
        /** Featured Product */
        Featured: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Featured) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Featured Sort Order */
        FeaturedSortOrder: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.FeaturedSortOrder) !== null && _l !== void 0 ? _l : null),
        /** THe owning organization id */
        OwningOrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _m !== void 0 ? _m : null),
        /** Display image resource id */
        DisplayImageId: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _o !== void 0 ? _o : null),
        /** Display Image Url (if applicable) */
        DisplayImageUrl: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.DisplayImageUrl) !== null && _p !== void 0 ? _p : null)
    });
}
/**
/* Generates a form from a ProductSiteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductSiteDto from which to create the form.
/* @returns FormGroup
 */
function GetProductSiteDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Site */
        Site: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Site) !== null && _a !== void 0 ? _a : null),
        /** Site Id */
        SiteId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.SiteId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Product */
        Product: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _c !== void 0 ? _c : null),
        /** Product Id */
        ProductId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a ProductTranslationCategoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductTranslationCategoryDto from which to create the form.
/* @returns FormGroup
 */
function GetProductTranslationCategoryDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Language */
        Languagecode: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Languagecode) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(10), Validators.required]),
        /** Translation Category from Translator Hub */
        TranslationCategory: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TranslationCategory) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(100)])
    });
}
/**
/* Generates a form from a ProductTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetProductTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Lesson Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null),
        /** Lesson */
        Name: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null),
        /** Marketing */
        Marketing: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _h !== void 0 ? _h : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(255)])
    });
}
/**
/* Generates a form from a ProductVersionAndCourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductVersionAndCourseDto from which to create the form.
/* @returns FormGroup
 */
function GetProductVersionAndCourseDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The selected version */
        VersionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The selected version name */
        Version: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The selected course */
        CourseId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Course Lesson */
        Course: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Course) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a ProductVersionCommandDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductVersionCommandDto from which to create the form.
/* @returns FormGroup
 */
function GetProductVersionCommandDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Product Id */
        VersionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Lesson */
        Version: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Product Command */
        Command: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required])
    });
}
/**
/* Generates a form from a ProductVersionCommandTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductVersionCommandTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetProductVersionCommandTranslationDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Command Key */
        Key: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Key) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Language Code */
        LanguageCode: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Translated Value */
        Command: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a ProductVersionCommandWithTranslationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductVersionCommandWithTranslationsDto from which to create the form.
/* @returns FormGroup
 */
function GetProductVersionCommandWithTranslationsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Product Id */
        VersionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Lesson */
        Version: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Product Command */
        Command: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Translations */
        Translations: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Translations) === null || _d === void 0 ? void 0 : _d.map(x => GetProductVersionCommandTranslationDtoForm(fb, x))) !== null && _e !== void 0 ? _e : [])
    });
}
/**
/* Generates a form from a ProductVersionCoursePreferenceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductVersionCoursePreferenceDto from which to create the form.
/* @returns FormGroup
 */
function GetProductVersionCoursePreferenceDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Course Id */
        CourseId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _b !== void 0 ? _b : null),
        /** Product Id */
        ProductId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Product Lesson */
        Product: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _d !== void 0 ? _d : null),
        /** Product Version Id */
        ProductVersionId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ProductVersionId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Product Version Lesson */
        ProductVersion: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ProductVersion) !== null && _f !== void 0 ? _f : null),
        /** Owned */
        Owned: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Owned) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a ProductVersionDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductVersionDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetProductVersionDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The Id of the product */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The string name of the product */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The version Id of the product */
        VersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The string name of the version */
        Version: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a ProductVersionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductVersionDto from which to create the form.
/* @returns FormGroup
 */
function GetProductVersionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The product Id */
        ProductId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The string representation of the product's name */
        Product: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _c !== void 0 ? _c : null),
        /** The name of the Version. Typically Major + "." + Minor + "." + Revision */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** A description of the version if any */
        Description: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _e !== void 0 ? _e : null),
        /** The major version number. */
        Major: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Major) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** The minor version number */
        Minor: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Minor) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The revision number */
        Revision: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Revision) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** When was the version released? */
        ReleasedOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ReleasedOn) !== null && _j !== void 0 ? _j : null),
        /** The External Vendor's Id - Autodesk */
        VendorId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.VendorId) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Default Course that should be used with viewing this product version */
        DefaultCourseId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.DefaultCourseId) !== null && _l !== void 0 ? _l : null),
        /** Default Course Lesson */
        DefaultCourse: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.DefaultCourse) !== null && _m !== void 0 ? _m : null),
        /** Active */
        Active: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _o !== void 0 ? _o : null, [Validators.required])
    });
}
/**
/* Generates a form from a ProductWebAddressDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProductWebAddressDto from which to create the form.
/* @returns FormGroup
 */
function GetProductWebAddressDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Id */
        ProductId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Domain name including wildcards in * notation */
        Domain: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Domain) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(400), Validators.required]),
        /** Site Lesson */
        Site: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Site) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required])
    });
}
/**
/* Generates a form from a ProjectActivityDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectActivityDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectActivityDetailDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a ProjectDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Started On */
        StartedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _d !== void 0 ? _d : null),
        /** Ends On */
        EndsOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _e !== void 0 ? _e : null),
        /** Owning Organization id */
        OwningOrganizationId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Owning Organization */
        OwningOrganization: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OwningOrganization) !== null && _g !== void 0 ? _g : null),
        /** Project Manager Id */
        ProjectManagerUserId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ProjectManagerUserId) !== null && _h !== void 0 ? _h : null),
        /** Project Manager */
        ProjectManagerUser: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ProjectManagerUser) !== null && _j !== void 0 ? _j : null)
    });
}
/**
/* Generates a form from a ProjectJobDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectJobDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectJobDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Project Id */
        ProjectId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ProjectId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Project Lesson */
        Project: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Project) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Job Id */
        JobId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Job Lesson */
        Job: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Job) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required]),
        /** Pre Hire Assessment Id */
        PreHireAssessmentId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PreHireAssessmentId) !== null && _f !== void 0 ? _f : null),
        /** Pre-Hire Assessment Lesson */
        PreHireAssessment: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PreHireAssessment) !== null && _g !== void 0 ? _g : null),
        /** Created On */
        CreatedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Users */
        Users: fb.array((_l = (_k = dto === null || dto === void 0 ? void 0 : dto.Users) === null || _k === void 0 ? void 0 : _k.map(x => GetProjectJobUserDtoForm(fb, x))) !== null && _l !== void 0 ? _l : []),
        /** When does the job start? */
        StartsOn: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _m !== void 0 ? _m : null),
        /** When does the job end? */
        EndsOn: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _o !== void 0 ? _o : null),
        /** Notes */
        Notes: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _p !== void 0 ? _p : null)
    });
}
/**
/* Generates a form from a ProjectJobUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectJobUserDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectJobUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Id */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** User */
        User: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Project Job Statuses */
        Status: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Status) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** User Job Id */
        UserJobId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.UserJobId) !== null && _e !== void 0 ? _e : null),
        /** Notes */
        Notes: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _f !== void 0 ? _f : null),
        /** User's Score */
        Score: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a ProjectManagementCompleteTaskDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectManagementCompleteTaskDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectManagementCompleteTaskDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The item (KAMs) Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a ProjectManagementIssueDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectManagementIssueDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectManagementIssueDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Key (i.e. CDD-140) */
        Key: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Key) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Text of the issue */
        Text: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Type of Jira ticket (Story, bug) */
        Type: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Status of the jira ticket */
        Status: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Status) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Subtasks */
        Subtasks: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Subtasks) === null || _e === void 0 ? void 0 : _e.map(x => GetProjectManagementIssueDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a ProjectProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectProductDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectProductDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Version Id */
        VersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Version */
        Version: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a ProjectUserMatchBadgeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectUserMatchBadgeDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectUserMatchBadgeDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Id of the Competency */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Lesson of the Competency */
        Badge: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Badge) !== null && _b !== void 0 ? _b : null),
        /** Score for the badge */
        Score: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ProjectUserMatchDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectUserMatchDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectUserMatchDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Username */
        Username: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Username) !== null && _b !== void 0 ? _b : null),
        /** Score */
        Score: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Badge List */
        Badges: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Badges) === null || _d === void 0 ? void 0 : _d.map(x => GetProjectUserMatchBadgeDtoForm(fb, x))) !== null && _e !== void 0 ? _e : [])
    });
}
/**
/* Generates a form from a ProjectUserRankDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProjectUserRankDto from which to create the form.
/* @returns FormGroup
 */
function GetProjectUserRankDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Project Job Id */
        ProjectJobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProjectJobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Users matched for project */
        MatchingUsers: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.MatchingUsers) === null || _b === void 0 ? void 0 : _b.map(x => GetProjectUserMatchDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a ProspectOrgUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ProspectOrgUserDto from which to create the form.
/* @returns FormGroup
 */
function GetProspectOrgUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The user's first name */
        FirstName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The user's last name */
        LastName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** The full name of the user */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Email Address */
        Email: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Description */
        OrganizationId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a PublicLessonDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublicLessonDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetPublicLessonDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Skill Level */
        SkillLevel: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.SkillLevel) !== null && _d !== void 0 ? _d : null),
        /** Rating */
        Rating: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Rating) !== null && _e !== void 0 ? _e : null),
        /** Length */
        Length: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Narration Sample */
        NarrationSample: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.NarrationSample) !== null && _g !== void 0 ? _g : null),
        /** Marketing Description */
        MarketingDescription: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.MarketingDescription) !== null && _h !== void 0 ? _h : null),
        /** Meta Data Description */
        MetaDescription: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _j !== void 0 ? _j : null),
        /** Meta Data Keywords */
        MetaKeywords: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _k !== void 0 ? _k : null),
        /** Created On */
        CreatedOn: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Language Code */
        LanguageCode: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _o !== void 0 ? _o : null)
    });
}
/**
/* Generates a form from a PublicVideoCourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublicVideoCourseDto from which to create the form.
/* @returns FormGroup
 */
function GetPublicVideoCourseDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Public Video Lesson */
        PublicVideo: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideo) !== null && _b !== void 0 ? _b : null),
        /** Course Id */
        CourseId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Course Lesson */
        Course: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Course) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a PublicVideoDisciplineDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublicVideoDisciplineDto from which to create the form.
/* @returns FormGroup
 */
function GetPublicVideoDisciplineDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Public Video Lesson */
        PublicVideo: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideo) !== null && _b !== void 0 ? _b : null),
        /** Discipline Id */
        DisciplineId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Discipline Lesson */
        Discipline: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Discipline) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a PublicVideoDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublicVideoDto from which to create the form.
/* @returns FormGroup
 */
function GetPublicVideoDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson of Public Video */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description of Public Video */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Video Id attached to the public video */
        VideoId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.VideoId) !== null && _d !== void 0 ? _d : null),
        /** Tags for the video */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null),
        /** YouTube Video Id */
        YouTubeVideoId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.YouTubeVideoId) !== null && _f !== void 0 ? _f : null),
        /** YouTube Link */
        YouTubeLink: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.YouTubeLink) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a PublicVideoJobDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublicVideoJobDto from which to create the form.
/* @returns FormGroup
 */
function GetPublicVideoJobDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Public Video Lesson */
        PublicVideo: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideo) !== null && _b !== void 0 ? _b : null),
        /** Job Id */
        JobId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Job Lesson */
        Job: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Job) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a PublicVideoLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublicVideoLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetPublicVideoLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Public Video Lesson */
        PublicVideo: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideo) !== null && _b !== void 0 ? _b : null),
        /** Lesson Id */
        LessonId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a PublicVideoTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublicVideoTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetPublicVideoTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson of public video */
        PublicVideo: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideo) !== null && _b !== void 0 ? _b : null),
        /** Description of public video */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Language Code */
        LanguageCode: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required])
    });
}
/**
/* Generates a form from a PublishCourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublishCourseDto from which to create the form.
/* @returns FormGroup
 */
function GetPublishCourseDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a PublishLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublishLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetPublishLessonDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Course Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a PublishTopicDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PublishTopicDto from which to create the form.
/* @returns FormGroup
 */
function GetPublishTopicDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Course Id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a PurchaseSubscriptionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original PurchaseSubscriptionDto from which to create the form.
/* @returns FormGroup
 */
function GetPurchaseSubscriptionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** Organization Id. Must be supplied if user id is not */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null),
        /** Billing address id */
        BillingAddressId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Stored payment credential id */
        StoredPaymentCredentialId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.StoredPaymentCredentialId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Sku to purchase */
        Sku: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Sku) !== null && _e !== void 0 ? _e : null),
        /** Number of Units */
        Units: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Units) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Reseller Id */
        ResellerId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ResellerId) !== null && _g !== void 0 ? _g : null),
        /** If an org and true, takes a payment at the time of request. Otherwise it delegates to let the invoice recurring job take care of it when it runs on the orgs bill date */
        TakePayment: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.TakePayment) !== null && _h !== void 0 ? _h : null, [Validators.required])
    });
}
/**
/* Generates a form from a QBotContentStateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QBotContentStateDto from which to create the form.
/* @returns FormGroup
 */
function GetQBotContentStateDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null),
        /** Asking Product */
        AskingProduct: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AskingProduct) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Version Id */
        VersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _c !== void 0 ? _c : null),
        /** Asking Version */
        AskingVersion: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AskingVersion) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Q Message */
        Question: GetQMessageDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Question),
        /** Prompt for Acceptable Answer */
        PromptAcceptableAnswer: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.PromptAcceptableAnswer) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Prompt Escalation */
        PromptEscalation: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PromptEscalation) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Prompt For Question */
        PromptForQuestion: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PromptForQuestion) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a QBotEscalationStateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QBotEscalationStateDto from which to create the form.
/* @returns FormGroup
 */
function GetQBotEscalationStateDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Sent Please Wait */
        SentPleaseWait: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SentPleaseWait) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Asked Queue */
        AskedQueue: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AskedQueue) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Expert Id */
        ExpertId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ExpertId) !== null && _c !== void 0 ? _c : null),
        /** Invited Expert Id */
        InvitedExpertId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.InvitedExpertId) !== null && _d !== void 0 ? _d : null),
        /** The Experts that were considered with scoring */
        ExpertsConsidered: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.ExpertsConsidered) === null || _e === void 0 ? void 0 : _e.map(x => GetQExpertDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a QBotSupportStateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QBotSupportStateDto from which to create the form.
/* @returns FormGroup
 */
function GetQBotSupportStateDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Q Message */
        Question: GetQMessageDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Question),
        /** Asking for Email Address */
        AskingForEmailAddress: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AskingForEmailAddress) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _b !== void 0 ? _b : null, [Validators.email]),
        /** asking for Token */
        AskingForToken: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.AskingForToken) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Token */
        Token: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Token) !== null && _d !== void 0 ? _d : null),
        /** Prompt Acceptable Answer */
        PromptAcceptableAnswer: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.PromptAcceptableAnswer) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Prompt for Escalation */
        PromptEscalation: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PromptEscalation) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Prompt for Question */
        PromptForQuestion: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PromptForQuestion) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a QConversationQuestionAnswerDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QConversationQuestionAnswerDto from which to create the form.
/* @returns FormGroup
 */
function GetQConversationQuestionAnswerDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Conversation Id */
        ConversationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ConversationId) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Question */
        Question: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Question) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Answer */
        Answer: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Answer) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a QConversationStateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QConversationStateDto from which to create the form.
/* @returns FormGroup
 */
function GetQConversationStateDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The Id of the conversation */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Q Message */
        OriginalQuestion: GetQMessageDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.OriginalQuestion),
        /** Has Asked Department */
        HasAskedDepartment: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.HasAskedDepartment) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Q Product Info */
        ProductInfo: GetQProductDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.ProductInfo),
        /** Q Bot Question State */
        ContentState: GetQBotContentStateDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.ContentState),
        /** Q Bot Support State */
        SupportState: GetQBotSupportStateDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.SupportState),
        /** Escalation State */
        EscalationState: GetQBotEscalationStateDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.EscalationState),
        /** When the conversation was started */
        StartedOn: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Q Paticipant */
        StartedBy: GetQParticipantDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.StartedBy),
        /** Ended On */
        EndedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.EndedOn) !== null && _d !== void 0 ? _d : null),
        /** Did the conversation result in success? */
        Successful: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Successful) !== null && _e !== void 0 ? _e : null),
        /** Participants */
        Participants: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Participants) === null || _f === void 0 ? void 0 : _f.map(x => GetQParticipantDtoForm(fb, x))) !== null && _g !== void 0 ? _g : []),
        /** Messages */
        Messages: fb.array((_j = (_h = dto === null || dto === void 0 ? void 0 : dto.Messages) === null || _h === void 0 ? void 0 : _h.map(x => GetQMessageDtoForm(fb, x))) !== null && _j !== void 0 ? _j : []),
        /** The answer that was generated by an expert or was already in the system that resolves the question */
        ResolutionAnswerId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.ResolutionAnswerId) !== null && _k !== void 0 ? _k : null),
        /** Q Paticipant */
        ResolvedBy: GetQParticipantDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.ResolvedBy),
    });
}
/**
/* Generates a form from a QExpertDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QExpertDto from which to create the form.
/* @returns FormGroup
 */
function GetQExpertDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** If there is no UserId, use the connection Id to respond. */
        ConnectionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ConnectionId) !== null && _b !== void 0 ? _b : null),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Access Token */
        AccessToken: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AccessToken) !== null && _d !== void 0 ? _d : null),
        /** Q Participant Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Active in conversation */
        Active: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _f !== void 0 ? _f : null),
        /** The active organization of the user */
        OrganizationId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _g !== void 0 ? _g : null),
        /** Score */
        OverallScore: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.OverallScore) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Assessment Score */
        AssessmentScore: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.AssessmentScore) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Usage Score */
        UsageScore: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.UsageScore) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Learning Score */
        LearningScore: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.LearningScore) !== null && _l !== void 0 ? _l : null, [Validators.required])
    });
}
/**
/* Generates a form from a QExpertEscalationResponseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QExpertEscalationResponseDto from which to create the form.
/* @returns FormGroup
 */
function GetQExpertEscalationResponseDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Verification Token */
        VerificationToken: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VerificationToken) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Accepted */
        Accepted: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Accepted) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Conversation to Accept */
        ConversationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ConversationId) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a QMessageButtonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QMessageButtonDto from which to create the form.
/* @returns FormGroup
 */
function GetQMessageButtonDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Button Text */
        Text: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Value of the response */
        Value: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Value) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Q Button Action Types */
        Type: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a QMessageDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QMessageDto from which to create the form.
/* @returns FormGroup
 */
function GetQMessageDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
    return fb.group({
        /** Message Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Conversation Id */
        ConversationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ConversationId) !== null && _b !== void 0 ? _b : null),
        /** Q Paticipant */
        FromParticipant: GetQParticipantDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.FromParticipant),
        /** Who is the message to? */
        ToParticipants: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.ToParticipants) === null || _c === void 0 ? void 0 : _c.map(x => GetQParticipantDtoForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /** Q Message Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Message */
        Message: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Message) !== null && _f !== void 0 ? _f : null),
        /** Is HTML Message */
        IsHtml: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.IsHtml) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Time stamp of the message */
        DateTime: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DateTime) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** The message that this response is in reference to. */
        InResponseToMessageId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.InResponseToMessageId) !== null && _j !== void 0 ? _j : null),
        /** Q Message */
        InResponseToMessage: GetQMessageDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.InResponseToMessage),
        /** Verification Token used for out of band invites to the call. */
        VerificationToken: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.VerificationToken) !== null && _k !== void 0 ? _k : null),
        /** Buttons that can be selected */
        Buttons: fb.array((_m = (_l = dto === null || dto === void 0 ? void 0 : dto.Buttons) === null || _l === void 0 ? void 0 : _l.map(x => GetQMessageButtonDtoForm(fb, x))) !== null && _m !== void 0 ? _m : []),
        /** Only a button press is allowed. */
        ButtonOnly: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ButtonOnly) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Lessons */
        Lessons: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _p === void 0 ? void 0 : _p.map(x => GetShortContentDtoForm(fb, x))) !== null && _q !== void 0 ? _q : []),
        /** The product Id if known to be sent on the initiation of a conversation */
        InitialProductId: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.InitialProductId) !== null && _r !== void 0 ? _r : null),
        /** The version Id if know to be send on the intiiation of a conversation */
        InitialVersionId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.InitialVersionId) !== null && _s !== void 0 ? _s : null),
        /** Is the initial message a guaranteed content question? */
        IsContent: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.IsContent) !== null && _t !== void 0 ? _t : null),
        /** Intent Score */
        IntentScore: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.IntentScore) !== null && _u !== void 0 ? _u : null),
        /** Interpreted Intent */
        Intent: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Intent) !== null && _v !== void 0 ? _v : null),
        /** Concepts */
        Concepts: fb.array([]),
        /** Entities */
        Entities: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Entities) !== null && _w !== void 0 ? _w : null)
    });
}
/**
/* Generates a form from a QParticipantDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QParticipantDto from which to create the form.
/* @returns FormGroup
 */
function GetQParticipantDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** If there is no UserId, use the connection Id to respond. */
        ConnectionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ConnectionId) !== null && _b !== void 0 ? _b : null),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Access Token */
        AccessToken: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AccessToken) !== null && _d !== void 0 ? _d : null),
        /** Q Participant Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Active in conversation */
        Active: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _f !== void 0 ? _f : null),
        /** The active organization of the user */
        OrganizationId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a QProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QProductDto from which to create the form.
/* @returns FormGroup
 */
function GetQProductDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Text */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Version Id */
        VersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _c !== void 0 ? _c : null),
        /** Version Text */
        Version: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a QuestionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuestionDto from which to create the form.
/* @returns FormGroup
 */
function GetQuestionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The text of the question */
        Text: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _b !== void 0 ? _b : null),
        /** Is the question active and published? */
        Active: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** An Enumeration of different types of assessments */
        AssessmentType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AssessmentType) !== null && _d !== void 0 ? _d : null),
        /** The Answers to the question */
        Answers: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Answers) === null || _e === void 0 ? void 0 : _e.map(x => GetAnswerDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Owning Organization's Id */
        OwningOrganizationId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a QuestionLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuestionLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetQuestionLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Lesson Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Lesson Length */
        Length: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Question answers lesson at time */
        Time: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Time) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a QuestionOfTheDayAssessmentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuestionOfTheDayAssessmentDto from which to create the form.
/* @returns FormGroup
 */
function GetQuestionOfTheDayAssessmentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Previous Question (If Applicable) result */
        PreviousQuestionResult: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PreviousQuestionResult) !== null && _a !== void 0 ? _a : null),
        /** Suggested lessons if previous result was incorrect */
        SuggestedLessons: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.SuggestedLessons) === null || _b === void 0 ? void 0 : _b.map(x => GetLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : []),
        /** Were there questions available */
        QuestionsAvailable: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.QuestionsAvailable) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Current User Assessment Id */
        CurrentUserAssessmentId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CurrentUserAssessmentId) !== null && _e !== void 0 ? _e : null),
        /** A question for a user assessment */
        CurrentQuestion: GetUserAssessmentQuestionDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.CurrentQuestion),
        /** Next User Assessment Id */
        NextUserAssessmentId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.NextUserAssessmentId) !== null && _f !== void 0 ? _f : null),
        /** A question for a user assessment */
        NextQuestion: GetUserAssessmentQuestionDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.NextQuestion),
        /** Was the previous question skipped */
        Skipped: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Skipped) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a QuestionSearchResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuestionSearchResultDto from which to create the form.
/* @returns FormGroup
 */
function GetQuestionSearchResultDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** Question */
        Question: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Question) !== null && _a !== void 0 ? _a : null),
        /** Course Id */
        CourseId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _b !== void 0 ? _b : null),
        /** Version Id */
        VersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _c !== void 0 ? _c : null),
        /** Version */
        Version: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _d !== void 0 ? _d : null),
        /** Major Version # */
        Major: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Major) !== null && _e !== void 0 ? _e : null),
        /** Minor Version # */
        Minor: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Minor) !== null && _f !== void 0 ? _f : null),
        /** Product Lesson */
        Product: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _g !== void 0 ? _g : null),
        /** Product Id */
        ProductId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _h !== void 0 ? _h : null),
        /** Answer */
        Answer: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Answer) !== null && _j !== void 0 ? _j : null),
        /** Question Id */
        QuestionId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** An Enumeration of different types of assessments */
        Type: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Date Updated */
        UpdatedOn: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Lessons associated with the question. */
        Lessons: fb.array((_p = (_o = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _o === void 0 ? void 0 : _o.map(x => GetShortContentDtoForm(fb, x))) !== null && _p !== void 0 ? _p : []),
        /** Match Liklihood */
        Rank: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Rank) !== null && _q !== void 0 ? _q : null, [Validators.required])
    });
}
/**
/* Generates a form from a QuestionTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuestionTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetQuestionTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Lesson Id */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        QuestionText: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.QuestionText) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Answers to the question */
        Answers: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Answers) === null || _e === void 0 ? void 0 : _e.map(x => GetAnswerTranslationDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a QuestionWithProductAndLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuestionWithProductAndLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetQuestionWithProductAndLessonDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The text of the question */
        Text: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _b !== void 0 ? _b : null),
        /** Is the question active and published? */
        Active: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** An Enumeration of different types of assessments */
        AssessmentType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AssessmentType) !== null && _d !== void 0 ? _d : null),
        /** The Answers to the question */
        Answers: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Answers) === null || _e === void 0 ? void 0 : _e.map(x => GetAnswerDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Owning Organization's Id */
        OwningOrganizationId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _g !== void 0 ? _g : null),
        /** Lesson Lesson */
        Lesson: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _h !== void 0 ? _h : null),
        /** Product Lesson */
        Product: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _j !== void 0 ? _j : null),
        /** Version Lesson */
        Version: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _k !== void 0 ? _k : null)
    });
}
/**
/* Generates a form from a QuestionWithWorkflowDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuestionWithWorkflowDto from which to create the form.
/* @returns FormGroup
 */
function GetQuestionWithWorkflowDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The text of the question */
        Text: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _b !== void 0 ? _b : null),
        /** Is the question active and published? */
        Active: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** An Enumeration of different types of assessments */
        AssessmentType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AssessmentType) !== null && _d !== void 0 ? _d : null),
        /** The Answers to the question */
        Answers: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Answers) === null || _e === void 0 ? void 0 : _e.map(x => GetAnswerDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Owning Organization's Id */
        OwningOrganizationId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _g !== void 0 ? _g : null),
        /** Lesson of the workflow Step the question is in */
        WorkflowStep: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _h !== void 0 ? _h : null)
    });
}
/**
/* Generates a form from a QuestionWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuestionWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetQuestionWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The Question Id */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Question */
        Question: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Question) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null),
        /** User Lesson */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null),
        /** Role Id */
        RoleId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Role Lesson */
        Role: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _f !== void 0 ? _f : null),
        /** Description if any */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a QuickSearchResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original QuickSearchResultDto from which to create the form.
/* @returns FormGroup
 */
function GetQuickSearchResultDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null),
        /** Product Lesson */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Product Id */
        VersionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _c !== void 0 ? _c : null),
        /** Product Lesson */
        Version: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** List of Lessons */
        Lessons: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _e === void 0 ? void 0 : _e.map(x => GetShortLessonWithCoursesDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Courses */
        Courses: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.Courses) === null || _g === void 0 ? void 0 : _g.map(x => GetShortCourseDtoForm(fb, x))) !== null && _h !== void 0 ? _h : [])
    });
}
/**
/* Generates a form from a RecordQuestionOfTheDayAnswerDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RecordQuestionOfTheDayAnswerDto from which to create the form.
/* @returns FormGroup
 */
function GetRecordQuestionOfTheDayAnswerDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Assessment Id */
        UserAssessmentId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserAssessmentId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Question Id */
        QuestionId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Answer Id */
        AnswerId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _d !== void 0 ? _d : null),
        /** Badge Id to get the next question, if applicable */
        BadgeId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _e !== void 0 ? _e : null),
        /** Medallion Id to get the next question, if applicable */
        MedallionId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a RedeemTokenDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RedeemTokenDto from which to create the form.
/* @returns FormGroup
 */
function GetRedeemTokenDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The token to redeem */
        TokenId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TokenId) !== null && _a !== void 0 ? _a : null),
        /** The User Id of the user that will receive the benefits */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a RejectQuoteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RejectQuoteDto from which to create the form.
/* @returns FormGroup
 */
function GetRejectQuoteDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Quote being rejected */
        QuoteId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuoteId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Reason quote is being rejected */
        Reason: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Reason) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a RemoveProductVersionCommandDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RemoveProductVersionCommandDto from which to create the form.
/* @returns FormGroup
 */
function GetRemoveProductVersionCommandDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Current version id */
        VersionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Command */
        Command: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required])
    });
}
/**
/* Generates a form from a RenewPartnerUserEntitlementDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RenewPartnerUserEntitlementDto from which to create the form.
/* @returns FormGroup
 */
function GetRenewPartnerUserEntitlementDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** User Id on the subscription */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Partner Id */
        PartnerId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Entitlement Id to renew */
        EntitlementId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EntitlementId) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportAchievementsTestedOutDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportAchievementsTestedOutDto from which to create the form.
/* @returns FormGroup
 */
function GetReportAchievementsTestedOutDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Badges tested out of */
        Badges: fb.array((_b = (_a = dto === null || dto === void 0 ? void 0 : dto.Badges) === null || _a === void 0 ? void 0 : _a.map(x => GetBadgeDtoForm(fb, x))) !== null && _b !== void 0 ? _b : []),
        /** Medallions tested out of */
        Medallions: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Medallions) === null || _c === void 0 ? void 0 : _c.map(x => GetMedallionDtoForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /** Disciplines tested out of */
        Disciplines: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _e === void 0 ? void 0 : _e.map(x => GetDisciplineDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a ReportActivityItemDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportActivityItemDto from which to create the form.
/* @returns FormGroup
 */
function GetReportActivityItemDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson Detail */
        Lesson: GetLessonActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Lesson),
        /** Course Activity Details */
        Course: GetCourseActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Course),
        /** Organization Details */
        Organization: GetOrganizationActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Organization),
        /** Product Details */
        Product: GetProductActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Product),
        /** Command */
        Command: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _a !== void 0 ? _a : null),
        /** Date Time */
        DateTime: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.DateTime) !== null && _b !== void 0 ? _b : null),
        /** User Details */
        User: GetUserActivityDetailDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.User),
    });
}
/**
/* Generates a form from a ReportBillableInventoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportBillableInventoryDto from which to create the form.
/* @returns FormGroup
 */
function GetReportBillableInventoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** From Organization Id */
        FromOrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FromOrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** From Organization */
        FromOrganization: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FromOrganization) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Grand Total */
        GrandTotal: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.GrandTotal) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Total Billed */
        TotalBilled: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.TotalBilled) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Delta */
        Delta: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Delta) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Invoice Id */
        InvoiceId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Invoice Number */
        InvoiceNumber: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.InvoiceNumber) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Date of invoice */
        Date: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Billable Inventory */
        BillableInventory: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.BillableInventory) !== null && _j !== void 0 ? _j : null)
    });
}
/**
/* Generates a form from a ReportCourseCompletionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportCourseCompletionDto from which to create the form.
/* @returns FormGroup
 */
function GetReportCourseCompletionDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The course name */
        Course: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Course) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The percentage complete */
        PercentComplete: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportCourseCompletionLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportCourseCompletionLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportCourseCompletionLessonsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The course Id */
        CourseId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The course name */
        Course: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Course) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** The number of completed lessons on the course */
        CompletedLessons: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CompletedLessons) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** The total number of lessons on the course */
        TotalLessons: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalLessons) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportCoursesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportCoursesDto from which to create the form.
/* @returns FormGroup
 */
function GetReportCoursesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** Question Type */
        ContentType: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ContentType) !== null && _a !== void 0 ? _a : null),
        /** Course Id */
        CustomerContentID: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CustomerContentID) !== null && _b !== void 0 ? _b : null),
        /** URL */
        URL: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.URL) !== null && _c !== void 0 ? _c : null),
        /** Image URL */
        ImageURL: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ImageURL) !== null && _d !== void 0 ? _d : null),
        /** Title */
        Title: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _e !== void 0 ? _e : null),
        /** Summary */
        Summary: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Summary) !== null && _f !== void 0 ? _f : null),
        /** Duration */
        Duration: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Duration) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Duration Units */
        DurationUnits: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DurationUnits) !== null && _h !== void 0 ? _h : null),
        /** Publish Date */
        PublishDate: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PublishDate) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Authors */
        Authors: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Authors) !== null && _k !== void 0 ? _k : null),
        /** Topics */
        Topics: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Topics) !== null && _l !== void 0 ? _l : null)
    });
}
/**
/* Generates a form from a ReportDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportDto from which to create the form.
/* @returns FormGroup
 */
function GetReportDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** The id of the screen or report */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** Report Endpoints */
        ApiEndpoint: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ApiEndpoint) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Report Detail Types */
        DetailType: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.DetailType) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Report Date Range */
        DateRange: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.DateRange) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Report Date Range */
        Visibility: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Visibility) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Custom Range Start Date */
        CustomStartDate: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CustomStartDate) !== null && _f !== void 0 ? _f : null),
        /** Custom Range End Date */
        CustomEndDate: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CustomEndDate) !== null && _g !== void 0 ? _g : null),
        /** The custom name of the report if applicable */
        ReportName: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ReportName) !== null && _h !== void 0 ? _h : null),
        /**  */
        LoadCriteria: GetLoadCriteriaForm(fb, dto === null || dto === void 0 ? void 0 : dto.LoadCriteria),
        /** Columns to be displayed in order */
        Columns: fb.array((_k = (_j = dto === null || dto === void 0 ? void 0 : dto.Columns) === null || _j === void 0 ? void 0 : _j.map(x => GetColumnDetailForm(fb, x))) !== null && _k !== void 0 ? _k : []),
        /** List of chart details on how charts should be built on a report */
        Charts: fb.array((_m = (_l = dto === null || dto === void 0 ? void 0 : dto.Charts) === null || _l === void 0 ? void 0 : _l.map(x => GetChartDetailForm(fb, x))) !== null && _m !== void 0 ? _m : []),
        /** Count Field Display Lesson */
        CountFieldDisplayName: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.CountFieldDisplayName) !== null && _o !== void 0 ? _o : null),
        /** Count Field Internal Lesson */
        CountFieldInternalName: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.CountFieldInternalName) !== null && _p !== void 0 ? _p : null)
    });
}
/**
/* Generates a form from a ReportGroupProductViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportGroupProductViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportGroupProductViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Command */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Total Views */
        TotalViews: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalViews) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Total Time Watched */
        TotalTimeWatched: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.TotalTimeWatched) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lessons Viewed */
        Lessons: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _e === void 0 ? void 0 : _e.map(x => GetShortContentWithViewsDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a ReportGroupViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportGroupViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportGroupViewsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Group Lesson */
        Group: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Views */
        TotalViews: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.TotalViews) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Total Length */
        TotalTime: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalTime) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportLessonActivityDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportLessonActivityDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportLessonActivityDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7;
    return fb.group({
        /** Date and Tiem of the Activity */
        DateTime: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DateTime) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** IP of the user */
        Origin: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Origin) !== null && _b !== void 0 ? _b : null),
        /** Client application that made the request. */
        ClientId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _c !== void 0 ? _c : null),
        /** User Id */
        UserId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _d !== void 0 ? _d : null),
        /** User name */
        UserName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _e !== void 0 ? _e : null),
        /** User Full Lesson */
        UserFullName: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UserFullName) !== null && _f !== void 0 ? _f : null),
        /** Email Address */
        UserEmailAddress: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.UserEmailAddress) !== null && _g !== void 0 ? _g : null),
        /** Is the user active? */
        UserIsActive: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.UserIsActive) !== null && _h !== void 0 ? _h : null),
        /** User Country */
        UserCountry: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.UserCountry) !== null && _j !== void 0 ? _j : null),
        /** User's location within the country */
        UserLocation: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.UserLocation) !== null && _k !== void 0 ? _k : null),
        /** User's Organizational Title */
        UserTitle: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.UserTitle) !== null && _l !== void 0 ? _l : null),
        /** Organization of the User */
        OrganizationId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _m !== void 0 ? _m : null),
        /** Organization Lesson */
        Organization: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _o !== void 0 ? _o : null),
        /** Organization Types */
        OrganizationType: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.OrganizationType) !== null && _p !== void 0 ? _p : null),
        /** User's Division */
        OrganizationDivision: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.OrganizationDivision) !== null && _q !== void 0 ? _q : null),
        /** User's Group */
        OrganizationGroup: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.OrganizationGroup) !== null && _r !== void 0 ? _r : null),
        /** User's Level */
        OrganizationLevel: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.OrganizationLevel) !== null && _s !== void 0 ? _s : null),
        /** Lesson Id */
        LessonId: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _t !== void 0 ? _t : null),
        /** Lesson Lesson */
        LessonName: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.LessonName) !== null && _u !== void 0 ? _u : null),
        /** Lesson Description */
        LessonDescription: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.LessonDescription) !== null && _v !== void 0 ? _v : null),
        /** Lesson Length */
        LessonLength: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.LessonLength) !== null && _w !== void 0 ? _w : null),
        /** Lesson Tags */
        LessonTags: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.LessonTags) !== null && _x !== void 0 ? _x : null),
        /** Course Id */
        CourseId: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _y !== void 0 ? _y : null),
        /** Course Lesson */
        CourseName: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.CourseName) !== null && _z !== void 0 ? _z : null),
        /** Topic Id */
        TopicId: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _0 !== void 0 ? _0 : null),
        /** Topic Lesson */
        TopicName: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.TopicName) !== null && _1 !== void 0 ? _1 : null),
        /** ProjectId */
        ProjectId: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.ProjectId) !== null && _2 !== void 0 ? _2 : null),
        /** Project Lesson */
        ProjectName: new FormControl((_3 = dto === null || dto === void 0 ? void 0 : dto.ProjectName) !== null && _3 !== void 0 ? _3 : null),
        /** Product Ids */
        ProductId: new FormControl((_4 = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _4 !== void 0 ? _4 : null),
        /** Product Lesson */
        ProductName: new FormControl((_5 = dto === null || dto === void 0 ? void 0 : dto.ProductName) !== null && _5 !== void 0 ? _5 : null),
        /** Version Id */
        VersionId: new FormControl((_6 = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _6 !== void 0 ? _6 : null),
        /** Version Lesson */
        VersionName: new FormControl((_7 = dto === null || dto === void 0 ? void 0 : dto.VersionName) !== null && _7 !== void 0 ? _7 : null)
    });
}
/**
/* Generates a form from a ReportLessonViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportLessonViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportLessonViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The Length of the lesson */
        Length: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The number of views */
        Views: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Views) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Courses for the lesson */
        Courses: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Courses) === null || _e === void 0 ? void 0 : _e.map(x => GetShortContentDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a ReportMostActiveProduct
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportMostActiveProduct from which to create the form.
/* @returns FormGroup
 */
function GetReportMostActiveProductForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Total Views */
        TotalViews: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalViews) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportMostTakenAssessmentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportMostTakenAssessmentDto from which to create the form.
/* @returns FormGroup
 */
function GetReportMostTakenAssessmentDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Assessment Id */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assessment */
        Assessment: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Assessment) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Times Taken */
        Times: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Times) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportOrganizationUserEntitlementsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportOrganizationUserEntitlementsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportOrganizationUserEntitlementsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** User's Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        UserName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _b !== void 0 ? _b : null),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Active? */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Created On */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _f !== void 0 ? _f : null, [Validators.email]),
        /** Division */
        Division: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _g !== void 0 ? _g : null),
        /** Group */
        Group: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _h !== void 0 ? _h : null),
        /** Location */
        Location: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _j !== void 0 ? _j : null),
        /** Language Code */
        LanguageCode: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _k !== void 0 ? _k : null),
        /** inventory item */
        InventoryItem: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.InventoryItem) !== null && _l !== void 0 ? _l : null),
        /** inventory item */
        InventoryItemId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.InventoryItemId) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Price */
        Price: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Price) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Starts On */
        StartsOn: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _p !== void 0 ? _p : null),
        /** Expiration Date */
        ExpirationDate: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.ExpirationDate) !== null && _q !== void 0 ? _q : null)
    });
}
/**
/* Generates a form from a ReportOrganizationUsersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportOrganizationUsersDto from which to create the form.
/* @returns FormGroup
 */
function GetReportOrganizationUsersDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** User's Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        UserName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _b !== void 0 ? _b : null),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Active? */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Created On */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _f !== void 0 ? _f : null, [Validators.email]),
        /** Division */
        Division: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _g !== void 0 ? _g : null),
        /** Group */
        Group: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _h !== void 0 ? _h : null),
        /** Location */
        Location: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _j !== void 0 ? _j : null),
        /** Language Code */
        LanguageCode: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _k !== void 0 ? _k : null)
    });
}
/**
/* Generates a form from a ReportPartnerActivityDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportPartnerActivityDto from which to create the form.
/* @returns FormGroup
 */
function GetReportPartnerActivityDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Id of the partner */
        PartnerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson of the partner */
        PartnerName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PartnerName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Contact Types */
        ToContactType: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ToContactType) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The contact id */
        ToContactId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ToContactId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lesson of the user or organzation */
        ToContactName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ToContactName) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required]),
        /** The date */
        Date: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportPartnerTokenDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportPartnerTokenDto from which to create the form.
/* @returns FormGroup
 */
function GetReportPartnerTokenDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    return fb.group({
        /** The internal id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Token Id */
        TokenId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.TokenId) !== null && _b !== void 0 ? _b : null),
        /** The date the token expires on */
        ExpiresOn: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ExpiresOn) !== null && _c !== void 0 ? _c : null),
        /** The date the token was cancelled on, if any. */
        CancelledOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CancelledOn) !== null && _d !== void 0 ? _d : null),
        /** The day the token was issued */
        IssuedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.IssuedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** The day the token was redeemed, if any. */
        RedeemedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.RedeemedOn) !== null && _f !== void 0 ? _f : null),
        /** The id of the user/organization the token was redeemed by, if any */
        RedeemedById: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.RedeemedById) !== null && _g !== void 0 ? _g : null),
        /** The name of the user/organization the token was redeemed by, if any */
        RedeemedBy: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.RedeemedBy) !== null && _h !== void 0 ? _h : null),
        /** The id of the user the token was cancelled by, if any */
        CancelledById: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.CancelledById) !== null && _j !== void 0 ? _j : null),
        /** The name of the user the token was cancelled by, if any */
        CancelledBy: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.CancelledBy) !== null && _k !== void 0 ? _k : null),
        /** The invoice inventory the token is attached to */
        InvoiceInventoryId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.InvoiceInventoryId) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** The friendly name of the invoice inventory object the token is attached to */
        InvoiceInventory: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.InvoiceInventory) !== null && _m !== void 0 ? _m : null),
        /** The owning organization id of the token */
        OrganizationId: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _o !== void 0 ? _o : null),
        /** Price */
        Price: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Price) !== null && _p !== void 0 ? _p : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportPlatformTotalDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportPlatformTotalDto from which to create the form.
/* @returns FormGroup
 */
function GetReportPlatformTotalDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Client Id */
        ClientId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** User Count */
        UserCount: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserCount) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportProductCommandViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportProductCommandViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportProductCommandViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Command */
        Command: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Command) !== null && _a !== void 0 ? _a : null),
        /** Total Views */
        TotalViews: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.TotalViews) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Total Time Watched */
        TotalTimeWatched: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalTimeWatched) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Lessons Viewed */
        Lessons: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _d === void 0 ? void 0 : _d.map(x => GetShortContentWithViewsDtoForm(fb, x))) !== null && _e !== void 0 ? _e : [])
    });
}
/**
/* Generates a form from a ReportProductVersionViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportProductVersionViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportProductVersionViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Command */
        Version: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _a !== void 0 ? _a : null),
        /** Total Views */
        TotalViews: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.TotalViews) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Total Time Watched */
        TotalTimeWatched: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalTimeWatched) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Lessons Viewed */
        Lessons: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _d === void 0 ? void 0 : _d.map(x => GetShortContentWithViewsDtoForm(fb, x))) !== null && _e !== void 0 ? _e : [])
    });
}
/**
/* Generates a form from a ReportProductViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportProductViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportProductViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Lesson */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null),
        /** Total Views */
        TotalViews: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalViews) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Total Time Watched */
        TotalTimeWatched: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.TotalTimeWatched) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportProjectLessonViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportProjectLessonViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportProjectLessonViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Project Id */
        ProjectId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProjectId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Project Lesson */
        Project: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Project) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Total Views */
        TotalViews: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalViews) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Total Time Watched */
        TotalTimeWatched: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.TotalTimeWatched) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportProjectUserViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportProjectUserViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportProjectUserViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Total Views */
        TotalViews: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalViews) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Total Time Watched */
        TotalTimeWatched: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.TotalTimeWatched) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Lessons Viewed */
        Lessons: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _e === void 0 ? void 0 : _e.map(x => GetShortContentWithViewsDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a ReportResourceViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportResourceViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportResourceViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The resource Id */
        ResourceId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ResourceId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the resource */
        Resource: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Resource) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The number of views */
        Views: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Views) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Courses for the resource */
        Courses: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Courses) === null || _d === void 0 ? void 0 : _d.map(x => GetShortContentDtoForm(fb, x))) !== null && _e !== void 0 ? _e : []),
        /** Lessons for the for the resource */
        Lessons: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _f === void 0 ? void 0 : _f.map(x => GetShortContentDtoForm(fb, x))) !== null && _g !== void 0 ? _g : [])
    });
}
/**
/* Generates a form from a ReportSalesBySalesRepDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportSalesBySalesRepDto from which to create the form.
/* @returns FormGroup
 */
function GetReportSalesBySalesRepDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Sales Rep id */
        SalesRepId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SalesRepId) !== null && _a !== void 0 ? _a : null),
        /** Sales Rep Lesson */
        SalesRep: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.SalesRep) !== null && _b !== void 0 ? _b : null),
        /** Organization Id */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Organization Lesson */
        OrganizationName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OrganizationName) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Total amount grossed by the sales rep */
        Total: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Total) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportScheduleDetail
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportScheduleDetail from which to create the form.
/* @returns FormGroup
 */
function GetReportScheduleDetailForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Organization Automated Report Types */
        Report: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Report) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Started On */
        StartedOn: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Last Run On */
        LastRunOn: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LastRunOn) !== null && _c !== void 0 ? _c : null),
        /** Next Run On */
        NextRunOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.NextRunOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Report Schedules */
        Schedule: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Schedule) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Recipients */
        Recipients: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Recipients) === null || _f === void 0 ? void 0 : _f.map(x => GetReportScheduleRecipientDetailForm(fb, x))) !== null && _g !== void 0 ? _g : [])
    });
}
/**
/* Generates a form from a ReportScheduleRecipientDetail
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportScheduleRecipientDetail from which to create the form.
/* @returns FormGroup
 */
function GetReportScheduleRecipientDetailForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** User Id if applicable */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** Users Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Users Email Address */
        EmailAddress: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _c !== void 0 ? _c : null, [Validators.email]),
        /** Whether or not the user will receive emailed report */
        Receive: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Receive) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a ReportSignupsByMonthDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportSignupsByMonthDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetReportSignupsByMonthDetailDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Month and Year */
        MonthAndYear: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MonthAndYear) !== null && _a !== void 0 ? _a : null),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Email */
        Email: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _c !== void 0 ? _c : null, [Validators.email]),
        /** UA Membership Id */
        MembershipId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.MembershipId) !== null && _d !== void 0 ? _d : null),
        /** Group or Local Number */
        Group: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a ReportSignupsByMonthDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportSignupsByMonthDto from which to create the form.
/* @returns FormGroup
 */
function GetReportSignupsByMonthDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Month */
        Month: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Month) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Signups in Month */
        Count: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Count) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportTopOrganizationsByDollarValueDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportTopOrganizationsByDollarValueDto from which to create the form.
/* @returns FormGroup
 */
function GetReportTopOrganizationsByDollarValueDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization */
        Organizaiton: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Organizaiton) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Amount Sold */
        Amount: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Amount) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportTopUsersByDollarValueDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportTopUsersByDollarValueDto from which to create the form.
/* @returns FormGroup
 */
function GetReportTopUsersByDollarValueDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Total Deals */
        TotalDeals: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TotalDeals) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Amount Sold */
        Amount: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Amount) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportTotalDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportTotalDto from which to create the form.
/* @returns FormGroup
 */
function GetReportTotalDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Total */
        Total: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Total) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportTranslationErrorDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportTranslationErrorDto from which to create the form.
/* @returns FormGroup
 */
function GetReportTranslationErrorDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Item with the error */
        ItemId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Description of Error */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** User who reported it */
        UserId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** User's name */
        User: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a ReportTrialsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportTrialsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportTrialsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** Entitlement Id */
        EntitlementId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.EntitlementId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Inventory Item */
        InventoryItem: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InventoryItem) !== null && _b !== void 0 ? _b : null),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null),
        /** User's Lesson */
        UserName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _d !== void 0 ? _d : null),
        /** Organization Id */
        OrganizationId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _e !== void 0 ? _e : null),
        /** Organization Lesson */
        Organization: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _f !== void 0 ? _f : null),
        /** Started On */
        StartedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Ends On */
        EndsOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.EndsOn) !== null && _h !== void 0 ? _h : null)
    });
}
/**
/* Generates a form from a ReportUpcomingOrganizationRenewalsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportUpcomingOrganizationRenewalsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportUpcomingOrganizationRenewalsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Renewal Date */
        RenewalDate: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.RenewalDate) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Active Users */
        ActiveUsers: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ActiveUsers) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Inactive Users */
        InactiveUsers: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.InactiveUsers) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportUserDetailViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportUserDetailViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportUserDetailViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User's Lesson */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Lesson */
        Lesson: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Lesson Id */
        LessonId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Last Viewed On */
        LastViewedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.LastViewedOn) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportUserLessonViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportUserLessonViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportUserLessonViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** User's Lesson */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null),
        /** Views */
        Views: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Views) !== null && _c !== void 0 ? _c : null),
        /** Total Time */
        TotalTime: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.TotalTime) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a ReportWorkFlowTaskDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportWorkFlowTaskDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetReportWorkFlowTaskDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** The item in question */
        ItemId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The Lesson of the item */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** The time of the last action on the item */
        LastActionOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LastActionOn) !== null && _d !== void 0 ? _d : null),
        /** Last Updated On */
        LastUpdatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.LastUpdatedOn) !== null && _e !== void 0 ? _e : null),
        /** The Step in the workflow that the change was made on. */
        Step: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Step) !== null && _f !== void 0 ? _f : null, [Validators.minLength(1), Validators.required]),
        /** Who made the change */
        AssignedTo: fb.array([]),
        /** Importance */
        Importance: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _g !== void 0 ? _g : null),
        /** Due Date */
        DueDate: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _h !== void 0 ? _h : null),
        /** Started On */
        StartedOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _j !== void 0 ? _j : null),
        /** Est. Completion Date */
        EstCompletionDate: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.EstCompletionDate) !== null && _k !== void 0 ? _k : null),
        /** Flagged */
        Flagged: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _l !== void 0 ? _l : null, [Validators.required])
    });
}
/**
/* Generates a form from a ReportWorkflowTaskChangesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ReportWorkflowTaskChangesDto from which to create the form.
/* @returns FormGroup
 */
function GetReportWorkflowTaskChangesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The item in question */
        ItemId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The Lesson of the item */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** The time of the change */
        DateTime: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.DateTime) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** The Step in the workflow that the change was made on. */
        Step: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Step) !== null && _e !== void 0 ? _e : null),
        /** Who made the change */
        ExecutedBy: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ExecutedBy) !== null && _f !== void 0 ? _f : null),
        /** The changes made */
        Changes: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Changes) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a RequestAccessDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RequestAccessDto from which to create the form.
/* @returns FormGroup
 */
function GetRequestAccessDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Last Lesson */
        LastName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** First Lesson */
        FirstName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The	email address requesting access */
        EmailAddress: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** The Site that is making the access request */
        RequestingSiteUrl: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RequestingSiteUrl) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** The id of the client making the request */
        ClientId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a RequestLessonRightsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RequestLessonRightsDto from which to create the form.
/* @returns FormGroup
 */
function GetRequestLessonRightsDtoForm(fb, dto) {
    return fb.group({
        /** The list of lessons that the current user is requesting rights information for. */
        LessonIds: fb.array([])
    });
}
/**
/* Generates a form from a RequestProjectMatchDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RequestProjectMatchDto from which to create the form.
/* @returns FormGroup
 */
function GetRequestProjectMatchDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** List of Project Job Ids to match */
        ProjectJobIds: fb.array([])
    });
}
/**
/* Generates a form from a RequestResetPasswordDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RequestResetPasswordDto from which to create the form.
/* @returns FormGroup
 */
function GetRequestResetPasswordDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The email address to send the password reset token to. */
        Email: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** The Url to use for the link for reset completion */
        ResetUrl: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ResetUrl) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The client */
        ClientId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a RequestSalesTaxExemptionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RequestSalesTaxExemptionDto from which to create the form.
/* @returns FormGroup
 */
function GetRequestSalesTaxExemptionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the address the default for the user */
        Default: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Default) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Is the address the billing address for the user */
        Billing: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Billing) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Is the address the shipping address for the user */
        Shipping: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Shipping) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Street 1 */
        Street1: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Street1) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Street 2 */
        Street2: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Street2) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** City */
        City: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.City) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** State */
        State: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.State) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(3)]),
        /** Postal/Zip Code */
        PostalCode: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PostalCode) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(15)]),
        /** Country */
        Country: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(2), Validators.required]),
        /** Sales Tax Id to exempt */
        SalesTaxId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.SalesTaxId) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Contact Id = null if not yet a contact */
        ContactId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.ContactId) !== null && _m !== void 0 ? _m : null),
        /** Contact Types */
        ContactType: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ContactType) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Organization Lesson if ContactType = Organization  - Must match on file if Contact Id specified */
        OrganizationName: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.OrganizationName) !== null && _p !== void 0 ? _p : null),
        /** First Lesson if ContactType = User - Must match on file if Contact Id specified */
        FirstName: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _q !== void 0 ? _q : null),
        /** Last Lesson  if ContactType = User - Must match on file if Contact Id specified */
        LastName: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _r !== void 0 ? _r : null),
        /** Contact Email Address - Always required, if existing org, must be linked to an org admin otherwise created as an org admin. */
        EmailAddress: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _s !== void 0 ? _s : null, [Validators.email]),
        /** Contact phone # - Always required, if existing org, must be linked to an org admin otherwise created as an org admin. */
        PhoneNumber: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _t !== void 0 ? _t : null),
        /** Marketing Campaign Sources (How did you hear about us?) */
        HowDidYouHearAboutUs: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUs) !== null && _u !== void 0 ? _u : null),
        /** Password */
        Password: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _v !== void 0 ? _v : null, [IsValidPassword]),
        /** Exemption Number */
        ExemptionNumber: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.ExemptionNumber) !== null && _w !== void 0 ? _w : null),
        /** Starts On */
        StartsOn: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _x !== void 0 ? _x : null, [Validators.required]),
        /** Expires On */
        ExpiresOn: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.ExpiresOn) !== null && _y !== void 0 ? _y : null),
        /** SSO Provider */
        Provider: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _z !== void 0 ? _z : null),
        /** SSO Provider Key */
        ProviderKey: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.ProviderKey) !== null && _0 !== void 0 ? _0 : null),
        /** SSO External Access Token */
        ExternalAccessToken: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.ExternalAccessToken) !== null && _1 !== void 0 ? _1 : null),
        /** The exemption certificate issued by the governing body. */
        File: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.File) !== null && _2 !== void 0 ? _2 : null)
    });
}
/**
/* Generates a form from a RequestVerifyEduDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original RequestVerifyEduDto from which to create the form.
/* @returns FormGroup
 */
function GetRequestVerifyEduDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** First Lesson */
        FirstName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Last Lesson */
        LastName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.email, Validators.required])
    });
}
/**
/* Generates a form from a ResetPasswordDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ResetPasswordDto from which to create the form.
/* @returns FormGroup
 */
function GetResetPasswordDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The email address of the user that wishes to reset their password */
        Email: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** The code to validate the password reset. */
        Code: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Code) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The new password to set */
        Password: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _c !== void 0 ? _c : null, [Validators.minLength(6), Validators.maxLength(15), IsValidPassword, Validators.required]),
        /** The confirmation of the new password to set. */
        ConfirmPassword: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _d !== void 0 ? _d : null, [Validators.minLength(6), Validators.maxLength(15), Validators.required]),
        /** The client that is executing the reset */
        ClientId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a ResourceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ResourceDto from which to create the form.
/* @returns FormGroup
 */
function GetResourceDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** The language of the item */
        LanguageCode: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _g !== void 0 ? _g : null),
        /** The Uri to download the resource */
        Uri: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Uri) !== null && _h !== void 0 ? _h : null),
        /** Resource Types */
        Type: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** The file name if any of the resource */
        FileName: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.FileName) !== null && _k !== void 0 ? _k : null),
        /** The size of the resource */
        Size: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Size) !== null && _l !== void 0 ? _l : null),
        /** the last time it was uploaded */
        DateTimeFileUpdated: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.DateTimeFileUpdated) !== null && _m !== void 0 ? _m : null),
        /** Resource Locations */
        Location: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Any child resources of this parent */
        ChildResources: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.ChildResources) === null || _p === void 0 ? void 0 : _p.map(x => GetChildResourceDtoForm(fb, x))) !== null && _q !== void 0 ? _q : []),
        /** The Organization that owns the course */
        OwningOrganizationId: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _r !== void 0 ? _r : null),
        /** Directions */
        Directions: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Directions) !== null && _s !== void 0 ? _s : null)
    });
}
/**
/* Generates a form from a ResourceLocatorDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ResourceLocatorDto from which to create the form.
/* @returns FormGroup
 */
function GetResourceLocatorDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The Id of the Resource */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson of the Resource */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Uri */
        Uri: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Uri) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Resource Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Size */
        Size: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Size) !== null && _f !== void 0 ? _f : null),
        /** File Lesson if Any */
        FileName: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.FileName) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a ResourceViewDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ResourceViewDto from which to create the form.
/* @returns FormGroup
 */
function GetResourceViewDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The Lesson Viewed */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null),
        /** The originating Course */
        CourseId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _b !== void 0 ? _b : null),
        /** The Topic */
        TopicId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _c !== void 0 ? _c : null),
        /** Product Id */
        ProductId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _d !== void 0 ? _d : null),
        /** Version Id */
        VersionId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _e !== void 0 ? _e : null),
        /** Project Id */
        ProjectId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ProjectId) !== null && _f !== void 0 ? _f : null),
        /** Playlist Id */
        PlaylistId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.PlaylistId) !== null && _g !== void 0 ? _g : null),
        /** The client viewing the lesson */
        ClientId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _h !== void 0 ? _h : null),
        /** Resource Id */
        ResourceId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ResourceId) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a ResourceWithParentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ResourceWithParentDto from which to create the form.
/* @returns FormGroup
 */
function GetResourceWithParentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** The language of the item */
        LanguageCode: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _g !== void 0 ? _g : null),
        /** The Uri to download the resource */
        Uri: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Uri) !== null && _h !== void 0 ? _h : null),
        /** Resource Types */
        Type: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** The file name if any of the resource */
        FileName: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.FileName) !== null && _k !== void 0 ? _k : null),
        /** The size of the resource */
        Size: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Size) !== null && _l !== void 0 ? _l : null),
        /** the last time it was uploaded */
        DateTimeFileUpdated: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.DateTimeFileUpdated) !== null && _m !== void 0 ? _m : null),
        /** Resource Locations */
        Location: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Any child resources of this parent */
        ChildResources: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.ChildResources) === null || _p === void 0 ? void 0 : _p.map(x => GetChildResourceDtoForm(fb, x))) !== null && _q !== void 0 ? _q : []),
        /** The Organization that owns the course */
        OwningOrganizationId: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.OwningOrganizationId) !== null && _r !== void 0 ? _r : null),
        /** Directions */
        Directions: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Directions) !== null && _s !== void 0 ? _s : null),
        /** The parents of the resource */
        Parents: fb.array([])
    });
}
/**
/* Generates a form from a ResourcesByTypeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ResourcesByTypeDto from which to create the form.
/* @returns FormGroup
 */
function GetResourcesByTypeDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Resource Types */
        ResourceType: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ResourceType) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The string name of the type */
        Type: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _b !== void 0 ? _b : null),
        /** Is the resource type expanded */
        Expanded: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The resources under the type */
        Resources: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Resources) === null || _d === void 0 ? void 0 : _d.map(x => GetResourceLocatorDtoForm(fb, x))) !== null && _e !== void 0 ? _e : [])
    });
}
/**
/* Generates a form from a SalesTaxDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SalesTaxDto from which to create the form.
/* @returns FormGroup
 */
function GetSalesTaxDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Does the sales tax require that shipping be included in the calculation? */
        IncludesShipping: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.IncludesShipping) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The country for which the sales tax is applicable */
        Country: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(2), Validators.required]),
        /** The state/province for which the sales tax is applicable */
        State: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.State) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(3), Validators.required]),
        /** The tax rate as a percentage */
        Rate: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Rate) !== null && _f !== void 0 ? _f : null),
        /** Specifies the provider to use */
        Provider: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _g !== void 0 ? _g : null),
        /** Specifies the Provider Id */
        ProviderId: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ProviderId) !== null && _h !== void 0 ? _h : null),
        /** Specifies the identifier to use for the provider */
        ProviderTaxIdentifier: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ProviderTaxIdentifier) !== null && _j !== void 0 ? _j : null)
    });
}
/**
/* Generates a form from a SalesTaxExemptRequestResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SalesTaxExemptRequestResultDto from which to create the form.
/* @returns FormGroup
 */
function GetSalesTaxExemptRequestResultDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The reference request Id */
        RequestId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.RequestId) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a SalesTaxExemptionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SalesTaxExemptionDto from which to create the form.
/* @returns FormGroup
 */
function GetSalesTaxExemptionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;
    return fb.group({
        /** Sales Tax Id */
        SalesTaxId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SalesTaxId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Sales Tax Lesson */
        SalesTax: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.SalesTax) !== null && _b !== void 0 ? _b : null),
        /** Contact Id */
        ContactId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ContactId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Contact Types */
        ContactType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ContactType) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Exemption Number */
        ExemptionNumber: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ExemptionNumber) !== null && _e !== void 0 ? _e : null),
        /** Image of Certificate Uri */
        CertificateUri: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CertificateUri) !== null && _f !== void 0 ? _f : null),
        /** Sales Tax Exemption */
        Verified: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Verified) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Verified By */
        VerifiedBy: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.VerifiedBy) !== null && _h !== void 0 ? _h : null),
        /** Verified By User Id */
        VerifiedById: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.VerifiedById) !== null && _j !== void 0 ? _j : null),
        /** Deleted */
        Deleted: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Deleted) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** RequestId */
        RequestId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.RequestId) !== null && _l !== void 0 ? _l : null),
        /** Requesting User */
        RequestedBy: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.RequestedBy) !== null && _m !== void 0 ? _m : null),
        /** Requesting User Id */
        RequestedById: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.RequestedById) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Rejected */
        Rejected: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Rejected) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Rejection Reason */
        RejectionReason: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.RejectionReason) !== null && _q !== void 0 ? _q : null),
        /** Rejected By User */
        RejectedBy: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.RejectedBy) !== null && _r !== void 0 ? _r : null),
        /** Rejected By User Id */
        RejectedById: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.RejectedById) !== null && _s !== void 0 ? _s : null),
        /** Starts On */
        StartsOn: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.StartsOn) !== null && _t !== void 0 ? _t : null, [Validators.required]),
        /** Expires On */
        ExpiresOn: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.ExpiresOn) !== null && _u !== void 0 ? _u : null)
    });
}
/**
/* Generates a form from a SalesTaxLineItemDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SalesTaxLineItemDto from which to create the form.
/* @returns FormGroup
 */
function GetSalesTaxLineItemDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** SKU */
        SKU: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _a !== void 0 ? _a : null),
        /** Inventory Id */
        InventoryId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InventoryId) !== null && _b !== void 0 ? _b : null),
        /** Price */
        Price: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Price) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Units */
        Units: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Units) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a SalesTaxProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SalesTaxProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetSalesTaxProviderDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson of Provider */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** Interface defined in code */
        Interface: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Interface) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required])
    });
}
/**
/* Generates a form from a SalesTaxRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SalesTaxRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetSalesTaxRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the address the default for the user */
        Default: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Default) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Is the address the billing address for the user */
        Billing: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Billing) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Is the address the shipping address for the user */
        Shipping: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Shipping) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Street 1 */
        Street1: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Street1) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Street 2 */
        Street2: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Street2) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** City */
        City: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.City) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** State */
        State: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.State) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(3)]),
        /** Postal/Zip Code */
        PostalCode: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PostalCode) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(15)]),
        /** Country */
        Country: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(2), Validators.required]),
        /** Contact Id */
        ContactId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.ContactId) !== null && _l !== void 0 ? _l : null),
        /** Contact Types */
        ContactType: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.ContactType) !== null && _m !== void 0 ? _m : null),
        /** Shipping Amount */
        ShippingAmount: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ShippingAmount) !== null && _o !== void 0 ? _o : null),
        /** Items */
        Items: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _p === void 0 ? void 0 : _p.map(x => GetSalesTaxLineItemDtoForm(fb, x))) !== null && _q !== void 0 ? _q : [])
    });
}
/**
/* Generates a form from a SalesTaxResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SalesTaxResultDto from which to create the form.
/* @returns FormGroup
 */
function GetSalesTaxResultDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Sales Tax Id */
        SalesTaxId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SalesTaxId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Sales Tax */
        SalesTax: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.SalesTax) !== null && _b !== void 0 ? _b : null),
        /** Amount of Sales Tax to be applied */
        Amount: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Amount) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a ScheduleReportDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ScheduleReportDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetScheduleReportDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization Automated Report Types */
        Report: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Report) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Report Schedules */
        Schedule: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Schedule) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Recipients */
        Recipients: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Recipients) === null || _e === void 0 ? void 0 : _e.map(x => GetScheduleReportRecipientsDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Started On */
        StartedOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Next time the report will be run. */
        NextRunOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.NextRunOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Last Run On */
        LastRunOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.LastRunOn) !== null && _j !== void 0 ? _j : null)
    });
}
/**
/* Generates a form from a ScheduleReportDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ScheduleReportDto from which to create the form.
/* @returns FormGroup
 */
function GetScheduleReportDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization Automated Report Types */
        Report: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Report) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Report Schedules */
        Schedule: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Schedule) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Recipients */
        Recipients: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Recipients) === null || _e === void 0 ? void 0 : _e.map(x => GetScheduleReportRecipientsDtoForm(fb, x))) !== null && _f !== void 0 ? _f : [])
    });
}
/**
/* Generates a form from a ScheduleReportRecipientsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ScheduleReportRecipientsDto from which to create the form.
/* @returns FormGroup
 */
function GetScheduleReportRecipientsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Existing User */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** Lesson of external user */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(255)]),
        /** Email address of external user */
        EmailAddress: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(400), Validators.email])
    });
}
/**
/* Generates a form from a SearchFilterDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SearchFilterDto from which to create the form.
/* @returns FormGroup
 */
function GetSearchFilterDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Item Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Item Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Selected */
        Selected: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Selected) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a SendEmailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SendEmailDto from which to create the form.
/* @returns FormGroup
 */
function GetSendEmailDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Users to send the message to */
        UserIds: fb.array([]),
        /** The subject of the email */
        Subject: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Subject) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** The body of the email */
        Body: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Body) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a SetCourseItemEditingStatusDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SetCourseItemEditingStatusDto from which to create the form.
/* @returns FormGroup
 */
function GetSetCourseItemEditingStatusDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2;
    return fb.group({
        /** The identifier used for linking the tree. */
        Identifier: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Identifier) !== null && _a !== void 0 ? _a : null),
        /** Is the item expanded */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The parent Id */
        ParentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _c !== void 0 ? _c : null),
        /** The Item linked to */
        ItemId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Resource Types */
        ResourceType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ResourceType) !== null && _f !== void 0 ? _f : null),
        /** Lesson */
        Name: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _g !== void 0 ? _g : null),
        /** The description */
        Description: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _h !== void 0 ? _h : null),
        /** The length of the video associated */
        Length: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _j !== void 0 ? _j : null),
        /** The original Itme that this one is based upon */
        OriginalItemId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.OriginalItemId) !== null && _k !== void 0 ? _k : null),
        /** Item Change status for KAMS */
        EditingStatus: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EditingStatus) !== null && _l !== void 0 ? _l : null),
        /** Is this a new feature? */
        NewFeature: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.NewFeature) !== null && _m !== void 0 ? _m : null),
        /** Order */
        Order: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Workflow step name */
        WorkflowStep: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _p !== void 0 ? _p : null),
        /** Assignees for the step */
        Assignees: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Assignees) !== null && _q !== void 0 ? _q : null),
        /** Is the content the current organization's? */
        IsOwnContent: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.IsOwnContent) !== null && _r !== void 0 ? _r : null),
        /** Labels */
        Labels: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Labels) !== null && _s !== void 0 ? _s : null),
        /** Due Date */
        DueDate: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _t !== void 0 ? _t : null),
        /** Flagged */
        Flagged: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Importance */
        Importance: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _v !== void 0 ? _v : null),
        /** Number of Questions */
        Questions: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Questions) !== null && _w !== void 0 ? _w : null),
        /** Versions */
        Versions: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.Versions) !== null && _x !== void 0 ? _x : null),
        /** Is Waiting For Customer Approval */
        IsWaitingForCustomerApproval: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForCustomerApproval) !== null && _y !== void 0 ? _y : null),
        /** Is Waiting For Question Team */
        IsWaitingForContentTeam: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForContentTeam) !== null && _z !== void 0 ? _z : null),
        /** Child Items */
        ChildItems: fb.array((_1 = (_0 = dto === null || dto === void 0 ? void 0 : dto.ChildItems) === null || _0 === void 0 ? void 0 : _0.map(x => GetCourseStructureForEditingDtoForm(fb, x))) !== null && _1 !== void 0 ? _1 : []),
        /** Item Change status for KAMS */
        NewStatus: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.NewStatus) !== null && _2 !== void 0 ? _2 : null, [Validators.required])
    });
}
/**
/* Generates a form from a SetDisciplinesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SetDisciplinesDto from which to create the form.
/* @returns FormGroup
 */
function GetSetDisciplinesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Id */
        Disciplines: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _b === void 0 ? void 0 : _b.map(x => GetDisciplineWithProductsDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a SetLanguageDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SetLanguageDto from which to create the form.
/* @returns FormGroup
 */
function GetSetLanguageDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Project Id to Set */
        LanguageCode: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a SetLessonUserRatingRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SetLessonUserRatingRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetSetLessonUserRatingRequestDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Rating */
        Rating: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Rating) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a SetLessonUserRatingResponseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SetLessonUserRatingResponseDto from which to create the form.
/* @returns FormGroup
 */
function GetSetLessonUserRatingResponseDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Rating */
        LessonRating: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.LessonRating) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a SetOrganizationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SetOrganizationDto from which to create the form.
/* @returns FormGroup
 */
function GetSetOrganizationDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The Organization that the user should be set to. */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null)
    });
}
/**
/* Generates a form from a SetProjectDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SetProjectDto from which to create the form.
/* @returns FormGroup
 */
function GetSetProjectDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Project Id to Set */
        ProjectId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProjectId) !== null && _a !== void 0 ? _a : null)
    });
}
/**
/* Generates a form from a SetTopicItemEditingStatusDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SetTopicItemEditingStatusDto from which to create the form.
/* @returns FormGroup
 */
function GetSetTopicItemEditingStatusDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0;
    return fb.group({
        /** The identifier used for linking the tree. */
        Identifier: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Identifier) !== null && _a !== void 0 ? _a : null),
        /** Is the item expanded */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The parent Id */
        ParentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _c !== void 0 ? _c : null),
        /** The Item linked to */
        ItemId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Resource Types */
        ResourceType: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ResourceType) !== null && _f !== void 0 ? _f : null),
        /** Lesson */
        Name: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _g !== void 0 ? _g : null),
        /** The description */
        Description: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _h !== void 0 ? _h : null),
        /** The length of the video associated */
        Length: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _j !== void 0 ? _j : null),
        /** The original Itme that this one is based upon */
        OriginalItemId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.OriginalItemId) !== null && _k !== void 0 ? _k : null),
        /** Item Change status for KAMS */
        EditingStatus: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EditingStatus) !== null && _l !== void 0 ? _l : null),
        /** Is this a new feature? */
        NewFeature: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.NewFeature) !== null && _m !== void 0 ? _m : null),
        /** Order */
        Order: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Workflow step name */
        WorkflowStep: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _p !== void 0 ? _p : null),
        /** Assignees for the step */
        Assignees: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Assignees) !== null && _q !== void 0 ? _q : null),
        /** Is the content the current organization's? */
        IsOwnContent: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.IsOwnContent) !== null && _r !== void 0 ? _r : null),
        /** Labels */
        Labels: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Labels) !== null && _s !== void 0 ? _s : null),
        /** Due Date */
        DueDate: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _t !== void 0 ? _t : null),
        /** Flagged */
        Flagged: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Importance */
        Importance: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _v !== void 0 ? _v : null),
        /** Number of Questions */
        Questions: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Questions) !== null && _w !== void 0 ? _w : null),
        /** Versions */
        Versions: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.Versions) !== null && _x !== void 0 ? _x : null),
        /** Is Waiting For Customer Approval */
        IsWaitingForCustomerApproval: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForCustomerApproval) !== null && _y !== void 0 ? _y : null),
        /** Is Waiting For Question Team */
        IsWaitingForContentTeam: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.IsWaitingForContentTeam) !== null && _z !== void 0 ? _z : null),
        /** Item Change status for KAMS */
        NewStatus: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.NewStatus) !== null && _0 !== void 0 ? _0 : null, [Validators.required])
    });
}
/**
/* Generates a form from a SharepointFileDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SharepointFileDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetSharepointFileDetailsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Document Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** Url */
        Url: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Url) !== null && _b !== void 0 ? _b : null),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a ShipInvoiceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ShipInvoiceDto from which to create the form.
/* @returns FormGroup
 */
function GetShipInvoiceDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Invoice to Ship */
        InvoiceId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a ShippingMethodDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ShippingMethodDto from which to create the form.
/* @returns FormGroup
 */
function GetShippingMethodDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the shipping method */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** The account # with the provider */
        AccountNo: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.AccountNo) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Shipping Providers */
        Provider: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a ShortContentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ShortContentDto from which to create the form.
/* @returns FormGroup
 */
function GetShortContentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The length of video for the content item */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a ShortContentWithViewsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ShortContentWithViewsDto from which to create the form.
/* @returns FormGroup
 */
function GetShortContentWithViewsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The length of video for the content item */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Number of views */
        Views: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Views) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a ShortCourseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ShortCourseDto from which to create the form.
/* @returns FormGroup
 */
function GetShortCourseDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The length of video for the content item */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Featured Lesson */
        FeaturedLessonId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.FeaturedLessonId) !== null && _f !== void 0 ? _f : null),
        /** Is The course a workflow? */
        Workflow: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Workflow) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a ShortLessonWithCoursesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original ShortLessonWithCoursesDto from which to create the form.
/* @returns FormGroup
 */
function GetShortLessonWithCoursesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** The description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** The length of video for the content item */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        Type: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Courses for the lesson */
        Courses: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Courses) === null || _f === void 0 ? void 0 : _f.map(x => GetShortContentDtoForm(fb, x))) !== null && _g !== void 0 ? _g : [])
    });
}
/**
/* Generates a form from a SiteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SiteDto from which to create the form.
/* @returns FormGroup
 */
function GetSiteDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Domain */
        Domain: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Domain) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(75)])
    });
}
/**
/* Generates a form from a SkillsGapDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SkillsGapDto from which to create the form.
/* @returns FormGroup
 */
function GetSkillsGapDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Medallion Id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Medallion Lesson */
        Medallion: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Medallion) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** History data for the spark line */
        History: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.History) === null || _c === void 0 ? void 0 : _c.map(x => GetCompletionHistoryDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a SmbRollupSubscriptionRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SmbRollupSubscriptionRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetSmbRollupSubscriptionRequestDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Date to run */
        Date: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is a test run. */
        Test: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Test) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization Id to run */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a SmbRollupSubscriptionResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SmbRollupSubscriptionResultDto from which to create the form.
/* @returns FormGroup
 */
function GetSmbRollupSubscriptionResultDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** Organization Id to run */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Lesson */
        Organization: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _b !== void 0 ? _b : null),
        /** Date to run */
        Date: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Date) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Is a test run. */
        Test: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Test) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Invoice */
        Invoice: GetInvoiceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Invoice),
        /** Invoice Inventory as apart of the rollup */
        InvoiceInventory: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.InvoiceInventory) === null || _e === void 0 ? void 0 : _e.map(x => GetInvoiceInventoryDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** User Subscription Creation Result Codes */
        Result: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Result) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Result Message */
        Message: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Message) !== null && _h !== void 0 ? _h : null)
    });
}
/**
/* Generates a form from a StaticPageTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original StaticPageTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetStaticPageTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Page Lesson */
        PageName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PageName) !== null && _a !== void 0 ? _a : null),
        /** Language Code */
        LanguageCode: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _b !== void 0 ? _b : null),
        /** Translated Fields */
        Fields: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Fields) === null || _c === void 0 ? void 0 : _c.map(x => GetStaticPageTranslationFieldsDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a StaticPageTranslationFieldsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original StaticPageTranslationFieldsDto from which to create the form.
/* @returns FormGroup
 */
function GetStaticPageTranslationFieldsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Tag */
        Tag: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Tag) !== null && _a !== void 0 ? _a : null),
        /** Localized Value */
        Value: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Value) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a StaticPageTranslationWithLanguagesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original StaticPageTranslationWithLanguagesDto from which to create the form.
/* @returns FormGroup
 */
function GetStaticPageTranslationWithLanguagesDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Page Lesson */
        PageName: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PageName) !== null && _a !== void 0 ? _a : null),
        /** Languages */
        Languages: fb.array([])
    });
}
/**
/* Generates a form from a StoredPaymentCredentialDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original StoredPaymentCredentialDto from which to create the form.
/* @returns FormGroup
 */
function GetStoredPaymentCredentialDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Payment Method Id */
        PaymentMethodId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PaymentMethodId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Payment Method */
        PaymentMethod: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.PaymentMethod) !== null && _c !== void 0 ? _c : null),
        /** Organization Id (null if attached to a user) */
        OrganizationId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _d !== void 0 ? _d : null),
        /** Organization (null if attached to a user) */
        Organization: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _e !== void 0 ? _e : null),
        /** User Id (null if attached to an organization) */
        UserId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _f !== void 0 ? _f : null),
        /** User (null if attached to an organization) */
        User: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _g !== void 0 ? _g : null),
        /** The reference number with the processor used to make a payment etc. with the credentials */
        ProcessorReferenceNumber: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ProcessorReferenceNumber) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** Merchant Payment Profile Id */
        SubProcessorReferenceNumber: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.SubProcessorReferenceNumber) !== null && _j !== void 0 ? _j : null),
        /** Card or Account Holder Lesson */
        CardHolderName: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.CardHolderName) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** The masked identifier (either card # or Account # masked) */
        MaskedIdentifier: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.MaskedIdentifier) !== null && _l !== void 0 ? _l : null, [Validators.minLength(0), Validators.maxLength(24), Validators.required]),
        /** The expiry year if any */
        ExpiryYear: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.ExpiryYear) !== null && _m !== void 0 ? _m : null),
        /** The expiry month if any */
        ExpiryMonth: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ExpiryMonth) !== null && _o !== void 0 ? _o : null),
        /** Billing Address Id */
        BillingAddressId: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Is stored credential deleted */
        Deleted: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Deleted) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** Contact Types */
        ContactType: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.ContactType) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** The Contact Id associated with the stored credentials */
        ContactId: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.ContactId) !== null && _s !== void 0 ? _s : null, [Validators.required])
    });
}
/**
/* Generates a form from a SubmitQuoteDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SubmitQuoteDto from which to create the form.
/* @returns FormGroup
 */
function GetSubmitQuoteDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** Rfq Id */
        RfqId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.RfqId) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a SupportAnswerDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SupportAnswerDto from which to create the form.
/* @returns FormGroup
 */
function GetSupportAnswerDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Answer */
        Answer: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Answer) !== null && _b !== void 0 ? _b : null),
        /** Active */
        Active: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a SupportQuestionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SupportQuestionDto from which to create the form.
/* @returns FormGroup
 */
function GetSupportQuestionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question */
        Question: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Question) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Support Answer Id */
        SupportAnswerId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.SupportAnswerId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Support Answer */
        SupportAnswer: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.SupportAnswer) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Active */
        Active: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a SyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetSyndicationProviderDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required])
    });
}
/**
/* Generates a form from a SyndicationProviderImplementationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SyndicationProviderImplementationDto from which to create the form.
/* @returns FormGroup
 */
function GetSyndicationProviderImplementationDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The syndication provider id */
        SyndicationProviderId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the syndication provider */
        SyndicationProvider: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _b !== void 0 ? _b : null),
        /** Syndication Methods */
        Method: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The Interface used to execute these types of syndications */
        Interface: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Interface) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required])
    });
}
/**
/* Generates a form from a SystemMessageDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SystemMessageDto from which to create the form.
/* @returns FormGroup
 */
function GetSystemMessageDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Title */
        Title: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(128), Validators.required]),
        /** Message */
        Message: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Message) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a SystemSettingDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original SystemSettingDto from which to create the form.
/* @returns FormGroup
 */
function GetSystemSettingDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Lesson */
        Name: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _a !== void 0 ? _a : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** Value */
        Value: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Value) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(250)]),
        /** Delta */
        Delta: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Delta) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(1024)]),
        /** Date Time instead of value */
        DateTime: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.DateTime) !== null && _d !== void 0 ? _d : null),
        /** When was the setting set? */
        SetOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SetOn) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a TimeSavedAcrossOrganizationResultDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TimeSavedAcrossOrganizationResultDto from which to create the form.
/* @returns FormGroup
 */
function GetTimeSavedAcrossOrganizationResultDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Time Saved */
        Time: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Time) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Start Date */
        StartDate: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.StartDate) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** End Date */
        EndDate: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.EndDate) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a TokenDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TokenDto from which to create the form.
/* @returns FormGroup
 */
function GetTokenDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The unique identifier for the token */
        TokenId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.TokenId) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Issued On */
        IssuedOn: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.IssuedOn) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Redeemed On */
        RedeemedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RedeemedOn) !== null && _d !== void 0 ? _d : null),
        /** Redeemed By Id */
        RedeemedById: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.RedeemedById) !== null && _e !== void 0 ? _e : null),
        /** Redeemed By */
        RedeemedBy: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.RedeemedBy) !== null && _f !== void 0 ? _f : null),
        /** Cancelled On */
        CancelledOn: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.CancelledOn) !== null && _g !== void 0 ? _g : null),
        /** Cancelled By Id */
        CancelledById: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.CancelledById) !== null && _h !== void 0 ? _h : null),
        /** Cancelled By Lesson */
        CancelledBy: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.CancelledBy) !== null && _j !== void 0 ? _j : null),
        /** Expires On */
        ExpiresOn: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.ExpiresOn) !== null && _k !== void 0 ? _k : null),
        /** Invoice Inventory Id */
        InvoiceInventoryId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.InvoiceInventoryId) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** The Invoice Id */
        InvoiceId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Invoice Inventory */
        InvoiceInventory: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.InvoiceInventory) !== null && _o !== void 0 ? _o : null),
        /** Invoice # */
        InvoiceNumber: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.InvoiceNumber) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _q !== void 0 ? _q : null),
        /** The Organization assigned the token for distribution if any */
        Organization: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _r !== void 0 ? _r : null)
    });
}
/**
/* Generates a form from a TopicActivityDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TopicActivityDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetTopicActivityDetailDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Length */
        Length: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a TopicAdminDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TopicAdminDto from which to create the form.
/* @returns FormGroup
 */
function GetTopicAdminDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** Content Preface */
        Introduction: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Introduction) !== null && _h !== void 0 ? _h : null),
        /** The conclusion of the item */
        Conclusion: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Conclusion) !== null && _j !== void 0 ? _j : null),
        /** Length */
        Length: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _l !== void 0 ? _l : null),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _m !== void 0 ? _m : null),
        /** Started On */
        StartedOn: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _o !== void 0 ? _o : null),
        /** Due Date */
        DueDate: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _p !== void 0 ? _p : null),
        /** Estimated Completion Date */
        EstCompletionDate: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.EstCompletionDate) !== null && _q !== void 0 ? _q : null),
        /** Importance */
        Importance: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _r !== void 0 ? _r : null),
        /** Flagged */
        Flagged: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _s !== void 0 ? _s : null, [Validators.required])
    });
}
/**
/* Generates a form from a TopicAtAGlanceReportDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TopicAtAGlanceReportDto from which to create the form.
/* @returns FormGroup
 */
function GetTopicAtAGlanceReportDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** Topic Lesson */
        Topic: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Topic) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Topic Id */
        TopicId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Topic Workflow Step */
        TopicWorkflowStep: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.TopicWorkflowStep) !== null && _c !== void 0 ? _c : null),
        /** Topic WOrkflow Step Id */
        TopicWorkflowStepId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.TopicWorkflowStepId) !== null && _d !== void 0 ? _d : null),
        /** Number of Lessons in Writing */
        Writing: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Writing) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Number of Lessons in Copy Edit */
        CopyEdit: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CopyEdit) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Number of Lessons  in Narration */
        Narration: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Narration) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Number of Lessons in Video Recording */
        VideoRecording: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.VideoRecording) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Number of Lessons in Video Edit */
        VideoEdit: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.VideoEdit) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Number of Lessons in Video Q/A 1 */
        VideoQA1: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.VideoQA1) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Number of Lessons in Video Q/A 2 */
        VideoQA2: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.VideoQA2) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Number of Lessons in Create Sub Titles */
        CreateSubTitles: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.CreateSubTitles) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Number of Lessons in Review and Sign Off */
        ReviewAndSignOff: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ReviewAndSignOff) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Number of Lessons Completed */
        Complete: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Complete) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Total Lessons across all steps */
        Total: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.Total) !== null && _q !== void 0 ? _q : null, [Validators.required])
    });
}
/**
/* Generates a form from a TopicDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TopicDto from which to create the form.
/* @returns FormGroup
 */
function GetTopicDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the item */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The description of the item */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Is the item published or not */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** When was the item created? */
        CreatedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** When was the item updated? */
        UpdatedOn: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Any tags used for search optimization */
        Tags: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _g !== void 0 ? _g : null),
        /** Content Preface */
        Introduction: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Introduction) !== null && _h !== void 0 ? _h : null),
        /** The conclusion of the item */
        Conclusion: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Conclusion) !== null && _j !== void 0 ? _j : null),
        /** Length */
        Length: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Notes */
        Notes: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _l !== void 0 ? _l : null),
        /** Jira Issue Link */
        JiraIssueLink: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.JiraIssueLink) !== null && _m !== void 0 ? _m : null)
    });
}
/**
/* Generates a form from a TopicSyndicationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TopicSyndicationDto from which to create the form.
/* @returns FormGroup
 */
function GetTopicSyndicationDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Topic id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndication Types */
        Type: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a TopicSyndicationProviderDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TopicSyndicationProviderDto from which to create the form.
/* @returns FormGroup
 */
function GetTopicSyndicationProviderDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Topic id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Organization */
        Organization: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _c !== void 0 ? _c : null),
        /** Syndication Methods */
        Method: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Method) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Syndication Provider Id */
        SyndicationProviderId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.SyndicationProviderId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Syndication Provider Lesson */
        SyndicationProvider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.SyndicationProvider) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a TopicTranslationDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TopicTranslationDto from which to create the form.
/* @returns FormGroup
 */
function GetTopicTranslationDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** Course Id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Topic: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Topic) !== null && _b !== void 0 ? _b : null),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** Is the translation Active */
        Active: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Tags */
        Tags: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _e !== void 0 ? _e : null),
        /** Lesson */
        Name: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null),
        /** Preface */
        Introduction: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Introduction) !== null && _h !== void 0 ? _h : null),
        /** Postface */
        Conclusion: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Conclusion) !== null && _j !== void 0 ? _j : null),
        /** Marketing */
        Marketing: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Marketing) !== null && _k !== void 0 ? _k : null),
        /** Meta Keywords */
        MetaKeywords: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.MetaKeywords) !== null && _l !== void 0 ? _l : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** Meta Description */
        MetaDescription: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.MetaDescription) !== null && _m !== void 0 ? _m : null, [Validators.minLength(0), Validators.maxLength(255)])
    });
}
/**
/* Generates a form from a TopicWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TopicWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetTopicWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The topic id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The topic name */
        Topic: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Topic) !== null && _b !== void 0 ? _b : null),
        /** The User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null),
        /** The name of the user */
        User: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _d !== void 0 ? _d : null),
        /** The Role Id */
        RoleId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** The Role */
        Role: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _f !== void 0 ? _f : null),
        /** Description */
        Description: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _g !== void 0 ? _g : null)
    });
}
/**
/* Generates a form from a TranslationErrorDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TranslationErrorDto from which to create the form.
/* @returns FormGroup
 */
function GetTranslationErrorDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** User Lesson */
        User: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _a !== void 0 ? _a : null),
        /** Reporter User Id */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Time of Report */
        TimeStamp: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.TimeStamp) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Item Id */
        ItemId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a TranslationWorkflowAssigneeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original TranslationWorkflowAssigneeDto from which to create the form.
/* @returns FormGroup
 */
function GetTranslationWorkflowAssigneeDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Parent Id */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Id */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _c !== void 0 ? _c : null),
        /** Role Id */
        RoleId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Role Lesson */
        Role: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _e !== void 0 ? _e : null),
        /** Description */
        Description: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a UpdateAnswerSuggestedLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAnswerSuggestedLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAnswerSuggestedLessonsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The answer to update */
        AnswerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Lessons to be assigned to the Answer. */
        Lessons: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _b === void 0 ? void 0 : _b.map(x => GetAnswerLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateAnswersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAnswersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAnswersDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Question Id */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Answers */
        Answers: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Answers) === null || _b === void 0 ? void 0 : _b.map(x => GetAnswerDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateAssessmentBadgesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAssessmentBadgesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAssessmentBadgesDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The assessment to manage */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All of the Badges assigned to the assessment */
        BadgeIds: fb.array([])
    });
}
/**
/* Generates a form from a UpdateAssessmentCoursesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAssessmentCoursesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAssessmentCoursesDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The assessment to manage */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All of the courses assigned to the assessment */
        CourseIds: fb.array([])
    });
}
/**
/* Generates a form from a UpdateAssessmentDynamicItemsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAssessmentDynamicItemsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAssessmentDynamicItemsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /**  */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /**  */
        CourseId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /**  */
        TopicIds: fb.array([]),
        /** Number of Questions */
        NumberOfQuestions: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.NumberOfQuestions) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a UpdateAssessmentMedallionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAssessmentMedallionsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAssessmentMedallionsDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The assessment to manage */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All of the Medallions assigned to the assessment */
        MedallionIds: fb.array([])
    });
}
/**
/* Generates a form from a UpdateAssessmentQuestionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAssessmentQuestionsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAssessmentQuestionsDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The assessment to update */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All of the questions associated with the assessment */
        QuestionIds: fb.array([])
    });
}
/**
/* Generates a form from a UpdateAssessmentWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAssessmentWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAssessmentWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The assessment to update */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The assignees to the Assessment (all of them) */
        Assignees: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Assignees) === null || _b === void 0 ? void 0 : _b.map(x => GetAssessmentWorkflowAssigneesDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateAuthMethodsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateAuthMethodsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateAuthMethodsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The domain that the auth methods belong to */
        DomainId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DomainId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The auth methods to update. Should include all auth methods for the domain as all others will be deleted. */
        AuthMethods: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.AuthMethods) === null || _b === void 0 ? void 0 : _b.map(x => GetAuthMethodAdminDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateBadgeGroupsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateBadgeGroupsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateBadgeGroupsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Badge Id */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Groups */
        Groups: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _c === void 0 ? void 0 : _c.map(x => GetBadgeGroupDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateBadgeHeaderLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateBadgeHeaderLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateBadgeHeaderLessonsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Badge Id */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Header Lessons */
        HeaderLessons: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _b === void 0 ? void 0 : _b.map(x => GetBadgeHeaderLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateBadgeLessonDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateBadgeLessonDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateBadgeLessonDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The question to update */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Lesson Ids of all lessons associated with the badge */
        Lessons: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _b === void 0 ? void 0 : _b.map(x => GetBadgeLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateBadgeSyndicationProvidersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateBadgeSyndicationProvidersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateBadgeSyndicationProvidersDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Badge Id */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _b === void 0 ? void 0 : _b.map(x => GetBadgeSyndicationProviderDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateCampaignSubscriptionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCampaignSubscriptionsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCampaignSubscriptionsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Campaign to update */
        CampaignId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CampaignId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All Subscriptions for the campaign. */
        Subscriptions: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Subscriptions) === null || _b === void 0 ? void 0 : _b.map(x => GetCampaignSubscriptionDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateClientSecretDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateClientSecretDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateClientSecretDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The Id of the client */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** The new Secret */
        Secret: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Secret) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a UpdateCourseAssignedOrganizationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCourseAssignedOrganizationsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCourseAssignedOrganizationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organizations */
        Organizations: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Organizations) === null || _b === void 0 ? void 0 : _b.map(x => GetCourseAssignedOrganizationsDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateCourseGroupsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCourseGroupsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCourseGroupsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Groups */
        Groups: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _c === void 0 ? void 0 : _c.map(x => GetCourseGroupDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateCoursePathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCoursePathDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCoursePathDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The course to update */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The layout of the workflow with any user customizations */
        Layout: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Layout) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The Root Item */
        Items: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _c === void 0 ? void 0 : _c.map(x => GetCoursePathItemDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateCoursePublicVideos
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCoursePublicVideos from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCoursePublicVideosForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Public Videos */
        PublicVideos: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideos) === null || _b === void 0 ? void 0 : _b.map(x => GetPublicVideoCourseDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateCourseSyndicationProvidersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCourseSyndicationProvidersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCourseSyndicationProvidersDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove syndications on Lessons and topics under the course or not */
        RemoveSubSyndications: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubSyndications) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _c === void 0 ? void 0 : _c.map(x => GetCourseSyndicationProviderDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateCourseSyndicationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCourseSyndicationsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCourseSyndicationsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove syndications on Lessons and topics under the course or not */
        RemoveSubSyndications: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubSyndications) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _c === void 0 ? void 0 : _c.map(x => GetCourseSyndicationDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateCourseWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCourseWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCourseWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assignees */
        Assignees: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Assignees) === null || _b === void 0 ? void 0 : _b.map(x => GetCourseWorkflowAssigneesDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateCreditCardPaymentCredentialDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCreditCardPaymentCredentialDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCreditCardPaymentCredentialDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Stored Payment Credential's Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** New Expiry Month */
        ExpiryMonth: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ExpiryMonth) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** New Expiry Year */
        ExpiryYear: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ExpiryYear) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Card # */
        CardNumber: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.CardNumber) !== null && _d !== void 0 ? _d : null),
        /** Updated CVV2 */
        CVV2: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CVV2) !== null && _e !== void 0 ? _e : null, [Validators.minLength(1), Validators.required]),
        /** Lesson on Card */
        NameOnCard: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.NameOnCard) !== null && _f !== void 0 ? _f : null, [Validators.minLength(1), Validators.required]),
        /** Billing Address */
        BillingAddressId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.BillingAddressId) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a UpdateCustomCourseStructureDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateCustomCourseStructureDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateCustomCourseStructureDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Course Id */
        CourseId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** structure */
        Structure: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Structure) === null || _b === void 0 ? void 0 : _b.map(x => GetCourseStructureForEditingWithChildrenDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateDisciplineGroupsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDisciplineGroupsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDisciplineGroupsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Groups */
        Groups: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _c === void 0 ? void 0 : _c.map(x => GetDisciplineGroupDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateDisciplineHeaderLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDisciplineHeaderLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDisciplineHeaderLessonsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove header lessons on badges and medallions under the Discipline or not */
        RemoveSubLessons: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubLessons) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Header Lessons */
        HeaderLessons: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _c === void 0 ? void 0 : _c.map(x => GetDisciplineHeaderLessonDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateDisciplineIndustriesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDisciplineIndustriesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDisciplineIndustriesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Discipline to update */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Industry Ids of all medallions associated with the discipline */
        Industries: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Industries) === null || _b === void 0 ? void 0 : _b.map(x => GetDisciplineIndustryDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateDisciplineMedallionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDisciplineMedallionsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDisciplineMedallionsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Discipline to update */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Medallion Ids of all medallions associated with the badge */
        Medallions: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Medallions) === null || _b === void 0 ? void 0 : _b.map(x => GetDisciplineMedallionDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateDisciplineOrganizationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDisciplineOrganizationsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDisciplineOrganizationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Badge to update */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Organization Ids of all Organizations associated with the discipline */
        Organizations: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Organizations) === null || _b === void 0 ? void 0 : _b.map(x => GetDisciplineAssignedOrganizationsDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateDisciplineProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDisciplineProductDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDisciplineProductDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Discipline's Products */
        Products: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _b === void 0 ? void 0 : _b.map(x => GetDisciplineProductDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateDisciplinePublicVideosDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDisciplinePublicVideosDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDisciplinePublicVideosDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Public Videos */
        PublicVideos: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideos) === null || _b === void 0 ? void 0 : _b.map(x => GetPublicVideoDisciplineDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateDisciplineSyndicationProvidersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDisciplineSyndicationProvidersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDisciplineSyndicationProvidersDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove syndications on badges and medallions under the Discipline or not */
        RemoveSubSyndications: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubSyndications) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _c === void 0 ? void 0 : _c.map(x => GetDisciplineSyndicationProviderDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateDocumentLinksDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateDocumentLinksDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateDocumentLinksDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Document Id */
        DocumentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DocumentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Links */
        Links: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Links) === null || _b === void 0 ? void 0 : _b.map(x => GetDocumentLinkDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateEduDomainsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateEduDomainsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateEduDomainsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The list of Edu Domains */
        EduDomains: fb.array((_b = (_a = dto === null || dto === void 0 ? void 0 : dto.EduDomains) === null || _a === void 0 ? void 0 : _a.map(x => GetEduDomainDtoForm(fb, x))) !== null && _b !== void 0 ? _b : [])
    });
}
/**
/* Generates a form from a UpdateEmailTemplateDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateEmailTemplateDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateEmailTemplateDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Organization Id */
        Organizationid: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Organizationid) !== null && _a !== void 0 ? _a : null),
        /** The list of templates */
        Templates: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Templates) === null || _b === void 0 ? void 0 : _b.map(x => GetOrganizationEmailTemplateDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateEntitlementPaymentDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateEntitlementPaymentDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateEntitlementPaymentDetailsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The entitltment to update */
        EntitlementId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.EntitlementId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The updated payment credentials */
        PaymentCredentialsId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.PaymentCredentialsId) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a UpdateInventoryItemsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateInventoryItemsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateInventoryItemsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Id of the inventory to be updated */
        InventoryId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.InventoryId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All of the items on the inventory */
        Items: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Items) === null || _b === void 0 ? void 0 : _b.map(x => GetInventoryItemDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateInvoiceInventoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateInvoiceInventoryDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateInvoiceInventoryDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Invoice Id */
        InvoiceId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Inventory to Save (all of it for the invoice) */
        Inventory: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Inventory) === null || _b === void 0 ? void 0 : _b.map(x => GetInvoiceInventoryDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateJobDisciplinesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateJobDisciplinesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateJobDisciplinesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Job to update */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Medallion Ids of all disciplines associated with the job */
        Disciplines: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _b === void 0 ? void 0 : _b.map(x => GetJobDisciplineDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateJobGroupsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateJobGroupsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateJobGroupsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Groups */
        Groups: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _c === void 0 ? void 0 : _c.map(x => GetJobGroupDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateJobHeaderLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateJobHeaderLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateJobHeaderLessonsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Header Lessons */
        HeaderLessons: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _b === void 0 ? void 0 : _b.map(x => GetJobHeaderLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateJobIndustriesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateJobIndustriesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateJobIndustriesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Job to update */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Industry Ids of all industries associated with the job */
        Industries: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Industries) === null || _b === void 0 ? void 0 : _b.map(x => GetJobIndustryDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateJobOrganizationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateJobOrganizationsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateJobOrganizationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Job to update */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Organization Ids of all Organizations associated with the medallion */
        Organizations: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Organizations) === null || _b === void 0 ? void 0 : _b.map(x => GetJobAssignedOrganizationsDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateJobProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateJobProductDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateJobProductDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Products */
        Products: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _b === void 0 ? void 0 : _b.map(x => GetJobProductDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateJobPublicVideosDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateJobPublicVideosDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateJobPublicVideosDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Public Videos */
        PublicVideos: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideos) === null || _b === void 0 ? void 0 : _b.map(x => GetPublicVideoJobDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateJobSyndicationProvidersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateJobSyndicationProvidersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateJobSyndicationProvidersDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _b === void 0 ? void 0 : _b.map(x => GetJobSyndicationProviderDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateLessonCommandsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateLessonCommandsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateLessonCommandsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All commands on Lesson */
        Commands: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Commands) === null || _b === void 0 ? void 0 : _b.map(x => GetLessonCommandDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateLessonDependenciesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateLessonDependenciesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateLessonDependenciesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Dependencies */
        Dependencies: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Dependencies) === null || _b === void 0 ? void 0 : _b.map(x => GetLessonDependencyDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateLessonLabelsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateLessonLabelsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateLessonLabelsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Labels */
        Labels: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Labels) === null || _b === void 0 ? void 0 : _b.map(x => GetLessonLabelDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateLessonOverrideThumbnailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateLessonOverrideThumbnailDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateLessonOverrideThumbnailDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Resource Id */
        ResourceId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ResourceId) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a UpdateLessonPublicVideosDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateLessonPublicVideosDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateLessonPublicVideosDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Public Videos */
        PublicVideos: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.PublicVideos) === null || _b === void 0 ? void 0 : _b.map(x => GetPublicVideoLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateLessonSyndicationProvidersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateLessonSyndicationProvidersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateLessonSyndicationProvidersDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _b === void 0 ? void 0 : _b.map(x => GetLessonSyndicationProviderDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateLessonSyndicationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateLessonSyndicationsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateLessonSyndicationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _b === void 0 ? void 0 : _b.map(x => GetLessonSyndicationDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateLessonWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateLessonWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateLessonWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The lesson Id */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** A complete list of assignees for the lesson */
        Assignees: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Assignees) === null || _b === void 0 ? void 0 : _b.map(x => GetLessonWorkflowAssigneesDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateMedallionBadgesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateMedallionBadgesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateMedallionBadgesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Medallion to update */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The badge Ids of all badges associated with the medallion */
        Badges: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Badges) === null || _b === void 0 ? void 0 : _b.map(x => GetMedallionBadgeDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateMedallionGroupsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateMedallionGroupsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateMedallionGroupsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Medallion Id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Groups */
        Groups: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _c === void 0 ? void 0 : _c.map(x => GetMedallionGroupDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateMedallionHeaderLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateMedallionHeaderLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateMedallionHeaderLessonsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Medallion Id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove header lessons on badges under the Medallion or not */
        RemoveSubLessons: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubLessons) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Header Lessons */
        HeaderLessons: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _c === void 0 ? void 0 : _c.map(x => GetMedallionHeaderLessonDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateMedallionSyndicationProvidersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateMedallionSyndicationProvidersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateMedallionSyndicationProvidersDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Medallion Id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove syndications on badges under the Medallion or not */
        RemoveSubSyndications: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubSyndications) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _c === void 0 ? void 0 : _c.map(x => GetMedallionSyndicationProviderDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateOrganizationAddressesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateOrganizationAddressesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateOrganizationAddressesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All Addresses for the organization */
        Addresses: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Addresses) === null || _b === void 0 ? void 0 : _b.map(x => GetOrganizationAddressDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateOrganizationEmailDomainsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateOrganizationEmailDomainsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateOrganizationEmailDomainsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The organization id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The email domains */
        EmailDomains: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.EmailDomains) === null || _b === void 0 ? void 0 : _b.map(x => GetOrganizationEmailDomainDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateOrganizationEntitlementUsersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateOrganizationEntitlementUsersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateOrganizationEntitlementUsersDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Organization to update */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Entitlements to update (note this does not delete non-existing ones, only updates the ones that have changed and only the UserId) */
        Entitlements: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Entitlements) === null || _b === void 0 ? void 0 : _b.map(x => GetEntitlementDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateOrganizationGroupCoursesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateOrganizationGroupCoursesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateOrganizationGroupCoursesDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The Organization Id associated with the group courses */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /**  */
        GroupId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** THe list of groups associated with the courses */
        CourseIds: fb.array([])
    });
}
/**
/* Generates a form from a UpdateOrganizationGroupsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateOrganizationGroupsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateOrganizationGroupsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All groups for the organization */
        Groups: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _b === void 0 ? void 0 : _b.map(x => GetOrganizationGroupDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateOrganizationLessonNotesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateOrganizationLessonNotesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateOrganizationLessonNotesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Notes to Update */
        Notes: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Notes) === null || _b === void 0 ? void 0 : _b.map(x => GetOrganizationLessonNoteDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateOrganizationMessagesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateOrganizationMessagesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateOrganizationMessagesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Id of the organization to update */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The messages to save under the organization */
        Messages: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Messages) === null || _b === void 0 ? void 0 : _b.map(x => GetOrganizationMessageDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateOrganizationUserGroupsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateOrganizationUserGroupsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateOrganizationUserGroupsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Organization Id */
        OrganizationId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Id */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Groups */
        Groups: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Groups) === null || _c === void 0 ? void 0 : _c.map(x => GetOrganizationUserGroupDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdatePartnerProspectsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePartnerProspectsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePartnerProspectsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Partner Organization Id */
        PartnerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PartnerId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** List of prospects */
        Prospects: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Prospects) === null || _b === void 0 ? void 0 : _b.map(x => GetPartnerProspectDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdatePaymentProviderImplementationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePaymentProviderImplementationsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePaymentProviderImplementationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The provider to update */
        ProviderId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProviderId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All implementations for the provider */
        Implementations: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Implementations) === null || _b === void 0 ? void 0 : _b.map(x => GetPaymentProviderImplementationDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdatePlayListHeaderLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePlayListHeaderLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePlayListHeaderLessonsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** PlayList Id */
        PlayListId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Header Lessons */
        HeaderLessons: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _b === void 0 ? void 0 : _b.map(x => GetPlayListHeaderLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdatePlayListSyndicationProvidersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePlayListSyndicationProvidersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePlayListSyndicationProvidersDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** PlayList Id */
        PlayListId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PlayListId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove syndications on Lessons and topics under the PlayList or not */
        RemoveSubSyndications: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubSyndications) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _c === void 0 ? void 0 : _c.map(x => GetPlayListSyndicationProviderDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdatePriceListRevisionInventoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePriceListRevisionInventoryDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePriceListRevisionInventoryDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The Revision to update */
        PriceListRevisionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PriceListRevisionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All of the inventory for the revision */
        Inventory: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Inventory) === null || _b === void 0 ? void 0 : _b.map(x => GetPriceListRevisionInventoryDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateProductAndVersionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductAndVersionsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductAndVersionsDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The course or lesson Id */
        ItemId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** A complete list of Product Versions for the given course or lesson */
        VersionIds: fb.array([])
    });
}
/**
/* Generates a form from a UpdateProductCategoriesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductCategoriesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductCategoriesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Categories associated with the product */
        Categories: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Categories) === null || _b === void 0 ? void 0 : _b.map(x => GetProductCategoryDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateProductSitesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductSitesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductSitesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Sites */
        ProductSites: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.ProductSites) === null || _b === void 0 ? void 0 : _b.map(x => GetProductSiteDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateProductTranslationCategoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductTranslationCategoryDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductTranslationCategoryDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Jargon to save */
        Categories: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Categories) === null || _b === void 0 ? void 0 : _b.map(x => GetProductTranslationCategoryDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateProductVendorIdsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductVendorIdsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductVendorIdsDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The product id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** List of vendor ids associated with a product */
        VendorIds: fb.array([])
    });
}
/**
/* Generates a form from a UpdateProductVersionAddDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductVersionAddDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductVersionAddDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The product Id */
        ProductId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The string representation of the product's name */
        Product: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _c !== void 0 ? _c : null),
        /** The name of the Version. Typically Major + "." + Minor + "." + Revision */
        Name: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(255), Validators.required]),
        /** A description of the version if any */
        Description: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _e !== void 0 ? _e : null),
        /** The major version number. */
        Major: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Major) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** The minor version number */
        Minor: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Minor) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The revision number */
        Revision: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Revision) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** When was the version released? */
        ReleasedOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ReleasedOn) !== null && _j !== void 0 ? _j : null),
        /** The External Vendor's Id - Autodesk */
        VendorId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.VendorId) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Default Course that should be used with viewing this product version */
        DefaultCourseId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.DefaultCourseId) !== null && _l !== void 0 ? _l : null),
        /** Default Course Lesson */
        DefaultCourse: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.DefaultCourse) !== null && _m !== void 0 ? _m : null),
        /** Active */
        Active: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Lessons */
        Lessons: fb.array((_q = (_p = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _p === void 0 ? void 0 : _p.map(x => GetAddVersionLessonDtoForm(fb, x))) !== null && _q !== void 0 ? _q : [])
    });
}
/**
/* Generates a form from a UpdateProductVersionCommandDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductVersionCommandDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductVersionCommandDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Current Command Lesson */
        Key: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Key) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.required]),
        /** Current version id */
        VersionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Product Version Command with translated values */
        ProductVersionCommand: GetProductVersionCommandWithTranslationsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.ProductVersionCommand),
    });
}
/**
/* Generates a form from a UpdateProductVersionCoursePreferenceDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductVersionCoursePreferenceDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductVersionCoursePreferenceDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Product */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Version */
        VersionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Course Id (optional) */
        CourseId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _c !== void 0 ? _c : null),
        /** Owned */
        Owned: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Owned) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a UpdateProductVersionCoursePreferencesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductVersionCoursePreferencesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductVersionCoursePreferencesDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** List of preferences */
        Preferences: fb.array((_b = (_a = dto === null || dto === void 0 ? void 0 : dto.Preferences) === null || _a === void 0 ? void 0 : _a.map(x => GetProductVersionCoursePreferenceDtoForm(fb, x))) !== null && _b !== void 0 ? _b : [])
    });
}
/**
/* Generates a form from a UpdateProductVersionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductVersionsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductVersionsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The root product */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All versions that are currently valid for that product */
        Versions: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Versions) === null || _b === void 0 ? void 0 : _b.map(x => GetProductVersionDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateProductWebAddressesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProductWebAddressesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProductWebAddressesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Product that the web addresses are associated with. */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Web addresses to upsert. */
        WebAddresses: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.WebAddresses) === null || _b === void 0 ? void 0 : _b.map(x => GetProductWebAddressDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateProjectProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateProjectProductDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateProjectProductDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Project Id */
        ProjectId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProjectId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Project's Products */
        Products: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _b === void 0 ? void 0 : _b.map(x => GetProjectProductDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdatePublicVideoCoursesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePublicVideoCoursesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePublicVideoCoursesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Course Ids */
        Courses: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Courses) === null || _b === void 0 ? void 0 : _b.map(x => GetPublicVideoCourseDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdatePublicVideoDisciplinesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePublicVideoDisciplinesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePublicVideoDisciplinesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Course Ids */
        Disciplines: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _b === void 0 ? void 0 : _b.map(x => GetPublicVideoDisciplineDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdatePublicVideoJobsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePublicVideoJobsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePublicVideoJobsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Course Ids */
        Jobs: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Jobs) === null || _b === void 0 ? void 0 : _b.map(x => GetPublicVideoJobDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdatePublicVideoLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdatePublicVideoLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdatePublicVideoLessonsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Public Video Id */
        PublicVideoId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.PublicVideoId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Course Ids */
        Lessons: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _b === void 0 ? void 0 : _b.map(x => GetPublicVideoLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateQuestionBranchDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateQuestionBranchDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateQuestionBranchDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The answer id */
        AnswerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** List of question ids to associate with an answer */
        Questions: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Questions) === null || _b === void 0 ? void 0 : _b.map(x => GetAnswerQuestionDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateQuestionLessonTimeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateQuestionLessonTimeDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateQuestionLessonTimeDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The question to update */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Lesson Ids of all lessons associated with the question */
        Lessons: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _b === void 0 ? void 0 : _b.map(x => GetQuestionLessonDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateQuestionLessonsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateQuestionLessonsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateQuestionLessonsDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** The question to update */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Lesson Ids of all lessons associated with the question */
        LessonIds: fb.array([])
    });
}
/**
/* Generates a form from a UpdateQuestionWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateQuestionWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateQuestionWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The question to update */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The assignees to the Question (all of them) */
        Assignees: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Assignees) === null || _b === void 0 ? void 0 : _b.map(x => GetQuestionWorkflowAssigneesDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateSupportAnswerQuestions
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateSupportAnswerQuestions from which to create the form.
/* @returns FormGroup
 */
function GetUpdateSupportAnswerQuestionsForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Support Answer */
        SupportAnswerId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.SupportAnswerId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Questions */
        Questions: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Questions) === null || _b === void 0 ? void 0 : _b.map(x => GetSupportQuestionDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateSyndicationProviderImplementationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateSyndicationProviderImplementationsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateSyndicationProviderImplementationsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The provider to update */
        ProviderId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProviderId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** All implementations for the provider */
        Implementations: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Implementations) === null || _b === void 0 ? void 0 : _b.map(x => GetSyndicationProviderImplementationDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateSystemSettingsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateSystemSettingsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateSystemSettingsDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The list of System Settings */
        Settings: fb.array((_b = (_a = dto === null || dto === void 0 ? void 0 : dto.Settings) === null || _a === void 0 ? void 0 : _a.map(x => GetSystemSettingDtoForm(fb, x))) !== null && _b !== void 0 ? _b : [])
    });
}
/**
/* Generates a form from a UpdateTopicStructureDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateTopicStructureDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateTopicStructureDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Topic Id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** structure */
        Structure: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Structure) === null || _b === void 0 ? void 0 : _b.map(x => GetCourseStructureForEditingDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateTopicSyndicationProvidersDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateTopicSyndicationProvidersDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateTopicSyndicationProvidersDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Topic Id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove syndications on Lessons and topics under the Topic or not */
        RemoveSubSyndications: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubSyndications) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _c === void 0 ? void 0 : _c.map(x => GetTopicSyndicationProviderDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateTopicSyndicationsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateTopicSyndicationsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateTopicSyndicationsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** Topic Id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Remove syndications on Lessons under the topic or not */
        RemoveSubSyndications: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RemoveSubSyndications) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Syndications */
        Syndications: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Syndications) === null || _c === void 0 ? void 0 : _c.map(x => GetTopicSyndicationDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateTopicWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateTopicWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateTopicWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Topic Id */
        TopicId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TopicId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Assignees */
        Assignees: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Assignees) === null || _b === void 0 ? void 0 : _b.map(x => GetTopicWorkflowAssigneesDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateTranslationWorkflowAssigneesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateTranslationWorkflowAssigneesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateTranslationWorkflowAssigneesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** The assessment to update */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Question Item Types */
        ParentType: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ParentType) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Language Code */
        LanguageCode: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(5), Validators.required]),
        /** The assignees to the Assessment (all of them) */
        Assignees: fb.array((_e = (_d = dto === null || dto === void 0 ? void 0 : dto.Assignees) === null || _d === void 0 ? void 0 : _d.map(x => GetTranslationWorkflowAssigneeDtoForm(fb, x))) !== null && _e !== void 0 ? _e : [])
    });
}
/**
/* Generates a form from a UpdateUserAddressesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateUserAddressesDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateUserAddressesDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** All Addresses for the user */
        Addresses: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Addresses) === null || _b === void 0 ? void 0 : _b.map(x => GetUserAddressDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateUserJobsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateUserJobsDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateUserJobsDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Optional Organization Id */
        OrganizationId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _b !== void 0 ? _b : null),
        /** Jobs */
        Jobs: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Jobs) === null || _c === void 0 ? void 0 : _c.map(x => GetUserJobDtoForm(fb, x))) !== null && _d !== void 0 ? _d : [])
    });
}
/**
/* Generates a form from a UpdateUserSubscriptionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateUserSubscriptionDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateUserSubscriptionDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** List of Subscriptions */
        Subscriptions: fb.array((_c = (_b = dto === null || dto === void 0 ? void 0 : dto.Subscriptions) === null || _b === void 0 ? void 0 : _b.map(x => GetUserSubscriptionDtoForm(fb, x))) !== null && _c !== void 0 ? _c : [])
    });
}
/**
/* Generates a form from a UpdateWorkflowStepDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateWorkflowStepDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateWorkflowStepDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The related Item */
        ItemId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The step to update */
        WorkflowStepId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.WorkflowStepId) !== null && _b !== void 0 ? _b : null),
        /** Any notes on the change */
        Notes: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a UpdateWorkflowTaskDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UpdateWorkflowTaskDto from which to create the form.
/* @returns FormGroup
 */
function GetUpdateWorkflowTaskDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Parent Id of the workflow target */
        ParentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Started On */
        StartedOn: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _b !== void 0 ? _b : null),
        /** Due Date */
        DueDate: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _c !== void 0 ? _c : null),
        /** Estimated Completion Date */
        EstCompletionDate: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.EstCompletionDate) !== null && _d !== void 0 ? _d : null),
        /** Importance */
        Importance: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _e !== void 0 ? _e : null),
        /** Flagged */
        Flagged: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a UploadDomainStyleSheetDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UploadDomainStyleSheetDto from which to create the form.
/* @returns FormGroup
 */
function GetUploadDomainStyleSheetDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** The domain Id */
        DomainId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DomainId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Style sheet in CSS format */
        StyleSheet: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.StyleSheet) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required])
    });
}
/**
/* Generates a form from a UserAcceptedTermsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAcceptedTermsDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAcceptedTermsDtoForm(fb, dto) {
    var _a;
    return fb.group({
        /** User has accepted terms */
        AcceptedTerms: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AcceptedTerms) !== null && _a !== void 0 ? _a : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserActivityDetailDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserActivityDetailDto from which to create the form.
/* @returns FormGroup
 */
function GetUserActivityDetailDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        UserName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Full Lesson */
        FullName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FullName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(1), Validators.required]),
        /** Email Address */
        EmailAddress: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** User Active? */
        IsActive: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.IsActive) !== null && _e !== void 0 ? _e : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserAddSubscriptionRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAddSubscriptionRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAddSubscriptionRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8;
    return fb.group({
        /** The User which to add the subscription. If this is null then the other fields for the user must be filled in. */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** Email Address */
        Email: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Password */
        Password: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _c !== void 0 ? _c : null, [IsValidPassword]),
        /** Confirmation Password */
        ConfirmPassword: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _d !== void 0 ? _d : null),
        /** First Lesson */
        FirstName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _e !== void 0 ? _e : null),
        /** Phone Number */
        PhoneNumber: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _f !== void 0 ? _f : null),
        /** Last Lesson */
        LastName: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _g !== void 0 ? _g : null),
        /** Provider */
        Provider: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _h !== void 0 ? _h : null),
        /** Unique Provider Key that links the provider to the user. */
        ProviderKey: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.ProviderKey) !== null && _j !== void 0 ? _j : null),
        /** Billing Street Address */
        BillingStreetAddress: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.BillingStreetAddress) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Billing Street Address 2 */
        BillingStreetAddress2: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.BillingStreetAddress2) !== null && _l !== void 0 ? _l : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Billing TownCity */
        BillingTownCity: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.BillingTownCity) !== null && _m !== void 0 ? _m : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Billing Postal Code */
        BillingPostalCode: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.BillingPostalCode) !== null && _o !== void 0 ? _o : null, [Validators.minLength(0), Validators.maxLength(15)]),
        /** Billing State */
        BillingState: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.BillingState) !== null && _p !== void 0 ? _p : null, [Validators.minLength(0), Validators.maxLength(3)]),
        /** Billing Country */
        BillingCountry: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.BillingCountry) !== null && _q !== void 0 ? _q : null, [Validators.minLength(0), Validators.maxLength(2)]),
        /** Shipping Street Address */
        ShippingStreetAddress: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.ShippingStreetAddress) !== null && _r !== void 0 ? _r : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Shipping Street Address 2 */
        ShippingStreetAddress2: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.ShippingStreetAddress2) !== null && _s !== void 0 ? _s : null, [Validators.minLength(0), Validators.maxLength(100)]),
        /** Shipping TownCity */
        ShippingTownCity: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.ShippingTownCity) !== null && _t !== void 0 ? _t : null, [Validators.minLength(0), Validators.maxLength(50)]),
        /** Shipping Postal Code */
        ShippingPostalCode: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.ShippingPostalCode) !== null && _u !== void 0 ? _u : null, [Validators.minLength(0), Validators.maxLength(20)]),
        /** Shipping State */
        ShippingState: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.ShippingState) !== null && _v !== void 0 ? _v : null, [Validators.minLength(0), Validators.maxLength(3)]),
        /** Shipping Country */
        ShippingCountry: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.ShippingCountry) !== null && _w !== void 0 ? _w : null, [Validators.minLength(0), Validators.maxLength(2)]),
        /** Marketing Campaign Sources (How did you hear about us?) */
        HowDidYouHearAboutUs: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUs) !== null && _x !== void 0 ? _x : null, [Validators.required]),
        /** Additional information about how the user heard about us */
        HowDidYouHearAboutUsOther: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUsOther) !== null && _y !== void 0 ? _y : null),
        /** The credit card details for a payment by credit card */
        CardDetails: GetMakePaymentCardDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.CardDetails),
        /** Account details for a payment made by bank draft */
        AccountDetails: GetMakePaymentAccountDetailsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.AccountDetails),
        /**  */
        PaymentMethodId: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.PaymentMethodId) !== null && _z !== void 0 ? _z : null),
        /** The SKU to use for the trial */
        SKU: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _0 !== void 0 ? _0 : null, [Validators.minLength(1), Validators.required]),
        /** Reseller Id. Used for setting associated organization */
        ResellerId: new FormControl((_1 = dto === null || dto === void 0 ? void 0 : dto.ResellerId) !== null && _1 !== void 0 ? _1 : null),
        /** UA Membership Id */
        MembershipId: new FormControl((_2 = dto === null || dto === void 0 ? void 0 : dto.MembershipId) !== null && _2 !== void 0 ? _2 : null),
        /** UA Local # */
        LocalNumber: new FormControl((_3 = dto === null || dto === void 0 ? void 0 : dto.LocalNumber) !== null && _3 !== void 0 ? _3 : null),
        /** UA Local Lesson */
        LocalName: new FormControl((_4 = dto === null || dto === void 0 ? void 0 : dto.LocalName) !== null && _4 !== void 0 ? _4 : null),
        /** Is Local Instructor */
        IsLocalInstructor: new FormControl((_5 = dto === null || dto === void 0 ? void 0 : dto.IsLocalInstructor) !== null && _5 !== void 0 ? _5 : null, [Validators.required]),
        /** The type of union (i.e. UA or ITI) */
        UnionType: new FormControl((_6 = dto === null || dto === void 0 ? void 0 : dto.UnionType) !== null && _6 !== void 0 ? _6 : null),
        /** Is purchasing cadlearning content */
        CADLearningContent: new FormControl((_7 = dto === null || dto === void 0 ? void 0 : dto.CADLearningContent) !== null && _7 !== void 0 ? _7 : null, [Validators.required]),
        /** Is purchasing Bluebeam content */
        BluebeamContent: new FormControl((_8 = dto === null || dto === void 0 ? void 0 : dto.BluebeamContent) !== null && _8 !== void 0 ? _8 : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserAddSubscriptionResponseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAddSubscriptionResponseDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAddSubscriptionResponseDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Error Message */
        ErrorMessage: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ErrorMessage) !== null && _a !== void 0 ? _a : null),
        /** User Subscription Creation Result Codes */
        Result: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Result) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The main Dto that describes a user */
        User: GetUserDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.User),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null),
        /** Invoice Id */
        InvoiceId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.InvoiceId) !== null && _d !== void 0 ? _d : null),
        /** Organization portal url */
        PortalUrl: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.PortalUrl) !== null && _e !== void 0 ? _e : null)
    });
}
/**
/* Generates a form from a UserAddTokenSubscriptionRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAddTokenSubscriptionRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAddTokenSubscriptionRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** Email Address */
        Email: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _a !== void 0 ? _a : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Password */
        Password: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _b !== void 0 ? _b : null, [IsValidPassword]),
        /** Confirmation Password */
        ConfirmPassword: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _c !== void 0 ? _c : null),
        /** First Lesson */
        FirstName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _d !== void 0 ? _d : null),
        /** Last Lesson */
        LastName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _e !== void 0 ? _e : null),
        /** Provider */
        Provider: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _f !== void 0 ? _f : null),
        /** Unique Provider Key that links the provider to the user. */
        ProviderKey: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ProviderKey) !== null && _g !== void 0 ? _g : null),
        /** External Access Token */
        ExternalAccessToken: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ExternalAccessToken) !== null && _h !== void 0 ? _h : null),
        /** Marketing Campaign Sources (How did you hear about us?) */
        HowDidYouHearAboutUs: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUs) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Additional information about how the user heard about us */
        HowDidYouHearAboutUsOther: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUsOther) !== null && _k !== void 0 ? _k : null),
        /** Reseller Id. Used for setting associated organization */
        ResellerId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.ResellerId) !== null && _l !== void 0 ? _l : null),
        /** Token to redeem */
        TokenId: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.TokenId) !== null && _m !== void 0 ? _m : null)
    });
}
/**
/* Generates a form from a UserAddTrialRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAddTrialRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAddTrialRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return fb.group({
        /** The User to add the trial to. If this is null then the other fields for the user must be filled in. */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null),
        /** Email Address */
        Email: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.email, Validators.required]),
        /** Password */
        Password: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _c !== void 0 ? _c : null, [IsValidPassword]),
        /** Confirmation Password */
        ConfirmPassword: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ConfirmPassword) !== null && _d !== void 0 ? _d : null),
        /** The provider used to login */
        Provider: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _e !== void 0 ? _e : null),
        /** Provider Key that links to the account */
        ProviderKey: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ProviderKey) !== null && _f !== void 0 ? _f : null),
        /** First Lesson */
        FirstName: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _g !== void 0 ? _g : null, [Validators.minLength(1), Validators.required]),
        /** Phone Number */
        PhoneNumber: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _h !== void 0 ? _h : null),
        /** Last Lesson */
        LastName: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _j !== void 0 ? _j : null, [Validators.minLength(1), Validators.required]),
        /** The SKU to use for the trial */
        SKU: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.SKU) !== null && _k !== void 0 ? _k : null, [Validators.minLength(1), Validators.required]),
        /** Marketing Campaign Sources (How did you hear about us?) */
        HowDidYouHearAboutUs: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUs) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Additional information about how the user heard about us */
        HowDidYouHearAboutUsOther: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.HowDidYouHearAboutUsOther) !== null && _m !== void 0 ? _m : null),
        /** Partner id */
        ResellerId: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.ResellerId) !== null && _o !== void 0 ? _o : null)
    });
}
/**
/* Generates a form from a UserAddTrialResponseDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAddTrialResponseDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAddTrialResponseDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Error Message */
        ErrorMessage: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ErrorMessage) !== null && _a !== void 0 ? _a : null),
        /** User Trial Creation Result Codes */
        Result: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Result) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The main Dto that describes a user */
        User: GetUserDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.User),
        /** Description */
        Description: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _c !== void 0 ? _c : null)
    });
}
/**
/* Generates a form from a UserAddressDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAddressDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAddressDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the address the default for the user */
        Default: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Default) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Is the address the billing address for the user */
        Billing: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Billing) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Is the address the shipping address for the user */
        Shipping: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Shipping) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Street 1 */
        Street1: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Street1) !== null && _e !== void 0 ? _e : null, [Validators.minLength(0), Validators.maxLength(150), Validators.required]),
        /** Street 2 */
        Street2: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Street2) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(150)]),
        /** City */
        City: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.City) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(100), Validators.required]),
        /** State */
        State: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.State) !== null && _h !== void 0 ? _h : null, [Validators.minLength(0), Validators.maxLength(3)]),
        /** Postal/Zip Code */
        PostalCode: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PostalCode) !== null && _j !== void 0 ? _j : null, [Validators.minLength(0), Validators.maxLength(15)]),
        /** Country */
        Country: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Country) !== null && _k !== void 0 ? _k : null, [Validators.minLength(0), Validators.maxLength(2), Validators.required]),
        /** The User Id */
        UserId: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** The name of the user */
        User: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _m !== void 0 ? _m : null)
    });
}
/**
/* Generates a form from a UserAssessmentAnswerDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAssessmentAnswerDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAssessmentAnswerDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The assessment you're answering */
        UserAssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserAssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The question you're answering. */
        QuestionId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The answer */
        AnswerId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _c !== void 0 ? _c : null),
        /** Duration */
        Duration: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Duration) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserAssessmentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAssessmentDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAssessmentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The parent assessment id */
        AssessmentId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _b !== void 0 ? _b : null),
        /** The questions for the assessment. */
        Questions: fb.array((_d = (_c = dto === null || dto === void 0 ? void 0 : dto.Questions) === null || _c === void 0 ? void 0 : _c.map(x => GetUserAssessmentQuestionDtoForm(fb, x))) !== null && _d !== void 0 ? _d : []),
        /** The Lesson of the Assessment */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null),
        /** The total duration the user took to complete the assessment */
        TotalDuration: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalDuration) !== null && _f !== void 0 ? _f : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserAssessmentQuestionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAssessmentQuestionDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAssessmentQuestionDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The text of the question */
        Text: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _b !== void 0 ? _b : null),
        /** The selected answer */
        AnswerId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _c !== void 0 ? _c : null),
        /** Parent Assessment Id */
        UserAssessmentId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.UserAssessmentId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** An Enumeration of different types of assessments */
        AssessmentType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.AssessmentType) !== null && _e !== void 0 ? _e : null),
        /** The Answers to the question */
        Answers: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Answers) === null || _f === void 0 ? void 0 : _f.map(x => GetAnswerDisplayDtoForm(fb, x))) !== null && _g !== void 0 ? _g : []),
        /** The resources associated with the question */
        Resources: fb.array((_j = (_h = dto === null || dto === void 0 ? void 0 : dto.Resources) === null || _h === void 0 ? void 0 : _h.map(x => GetResourceLocatorDtoForm(fb, x))) !== null && _j !== void 0 ? _j : []),
        /** The duration the user took to answer the question */
        Duration: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Duration) !== null && _k !== void 0 ? _k : null),
        /** The order of the question */
        Order: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _l !== void 0 ? _l : null)
    });
}
/**
/* Generates a form from a UserAssessmentTranscriptDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserAssessmentTranscriptDto from which to create the form.
/* @returns FormGroup
 */
function GetUserAssessmentTranscriptDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The assessment id taken */
        AssessmentId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.AssessmentId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The name of the assessment */
        Assessment: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Assessment) !== null && _b !== void 0 ? _b : null),
        /** What the assessment belongs to */
        ParentId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ParentId) !== null && _c !== void 0 ? _c : null),
        /** The name of the parent of the assessment */
        Parent: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Parent) !== null && _d !== void 0 ? _d : null),
        /** The Type of the parent that kicked off the assessment */
        ParentType: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ParentType) !== null && _e !== void 0 ? _e : null),
        /** The user's score */
        Score: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Score) !== null && _f !== void 0 ? _f : null),
        /** Total Possible */
        OutOf: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.OutOf) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Is the assessment complete */
        Complete: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Complete) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Date that the assessment was completed */
        CompletedOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.CompletedOn) !== null && _j !== void 0 ? _j : null),
        /** User Id */
        UserId: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _k !== void 0 ? _k : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserDataRequestDocumentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserDataRequestDocumentDto from which to create the form.
/* @returns FormGroup
 */
function GetUserDataRequestDocumentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User data request id */
        UserDataRequestId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserDataRequestId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Is return data */
        IsReturnData: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.IsReturnData) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Uri */
        Uri: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Uri) !== null && _e !== void 0 ? _e : null),
        /** File Lesson */
        FileName: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.FileName) !== null && _f !== void 0 ? _f : null),
        /** File Size */
        Size: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Size) !== null && _g !== void 0 ? _g : null),
        /** Date File Updated */
        DateTimeFileUpdated: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DateTimeFileUpdated) !== null && _h !== void 0 ? _h : null),
        /** Resource Locations */
        Location: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Resource Types */
        Type: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Type) !== null && _k !== void 0 ? _k : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserDataRequestDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserDataRequestDto from which to create the form.
/* @returns FormGroup
 */
function GetUserDataRequestDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Request Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Id Making Request */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** User Lesson making request */
        User: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _c !== void 0 ? _c : null),
        /** Requested On */
        RequestedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RequestedOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Is a data retrieval request */
        DataRequest: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.DataRequest) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Is a data removal request */
        DataRemoval: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.DataRemoval) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** User accepted privacy policy (Used on initial request) */
        AcceptedTerms: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.AcceptedTerms) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Approved */
        Approved: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Approved) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Rejected */
        Rejected: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Rejected) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Rejected Reason */
        RejectedReason: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.RejectedReason) !== null && _k !== void 0 ? _k : null)
    });
}
/**
/* Generates a form from a UserDataRequestRejectDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserDataRequestRejectDto from which to create the form.
/* @returns FormGroup
 */
function GetUserDataRequestRejectDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** Id of Request */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Reject Reason */
        RejectReason: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.RejectReason) !== null && _b !== void 0 ? _b : null)
    });
}
/**
/* Generates a form from a UserDataRequestWithResourcesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserDataRequestWithResourcesDto from which to create the form.
/* @returns FormGroup
 */
function GetUserDataRequestWithResourcesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    return fb.group({
        /** Request Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Id Making Request */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** User Lesson making request */
        User: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _c !== void 0 ? _c : null),
        /** Requested On */
        RequestedOn: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RequestedOn) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Is a data retrieval request */
        DataRequest: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.DataRequest) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Is a data removal request */
        DataRemoval: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.DataRemoval) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** User accepted privacy policy (Used on initial request) */
        AcceptedTerms: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.AcceptedTerms) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Approved */
        Approved: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Approved) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Rejected */
        Rejected: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Rejected) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Rejected Reason */
        RejectedReason: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.RejectedReason) !== null && _k !== void 0 ? _k : null),
        /** Documents */
        Documents: fb.array((_m = (_l = dto === null || dto === void 0 ? void 0 : dto.Documents) === null || _l === void 0 ? void 0 : _l.map(x => GetUserDataRequestDocumentDtoForm(fb, x))) !== null && _m !== void 0 ? _m : [])
    });
}
/**
/* Generates a form from a UserDisciplineDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserDisciplineDto from which to create the form.
/* @returns FormGroup
 */
function GetUserDisciplineDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null),
        /** Started On */
        StartedOn: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Discipline with its products */
        Discipline: GetDisciplineWithProductsDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Discipline),
    });
}
/**
/* Generates a form from a UserDisciplineLearningPathDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserDisciplineLearningPathDto from which to create the form.
/* @returns FormGroup
 */
function GetUserDisciplineLearningPathDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
    return fb.group({
        /** Length of all incomplete lessons */
        Length: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the Path Expanded? */
        Expanded: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Expanded) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Discipline Lesson */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Discipline Id */
        Id: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** A Resource */
        DisplayImage: GetResourceDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.DisplayImage),
        /** Total Number of Medallions */
        TotalMedallions: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.TotalMedallions) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Number of Completed Medallions */
        TotalCompletedMedallions: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.TotalCompletedMedallions) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Total # of Badges */
        TotalBadges: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.TotalBadges) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** When the Discipline was started. */
        StartedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** When will the trend hit 0? */
        TrendZeroOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.TrendZeroOn) !== null && _j !== void 0 ? _j : null),
        /** Percent Complete */
        PercentComplete: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Discipline Earned Date, if applicable */
        EarnedOn: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EarnedOn) !== null && _l !== void 0 ? _l : null),
        /** History of completion */
        History: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.History) === null || _m === void 0 ? void 0 : _m.map(x => GetLearningPathHistoryDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** Order */
        Order: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Was the discipline added by a job? */
        AddedByJob: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.AddedByJob) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** Medallions */
        Medallions: fb.array((_s = (_r = dto === null || dto === void 0 ? void 0 : dto.Medallions) === null || _r === void 0 ? void 0 : _r.map(x => GetMedallionLearningPathDtoForm(fb, x))) !== null && _s !== void 0 ? _s : []),
        /** Discipline Header Lessons */
        HeaderLessons: fb.array((_u = (_t = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _t === void 0 ? void 0 : _t.map(x => GetLessonDtoForm(fb, x))) !== null && _u !== void 0 ? _u : []),
        /** Users first name */
        FirstName: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _v !== void 0 ? _v : null),
        /** Users Last Lesson */
        LastName: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _w !== void 0 ? _w : null)
    });
}
/**
/* Generates a form from a UserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserDto from which to create the form.
/* @returns FormGroup
 */
function GetUserDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** This is the Email Address - Required for Identity Framework */
        UserName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The user's first name */
        FirstName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** The user's last name */
        LastName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** The user's full name */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null),
        /** The user's email */
        Email: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(450), Validators.email, Validators.required]),
        /** Is the email address confirmed? */
        EmailConfirmed: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.EmailConfirmed) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Phone Number */
        PhoneNumber: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _h !== void 0 ? _h : null),
        /** Is the phone number confirmed? */
        PhoneNumberConfirmed: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PhoneNumberConfirmed) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Is the user active? */
        Active: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Creation Date */
        CreatedOn: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Description */
        Description: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _o !== void 0 ? _o : null),
        /** Tags */
        Tags: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _p !== void 0 ? _p : null),
        /** EduConfirmed */
        EduConfirmed: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.EduConfirmed) !== null && _q !== void 0 ? _q : null),
        /** User Expert Bot Escalation Availabilities */
        ExpertBotEscalationAvailability: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.ExpertBotEscalationAvailability) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** Available for Escalation */
        AvailableForEscalation: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.AvailableForEscalation) !== null && _s !== void 0 ? _s : null, [Validators.required]),
        /** Users selected language */
        LanguageCode: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _t !== void 0 ? _t : null, [Validators.minLength(0), Validators.maxLength(10)])
    });
}
/**
/* Generates a form from a UserGridLayoutDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserGridLayoutDto from which to create the form.
/* @returns FormGroup
 */
function GetUserGridLayoutDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return fb.group({
        /** Id of the Grid that is customized */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** Grid Unique Key */
        Key: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Key) !== null && _b !== void 0 ? _b : null),
        /** User Id */
        UserId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Default Layout */
        IsDefault: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.IsDefault) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Title to add to the grid */
        Title: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Title) !== null && _e !== void 0 ? _e : null),
        /** The filter criteria for the grid */
        Filters: fb.array((_g = (_f = dto === null || dto === void 0 ? void 0 : dto.Filters) === null || _f === void 0 ? void 0 : _f.map(x => GetFilterCriteriaForm(fb, x))) !== null && _g !== void 0 ? _g : []),
        /** The Sorting rules for the grid */
        Sorting: fb.array((_j = (_h = dto === null || dto === void 0 ? void 0 : dto.Sorting) === null || _h === void 0 ? void 0 : _h.map(x => GetOrderCriteriaForm(fb, x))) !== null && _j !== void 0 ? _j : []),
        /**  */
        GroupBy: GetGroupCriteriaForm(fb, dto === null || dto === void 0 ? void 0 : dto.GroupBy),
        /** Summary Aggregates for the Grid */
        Aggregates: fb.array((_l = (_k = dto === null || dto === void 0 ? void 0 : dto.Aggregates) === null || _k === void 0 ? void 0 : _k.map(x => GetAggregateCriteriaForm(fb, x))) !== null && _l !== void 0 ? _l : []),
        /** Column Definition and order */
        Columns: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.Columns) === null || _m === void 0 ? void 0 : _m.map(x => GetColumnDetailForm(fb, x))) !== null && _o !== void 0 ? _o : [])
    });
}
/**
/* Generates a form from a UserJobDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserJobDto from which to create the form.
/* @returns FormGroup
 */
function GetUserJobDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Id */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** User's Lesson */
        User: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _c !== void 0 ? _c : null),
        /** Job Id */
        JobId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Job Lesson */
        Job: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Job) !== null && _e !== void 0 ? _e : null),
        /** Organization Id */
        OrganizationId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _f !== void 0 ? _f : null),
        /** Organization Lesson */
        Organization: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Organization) !== null && _g !== void 0 ? _g : null),
        /** Started On */
        StartedOn: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _h !== void 0 ? _h : null, [Validators.required]),
        /** Products linked to the job. */
        Products: fb.array((_k = (_j = dto === null || dto === void 0 ? void 0 : dto.Products) === null || _j === void 0 ? void 0 : _j.map(x => GetUserJobProductDtoForm(fb, x))) !== null && _k !== void 0 ? _k : [])
    });
}
/**
/* Generates a form from a UserJobProductDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserJobProductDto from which to create the form.
/* @returns FormGroup
 */
function GetUserJobProductDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Link to the User Job */
        UserJobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserJobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Job Lesson */
        Job: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Job) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Product Id */
        ProductId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Product */
        Product: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _d !== void 0 ? _d : null),
        /** Version Id */
        VersionId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.VersionId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** Version Lesson */
        Version: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Version) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a UserProgressStatsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserProgressStatsDto from which to create the form.
/* @returns FormGroup
 */
function GetUserProgressStatsDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Total Badges */
        TotalBadges: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.TotalBadges) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** In Progress Badges */
        InProgressBadges: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.InProgressBadges) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** Complete Badges */
        CompleteBadges: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CompleteBadges) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserReportDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserReportDto from which to create the form.
/* @returns FormGroup
 */
function GetUserReportDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** Report Id */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null),
        /** User */
        UserId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _b !== void 0 ? _b : null),
        /** Organization */
        OrganizationId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.OrganizationId) !== null && _c !== void 0 ? _c : null),
        /** How reports should be persisted to the database for recovery with custom reports etc. */
        Report: GetReportDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.Report),
        /** Report Schedule */
        Schedule: GetReportScheduleDetailForm(fb, dto === null || dto === void 0 ? void 0 : dto.Schedule),
    });
}
/**
/* Generates a form from a UserSubscriptionDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserSubscriptionDto from which to create the form.
/* @returns FormGroup
 */
function GetUserSubscriptionDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** User Lesson */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** Campaign Types */
        CampaignType: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.CampaignType) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Subscription Types */
        SubscriptionTypes: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.SubscriptionTypes) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserSuggestedContentDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserSuggestedContentDto from which to create the form.
/* @returns FormGroup
 */
function GetUserSuggestedContentDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** The productId */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The Product Lesson */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null, [Validators.minLength(1), Validators.required]),
        /** The key used for generating the image name */
        ProductKey: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ProductKey) !== null && _c !== void 0 ? _c : null),
        /** Product Description */
        ProductDescription: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ProductDescription) !== null && _d !== void 0 ? _d : null),
        /** The Courses associated with the products */
        Courses: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Courses) === null || _e === void 0 ? void 0 : _e.map(x => GetShortContentDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** The Brand color of the product */
        BrandingColor: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.BrandingColor) !== null && _g !== void 0 ? _g : null, [Validators.minLength(0), Validators.maxLength(10)])
    });
}
/**
/* Generates a form from a UserSuggestedProductsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserSuggestedProductsDto from which to create the form.
/* @returns FormGroup
 */
function GetUserSuggestedProductsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f;
    return fb.group({
        /** Product Id */
        ProductId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.ProductId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Product Lesson */
        Product: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Product) !== null && _b !== void 0 ? _b : null),
        /** Product Branding Color */
        BrandingColor: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.BrandingColor) !== null && _c !== void 0 ? _c : null),
        /** Owned */
        Owned: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Owned) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Display Image Url */
        DisplayImageUrl: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.DisplayImageUrl) !== null && _e !== void 0 ? _e : null),
        /** Display String */
        DisplayImageId: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.DisplayImageId) !== null && _f !== void 0 ? _f : null)
    });
}
/**
/* Generates a form from a UserUpdateAvailabilityDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserUpdateAvailabilityDto from which to create the form.
/* @returns FormGroup
 */
function GetUserUpdateAvailabilityDtoForm(fb, dto) {
    var _a, _b;
    return fb.group({
        /** User Id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Is the User Available */
        Available: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Available) !== null && _b !== void 0 ? _b : null, [Validators.required])
    });
}
/**
/* Generates a form from a UserWithRolesDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original UserWithRolesDto from which to create the form.
/* @returns FormGroup
 */
function GetUserWithRolesDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** This is the Email Address - Required for Identity Framework */
        UserName: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.UserName) !== null && _b !== void 0 ? _b : null, [Validators.minLength(0), Validators.maxLength(450), Validators.required]),
        /** The user's first name */
        FirstName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FirstName) !== null && _c !== void 0 ? _c : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** The user's last name */
        LastName: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.LastName) !== null && _d !== void 0 ? _d : null, [Validators.minLength(0), Validators.maxLength(50), Validators.required]),
        /** The user's full name */
        Name: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _e !== void 0 ? _e : null),
        /** The user's email */
        Email: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Email) !== null && _f !== void 0 ? _f : null, [Validators.minLength(0), Validators.maxLength(450), Validators.email, Validators.required]),
        /** Is the email address confirmed? */
        EmailConfirmed: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.EmailConfirmed) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** Phone Number */
        PhoneNumber: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.PhoneNumber) !== null && _h !== void 0 ? _h : null),
        /** Is the phone number confirmed? */
        PhoneNumberConfirmed: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.PhoneNumberConfirmed) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Is the user active? */
        Active: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _k !== void 0 ? _k : null, [Validators.required]),
        /** Creation Date */
        CreatedOn: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _m !== void 0 ? _m : null, [Validators.required]),
        /** Description */
        Description: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _o !== void 0 ? _o : null),
        /** Tags */
        Tags: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Tags) !== null && _p !== void 0 ? _p : null),
        /** EduConfirmed */
        EduConfirmed: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.EduConfirmed) !== null && _q !== void 0 ? _q : null),
        /** User Expert Bot Escalation Availabilities */
        ExpertBotEscalationAvailability: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.ExpertBotEscalationAvailability) !== null && _r !== void 0 ? _r : null, [Validators.required]),
        /** Available for Escalation */
        AvailableForEscalation: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.AvailableForEscalation) !== null && _s !== void 0 ? _s : null, [Validators.required]),
        /** Users selected language */
        LanguageCode: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _t !== void 0 ? _t : null, [Validators.minLength(0), Validators.maxLength(10)]),
        /** Admin */
        Admin: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.Admin) !== null && _u !== void 0 ? _u : null, [Validators.required]),
        /** Creator */
        Creator: new FormControl((_v = dto === null || dto === void 0 ? void 0 : dto.Creator) !== null && _v !== void 0 ? _v : null, [Validators.required]),
        /** Reporter */
        Reporter: new FormControl((_w = dto === null || dto === void 0 ? void 0 : dto.Reporter) !== null && _w !== void 0 ? _w : null, [Validators.required]),
        /** Organization Division */
        Division: new FormControl((_x = dto === null || dto === void 0 ? void 0 : dto.Division) !== null && _x !== void 0 ? _x : null),
        /** Organization Group */
        GroupId: new FormControl((_y = dto === null || dto === void 0 ? void 0 : dto.GroupId) !== null && _y !== void 0 ? _y : null),
        /** Organization Group Lesson */
        Group: new FormControl((_z = dto === null || dto === void 0 ? void 0 : dto.Group) !== null && _z !== void 0 ? _z : null),
        /** Organization Location */
        Location: new FormControl((_0 = dto === null || dto === void 0 ? void 0 : dto.Location) !== null && _0 !== void 0 ? _0 : null)
    });
}
/**
/* Generates a form from a VerifyRequestAccessDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original VerifyRequestAccessDto from which to create the form.
/* @returns FormGroup
 */
function GetVerifyRequestAccessDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e;
    return fb.group({
        /** Email Address */
        EmailAddress: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.EmailAddress) !== null && _a !== void 0 ? _a : null, [Validators.email]),
        /** Verification Code */
        Code: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Code) !== null && _b !== void 0 ? _b : null),
        /** Client Id making the request */
        ClientId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ClientId) !== null && _c !== void 0 ? _c : null),
        /** The Requesting Site */
        RequestingSiteUrl: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RequestingSiteUrl) !== null && _d !== void 0 ? _d : null, [Validators.minLength(1), Validators.required]),
        /** Password */
        Password: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Password) !== null && _e !== void 0 ? _e : null, [Validators.minLength(6), Validators.maxLength(15), IsValidPassword, Validators.required])
    });
}
/**
/* Generates a form from a VideoWithCaptionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original VideoWithCaptionsDto from which to create the form.
/* @returns FormGroup
 */
function GetVideoWithCaptionsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** External Id */
        ExternalId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ExternalId) !== null && _b !== void 0 ? _b : null),
        /** File Lesson */
        FileName: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.FileName) !== null && _c !== void 0 ? _c : null),
        /** Extension */
        Extension: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Extension) !== null && _d !== void 0 ? _d : null),
        /** Size */
        Size: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.Size) !== null && _e !== void 0 ? _e : null),
        /** Length */
        Length: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _f !== void 0 ? _f : null, [Validators.required]),
        /** Audio Bit Rate */
        AudioBitRate: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.AudioBitRate) !== null && _g !== void 0 ? _g : null),
        /** Data Bit Rate */
        DataBitRate: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.DataBitRate) !== null && _h !== void 0 ? _h : null),
        /** Total Bit Rate */
        TotalBitRate: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.TotalBitRate) !== null && _j !== void 0 ? _j : null),
        /** Frames per second */
        FramesPerSecond: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.FramesPerSecond) !== null && _k !== void 0 ? _k : null),
        /** Width */
        Width: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Width) !== null && _l !== void 0 ? _l : null),
        /** Height */
        Height: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Height) !== null && _m !== void 0 ? _m : null),
        /** Active */
        Active: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Active) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** Created On */
        CreatedOn: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _p !== void 0 ? _p : null, [Validators.required]),
        /** Updated On */
        UpdatedOn: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.UpdatedOn) !== null && _q !== void 0 ? _q : null, [Validators.required]),
        /** Language */
        LanguageCode: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.LanguageCode) !== null && _r !== void 0 ? _r : null),
        /** Video Text */
        Text: new FormControl((_s = dto === null || dto === void 0 ? void 0 : dto.Text) !== null && _s !== void 0 ? _s : null),
        /** Video Providers */
        Provider: new FormControl((_t = dto === null || dto === void 0 ? void 0 : dto.Provider) !== null && _t !== void 0 ? _t : null, [Validators.required]),
        /** Video streaming Uri without security token */
        StreamingUri: new FormControl((_u = dto === null || dto === void 0 ? void 0 : dto.StreamingUri) !== null && _u !== void 0 ? _u : null),
        /** Captions */
        Captions: fb.array((_w = (_v = dto === null || dto === void 0 ? void 0 : dto.Captions) === null || _v === void 0 ? void 0 : _v.map(x => GetCaptionDtoForm(fb, x))) !== null && _w !== void 0 ? _w : [])
    });
}
/**
/* Generates a form from a WhatsNextBadgeDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WhatsNextBadgeDto from which to create the form.
/* @returns FormGroup
 */
function GetWhatsNextBadgeDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g;
    return fb.group({
        /** Badge Id */
        BadgeId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.BadgeId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Badge Lesson */
        Badge: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Badge) !== null && _b !== void 0 ? _b : null),
        /** Has the badge been earned */
        Earned: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Earned) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Header Lessons */
        HeaderLessons: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _e === void 0 ? void 0 : _e.map(x => GetLessonDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Order */
        Order: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _g !== void 0 ? _g : null, [Validators.required])
    });
}
/**
/* Generates a form from a WhatsNextDisciplineDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WhatsNextDisciplineDto from which to create the form.
/* @returns FormGroup
 */
function GetWhatsNextDisciplineDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Discipline Id */
        DisciplineId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.DisciplineId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Discipline Lesson */
        Discipline: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Discipline) !== null && _b !== void 0 ? _b : null),
        /** Earned */
        Earned: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Earned) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Associated Medallions */
        Medallions: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Medallions) === null || _e === void 0 ? void 0 : _e.map(x => GetWhatsNextMedallionsDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Header Lessons */
        HeaderLessons: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _g === void 0 ? void 0 : _g.map(x => GetLessonDtoForm(fb, x))) !== null && _h !== void 0 ? _h : []),
        /** Order */
        Order: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a WhatsNextDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WhatsNextDto from which to create the form.
/* @returns FormGroup
 */
function GetWhatsNextDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    return fb.group({
        /** Lesson Id value */
        LessonId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.LessonId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson Lesson */
        Lesson: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Lesson) !== null && _b !== void 0 ? _b : null),
        /** Lesson Length */
        Length: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Length) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Has the lesson been learned */
        Learned: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Learned) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Associated Badges */
        Badges: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Badges) === null || _e === void 0 ? void 0 : _e.map(x => GetWhatsNextBadgeDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Associated Medallions */
        Medallions: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.Medallions) === null || _g === void 0 ? void 0 : _g.map(x => GetWhatsNextMedallionsDtoForm(fb, x))) !== null && _h !== void 0 ? _h : []),
        /** Associated Disciplines */
        Disciplines: fb.array((_k = (_j = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _j === void 0 ? void 0 : _j.map(x => GetWhatsNextDisciplineDtoForm(fb, x))) !== null && _k !== void 0 ? _k : [])
    });
}
/**
/* Generates a form from a WhatsNextJobDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WhatsNextJobDto from which to create the form.
/* @returns FormGroup
 */
function GetWhatsNextJobDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** Job Id */
        JobId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.JobId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Job Lesson */
        Job: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Job) !== null && _b !== void 0 ? _b : null),
        /** Earned */
        Earned: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Earned) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Associated Medallions */
        Disciplines: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Disciplines) === null || _e === void 0 ? void 0 : _e.map(x => GetWhatsNextDisciplineDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Header Lessons */
        HeaderLessons: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _g === void 0 ? void 0 : _g.map(x => GetLessonDtoForm(fb, x))) !== null && _h !== void 0 ? _h : [])
    });
}
/**
/* Generates a form from a WhatsNextMedallionsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WhatsNextMedallionsDto from which to create the form.
/* @returns FormGroup
 */
function GetWhatsNextMedallionsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    return fb.group({
        /** Medallion Id */
        MedallionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.MedallionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Medallion Lesson */
        Medallion: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Medallion) !== null && _b !== void 0 ? _b : null),
        /** Has the medallion been earned */
        Earned: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Earned) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Percent Complete */
        PercentComplete: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.PercentComplete) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** Associated Badges */
        Badges: fb.array((_f = (_e = dto === null || dto === void 0 ? void 0 : dto.Badges) === null || _e === void 0 ? void 0 : _e.map(x => GetWhatsNextBadgeDtoForm(fb, x))) !== null && _f !== void 0 ? _f : []),
        /** Header Lessons */
        HeaderLessons: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.HeaderLessons) === null || _g === void 0 ? void 0 : _g.map(x => GetLessonDtoForm(fb, x))) !== null && _h !== void 0 ? _h : []),
        /** Order */
        Order: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Order) !== null && _j !== void 0 ? _j : null, [Validators.required])
    });
}
/**
/* Generates a form from a WorkFlowStepDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WorkFlowStepDto from which to create the form.
/* @returns FormGroup
 */
function GetWorkFlowStepDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** The id of the item */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The workflow Id */
        WorkflowId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.WorkflowId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The name of the step */
        Name: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _c !== void 0 ? _c : null),
        /** Description */
        Description: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _d !== void 0 ? _d : null)
    });
}
/**
/* Generates a form from a WorkflowHistoryDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WorkflowHistoryDto from which to create the form.
/* @returns FormGroup
 */
function GetWorkflowHistoryDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return fb.group({
        /** Created On */
        CreatedOn: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.CreatedOn) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The referencing item */
        ItemId: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _b !== void 0 ? _b : null, [Validators.required]),
        /** The workflow Id */
        WorkflowId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.WorkflowId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The name of the workflow */
        Workflow: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Workflow) !== null && _d !== void 0 ? _d : null),
        /** The Step of the history */
        WorkflowStepId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.WorkflowStepId) !== null && _e !== void 0 ? _e : null, [Validators.required]),
        /** The name of the step of the history */
        WorkflowStep: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _f !== void 0 ? _f : null),
        /** How executed the workflow change */
        ExecutedById: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.ExecutedById) !== null && _g !== void 0 ? _g : null, [Validators.required]),
        /** The name of the person that executed the workflow change */
        ExecutedBy: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.ExecutedBy) !== null && _h !== void 0 ? _h : null),
        /** What the next step was based on the choice by the person executing the action if applicable */
        NextWorkflowStepId: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.NextWorkflowStepId) !== null && _j !== void 0 ? _j : null),
        /** The name of the next step */
        NextWorkflowStep: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.NextWorkflowStep) !== null && _k !== void 0 ? _k : null),
        /** Workflow Actions */
        Action: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.Action) !== null && _l !== void 0 ? _l : null, [Validators.required]),
        /** A description of what was taken */
        Description: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Description) !== null && _m !== void 0 ? _m : null),
        /** Any notes by the person executing the change */
        Notes: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _o !== void 0 ? _o : null)
    });
}
/**
/* Generates a form from a WorkflowStatusDetailsDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WorkflowStatusDetailsDto from which to create the form.
/* @returns FormGroup
 */
function GetWorkflowStatusDetailsDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
    return fb.group({
        /** The UserId */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The user name */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null),
        /** the Item that the status is for */
        ItemId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.ItemId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** Question Item Types */
        ItemType: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.ItemType) !== null && _d !== void 0 ? _d : null, [Validators.required]),
        /** The name of hte item */
        ItemName: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.ItemName) !== null && _e !== void 0 ? _e : null),
        /** The description of the item */
        ItemDescription: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.ItemDescription) !== null && _f !== void 0 ? _f : null),
        /** The current workflow step Id */
        WorkflowStepId: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.WorkflowStepId) !== null && _g !== void 0 ? _g : null),
        /** The current workflow step name */
        WorkflowStep: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _h !== void 0 ? _h : null),
        /** Started On */
        StartedOn: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _j !== void 0 ? _j : null),
        /** Due Date */
        DueDate: new FormControl((_k = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _k !== void 0 ? _k : null),
        /** Estimated Completion Date */
        EstCompletionDate: new FormControl((_l = dto === null || dto === void 0 ? void 0 : dto.EstCompletionDate) !== null && _l !== void 0 ? _l : null),
        /** Importance */
        Importance: new FormControl((_m = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _m !== void 0 ? _m : null),
        /** Flagged */
        Flagged: new FormControl((_o = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _o !== void 0 ? _o : null, [Validators.required]),
        /** The course name */
        Course: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Course) !== null && _p !== void 0 ? _p : null),
        /** The Course Id */
        CourseId: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.CourseId) !== null && _q !== void 0 ? _q : null),
        /** Has the item been returned for correction? */
        Returned: new FormControl((_r = dto === null || dto === void 0 ? void 0 : dto.Returned) !== null && _r !== void 0 ? _r : null, [Validators.required])
    });
}
/**
/* Generates a form from a WorkflowStatusInfoDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WorkflowStatusInfoDto from which to create the form.
/* @returns FormGroup
 */
function GetWorkflowStatusInfoDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
    return fb.group({
        /** The workflow Id */
        WorkflowId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.WorkflowId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The workflow name */
        Workflow: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Workflow) !== null && _b !== void 0 ? _b : null),
        /** The current step Id */
        WorkflowStepId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.WorkflowStepId) !== null && _c !== void 0 ? _c : null, [Validators.required]),
        /** The name of the current step */
        WorkflowStep: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.WorkflowStep) !== null && _d !== void 0 ? _d : null),
        /** Started On */
        StartedOn: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.StartedOn) !== null && _e !== void 0 ? _e : null),
        /** Due Date */
        DueDate: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.DueDate) !== null && _f !== void 0 ? _f : null),
        /** Estimated Completion Date */
        EstCompletionDate: new FormControl((_g = dto === null || dto === void 0 ? void 0 : dto.EstCompletionDate) !== null && _g !== void 0 ? _g : null),
        /** Importance */
        Importance: new FormControl((_h = dto === null || dto === void 0 ? void 0 : dto.Importance) !== null && _h !== void 0 ? _h : null),
        /** Flagged */
        Flagged: new FormControl((_j = dto === null || dto === void 0 ? void 0 : dto.Flagged) !== null && _j !== void 0 ? _j : null, [Validators.required]),
        /** Possible next steps */
        NextSteps: fb.array((_l = (_k = dto === null || dto === void 0 ? void 0 : dto.NextSteps) === null || _k === void 0 ? void 0 : _k.map(x => GetWorkFlowStepDtoForm(fb, x))) !== null && _l !== void 0 ? _l : []),
        /** Who is currently assigned */
        Assignees: fb.array((_o = (_m = dto === null || dto === void 0 ? void 0 : dto.Assignees) === null || _m === void 0 ? void 0 : _m.map(x => GetWorkflowUserDtoForm(fb, x))) !== null && _o !== void 0 ? _o : []),
        /** Any notes from the previous step */
        Notes: new FormControl((_p = dto === null || dto === void 0 ? void 0 : dto.Notes) !== null && _p !== void 0 ? _p : null),
        /** The name of the person that wrote the notes to you */
        NoteWritter: new FormControl((_q = dto === null || dto === void 0 ? void 0 : dto.NoteWritter) !== null && _q !== void 0 ? _q : null),
        /** Workflow step */
        QuestionApprovalStep: GetWorkFlowStepDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.QuestionApprovalStep),
        /** Workflow step */
        ScriptApprovalStep: GetWorkFlowStepDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.ScriptApprovalStep),
        /** Workflow step */
        NarrationApprovalStep: GetWorkFlowStepDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.NarrationApprovalStep),
        /** Workflow step */
        FinalApprovalStep: GetWorkFlowStepDtoForm(fb, dto === null || dto === void 0 ? void 0 : dto.FinalApprovalStep),
    });
}
/**
/* Generates a form from a WorkflowUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WorkflowUserDto from which to create the form.
/* @returns FormGroup
 */
function GetWorkflowUserDtoForm(fb, dto) {
    var _a, _b, _c, _d;
    return fb.group({
        /** the Id of the user */
        Id: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.Id) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** Lesson */
        Name: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Name) !== null && _b !== void 0 ? _b : null),
        /** Role name */
        Role: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Role) !== null && _c !== void 0 ? _c : null),
        /** The Id of the role */
        RoleId: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.RoleId) !== null && _d !== void 0 ? _d : null, [Validators.required])
    });
}
/**
/* Generates a form from a WorkflowWorkLoadByUserDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WorkflowWorkLoadByUserDto from which to create the form.
/* @returns FormGroup
 */
function GetWorkflowWorkLoadByUserDtoForm(fb, dto) {
    var _a, _b, _c;
    return fb.group({
        /** The user id */
        UserId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.UserId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The user's name */
        User: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.User) !== null && _b !== void 0 ? _b : null),
        /** How many assignments the person has */
        Assigned: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.Assigned) !== null && _c !== void 0 ? _c : null, [Validators.required])
    });
}
/**
/* Generates a form from a WrongAnswerDto
/* @param fb The FormBuilder that will build the form for you
/* @param dto The original WrongAnswerDto from which to create the form.
/* @returns FormGroup
 */
function GetWrongAnswerDtoForm(fb, dto) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    return fb.group({
        /** The question Id */
        QuestionId: new FormControl((_a = dto === null || dto === void 0 ? void 0 : dto.QuestionId) !== null && _a !== void 0 ? _a : null, [Validators.required]),
        /** The question text */
        Question: new FormControl((_b = dto === null || dto === void 0 ? void 0 : dto.Question) !== null && _b !== void 0 ? _b : null),
        /** The given answer id */
        AnswerId: new FormControl((_c = dto === null || dto === void 0 ? void 0 : dto.AnswerId) !== null && _c !== void 0 ? _c : null),
        /** The given answer text */
        Answer: new FormControl((_d = dto === null || dto === void 0 ? void 0 : dto.Answer) !== null && _d !== void 0 ? _d : null),
        /** the correct answer id */
        CorrectAnswerId: new FormControl((_e = dto === null || dto === void 0 ? void 0 : dto.CorrectAnswerId) !== null && _e !== void 0 ? _e : null),
        /** The correct answer text */
        CorrectAnswer: new FormControl((_f = dto === null || dto === void 0 ? void 0 : dto.CorrectAnswer) !== null && _f !== void 0 ? _f : null),
        /** Suggested lessons to review */
        Lessons: fb.array((_h = (_g = dto === null || dto === void 0 ? void 0 : dto.Lessons) === null || _g === void 0 ? void 0 : _g.map(x => GetShortContentDtoForm(fb, x))) !== null && _h !== void 0 ? _h : [])
    });
}

class BaseUserService {
    constructor() {
        this.User = null;
        this.IsLoggedIn = null;
        this.IsAuthenticationReady = false;
        this.AuthenticationChanged = new EventEmitter();
    }
}

class BaseComponent {
    get User() {
        return this.UserService.User;
    }
    constructor(injector) {
        this.IsLoaded = false;
        this.Language = null;
        this.PageTranslation = {};
        this.Uri = null;
        this.SystemClient = injector.get(SystemV1Client);
        this.UserService = injector.get(BaseUserService);
        this.Route = injector.get(ActivatedRoute);
        this.Translate = injector.get(TranslateService);
    }
    TranslatePage() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.Translate && this.Route && location) {
                if (this.User != null) {
                    this.Language = this.User.LanguageCode;
                }
                else {
                    this.Language = this.Route.snapshot.queryParams["lang"];
                }
                if (!this.Language)
                    this.Language = "EN";
                this.Language = this.Language.toUpperCase();
                this.Translate.use(this.Language);
                let uri = this.Uri ? this.Uri : this.GetActivatedRouteSegments(this.Route);
                if (uri.endsWith("/"))
                    uri = uri.substring(0, uri.length - 1);
                if (!uri)
                    uri = "/";
                if (this.Language !== "EN") {
                    this.PageTranslation = yield this.SystemClient.GetPageTranslation(uri, this.Language);
                    //In case of dialogs which will exist on the same page, we don't want to override the base pages translations
                    if (this.PageTranslation.Fields) {
                        let translations = Object.assign(Object.assign({}, this.Translate.translations[this.Language]), this.MapTranslationFields(this.PageTranslation.Fields));
                        this.Translate.setTranslation(this.Language, translations);
                    }
                }
                let english = yield this.SystemClient.GetPageTranslation(uri, "EN");
                if (english.Fields) {
                    let translations = Object.assign(Object.assign({}, this.Translate.translations[this.Language]), this.MapTranslationFields(english.Fields));
                    this.Translate.setTranslation("EN", translations);
                }
            }
        });
    }
    GetActivatedRouteSegments(route) {
        //because apparently this needs to be a fucking thing.
        if (!route)
            return "/";
        let parent = this.GetActivatedRouteSegments(route.parent); //Even if it is null, the next recursive call will take care of it
        if (!parent.endsWith("/"))
            parent += "/";
        return parent + route.snapshot.url.join("");
    }
    MapTranslationFields(fields) {
        if (!fields || !fields.length || fields.length === 0)
            return {};
        return fields
            .map((f) => {
            let obj = {};
            obj[f.Tag] = f.Value;
            return obj;
        })
            .reduce((result, tr) => {
            return Object.assign(tr, result);
        });
    }
    TranslateValue(list, value, valueField = "value", textField = "text") {
        const result = list.filter((l) => l[valueField] === value);
        if (result.length > 0)
            return result[0][textField];
        return null;
    }
    GetTranslationString(key) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.Translate) {
                let promise = yield this.Translate.get(key).toPromise();
                return promise;
            }
            else {
                return key;
            }
        });
    }
    OverrideTranslationUri(uri) {
        this.Uri = uri;
    }
}

class EditBaseComponent extends BaseComponent {
    constructor(injector) {
        super(injector);
        this.Working = false;
        this.ActionMessage = null;
        this.actionTimer = null;
        this.actionTimerSubscription = null;
        this.CMSRoles = [
            Roles.CADAudioCreator,
            Roles.CADAudioQA,
            Roles.CADContentManager,
            Roles.CADContentPublisher,
            Roles.CADCopyEditor,
            Roles.CADSME,
            Roles.CADTranslator,
            Roles.CADVideoCreator,
            Roles.CADVideoProducer,
            Roles.CADVideoProductionManager,
            Roles.CADVideoQA,
            Roles.CADAdmin,
            Roles.SMEContractor,
        ];
    }
    Ctl(fg, path) {
        if (!fg)
            return null;
        const ctl = fg.get(path);
        return ctl;
    }
    CtlIndicator(fg, path) {
        if (!fg)
            return {};
        const ctl = fg.get(path);
        if (!ctl)
            return {};
        return {
            "is-invalid": ctl.invalid && ctl.dirty,
            "is-valid": ctl.valid && ctl.dirty,
        };
    }
    CtlHasErrors(fg, path) {
        if (!fg)
            return false;
        const ctl = fg.get(path);
        if (!ctl)
            return false;
        return ctl.errors && (ctl.dirty || ctl.touched);
    }
    CtlsDisable(fg, path) {
        for (let i = 0; i < path.length; ++i) {
            let ctl = this.Ctl(fg, path[i]);
            if (ctl) {
                ctl.disable();
            }
        }
    }
    CtlsEnable(fg, path) {
        for (let i = 0; i < path.length; ++i) {
            let ctl = this.Ctl(fg, path[i]);
            if (ctl) {
                ctl.enable();
            }
        }
    }
    CtlsReset(fg, path) {
        for (let i = 0; i < path.length; ++i) {
            let ctl = this.Ctl(fg, path[i]);
            if (ctl) {
                ctl.markAsPristine();
                ctl.setValue(null);
            }
        }
    }
    IndicatorCss(ctl) {
        if (!ctl)
            return {};
        return {
            "is-invalid": ctl.invalid && ctl.dirty,
            "is-valid": ctl.valid && ctl.dirty,
        };
    }
    HasErrors(ctl) {
        if (!ctl)
            return false;
        return ctl.errors != null && (ctl.dirty || ctl.touched);
    }
    GroupReset(fg) {
        Object.keys(fg.controls).forEach((key) => {
            fg.controls[key].markAsPristine();
            fg.controls[key].setValue(null);
        });
    }
    Validate(fg) {
        if (fg.invalid) {
            for (let c in fg.controls)
                fg.controls[c].markAsDirty();
            return false;
        }
        return true;
    }
    ResetForm(fg, message, delay = 5000) {
        for (let c in fg.controls)
            fg.controls[c].markAsPristine();
        this.ActionMessage = message;
        if (this.actionTimer) {
            this.actionTimerSubscription.unsubscribe();
            this.actionTimer = null;
        }
        let self = this;
        this.actionTimer = timer(delay);
        this.actionTimerSubscription = this.actionTimer.subscribe(() => {
            self.ActionMessage = "";
            self.actionTimerSubscription.unsubscribe();
            self.actionTimer = null;
        });
    }
    SetActionMessage(message, delay = 5000, cb) {
        this.ActionMessage = message;
        let self = this;
        this.actionTimer = timer(delay);
        this.actionTimerSubscription = this.actionTimer.subscribe(() => {
            self.ActionMessage = "";
            self.actionTimerSubscription.unsubscribe();
            self.actionTimer = null;
            if (cb) {
                cb();
            }
        });
    }
    CtlValue(fg, path) {
        if (!fg)
            return undefined;
        const ctl = fg.get(path);
        if (!ctl)
            return undefined;
        return ctl.value;
    }
    FormToObject(fg, obj) {
        for (let field in obj) {
            const ctl = fg.get(field);
            if (!ctl)
                continue;
            obj[field] = fg.get(field).value;
        }
    }
    FormToNewObject(fg, includeFields = null, skipFields = null, unassignedFields = null) {
        let obj = {};
        for (let field in fg.controls) {
            if (!field ||
                (skipFields && skipFields.includes(field)) ||
                (includeFields && includeFields.includes(field)))
                continue;
            const ctl = fg.get(field);
            if (!ctl.value &&
                (field === "Id" || field === "TimeStamp" || (unassignedFields && unassignedFields.includes(field))))
                continue;
            obj[field] = ctl.value;
        }
        return obj;
    }
    ObjectToForm(obj) {
        let fg = new FormGroup({});
        for (const prop in obj) {
            fg.addControl(prop, new FormControl(obj[prop]));
        }
        return fg;
    }
    MapFormArray(fa, includeFields = null, skipFields = null, unassignedFields = null) {
        let arr = fa;
        if (arr == null)
            throw "The passed control is not a form array";
        return arr.controls.map((c) => this.FormToNewObject(c, includeFields, skipFields, unassignedFields));
    }
    ToFormArray(ctl) {
        return ctl;
    }
    ToFormGroup(ctl) {
        return ctl;
    }
}

class EditGridComponent extends EditBaseComponent {
    constructor(injector) {
        super(injector);
        this.Form = null;
        this.data = [];
        this.GridView = { data: [], total: 0 };
        this.State = {
            skip: 0,
            take: 15,
            sort: [{ field: "Name", dir: "asc" }],
        };
        this.grid = null;
        this.editedRowIndex = null;
    }
    editHandler({ sender, rowIndex, dataItem }) {
        this.closeEditor(sender);
        this.Form = this.initForm(dataItem);
        this.editedRowIndex = rowIndex;
        sender.editRow(rowIndex, this.Form);
    }
    addHandler({ sender }) {
        this.closeEditor(sender);
        this.Form = this.initForm({});
        this.editedRowIndex = 0;
        sender.addRow(this.Form);
    }
    cancelHandler({ sender, rowIndex }) {
        this.closeEditor(sender, rowIndex);
    }
    closeEditor(grid, rowIndex = this.editedRowIndex, keepForm) {
        grid.closeRow(rowIndex);
        this.editedRowIndex = null;
        if (!keepForm)
            this.Form = null;
    }
    LoadGrid() {
        this.GridView = process(this.data, this.State);
    }
    removeHandler({ dataItem }) {
        this.data.splice(this.data.indexOf(dataItem), 1);
        this.LoadGrid();
    }
    dataStateChange(state) {
        this.State = state;
        this.LoadGrid();
    }
}
EditGridComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: EditGridComponent, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
EditGridComponent.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: EditGridComponent });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.1.4", ngImport: i0, type: EditGridComponent, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i0.Injector }]; }, propDecorators: { grid: [{
                type: ViewChild,
                args: ["grid", { static: true }]
            }] } });

class User {
    constructor(token) {
        var _a, _b, _c, _d, _e, _f, _g;
        this.HasBotEscalation = false;
        this.HasAccomplishments = false;
        this.HasPartnerAccomplishments = false;
        this.HasProjectManagement = false;
        this.HasAcceptedTerms = false;
        this.HasChatBot = false;
        this.OrganizationGroupLogo = undefined;
        if (!token || !token.sub)
            throw new Error("The token or the subject is not set");
        this.OrganizationId = token.current_organization_id ? parseInt(token.current_organization_id) : undefined;
        this.ProjectId = token.project_id ? parseInt(token.project_id) : undefined;
        this.UserName = token.username;
        this.Id = parseInt(token.sub);
        this.Name = token.name;
        this.FirstName = token.given_name;
        this.LastName = token.family_name;
        this.LanguageCode = token.locale || "EN";
        this.LanguageCode = this.LanguageCode.toUpperCase();
        this.EmailAddress = token.email;
        if (Array.isArray(token.organization_ids)) {
            this.OrganizationIds = token.organization_ids.map((o) => parseInt(o));
        }
        else {
            this.OrganizationIds = [parseInt(token.organization_ids)];
        }
        if (Array.isArray(token.role)) {
            this.Roles = token.role.map((r) => Roles[r]);
        }
        else {
            this.Roles = [parseInt(Roles[token.role])];
        }
        if (Array.isArray(token.discipline_ids)) {
            this.DisciplineIds = token.discipline_ids.map((d) => parseInt(d));
        }
        else {
            this.DisciplineIds = [parseInt(token.discipline_ids)];
        }
        this.HasBotEscalation = ((_a = token.BotEscallation) === null || _a === void 0 ? void 0 : _a.toLowerCase()) == "true";
        this.HasAccomplishments = ((_b = token.Accomplishments) === null || _b === void 0 ? void 0 : _b.toLowerCase()) == "true";
        this.HasPartnerAccomplishments = ((_c = token.PartnerAccomplishments) === null || _c === void 0 ? void 0 : _c.toLowerCase()) == "true";
        this.HasProjectManagement = ((_d = token.ProjectManagement) === null || _d === void 0 ? void 0 : _d.toLowerCase()) == "true";
        this.HasAcceptedTerms = ((_e = token.TermsAccepted) === null || _e === void 0 ? void 0 : _e.toLowerCase()) == "true";
        this.HasChatBot = ((_f = token.ChatBot) === null || _f === void 0 ? void 0 : _f.toLowerCase()) == "true";
        if (Array.isArray(token.Languages)) {
            this.HasLanguages = token.Languages;
        }
        else {
            this.HasLanguages = [(_g = token.Languages) !== null && _g !== void 0 ? _g : "EN"];
        }
        if (token.GroupLogo) {
            this.OrganizationGroupLogo = token.GroupLogo;
        }
    }
    IsInRole(...roles) {
        if (!this.Roles || this.Roles.length === 0)
            return false;
        return this.Roles.some((r) => roles.some((rr) => rr === r));
    }
}

class DefaultLocalStorage {
    read(key) {
        return localStorage.getItem(key);
    }
    write(key, value) {
        localStorage.setItem(key, value);
    }
    remove(key) {
        localStorage.removeItem(key);
    }
    clear() {
        localStorage.clear();
    }
}

/*
 * Public API Surface of angular
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AreEqual, AssessmentsV1Client, AssessmentsV1Urls, AtLeastOneChecked, BadgesV1Client, BadgesV1Urls, BaseClient, BaseComponent, BaseUserService, BotV1Client, BotV1Urls, CADLearningCommonModule, CADLearningLightboxComponent, CLIENT_CONFIG, CampaignDripsV1Client, CampaignDripsV1Urls, CampaignsV1Client, CampaignsV1Urls, CardNumber, ConfirmEmail, ConfirmModule, ConfirmService, CoursesV1Client, CoursesV1Urls, DefaultLocalStorage, DisciplinesV1Client, DisciplinesV1Urls, DocumentsV1Client, DocumentsV1Urls, DomainsV1Client, DomainsV1Urls, EditBaseComponent, EditGridComponent, EntitlementsV1Client, EntitlementsV1Urls, GetAcceptQuoteDtoForm, GetActivityFilterDataDtoForm, GetAddAssessmentToCourseDtoForm, GetAddBotCommunicationDtoForm, GetAddCaptionsToVideoDtoForm, GetAddIndividualSubscriptionToPartnerDtoForm, GetAddIndividualSubscriptionToPartnerResultDtoForm, GetAddLinkDtoForm, GetAddPartnerOrganizationSubscriptionDtoForm, GetAddRemoveQuestionFromLessonDtoForm, GetAddStoredPaymentCredentialDtoForm, GetAddVersionLessonDtoForm, GetAddressBaseDtoForm, GetAdminChangePasswordDtoForm, GetAdminOrganizationDtoForm, GetAdminResetPasswordForm, GetAdminUserDtoForm, GetAggregateCriteriaForm, GetAggregateResultForm, GetAnswerDisplayDtoForm, GetAnswerDtoForm, GetAnswerLessonDtoForm, GetAnswerQuestionDtoForm, GetAnswerTranslationDtoForm, GetAssessmentDistributionDtoForm, GetAssessmentDtoForm, GetAssessmentDynamicItemsDtoForm, GetAssessmentInvitationDtoForm, GetAssessmentReportCardDtoForm, GetAssessmentReportCardQuestionResultDtoForm, GetAssessmentReportCardUserDtoForm, GetAssessmentResultDtoForm, GetAssessmentStructureForEditingWithParentItemsForm, GetAssessmentTranslationDtoForm, GetAssessmentUserHistoryDtoForm, GetAssessmentUserHistoryScoreDtoForm, GetAssessmentWithParentsDtoForm, GetAssessmentWorkflowAssigneesDtoForm, GetAssignRolesToUserDtoForm, GetAssignmentDtoForm, GetAudienceDtoForm, GetAuthMethodAdminDtoForm, GetAuthMethodDtoForm, GetBadgeDtoForm, GetBadgeGroupDtoForm, GetBadgeHeaderLessonDtoForm, GetBadgeLearningPathDtoForm, GetBadgeLessonDtoForm, GetBadgeSyndicationProviderDtoForm, GetBadgeTranslationDtoForm, GetBadgeUserEarnedDtoForm, GetBadgeUserReportDtoForm, GetBadgeWithUsersDtoForm, GetBotConversationDtoForm, GetBotConversationElementDtoForm, GetBotConversationRefDtoForm, GetBotResponseDtoForm, GetBulkCreateEntitlementsDtoForm, GetCampaignDripDtoForm, GetCampaignDtoForm, GetCampaignSubscriptionDtoForm, GetCaptionDtoForm, GetCaptionWithUrlDtoForm, GetChangePasswordDtoForm, GetChartDetailForm, GetChildResourceDtoForm, GetChurnRateByDateDtoForm, GetChurnRateDtoForm, GetClientDtoForm, GetColumnDetailForm, GetCommandNotificationDtoForm, GetCompetenciesAchievedDtoForm, GetCompetenciesAchievedHistoryDtoForm, GetCompetenciesAchievedUserDtoForm, GetCompleteAssessmentInviteDtoForm, GetCompleteBotConversationDtoForm, GetCompleteInviteDtoForm, GetCompletePartnerInviteDtoForm, GetCompletePartnerSubscriptionOrganizationRequestDtoForm, GetCompletionHistoryDtoForm, GetContactDtoForm, GetContentItemDtoForm, GetContentItemWithChildrenDtoForm, GetContentSearchResponseDtoForm, GetContentSearchResultDtoForm, GetContentSearchResultsWithUserInfoDtoForm, GetCopyLessonDtoForm, GetCopyQuoteDtoForm, GetCopyStaticPageTranslationDtoForm, GetCourseActivityDetailDtoForm, GetCourseAdminDtoForm, GetCourseApprovalCompletionDtoForm, GetCourseAssignedOrganizationsDtoForm, GetCourseAtAGlanceReportDtoForm, GetCourseDtoForm, GetCourseGroupDtoForm, GetCourseNextAndPreviousLessonsDtoForm, GetCoursePathItemDtoForm, GetCoursePathsDtoForm, GetCourseStructureForEditingDtoForm, GetCourseStructureForEditingWithChildrenDtoForm, GetCourseSyndicationDtoForm, GetCourseSyndicationProviderDtoForm, GetCourseTranslationDtoForm, GetCourseWithUserInfoDtoForm, GetCourseWithVersionsDtoForm, GetCourseWorkflowAssigneesDtoForm, GetCoursesByProductDtoForm, GetCreateCaptionsFromScriptDtoForm, GetCreateCourseDtoForm, GetCreateCourseLessonDtoForm, GetCreateCourseTopicDtoForm, GetCreateCustomCourseDtoForm, GetCreateCustomLessonDtoForm, GetCreateCustomProductDtoForm, GetCreateCustomTopicDtoForm, GetCreateTopicLessonDtoForm, GetCreateVideoFromResourcesDtoForm, GetDecimalNameValueDtoForm, GetDisciplineAssignedOrganizationsDtoForm, GetDisciplineAverageScoreDisciplineDtoForm, GetDisciplineAverageScoresDtoForm, GetDisciplineDtoForm, GetDisciplineGroupDtoForm, GetDisciplineHeaderLessonDtoForm, GetDisciplineIndustryDtoForm, GetDisciplineLearningPathDtoForm, GetDisciplineMedallionDtoForm, GetDisciplinePathDtoForm, GetDisciplineProductDtoForm, GetDisciplineProductVersionDtoForm, GetDisciplineSyndicationProviderDtoForm, GetDisciplineTranslationDtoForm, GetDisciplineUserEarnedDtoForm, GetDisciplineWithProductsDtoForm, GetDisputeInvoiceDtoForm, GetDocumentCategoriesWithDocumentsDtoForm, GetDocumentCategoryDtoForm, GetDocumentDtoForm, GetDocumentLinkDtoForm, GetDomainAndAuthMethodsDtoForm, GetDomainDtoForm, GetDownloadAssessmentDataDtoForm, GetDownloadGoalDataDtoForm, GetDownloadRoleDataDtoForm, GetEditProductionLessonDtoForm, GetEduAddSubscriptionRequestDtoForm, GetEduAddSubscriptionResponseDtoForm, GetEduDomainDtoForm, GetEduSubscriptionPaymentRequestDtoForm, GetEmailDomainBlackListItemDtoForm, GetEmailTemplateDtoForm, GetEmployeeActivityDtoForm, GetEmployeeAssignedToItemDtoForm, GetEmployeeItemCompletionDtoForm, GetEmployeeItemCompletionFlattenedDtoForm, GetEmployeeScoreChangeDtoForm, GetEmployeeWithEngagementDtoForm, GetEmployeeWithOverallGoalCompletionDtoForm, GetEngagementTrendsDtoForm, GetEnterpriseRequestInformationDtoForm, GetEntitlementDtoForm, GetEntitlementPaymentHistoryDtoForm, GetErrorLogDtoForm, GetExpiredUserEntitlementDtoForm, GetExpiringEntitlementDtoForm, GetFileUploadWithParentDetailsDtoForm, GetFilterCriteriaForm, GetGamificationStructureForEditingDtoForm, GetGamificationStructureForEditingWithChildrenDtoForm, GetGamificationUserEarnedDtoForm, GetGenerateAssessmentDtoForm, GetGenerateAssessmentGamificationDtoForm, GetGenerateGapAssessmentDtoForm, GetGenerateProjectPreHireAssessmentDtoForm, GetGetBotConversationDtoForm, GetGroupCriteriaForm, GetGroupResultForm, GetHelpQuestionDtoForm, GetImageUploadDetailsDtoForm, GetImportCourseDtoForm, GetImportQuestionDtoForm, GetImportResourceDtoForm, GetIndustryDtoForm, GetInt32NameValueDtoForm, GetInventoryDtoForm, GetInventoryItemDtoForm, GetInventoryWithPriceDtoForm, GetInvitePlayListEmailAddressesDtoForm, GetInvitePlayListUsersByGroupDtoForm, GetInvitePlayListUsersDtoForm, GetInvitePreHireUserDtoForm, GetInviteUserDtoForm, GetInvoiceDisplayDtoForm, GetInvoiceDtoForm, GetInvoiceInventoryDtoForm, GetInvoiceInventoryEntitlementDtoForm, GetInvoicePaymentDtoForm, GetInvoiceWithInventoryDtoForm, GetItemCompletionDtoForm, GetJobAssignedOrganizationsDtoForm, GetJobAverageScoreJobDtoForm, GetJobAverageScoresDtoForm, GetJobDisciplineDtoForm, GetJobDtoForm, GetJobGroupDtoForm, GetJobHeaderLessonDtoForm, GetJobIndustryDtoForm, GetJobLearningPathDtoForm, GetJobProductDtoForm, GetJobSyndicationProviderDtoForm, GetJobTranslationDtoForm, GetJobWithDisciplineIdsDtoForm, GetJobWithProductsDtoForm, GetLanguageImportDtoForm, GetLanguageImportItemDtoForm, GetLearningPathHistoryDtoForm, GetLessonActivityDetailDtoForm, GetLessonAdminDtoForm, GetLessonBadgeDtoForm, GetLessonCommandDtoForm, GetLessonDependencyDtoForm, GetLessonDetailsWithUserInfoDtoForm, GetLessonDisciplineDtoForm, GetLessonDtoForm, GetLessonJobDtoForm, GetLessonLabelDtoForm, GetLessonMedallionDtoForm, GetLessonPathDtoForm, GetLessonPublicationStatusDtoForm, GetLessonSyndicationDtoForm, GetLessonSyndicationProviderDtoForm, GetLessonTranslationDtoForm, GetLessonVideoDtoForm, GetLessonWithCourseInfoDtoForm, GetLessonWithQuestionsDtoForm, GetLessonWorkflowAssigneesDtoForm, GetListBotConversationsRequestForm, GetLoadCriteriaForm, GetMakePaymentAccountDetailsDtoForm, GetMakePaymentCardDetailsDtoForm, GetMakePaymentDtoForm, GetMakePaymentInvoiceDetailDtoForm, GetMedallionBadgeDtoForm, GetMedallionDtoForm, GetMedallionGroupDtoForm, GetMedallionHeaderLessonDtoForm, GetMedallionLearningPathDtoForm, GetMedallionPathDtoForm, GetMedallionSyndicationProviderDtoForm, GetMedallionTranslationDtoForm, GetMedallionUserEarnedDtoForm, GetMergeFieldDtoForm, GetNextQuestionDtoForm, GetNotificationDtoForm, GetOrderCriteriaForm, GetOrgUserDtoForm, GetOrgUserWithOrganizationDtoForm, GetOrganizationActivityDetailDtoForm, GetOrganizationAddSubscriptionRequestDtoForm, GetOrganizationAddSubscriptionResponseDtoForm, GetOrganizationAddressDtoForm, GetOrganizationContentCapabilitiesDtoForm, GetOrganizationContentOptionsDtoForm, GetOrganizationDtoForm, GetOrganizationEmailDomainDtoForm, GetOrganizationEmailTemplateDtoForm, GetOrganizationFeaturesDtoForm, GetOrganizationGroupCoursesDtoForm, GetOrganizationGroupDtoForm, GetOrganizationLessonNoteDtoForm, GetOrganizationMessageDtoForm, GetOrganizationPermissionsDtoForm, GetOrganizationPriceListInventoryDtoForm, GetOrganizationProjectRoleDtoForm, GetOrganizationReportGroupRuleForm, GetOrganizationShortDtoForm, GetOrganizationStatsDtoForm, GetOrganizationUserDtoForm, GetOrganizationUserFieldsDtoForm, GetOrganizationUserGroupDtoForm, GetOrganizationUserRoleDtoForm, GetOrganizationxApiCredentialsDtoForm, GetPartnerOrganizationGroupDtoForm, GetPartnerProspectDtoForm, GetPaymentMethodDtoForm, GetPaymentProviderDtoForm, GetPaymentProviderImplementationDtoForm, GetPingDtoForm, GetPlatformReportDtoForm, GetPlatformReportOrganizationDetailsForm, GetPlayListContentDtoForm, GetPlayListHeaderLessonDtoForm, GetPlayListSyndicationProviderDtoForm, GetPlayListUserDtoForm, GetPlayListWithContentDtoForm, GetPlaylistActivityDetailDtoForm, GetPluginNotifyCommandDtoForm, GetPluginNotifyPageCommandDtoForm, GetPluginNotifyPageDtoForm, GetPossibleLessonVersionsDtoForm, GetPriceListDtoForm, GetPriceListRevisionDtoForm, GetPriceListRevisionInventoryDtoForm, GetProductActivityDetailDtoForm, GetProductAndVersionIdDtoForm, GetProductCategoryDtoForm, GetProductCommandLessonsDtoForm, GetProductDtoForm, GetProductSiteDtoForm, GetProductTranslationCategoryDtoForm, GetProductTranslationDtoForm, GetProductVersionAndCourseDtoForm, GetProductVersionCommandDtoForm, GetProductVersionCommandTranslationDtoForm, GetProductVersionCommandWithTranslationsDtoForm, GetProductVersionCoursePreferenceDtoForm, GetProductVersionDetailsDtoForm, GetProductVersionDtoForm, GetProductWebAddressDtoForm, GetProjectActivityDetailDtoForm, GetProjectDtoForm, GetProjectJobDtoForm, GetProjectJobUserDtoForm, GetProjectManagementCompleteTaskDtoForm, GetProjectManagementIssueDtoForm, GetProjectProductDtoForm, GetProjectUserMatchBadgeDtoForm, GetProjectUserMatchDtoForm, GetProjectUserRankDtoForm, GetProspectOrgUserDtoForm, GetPublicLessonDetailsDtoForm, GetPublicVideoCourseDtoForm, GetPublicVideoDisciplineDtoForm, GetPublicVideoDtoForm, GetPublicVideoJobDtoForm, GetPublicVideoLessonDtoForm, GetPublicVideoTranslationDtoForm, GetPublishCourseDtoForm, GetPublishLessonDtoForm, GetPublishTopicDtoForm, GetPurchaseSubscriptionDtoForm, GetQBotContentStateDtoForm, GetQBotEscalationStateDtoForm, GetQBotSupportStateDtoForm, GetQConversationQuestionAnswerDtoForm, GetQConversationStateDtoForm, GetQExpertDtoForm, GetQExpertEscalationResponseDtoForm, GetQMessageButtonDtoForm, GetQMessageDtoForm, GetQParticipantDtoForm, GetQProductDtoForm, GetQuestionDtoForm, GetQuestionLessonDtoForm, GetQuestionOfTheDayAssessmentDtoForm, GetQuestionSearchResultDtoForm, GetQuestionTranslationDtoForm, GetQuestionWithProductAndLessonDtoForm, GetQuestionWithWorkflowDtoForm, GetQuestionWorkflowAssigneesDtoForm, GetQuickSearchResultDtoForm, GetRecordQuestionOfTheDayAnswerDtoForm, GetRedeemTokenDtoForm, GetRejectQuoteDtoForm, GetRemoveProductVersionCommandDtoForm, GetRenewPartnerUserEntitlementDtoForm, GetReportAchievementsTestedOutDtoForm, GetReportActivityItemDtoForm, GetReportBillableInventoryDtoForm, GetReportCourseCompletionDtoForm, GetReportCourseCompletionLessonsDtoForm, GetReportCoursesDtoForm, GetReportDtoForm, GetReportGroupProductViewsDtoForm, GetReportGroupViewsDtoForm, GetReportLessonActivityDetailsDtoForm, GetReportLessonViewsDtoForm, GetReportMostActiveProductForm, GetReportMostTakenAssessmentDtoForm, GetReportOrganizationUserEntitlementsDtoForm, GetReportOrganizationUsersDtoForm, GetReportPartnerActivityDtoForm, GetReportPartnerTokenDtoForm, GetReportPlatformTotalDtoForm, GetReportProductCommandViewsDtoForm, GetReportProductVersionViewsDtoForm, GetReportProductViewsDtoForm, GetReportProjectLessonViewsDtoForm, GetReportProjectUserViewsDtoForm, GetReportResourceViewsDtoForm, GetReportSalesBySalesRepDtoForm, GetReportScheduleDetailForm, GetReportScheduleRecipientDetailForm, GetReportSignupsByMonthDetailDtoForm, GetReportSignupsByMonthDtoForm, GetReportTopOrganizationsByDollarValueDtoForm, GetReportTopUsersByDollarValueDtoForm, GetReportTotalDtoForm, GetReportTranslationErrorDtoForm, GetReportTrialsDtoForm, GetReportUpcomingOrganizationRenewalsDtoForm, GetReportUserDetailViewsDtoForm, GetReportUserLessonViewsDtoForm, GetReportWorkFlowTaskDetailsDtoForm, GetReportWorkflowTaskChangesDtoForm, GetRequestAccessDtoForm, GetRequestLessonRightsDtoForm, GetRequestProjectMatchDtoForm, GetRequestResetPasswordDtoForm, GetRequestSalesTaxExemptionDtoForm, GetRequestVerifyEduDtoForm, GetResetPasswordDtoForm, GetResourceDtoForm, GetResourceLocatorDtoForm, GetResourceViewDtoForm, GetResourceWithParentDtoForm, GetResourcesByTypeDtoForm, GetSalesTaxDtoForm, GetSalesTaxExemptRequestResultDtoForm, GetSalesTaxExemptionDtoForm, GetSalesTaxLineItemDtoForm, GetSalesTaxProviderDtoForm, GetSalesTaxRequestDtoForm, GetSalesTaxResultDtoForm, GetScheduleReportDetailsDtoForm, GetScheduleReportDtoForm, GetScheduleReportRecipientsDtoForm, GetSearchFilterDtoForm, GetSendEmailDtoForm, GetSetCourseItemEditingStatusDtoForm, GetSetDisciplinesDtoForm, GetSetLanguageDtoForm, GetSetLessonUserRatingRequestDtoForm, GetSetLessonUserRatingResponseDtoForm, GetSetOrganizationDtoForm, GetSetProjectDtoForm, GetSetTopicItemEditingStatusDtoForm, GetSharepointFileDetailsDtoForm, GetShipInvoiceDtoForm, GetShippingMethodDtoForm, GetShortContentDtoForm, GetShortContentWithViewsDtoForm, GetShortCourseDtoForm, GetShortLessonWithCoursesDtoForm, GetSiteDtoForm, GetSkillsGapDtoForm, GetSmbRollupSubscriptionRequestDtoForm, GetSmbRollupSubscriptionResultDtoForm, GetStaticPageTranslationDtoForm, GetStaticPageTranslationFieldsDtoForm, GetStaticPageTranslationWithLanguagesDtoForm, GetStoredPaymentCredentialDtoForm, GetSubmitQuoteDtoForm, GetSupportAnswerDtoForm, GetSupportQuestionDtoForm, GetSyndicationProviderDtoForm, GetSyndicationProviderImplementationDtoForm, GetSystemMessageDtoForm, GetSystemSettingDtoForm, GetTimeSavedAcrossOrganizationResultDtoForm, GetTokenDtoForm, GetTopicActivityDetailDtoForm, GetTopicAdminDtoForm, GetTopicAtAGlanceReportDtoForm, GetTopicDtoForm, GetTopicSyndicationDtoForm, GetTopicSyndicationProviderDtoForm, GetTopicTranslationDtoForm, GetTopicWorkflowAssigneesDtoForm, GetTranslationErrorDtoForm, GetTranslationWorkflowAssigneeDtoForm, GetUpdateAnswerSuggestedLessonsDtoForm, GetUpdateAnswersDtoForm, GetUpdateAssessmentBadgesDtoForm, GetUpdateAssessmentCoursesDtoForm, GetUpdateAssessmentDynamicItemsDtoForm, GetUpdateAssessmentMedallionsDtoForm, GetUpdateAssessmentQuestionsDtoForm, GetUpdateAssessmentWorkflowAssigneesDtoForm, GetUpdateAuthMethodsDtoForm, GetUpdateBadgeGroupsDtoForm, GetUpdateBadgeHeaderLessonsDtoForm, GetUpdateBadgeLessonDtoForm, GetUpdateBadgeSyndicationProvidersDtoForm, GetUpdateCampaignSubscriptionsDtoForm, GetUpdateClientSecretDtoForm, GetUpdateCourseAssignedOrganizationsDtoForm, GetUpdateCourseGroupsDtoForm, GetUpdateCoursePathDtoForm, GetUpdateCoursePublicVideosForm, GetUpdateCourseSyndicationProvidersDtoForm, GetUpdateCourseSyndicationsDtoForm, GetUpdateCourseWorkflowAssigneesDtoForm, GetUpdateCreditCardPaymentCredentialDtoForm, GetUpdateCustomCourseStructureDtoForm, GetUpdateDisciplineGroupsDtoForm, GetUpdateDisciplineHeaderLessonsDtoForm, GetUpdateDisciplineIndustriesDtoForm, GetUpdateDisciplineMedallionsDtoForm, GetUpdateDisciplineOrganizationsDtoForm, GetUpdateDisciplineProductDtoForm, GetUpdateDisciplinePublicVideosDtoForm, GetUpdateDisciplineSyndicationProvidersDtoForm, GetUpdateDocumentLinksDtoForm, GetUpdateEduDomainsDtoForm, GetUpdateEmailTemplateDtoForm, GetUpdateEntitlementPaymentDetailsDtoForm, GetUpdateInventoryItemsDtoForm, GetUpdateInvoiceInventoryDtoForm, GetUpdateJobDisciplinesDtoForm, GetUpdateJobGroupsDtoForm, GetUpdateJobHeaderLessonsDtoForm, GetUpdateJobIndustriesDtoForm, GetUpdateJobOrganizationsDtoForm, GetUpdateJobProductDtoForm, GetUpdateJobPublicVideosDtoForm, GetUpdateJobSyndicationProvidersDtoForm, GetUpdateLessonCommandsDtoForm, GetUpdateLessonDependenciesDtoForm, GetUpdateLessonLabelsDtoForm, GetUpdateLessonOverrideThumbnailDtoForm, GetUpdateLessonPublicVideosDtoForm, GetUpdateLessonSyndicationProvidersDtoForm, GetUpdateLessonSyndicationsDtoForm, GetUpdateLessonWorkflowAssigneesDtoForm, GetUpdateMedallionBadgesDtoForm, GetUpdateMedallionGroupsDtoForm, GetUpdateMedallionHeaderLessonsDtoForm, GetUpdateMedallionSyndicationProvidersDtoForm, GetUpdateOrganizationAddressesDtoForm, GetUpdateOrganizationEmailDomainsDtoForm, GetUpdateOrganizationEntitlementUsersDtoForm, GetUpdateOrganizationGroupCoursesDtoForm, GetUpdateOrganizationGroupsDtoForm, GetUpdateOrganizationLessonNotesDtoForm, GetUpdateOrganizationMessagesDtoForm, GetUpdateOrganizationUserGroupsDtoForm, GetUpdatePartnerProspectsDtoForm, GetUpdatePaymentProviderImplementationsDtoForm, GetUpdatePlayListHeaderLessonsDtoForm, GetUpdatePlayListSyndicationProvidersDtoForm, GetUpdatePriceListRevisionInventoryDtoForm, GetUpdateProductAndVersionsDtoForm, GetUpdateProductCategoriesDtoForm, GetUpdateProductSitesDtoForm, GetUpdateProductTranslationCategoryDtoForm, GetUpdateProductVendorIdsDtoForm, GetUpdateProductVersionAddDtoForm, GetUpdateProductVersionCommandDtoForm, GetUpdateProductVersionCoursePreferenceDtoForm, GetUpdateProductVersionCoursePreferencesDtoForm, GetUpdateProductVersionsDtoForm, GetUpdateProductWebAddressesDtoForm, GetUpdateProjectProductDtoForm, GetUpdatePublicVideoCoursesDtoForm, GetUpdatePublicVideoDisciplinesDtoForm, GetUpdatePublicVideoJobsDtoForm, GetUpdatePublicVideoLessonsDtoForm, GetUpdateQuestionBranchDtoForm, GetUpdateQuestionLessonTimeDtoForm, GetUpdateQuestionLessonsDtoForm, GetUpdateQuestionWorkflowAssigneesDtoForm, GetUpdateSupportAnswerQuestionsForm, GetUpdateSyndicationProviderImplementationsDtoForm, GetUpdateSystemSettingsDtoForm, GetUpdateTopicStructureDtoForm, GetUpdateTopicSyndicationProvidersDtoForm, GetUpdateTopicSyndicationsDtoForm, GetUpdateTopicWorkflowAssigneesDtoForm, GetUpdateTranslationWorkflowAssigneesDtoForm, GetUpdateUserAddressesDtoForm, GetUpdateUserJobsDtoForm, GetUpdateUserSubscriptionDtoForm, GetUpdateWorkflowStepDtoForm, GetUpdateWorkflowTaskDtoForm, GetUploadDomainStyleSheetDtoForm, GetUserAcceptedTermsDtoForm, GetUserActivityDetailDtoForm, GetUserAddSubscriptionRequestDtoForm, GetUserAddSubscriptionResponseDtoForm, GetUserAddTokenSubscriptionRequestDtoForm, GetUserAddTrialRequestDtoForm, GetUserAddTrialResponseDtoForm, GetUserAddressDtoForm, GetUserAssessmentAnswerDtoForm, GetUserAssessmentDtoForm, GetUserAssessmentQuestionDtoForm, GetUserAssessmentTranscriptDtoForm, GetUserDataRequestDocumentDtoForm, GetUserDataRequestDtoForm, GetUserDataRequestRejectDtoForm, GetUserDataRequestWithResourcesDtoForm, GetUserDisciplineDtoForm, GetUserDisciplineLearningPathDtoForm, GetUserDtoForm, GetUserGridLayoutDtoForm, GetUserJobDtoForm, GetUserJobProductDtoForm, GetUserProgressStatsDtoForm, GetUserReportDtoForm, GetUserSubscriptionDtoForm, GetUserSuggestedContentDtoForm, GetUserSuggestedProductsDtoForm, GetUserUpdateAvailabilityDtoForm, GetUserWithRolesDtoForm, GetVerifyRequestAccessDtoForm, GetVideoWithCaptionsDtoForm, GetWhatsNextBadgeDtoForm, GetWhatsNextDisciplineDtoForm, GetWhatsNextDtoForm, GetWhatsNextJobDtoForm, GetWhatsNextMedallionsDtoForm, GetWorkFlowStepDtoForm, GetWorkflowHistoryDtoForm, GetWorkflowStatusDetailsDtoForm, GetWorkflowStatusInfoDtoForm, GetWorkflowUserDtoForm, GetWorkflowWorkLoadByUserDtoForm, GetWrongAnswerDtoForm, IndustriesV1Client, IndustriesV1Urls, InventoryV1Client, InventoryV1Urls, InvoicesV1Client, InvoicesV1Urls, IsTrue, IsValidEmail, IsValidPassword, IsValidUri, JobsV1Client, JobsV1Urls, LessonsV1Client, LessonsV1Urls, LoadingComponent, MedallionsV1Client, MedallionsV1Urls, OdataKendoComboBoxComponent, OrgInfoFilled, OrganizationsV1Client, OrganizationsV1Urls, OtherRequiredValidator, PaymentMethodsV1Client, PaymentMethodsV1Urls, PaymentProvidersV1Client, PaymentProvidersV1Urls, PlatformV1Client, PlatformV1Urls, PlaylistsV1Client, PlaylistsV1Urls, PreferencesV1Client, PreferencesV1Urls, PriceListRevisionsV1Client, PriceListRevisionsV1Urls, PriceListsV1Client, PriceListsV1Urls, ProductCategoriesV1Client, ProductCategoriesV1Urls, ProductsV1Client, ProductsV1Urls, ProjectsV1Client, ProjectsV1Urls, PromptComponent, PublicVideosV1Client, PublicVideosV1Urls, QuestionsV1Client, QuestionsV1Urls, Range, ReportsV1Client, ReportsV1Urls, RequiredCond, ResourcesV1Client, ResourcesV1Urls, ReturnCardType, RoutingNumber, SalesTaxesV1Client, SalesTaxesV1Urls, SearchV1Client, SearchV1Urls, ShippingMethodsV1Client, ShippingMethodsV1Urls, SitesV1Client, SitesV1Urls, SupportV1Client, SupportV1Urls, SyndicationProvidersV1Client, SyndicationProvidersV1Urls, SystemV1Client, SystemV1Urls, TokensV1Client, TokensV1Urls, TopicsV1Client, TopicsV1Urls, User, UsersV1Client, UsersV1Urls, WorkflowsV1Client, WorkflowsV1Urls, numbersOnly };
//# sourceMappingURL=cadlearning.angular.mjs.map
